--{{{  REALOP codes

VAL Add IS 0 :
VAL Sub IS 1 :
VAL Mul IS 2 :
VAL Div IS 3 :
--}}}

--{{{  IEECOMPARE values

VAL less.than    IS -1 :
VAL equal.to     IS  0 :
VAL greater.than IS  1 :
VAL is.nan       IS  2 :
--}}}

--{{{  single constants

--{{{  NaNs and Inf

VAL REAL32 undefined.NaN RETYPES #7F800010(INT32) :
VAL REAL32 unstable.NaN  RETYPES #7F800008(INT32) :
VAL REAL32 inexact.NaN   RETYPES #7F800004(INT32) :
VAL REAL32 RInf          RETYPES #7F800000(INT32) :
--}}}

--{{{  small constants

VAL Zero IS 0.0(REAL32) :
VAL Half IS 0.5(REAL32) :
VAL One  IS 1.0(REAL32) :
VAL Two  IS 2.0(REAL32) :
VAL one  IS 1(INT32) :
--}}}

--{{{  limiting values

VAL REAL32 Eps  RETYPES #39800000(INT32) : -- 2 ** (-Manbits/2)
VAL REAL32 SMax RETYPES #48490FDB(INT32) : -- Pi*(2^16)
VAL REAL32 TMax RETYPES #47C90FDB(INT32) : -- Pi/2*(2^16)
--}}}

--{{{  transcendental constants

VAL REAL32 Pi           RETYPES #40490FDB(INT32) :
VAL REAL32 Pi.err       RETYPES #B3BBBD2E(INT32) : --  -8.74227766 E-08
VAL REAL32 Nearly.PiBy2 RETYPES #3FC907DB(INT32) : --  PiBy2 - Eps
VAL REAL32 PiBy2        RETYPES #3FC90FDB(INT32) :
VAL REAL32 PiBy2.err    RETYPES #B33BBD2E(INT32) : --  -4.37113883 E-08
VAL REAL32 PiBy4        RETYPES #3F490FDB(INT32) :
VAL REAL32 InvPi        RETYPES #3EA2F983(INT32) :
VAL REAL64 DPi          RETYPES #400921FB54442D18(INT64) :
VAL REAL64 DPiBy2       RETYPES #3FF921FB54442D18(INT64) :
VAL REAL64 DLn2         RETYPES #3FE62E42FEFA39EF(INT64) :
--}}}
--}}}

--{{{  double constants

--{{{  NaNs and Inf

VAL REAL64 Dundefined.NaN RETYPES #7FF0000200000000(INT64) :
VAL REAL64 Dunstable.NaN  RETYPES #7FF0000100000000(INT64) :
VAL REAL64 Dinexact.NaN   RETYPES #7FF0000080000000(INT64) :
VAL REAL64 DRInf          RETYPES #7FF0000000000000(INT64) :
--}}}

--{{{  small constants

VAL DZero IS 0.0(REAL64) :
VAL DHalf IS 0.5(REAL64) :
VAL DOne  IS 1.0(REAL64) :
VAL DTwo  IS 2.0(REAL64) :
--}}}

--{{{  trigonometric constants

VAL REAL64 DPi           RETYPES #400921FB54442D18(INT64) :
VAL REAL64 DPi.err       RETYPES #3CA1A62633145C07(INT64) :
VAL REAL64 Nearly.DPiBy2 RETYPES #3FF921FB50442D18(INT64) : -- DPiBy2 - Eps
VAL REAL64 DPiBy2        RETYPES #3FF921FB54442D18(INT64) :
VAL REAL64 DPiBy2.err    RETYPES #3C91A62633145C07(INT64) :
VAL REAL64 DInvPi        RETYPES #3FD45F306DC9C883(INT64) : -- 1/pi
VAL REAL64 DPiBy4        RETYPES #3FE921FB54442D18(INT64) :
--}}}

VAL REAL64 DEps RETYPES #3E50000000000000(INT64) :
--}}}
