/*{{{  File banner*/
/*@(#)=====================================================*\
||@(#)  Project : GPMIMD ESPRIT P5404
||@(#)  Authors : Mark Debbage, Mark Hill, Denis Nicole and Sean Wykes
||@(#)            University of Southampton
||  
||@(#)    Title : Prototype Source File for generated C
||@(#)   System : Occam 2 C
||@(#)  Version : 1.3
||@(#) Filename : Occam2C.c
||@(#)     Date : 3/4/97
\*@(#)====================================================*/
/*}}}*/

/*{{{  Insert SWITCHES*/
#define LIBRARY_UNIT
#define BYTES_PER_WORD 4
#define TERMINATE_ON_ERROR
#define CHECK_CONVERSIONS
#define CHECK_ARRAYS
#define CHECK_RANGES
#define NO_DEBUG
#define FASTGOTOS
#define SOURCE LITTLE

/*}}}*/
/*{{{  defines*/
#define DEFAULT_MEMSIZE_IN_INTS 1000
#define OCCAM_MAIN

/*}}}*/
/*{{{  includes*/
#include <stdio.h>
#include <errno.h>

#if  (defined USESIGTIMER) || (defined USE_NONBLOCKING_SOCKETS)
#include <signal.h>
#include <sys/time.h>
#endif

#ifdef USE_NONBLOCKING_SOCKETS
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef solaris
#include <stropts.h>
#include <sys/file.h>
#include <sys/conf.h>
#endif
#endif

#ifdef CALL_NAG_F90
#include <f90.h>
#endif

#include "Occam2C.h"

#ifdef USE_NONBLOCKING_SOCKETS
  #ifdef solaris
  #define SOCKET_SIGNAL SIGPOLL
  #else
  #define SOCKET_SIGNAL SIGIO
  #endif
#endif
/*}}}*/
/*{{{  Insert HEADER*/
typedef struct SF_P_172 tSF_P_172;
typedef struct SF_P_176 tSF_P_176;
typedef struct SF_P_177 tSF_P_177;
typedef struct SF_P_179 tSF_P_179;
typedef struct SF_P_sp_overlapped_buffer_ovbuffer tSF_P_sp_overlapped_buffer_ovbuffer;
typedef struct SF_P_so_overlapped_buffer_ovbuffer tSF_P_so_overlapped_buffer_ovbuffer;
void P_so_overlapped_buffer_ovbuffer (tSF_P_so_overlapped_buffer_ovbuffer *FP);
struct SF_P_172
{
  tHeader _Header;
  tSF_P_sp_overlapped_buffer_ovbuffer *Chain;
  BYTE buffer_165[510];
  INT16 len_166;
  BOOL running_167;
  INT replies_outstanding_168;
  union
  {
    struct
    {
      INT any_169;
    } _S0;
    struct
    {
      INT i_170;
      INT i_170_End;
      INT any_171;
    } _S1;
  } _U0;
};
struct SF_P_176
{
  tHeader _Header;
  tSF_P_179 *Chain;
};
struct SF_P_177
{
  tHeader _Header;
  tSF_P_179 *Chain;
};
struct SF_P_179
{
  tHeader _Header;
  tSF_P_sp_overlapped_buffer_ovbuffer *Chain;
  BYTE buffer_173[510];
  INT16 len_174;
  BOOL running_175;
  union
  {
    struct
    {
      tTask _T1;
      tSF_P_176 _C1;
      tTask _T2;
      tSF_P_177 _C2;
    } _S2;
    struct
    {
      INT any_178;
    } _S3;
  } _U1;
};
struct SF_P_sp_overlapped_buffer_ovbuffer
{
  tHeader _Header;
  void *Chain;
  CHAN *fs_156;
  CHAN *ts_157;
  CHAN *from_user_158;
  CHAN *to_user_159;
  CHAN *stopper_160;
  CHAN stop_replies_162_CHAN;
  CHAN *stop_replies_162;
  CHAN done_one_reply_164_CHAN;
  CHAN *done_one_reply_164;
  tTask _T0;
  tSF_P_172 _C0;
  tTask _T3;
  tSF_P_179 _C3;
};
struct SF_P_so_overlapped_buffer_ovbuffer
{
  tHeader _Header;
  void *Chain;
  CHAN *fs_181;
  CHAN *ts_182;
  CHAN *from_user_183;
  CHAN *to_user_184;
  CHAN *stopper_185;
  tSF_P_sp_overlapped_buffer_ovbuffer _C0;
};

/*}}}*/

#if (defined GENPROTO) || !(defined LIBRARY_UNIT)
/*{{{  statics*/
jmp_buf STOPP_env;
int MAIN_ARGC ;
char **MAIN_ARGV;
tTask *QFP[NUM_PRIORITY_LEVELS],*QBP[NUM_PRIORITY_LEVELS],*CURTASK,*QTM; 
static volatile int TimerEvent = false;
static volatile int SocketEvent = false;
tTimer TIMER;
static int process_count;


/*}}}*/
#endif

#ifdef GENPROTO
/*{{{  seterr*/
void seterr(char *M,int L,char *F) {}
/*}}}*/
/*{{{  struct Prototypes*/
struct Prototypes
{
  char *Proto;
  char *Define;
  int Space;
};
/*}}}*/
/*{{{  static struct Prototypes Table[] =*/
static struct Prototypes Table[] =
{
  {"void P_sp_overlapped_buffer_ovbuffer (tSF_P_sp_overlapped_buffer_ovbuffer *FP);","P_sp_overlapped_buffer_ovbuffer",sizeof(tSF_P_sp_overlapped_buffer_ovbuffer)},
  {"void P_so_overlapped_buffer_ovbuffer (tSF_P_so_overlapped_buffer_ovbuffer *FP);","P_so_overlapped_buffer_ovbuffer",sizeof(tSF_P_so_overlapped_buffer_ovbuffer)},

 {NULL,NULL,0}
} ;
/*}}}*/
/*{{{  int main(int argc, char**argv)*/
int main(int argc, char**argv)
{
  char *name;
  FILE *f;
  int fcnt;
  
  CheckPrimitiveSizes();

  if (argc<2)
  {
    name="ovbuffer.hdr";
    f=fopen(name,"w");
  }
  else
  {
    name = argv[argc-1];
    if (name[0]=='-')
    {
      name = "stdout";
      f=stdout;
    }
    else
    {
      f=fopen(name,"w");
    }
  }
  fcnt=argc-1;
  
  if (f==NULL)
    { fprintf(stderr,"Error - could not open file %s\n",name);exit(-1); }
  else
  {
    int arg;
    int i;
    fprintf(f,"#ifndef __ovbuffer_INCLUDES__\n");
    fprintf(f,"#define __ovbuffer_INCLUDES__\n");
    
    for(arg = 1; arg < fcnt; ++arg)
    {
      FILE *fh = fopen(argv[arg],"r");
      if (fh == NULL) { fprintf(stderr,"Error - could not read file %s\n",name); exit(-1); }
      while(!feof(fh))
      {
	char line[256];

	if (fgets(line,256,fh) == NULL) break;
	if (line[0] == '#')
	  if (strncmp(line,"#define WS",10)!=0) continue;
	fputs(line,f);
      }
      fclose(fh);
    }      
      
    i = 0;
    while (Table[i].Proto!=NULL)
    {
      if (Table[i].Define != NULL)
      {
	fprintf(f,"typedef struct SF_%s tSF_%s;\n",Table[i].Define,Table[i].Define);
	fprintf(f,"#define WS_%s (%d)\n",Table[i].Define,Table[i].Space);
      }
      fprintf(f,"%s\n",Table[i].Proto);
      i++;
    }
    fprintf(f,"#endif\n");

    if (f!=stdout) fclose(f);
  }
  return(0);
}     
/*}}}*/
#endif

#ifndef LIBRARY_UNIT
/*{{{  seterr*/
static void DONE_SETERR() {}

void seterr(char *M,int L,char *F)
{
  if (M!=NULL) fputs(M,stderr);
  fprintf(stderr,MSG_EFROL,L,F);
  DONE_SETERR();
  SETERR_PROCEED;
}
/*}}}*/
/*{{{  DEBUGDONE,MARK_SCHEDULE*/
#ifndef NO_DEBUG
void DEBUGDONE(void) {}
void MARK_SCHEDULE(void) {}
#endif

/*}}}*/
/*{{{  timer*/
#ifdef USESIGTIMER
static struct timeval tv_start;
/*{{{  static void TimerSignalHandler(int sig)*/
static void TimerSignalHandler(int sig)
{
  switch(sig)
  {
    case SIGALRM:
      {
	struct timeval tv;
	tTask *task;

	gettimeofday(&tv,NULL);
	TIMER = ((tv.tv_usec - tv_start.tv_usec)>>6) + (1000000>>6) * (tv.tv_sec - tv_start.tv_sec);
	if (QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
	  TimerEvent = true;
      }
      break;

    default:
      fprintf(stderr,"Error - Caught signal %d - Exiting\n",sig);
      fflush(stderr);
      exit(20);
  }
}
/*}}}*/
/*{{{  static void Init_Timer()*/
static void Init_Timer()
{
  struct itimerval itv;
#ifndef solaris
  struct sigaction sa;
#endif

  TIMER = 0;
  gettimeofday(&tv_start,NULL);
  TimerSignalHandler(SIGALRM);
  
#ifndef solaris
  memset((char*)&sa,0,sizeof(sa));
  sa.sa_handler = TimerSignalHandler;

#ifdef SA_RESTART
  sa.sa_flags = SA_RESTART;
#endif

  sigaction(SIGALRM,&sa,NULL);
#else
  sigset(SIGALRM,TimerSignalHandler);
#endif

  itv.it_interval.tv_usec = 1000;
  itv.it_interval.tv_sec = 0;
     
  itv.it_value.tv_usec = 1;
  itv.it_value.tv_sec = 0;

  if (setitimer(ITIMER_REAL,&itv,NULL)) 
    fprintf(stderr,"Error - setitimer failed\n");

  QTM = NoTask;
  TimerEvent = false;
}

/*}}}*/

#else
static void Init_Timer() { (void)clock(); TimerEvent = false; }
#endif
/*}}}*/
/*{{{  sockets*/
#ifdef USE_NONBLOCKING_SOCKETS
static int io_limit;
static struct timeval io_zerotime;

static int    io_socket;
static tTask *io_task = NoTask;

/*{{{  void SocketHandler (int sig)*/
void SocketHandler (int sig)
{
  switch (sig)
  {
    case SOCKET_SIGNAL:
    {
      #ifdef MD_DEBUG
      fprintf(stderr,"Caught signal %d\n",sig);
      #endif
      
      SocketEvent = true;
      
      #ifdef solaris
      signal (SOCKET_SIGNAL, SocketHandler);
      #endif
      
      break;
    }
    default:
      fprintf(stderr,"Error - Caught unexpected signal %d - exiting\n",sig);
      fflush(stderr);
      exit(20);
  }  
}
/*}}}*/
 
/*{{{  void WaitSocket (int socket)*/
void WaitSocket (int socket)
{
  fd_set io_set;

  io_socket = socket;

  FD_ZERO (&io_set);
  FD_SET  (socket,&io_set);
  
  errno = 0;
  while (select (io_limit, &io_set, NULL, NULL, &io_zerotime) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
  
  if (!FD_ISSET(socket,&io_set))
  {
    if (io_task == NoTask)
      io_task = CURTASK;
    else
    {
      fprintf(stderr, "Error - Implementation restriction, only one signaling socket\n");
      exit(-1);
    }
    DeSchedule(TSOCK_p);
  }
}
/*}}}*/

/*{{{  void EnableSocket (int socket)*/
void EnableSocket (int socket)
{
  errno = 0;
  
  #ifdef solaris
  if (ioctl(socket,I_SETSIG,S_RDNORM) < 0)
  {
    fprintf(stderr,"Error - could not set signal handler for socket (errno %d)\n",errno);
    exit(-1);
  }
  #else
  if (fcntl(socket, F_SETOWN, getpid()) < 0)
  {
    fprintf(stderr,"Error - could not set owner on socket (errno %d)\n",errno);
    exit(-1);
  }
  if (fcntl(socket, F_SETFL, FASYNC)    < 0)
  {
    fprintf(stderr,"Error - could not set asynchronous socket (errno %d)\n",errno);
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void DisableSocket (int socket)*/
void DisableSocket (int socket)
{
  #ifdef sun4
  if (fcntl(socket, F_SETFL, FSYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
  #ifdef linux
  if (fcntl(socket, F_SETFL, FASYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void ServeSocket (void)*/
void ServeSocket (void)
{
  fd_set io_set;
  int res;

  /* In the general case there's a timing hazard here since a new signal
     could arrive and we can lose it. Really need test-and-set or a
     semaphore. For hostio, however, there's only ever one outstanding 
     communication and this thread is serving it. Hence, no problem here. */

  SocketEvent = false; 

  FD_ZERO (&io_set);
  FD_SET  (io_socket,&io_set);
  
  errno = 0;
  while ((res = select (io_limit, &io_set, NULL, NULL, &io_zerotime)) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
      
  if (res == 0)
  {
    /*fprintf(stderr,"Could not locate socket signal source, ignoring select\n");*/
    return;
  }
  
  if (!FD_ISSET(io_socket,&io_set))
  {
    fprintf(stderr,"Error - socket is not ready\n");
    exit(-1);
  }

  if (io_task != NoTask)
  {
    ReSchedule(io_task);
    io_task = NoTask;
  }
}
/*}}}*/

/*{{{  void Init_Sockets()*/
void Init_Sockets()
{
  io_limit = ulimit (4,0);

  timerclear (&io_zerotime);

  signal (SOCKET_SIGNAL, SocketHandler);
  #ifdef linux
  {
    struct sigaction action;
    sigaction(SIGIO,NULL,&action);
    action.sa_flags = (action.sa_flags & (~SA_ONESHOT));
    sigaction(SIGIO,&action,NULL);
  }
  #endif
}
/*}}}*/
#else
void WaitSocket (int socket)
{ 
  fprintf(stderr, "Error - No SIGSOCKETS\n"); 
}
#endif
/*}}}*/

/*{{{  static void Init_Scheduler()*/
static void Init_Scheduler()
{
  int i;

  for(i = 0; i < NUM_PRIORITY_LEVELS; ++i)
    QFP[i] = QBP[i] = NoTask;

  CURTASK = NoTask;

  Init_Timer();

  #ifdef USE_NONBLOCKING_SOCKETS
  Init_Sockets();  
  #endif
}
/*}}}*/
/*{{{  static void Scheduler()*/
static void Scheduler()
{
  if (setjmp(STOPP_env)) DeSchedule(0);
  
  while(CURTASK != NoTask || TimerEvent || SocketEvent)
  {
    int pri;

#ifdef USESIGTIMER
    /*{{{  if (TimerEvent)*/
    if (TimerEvent)
    {
    #ifdef DEBUG
	fprintf(stderr,"Timer = %d\n",TIMER);
    #endif
      TimerEvent = false;
      while(QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
      {
    #ifdef DEBUG
	{  
	  tTask *task = QTM;
    
	  fprintf(stderr,"Timer Queue contains:");
	  if (task == NoTask) fprintf(stderr,"No Tasks");
	  else while(task != NoTask) { fprintf(stderr,"%d(%d) ",task->TaskId,task->comms.timer.time); task = task->Next; }
	  fprintf(stderr,"\n");
	}  
    #endif
	if (QTM->AltMode == Waiting_p) QTM->AltMode = TReady_p;
	ReSchedule(QTM);
      }
    }
    /*}}}*/
#endif

#ifdef USE_NONBLOCKING_SOCKETS
    if (SocketEvent)
      ServeSocket();
#endif

    for(pri = 0; pri < NUM_PRIORITY_LEVELS; ++pri)
    {
#ifdef DEBUG
  {
    tTask *task = QFP[pri];
    fprintf(stderr,"Task Queue %d contains:",pri);
    if (task == NoTask) fprintf(stderr,"No Tasks");
    else while(task != NoTask) { fprintf(stderr,"%d ",task->TaskId); task = task->Next; }
    fprintf(stderr,"\n");
  }
#endif

      if ((CURTASK=QFP[pri]) != NoTask)
      {
	/*{{{  #ifdef SHOWTASKING*/
	#ifdef SHOWTASKING
		fprintf(stderr,"Scheduler - Current task is %c%d (%s) IP=%d\n",(CURTASK->TaskPriority)?'L':'H',CURTASK->TaskId,((tHeader *)CURTASK->FP)->ProcName,((tHeader *)CURTASK->FP)->IP); fflush(stderr); 
	#endif
	/*}}}*/
	/*{{{  #ifndef NO_DEBUG*/
	#ifndef NO_DEBUG
	MARK_SCHEDULE() ;
	#endif
	/*}}}*/
	CURTASK->Func (CURTASK->FP);
	break;
      }
    }

    /*{{{  catch any signals*/
    #if (defined USESIGTIMER && defined USE_NONBLOCKING_SOCKETS)
	if (CURTASK == NoTask && (QTM != NoTask || io_task != NoTask))
	  while(!TimerEvent && !SocketEvent)
	    pause();
    #else
      #if (defined USESIGTIMER)
	  if (CURTASK == NoTask && QTM != NoTask)
	    while(!TimerEvent)
	      pause();
      #endif
      
      #if (defined USE_NONBLOCKING_SOCKETS)
	  if (CURTASK == NoTask && io_task != NoTask)
	    while(!SocketEvent)
	      pause();
      #endif
    #endif
    /*}}}*/

  }

#ifdef DEBUG
  fprintf(stderr,"Scheduling Queue empty\n");
#endif
}

/*}}}*/
/*{{{  void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)
{
  static int NextTaskId = 0;
  process_count++;
  
  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = (CURTASK != NoTask && CURTASK->TaskPriority == HighPriority) ? HighPriority : Priority;
  ((tHeader *)FP)->ProcName = name;
  
  if (Priority < 0 || Priority >= NUM_PRIORITY_LEVELS) SETERR(MSG_PRI);
  
  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Processor)
{
  static int NextTaskId = 0;
  process_count++;

  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = LowPriority;

  ((tHeader *)FP)->ProcName = name;

  SETERR("PLACED PAR is not supported in this implementation");

  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void End_Process()*/
void End_Process()
{
  register tTask *task = CURTASK;
  process_count--;
    
  QFP[task->TaskPriority] = task->Next;
  if (QFP[task->TaskPriority] == NoTask) QBP[task->TaskPriority] = NoTask;
  task->Next = NoTask;
  if (task->Parent)
  {
    if (--(task->Parent->Children) == 0) ReSchedule(task->Parent);
  }
}
/*}}}*/

/*{{{  SPOC iserver definitions*/
#ifdef USE_SPOC_ISERVER
extern int CocoPops;
#include "spserver.hdr"

struct SF_P_spoc_iserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_iserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_iserver_spserver spserver;
} tSF_P_spoc_iserver_caller;

static tSF_P_spoc_iserver_caller spoc_iserver_data;
static tTask spoc_iserver_task;

static tFuncPtr P_spoc_iserver_caller (tSF_P_spoc_iserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_iserver_spserver,&FP->spserver,1,"P_spoc_iserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/
/*{{{  SPOC aserver definitions*/
#ifdef USE_SPOC_ASERVER
#include "spserver.hdr"

struct SF_P_spoc_aserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_aserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_aserver_spserver spserver;
} tSF_P_spoc_aserver_caller;

static tSF_P_spoc_aserver_caller spoc_aserver_data;
static tTask spoc_aserver_task;

static tFuncPtr P_spoc_aserver_caller (tSF_P_spoc_aserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_aserver_spserver,&FP->spserver,1,"P_spoc_aserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/

/*{{{  int main(int argc, char **argv)*/
int main(int argc, char **argv)
{
  void *FP=NULL;
  tSF_ *MAINFP=(tSF_ *)malloc(sizeof(tSF_));
  tTask main_t;
  INT mem_size = (argc>1 && atoi(argv[1])>0)?atoi(argv[1]):DEFAULT_MEMSIZE_IN_INTS;
  INT *mem=(INT*)malloc(mem_size*sizeof(INT));
  CHAN fs,ts;
  
  if (MAINFP==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s bytes for occam workspace failed\n",sizeof(tSF_));
    exit(-1);
  }
  if (mem_size>0 && mem==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s INTs for occam memory array failed\n",mem_size);
    exit(-1);
  }
  (void) clock();
  MAIN_ARGC = argc ;
  MAIN_ARGV = argv ;
  process_count = 0;
 
  CheckPrimitiveSizes();
  INITCH(&fs);
  INITCH(&ts);
  Init_Scheduler();
  
  STARTP(&main_t,,MAINFP,"",LowPriority);

  /*{{{  #ifdef USE_SPOC_ISERVER*/
  #ifdef USE_SPOC_ISERVER
  #ifdef SHOWTASKING
  CocoPops=true;
  #endif
  spoc_iserver_data.fs = &fs;
  spoc_iserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_iserver_task, P_spoc_iserver_caller, &spoc_iserver_data, "P_spoc_iserver_spserver",LowPriority);
  #endif
  /*}}}*/
  /*{{{  #ifdef USE_SPOC_ASERVER*/
  #ifdef USE_SPOC_ASERVER
  spoc_aserver_data.fs = &fs;
  spoc_aserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_aserver_task, P_spoc_aserver_caller, &spoc_aserver_data, "P_spoc_aserver_spserver",LowPriority);
  #endif
  /*}}}*/
/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_init(argc,argv);
#endif
/*}}}*/
  
  Scheduler();

/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_finish(0);
#endif
/*}}}*/
  if (process_count == 0)
    return 0;
  else
  {
    fprintf(stderr,"Deadlock: %d stopped process%s.\n", process_count,(process_count>1)?"es":"");
    return 1;
  }
}     
/*}}}*/
#endif

#ifndef GENPROTO
/*{{{  Insert DEBUG*/

/*}}}*/
/*{{{  Insert CODE*/
static void P_172 (tSF_P_172 *FP)
#line   51 "ovbuffer.occ"
{
#line   51 "ovbuffer.occ"
  while(true)
#line   51 "ovbuffer.occ"
  {
#line   51 "ovbuffer.occ"
    switch(FP->_Header.IP)
#line   51 "ovbuffer.occ"
    {
#line   51 "ovbuffer.occ"
      CASE(0):  
#line   58 "ovbuffer.occ"
        FP->running_167 = true; 
#line   59 "ovbuffer.occ"
        FP->replies_outstanding_168 = 0; 
#line   61 "ovbuffer.occ"
        GOTO(1);
#line   61 "ovbuffer.occ"
      CASE(2):  
#line   62 "ovbuffer.occ"
        ALT();
#line   63 "ovbuffer.occ"
        ENBC(true,FP->Chain->done_one_reply_164);
#line   63 "ovbuffer.occ"
        ENBC(true,FP->Chain->from_user_158);
#line   63 "ovbuffer.occ"
        ENBC(true,FP->Chain->stopper_160);
#line   63 "ovbuffer.occ"
        ALTWT(3);
#line   63 "ovbuffer.occ"
      CASE(3):  
#line   63 "ovbuffer.occ"
        {
#line   63 "ovbuffer.occ"
          BOOL TMP = false;
#line   63 "ovbuffer.occ"
          TMP |= DISC(4,true,FP->Chain->done_one_reply_164);
#line   63 "ovbuffer.occ"
          TMP |= DISC(5,true,FP->Chain->from_user_158);
#line   63 "ovbuffer.occ"
          TMP |= DISC(6,true,FP->Chain->stopper_160);
#line   63 "ovbuffer.occ"
        }
#line   63 "ovbuffer.occ"
        ALTEND();
#line   63 "ovbuffer.occ"
      CASE(4):  
#line   63 "ovbuffer.occ"
        INPUT4(FP->Chain->done_one_reply_164,&FP->_U0._S0.any_169,8);
#line   63 "ovbuffer.occ"
      CASE(8):  
#line   65 "ovbuffer.occ"
        FP->replies_outstanding_168 = (FP->replies_outstanding_168 - 1); 
#line   65 "ovbuffer.occ"
        GOTO(7);
#line   65 "ovbuffer.occ"
      CASE(5):  
#line   65 "ovbuffer.occ"
        INPUT2(FP->Chain->from_user_158,&FP->len_166,9);
#line   65 "ovbuffer.occ"
      CASE(9):  
#line   65 "ovbuffer.occ"
        CHK(FP->len_166<=510,MSG_CITL);
#line   65 "ovbuffer.occ"
        INPUT(FP->Chain->from_user_158,FP->buffer_165,(FP->len_166)*(sizeof(BYTE)),10);
#line   65 "ovbuffer.occ"
      CASE(10):  
#line   69 "ovbuffer.occ"
        OUTPUT2(FP->Chain->ts_157,&FP->len_166,11);
#line   69 "ovbuffer.occ"
      CASE(11):  
#line   69 "ovbuffer.occ"
        OUTPUT(FP->Chain->ts_157,FP->buffer_165,(FP->len_166)*(sizeof(BYTE)),12);
#line   69 "ovbuffer.occ"
      CASE(12):  
#line   70 "ovbuffer.occ"
        FP->replies_outstanding_168 = (FP->replies_outstanding_168 + 1); 
#line   70 "ovbuffer.occ"
        GOTO(7);
#line   70 "ovbuffer.occ"
      CASE(6):  
#line   70 "ovbuffer.occ"
        INPUT1(FP->Chain->stopper_160,&FP->running_167,13);
#line   70 "ovbuffer.occ"
      CASE(13):  
#line   73 "ovbuffer.occ"
        FP->running_167 = false; 
#line   73 "ovbuffer.occ"
        GOTO(7);
#line   73 "ovbuffer.occ"
      CASE(7):  
#line   61 "ovbuffer.occ"
      CASE(1):  
#line   61 "ovbuffer.occ"
        if (FP->running_167)
#line   61 "ovbuffer.occ"
        {
#line   61 "ovbuffer.occ"
          GOTO(2);
#line   61 "ovbuffer.occ"
        }
#line   76 "ovbuffer.occ"
        FP->_U0._S1.i_170 = 0;
#line   76 "ovbuffer.occ"
        FP->_U0._S1.i_170_End = FP->_U0._S1.i_170 + FP->replies_outstanding_168;
#line   76 "ovbuffer.occ"
        GOTO(14);
#line   76 "ovbuffer.occ"
      CASE(15):  
#line   78 "ovbuffer.occ"
        INPUT4(FP->Chain->done_one_reply_164,&FP->_U0._S1.any_171,16);
#line   78 "ovbuffer.occ"
      CASE(16):  
#line   76 "ovbuffer.occ"
        FP->_U0._S1.i_170++;
#line   76 "ovbuffer.occ"
      CASE(14):  
#line   76 "ovbuffer.occ"
        if (FP->_U0._S1.i_170 != FP->_U0._S1.i_170_End) GOTO(15);
#line   80 "ovbuffer.occ"
        FP->_Header.Temp.VINT = 0;
#line   80 "ovbuffer.occ"
        OUTPUT4(FP->Chain->stop_replies_162,&FP->_Header.Temp.VINT,17);
#line   80 "ovbuffer.occ"
      CASE(17):  
#line   80 "ovbuffer.occ"
        ENDP();
#line   80 "ovbuffer.occ"
      default: SETERR(MSG_IP);
#line   80 "ovbuffer.occ"
    }
#line   80 "ovbuffer.occ"
  }
#line   80 "ovbuffer.occ"
}

#line   92 "ovbuffer.occ"
static void P_176 (tSF_P_176 *FP)
#line   92 "ovbuffer.occ"
{
#line   92 "ovbuffer.occ"
  while(true)
#line   92 "ovbuffer.occ"
  {
#line   92 "ovbuffer.occ"
    switch(FP->_Header.IP)
#line   92 "ovbuffer.occ"
    {
#line   92 "ovbuffer.occ"
      CASE(0):  
#line   93 "ovbuffer.occ"
        OUTPUT2(FP->Chain->Chain->to_user_159,&FP->Chain->len_174,1);
#line   93 "ovbuffer.occ"
      CASE(1):  
#line   93 "ovbuffer.occ"
        OUTPUT(FP->Chain->Chain->to_user_159,FP->Chain->buffer_173,(FP->Chain->len_174)*(sizeof(BYTE)),2);
#line   93 "ovbuffer.occ"
      CASE(2):  
#line   93 "ovbuffer.occ"
        ENDP();
#line   93 "ovbuffer.occ"
      default: SETERR(MSG_IP);
#line   93 "ovbuffer.occ"
    }
#line   93 "ovbuffer.occ"
  }
#line   93 "ovbuffer.occ"
}

#line   92 "ovbuffer.occ"
static void P_177 (tSF_P_177 *FP)
#line   92 "ovbuffer.occ"
{
#line   92 "ovbuffer.occ"
  while(true)
#line   92 "ovbuffer.occ"
  {
#line   92 "ovbuffer.occ"
    switch(FP->_Header.IP)
#line   92 "ovbuffer.occ"
    {
#line   92 "ovbuffer.occ"
      CASE(0):  
#line   94 "ovbuffer.occ"
        FP->_Header.Temp.VINT = 0;
#line   94 "ovbuffer.occ"
        OUTPUT4(FP->Chain->Chain->done_one_reply_164,&FP->_Header.Temp.VINT,1);
#line   94 "ovbuffer.occ"
      CASE(1):  
#line   94 "ovbuffer.occ"
        ENDP();
#line   94 "ovbuffer.occ"
      default: SETERR(MSG_IP);
#line   94 "ovbuffer.occ"
    }
#line   94 "ovbuffer.occ"
  }
#line   94 "ovbuffer.occ"
}

#line   51 "ovbuffer.occ"
static void P_179 (tSF_P_179 *FP)
#line   51 "ovbuffer.occ"
{
#line   51 "ovbuffer.occ"
  while(true)
#line   51 "ovbuffer.occ"
  {
#line   51 "ovbuffer.occ"
    switch(FP->_Header.IP)
#line   51 "ovbuffer.occ"
    {
#line   51 "ovbuffer.occ"
      CASE(0):  
#line   87 "ovbuffer.occ"
        FP->running_175 = true; 
#line   89 "ovbuffer.occ"
        GOTO(1);
#line   89 "ovbuffer.occ"
      CASE(2):  
#line   90 "ovbuffer.occ"
        ALT();
#line   90 "ovbuffer.occ"
        ENBC(true,FP->Chain->fs_156);
#line   96 "ovbuffer.occ"
        ENBC(true,FP->Chain->stop_replies_162);
#line   96 "ovbuffer.occ"
        ALTWT(3);
#line   96 "ovbuffer.occ"
      CASE(3):  
#line   96 "ovbuffer.occ"
        {
#line   96 "ovbuffer.occ"
          BOOL TMP = false;
#line   96 "ovbuffer.occ"
          TMP |= DISC(4,true,FP->Chain->fs_156);
#line   96 "ovbuffer.occ"
          TMP |= DISC(5,true,FP->Chain->stop_replies_162);
#line   96 "ovbuffer.occ"
        }
#line   96 "ovbuffer.occ"
        ALTEND();
#line   96 "ovbuffer.occ"
      CASE(4):  
#line   96 "ovbuffer.occ"
        INPUT2(FP->Chain->fs_156,&FP->len_174,7);
#line   96 "ovbuffer.occ"
      CASE(7):  
#line   96 "ovbuffer.occ"
        CHK(FP->len_174<=510,MSG_CITL);
#line   96 "ovbuffer.occ"
        INPUT(FP->Chain->fs_156,FP->buffer_173,(FP->len_174)*(sizeof(BYTE)),8);
#line   96 "ovbuffer.occ"
      CASE(8):  
#line   92 "ovbuffer.occ"
        STARTP(&FP->_U1._S2._T1,P_176,&FP->_U1._S2._C1,"P_176",1);
#line   92 "ovbuffer.occ"
        STARTP(&FP->_U1._S2._T2,P_177,&FP->_U1._S2._C2,"P_177",1);
#line   92 "ovbuffer.occ"
        WAITP(9);
#line   92 "ovbuffer.occ"
      CASE(9):  
#line   92 "ovbuffer.occ"
        GOTO(6);
#line   92 "ovbuffer.occ"
      CASE(5):  
#line   96 "ovbuffer.occ"
        INPUT4(FP->Chain->stop_replies_162,&FP->_U1._S3.any_178,10);
#line   96 "ovbuffer.occ"
      CASE(10):  
#line   98 "ovbuffer.occ"
        FP->running_175 = false; 
#line   98 "ovbuffer.occ"
        GOTO(6);
#line   98 "ovbuffer.occ"
      CASE(6):  
#line   89 "ovbuffer.occ"
      CASE(1):  
#line   89 "ovbuffer.occ"
        if (FP->running_175)
#line   89 "ovbuffer.occ"
        {
#line   89 "ovbuffer.occ"
          GOTO(2);
#line   89 "ovbuffer.occ"
        }
#line   89 "ovbuffer.occ"
        ENDP();
#line   89 "ovbuffer.occ"
      default: SETERR(MSG_IP);
#line   89 "ovbuffer.occ"
    }
#line   89 "ovbuffer.occ"
  }
#line   89 "ovbuffer.occ"
}

#line    5 "ovbuffer.occ"
void P_sp_overlapped_buffer_ovbuffer (tSF_P_sp_overlapped_buffer_ovbuffer *FP)
#line    5 "ovbuffer.occ"
{
#line    5 "ovbuffer.occ"
  while(true)
#line    5 "ovbuffer.occ"
  {
#line    5 "ovbuffer.occ"
    switch(FP->_Header.IP)
#line    5 "ovbuffer.occ"
    {
#line    5 "ovbuffer.occ"
      CASE(0):  
#line   50 "ovbuffer.occ"
        FP->stop_replies_162 = &FP->stop_replies_162_CHAN;
#line   50 "ovbuffer.occ"
        INITCH(FP->stop_replies_162);
#line   50 "ovbuffer.occ"
        FP->done_one_reply_164 = &FP->done_one_reply_164_CHAN;
#line   50 "ovbuffer.occ"
        INITCH(FP->done_one_reply_164);
#line   51 "ovbuffer.occ"
        STARTP(&FP->_T0,P_172,&FP->_C0,"P_172",1);
#line   51 "ovbuffer.occ"
        STARTP(&FP->_T3,P_179,&FP->_C3,"P_179",1);
#line   51 "ovbuffer.occ"
        WAITP(1);
#line   51 "ovbuffer.occ"
      CASE(1):  
#line   51 "ovbuffer.occ"
        RETURN();
#line   51 "ovbuffer.occ"
      default: SETERR(MSG_IP);
#line   51 "ovbuffer.occ"
    }
#line   51 "ovbuffer.occ"
  }
#line   51 "ovbuffer.occ"
}

#line  104 "ovbuffer.occ"
void P_so_overlapped_buffer_ovbuffer (tSF_P_so_overlapped_buffer_ovbuffer *FP)
#line  104 "ovbuffer.occ"
{
#line  104 "ovbuffer.occ"
  while(true)
#line  104 "ovbuffer.occ"
  {
#line  104 "ovbuffer.occ"
    switch(FP->_Header.IP)
#line  104 "ovbuffer.occ"
    {
#line  104 "ovbuffer.occ"
      CASE(0):  
#line  107 "ovbuffer.occ"
        FP->_C0.fs_156=FP->fs_181;
#line  107 "ovbuffer.occ"
        FP->_C0.ts_157=FP->ts_182;
#line  107 "ovbuffer.occ"
        FP->_C0.from_user_158=FP->from_user_183;
#line  107 "ovbuffer.occ"
        FP->_C0.to_user_159=FP->to_user_184;
#line  107 "ovbuffer.occ"
        FP->_C0.stopper_160=FP->stopper_185;
#line  107 "ovbuffer.occ"
        FP->_C0.Chain = NULL;
#line  107 "ovbuffer.occ"
        CALL(P_sp_overlapped_buffer_ovbuffer,&FP->_C0,1,"P_sp_overlapped_buffer_ovbuffer");
#line  107 "ovbuffer.occ"
      CASE(1):  
#line  107 "ovbuffer.occ"
        RETURN();
#line  107 "ovbuffer.occ"
      default: SETERR(MSG_IP);
#line  107 "ovbuffer.occ"
    }
#line  107 "ovbuffer.occ"
  }
#line  107 "ovbuffer.occ"
}


/*}}}*/
#endif
