/*{{{  File banner*/
/*@(#)=====================================================*\
||@(#)  Project : GPMIMD ESPRIT P5404
||@(#)  Authors : Mark Debbage, Mark Hill, Denis Nicole and Sean Wykes
||@(#)            University of Southampton
||  
||@(#)    Title : Prototype Source File for generated C
||@(#)   System : Occam 2 C
||@(#)  Version : 1.3
||@(#) Filename : Occam2C.c
||@(#)     Date : 3/4/97
\*@(#)====================================================*/
/*}}}*/

/*{{{  Insert SWITCHES*/
#define LIBRARY_UNIT
#define BYTES_PER_WORD 4
#define TERMINATE_ON_ERROR
#define CHECK_CONVERSIONS
#define CHECK_ARRAYS
#define CHECK_RANGES
#define NO_DEBUG
#define FASTGOTOS
#define SOURCE LITTLE

/*}}}*/
/*{{{  defines*/
#define DEFAULT_MEMSIZE_IN_INTS 1000
#define OCCAM_MAIN

/*}}}*/
/*{{{  includes*/
#include <stdio.h>
#include <errno.h>

#if  (defined USESIGTIMER) || (defined USE_NONBLOCKING_SOCKETS)
#include <signal.h>
#include <sys/time.h>
#endif

#ifdef USE_NONBLOCKING_SOCKETS
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef solaris
#include <stropts.h>
#include <sys/file.h>
#include <sys/conf.h>
#endif
#endif

#ifdef CALL_NAG_F90
#include <f90.h>
#endif

#include "Occam2C.h"

#ifdef USE_NONBLOCKING_SOCKETS
  #ifdef solaris
  #define SOCKET_SIGNAL SIGPOLL
  #else
  #define SOCKET_SIGNAL SIGIO
  #endif
#endif
/*}}}*/
/*{{{  Insert HEADER*/
#include "splib.hdr"
struct SF_P_sp_commandline_command
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  BYTE Param2;
  INT *Param3;
  BYTE *Param4;
  INT Param4_Dim0;
  BYTE *Param5;
  char WS[WS_P_sp_commandline_command];
};
struct SF_P_sp_version_version
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  BYTE *Param2;
  BYTE *Param3;
  BYTE *Param4;
  BYTE *Param5;
  BYTE *Param6;
  char WS[WS_P_sp_version_version];
};
typedef struct SF_P_app_text_359 tSF_P_app_text_359;
typedef struct SF_P_set_error_360 tSF_P_set_error_360;
typedef struct SF_P_get_next_string_386 tSF_P_get_next_string_386;
typedef struct SF_P_so_parse_command_line_parse tSF_P_so_parse_command_line_parse;
void P_so_parse_command_line_parse (tSF_P_so_parse_command_line_parse *FP);
struct SF_P_app_text_359
{
  tHeader _Header;
  tSF_P_set_error_360 *Chain;
};
struct SF_P_set_error_360
{
  tHeader _Header;
  tSF_P_so_parse_command_line_parse *Chain;
  union
  {
    INT _P_dummy;
  } _U0;
};
struct SF_P_get_next_string_386
{
  tHeader _Header;
  tSF_P_so_parse_command_line_parse *Chain;
};
struct SF_P_so_parse_command_line_parse
{
  tHeader _Header;
  void *Chain;
  CHAN *fs_340;
  CHAN *ts_341;
  BYTE *option_strings_342;
  INT option_strings_342_Dim1;
  INT option_strings_342_Dim0;
  INT *option_parameters_required_343;
  INT option_parameters_required_343_Dim0;
  BOOL *option_exists_344;
  INT option_exists_344_Dim0;
  INT *option_parameters_345;
  INT option_parameters_345_Dim0;
  INT *error_len_346;
  BYTE *line_347;
  INT line_347_Dim0;
  BYTE *command_line_error_msg_351;
  BYTE esc_char_361;
  INT line_length_362;
  BOOL first_row_is_blank_363;
  union
  {
    struct
    {
      BYTE os_369;
      BYTE version_370;
      BYTE host_371;
      BYTE board_372;
      BYTE result_373;
      tSF_P_sp_version_version _C4;
    } _S0;
    struct
    {
      BYTE result_374;
      union
      {
        tSF_P_sp_commandline_command _C5;
      } _U2;
    } _S1;
    struct
    {
      INT ptr_377;
      union
      {
        INT _P_dummy;
      } _U3;
    } _S2;
  } _U1;
};

/*}}}*/

#if (defined GENPROTO) || !(defined LIBRARY_UNIT)
/*{{{  statics*/
jmp_buf STOPP_env;
int MAIN_ARGC ;
char **MAIN_ARGV;
tTask *QFP[NUM_PRIORITY_LEVELS],*QBP[NUM_PRIORITY_LEVELS],*CURTASK,*QTM; 
static volatile int TimerEvent = false;
static volatile int SocketEvent = false;
tTimer TIMER;
static int process_count;


/*}}}*/
#endif

#ifdef GENPROTO
/*{{{  seterr*/
void seterr(char *M,int L,char *F) {}
/*}}}*/
/*{{{  struct Prototypes*/
struct Prototypes
{
  char *Proto;
  char *Define;
  int Space;
};
/*}}}*/
/*{{{  static struct Prototypes Table[] =*/
static struct Prototypes Table[] =
{
  {"void P_so_parse_command_line_parse (tSF_P_so_parse_command_line_parse *FP);","P_so_parse_command_line_parse",sizeof(tSF_P_so_parse_command_line_parse)},

 {NULL,NULL,0}
} ;
/*}}}*/
/*{{{  int main(int argc, char**argv)*/
int main(int argc, char**argv)
{
  char *name;
  FILE *f;
  int fcnt;
  
  CheckPrimitiveSizes();

  if (argc<2)
  {
    name="parse.hdr";
    f=fopen(name,"w");
  }
  else
  {
    name = argv[argc-1];
    if (name[0]=='-')
    {
      name = "stdout";
      f=stdout;
    }
    else
    {
      f=fopen(name,"w");
    }
  }
  fcnt=argc-1;
  
  if (f==NULL)
    { fprintf(stderr,"Error - could not open file %s\n",name);exit(-1); }
  else
  {
    int arg;
    int i;
    fprintf(f,"#ifndef __parse_INCLUDES__\n");
    fprintf(f,"#define __parse_INCLUDES__\n");
    
    for(arg = 1; arg < fcnt; ++arg)
    {
      FILE *fh = fopen(argv[arg],"r");
      if (fh == NULL) { fprintf(stderr,"Error - could not read file %s\n",name); exit(-1); }
      while(!feof(fh))
      {
	char line[256];

	if (fgets(line,256,fh) == NULL) break;
	if (line[0] == '#')
	  if (strncmp(line,"#define WS",10)!=0) continue;
	fputs(line,f);
      }
      fclose(fh);
    }      
      
    i = 0;
    while (Table[i].Proto!=NULL)
    {
      if (Table[i].Define != NULL)
      {
	fprintf(f,"typedef struct SF_%s tSF_%s;\n",Table[i].Define,Table[i].Define);
	fprintf(f,"#define WS_%s (%d)\n",Table[i].Define,Table[i].Space);
      }
      fprintf(f,"%s\n",Table[i].Proto);
      i++;
    }
    fprintf(f,"#endif\n");

    if (f!=stdout) fclose(f);
  }
  return(0);
}     
/*}}}*/
#endif

#ifndef LIBRARY_UNIT
/*{{{  seterr*/
static void DONE_SETERR() {}

void seterr(char *M,int L,char *F)
{
  if (M!=NULL) fputs(M,stderr);
  fprintf(stderr,MSG_EFROL,L,F);
  DONE_SETERR();
  SETERR_PROCEED;
}
/*}}}*/
/*{{{  DEBUGDONE,MARK_SCHEDULE*/
#ifndef NO_DEBUG
void DEBUGDONE(void) {}
void MARK_SCHEDULE(void) {}
#endif

/*}}}*/
/*{{{  timer*/
#ifdef USESIGTIMER
static struct timeval tv_start;
/*{{{  static void TimerSignalHandler(int sig)*/
static void TimerSignalHandler(int sig)
{
  switch(sig)
  {
    case SIGALRM:
      {
	struct timeval tv;
	tTask *task;

	gettimeofday(&tv,NULL);
	TIMER = ((tv.tv_usec - tv_start.tv_usec)>>6) + (1000000>>6) * (tv.tv_sec - tv_start.tv_sec);
	if (QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
	  TimerEvent = true;
      }
      break;

    default:
      fprintf(stderr,"Error - Caught signal %d - Exiting\n",sig);
      fflush(stderr);
      exit(20);
  }
}
/*}}}*/
/*{{{  static void Init_Timer()*/
static void Init_Timer()
{
  struct itimerval itv;
#ifndef solaris
  struct sigaction sa;
#endif

  TIMER = 0;
  gettimeofday(&tv_start,NULL);
  TimerSignalHandler(SIGALRM);
  
#ifndef solaris
  memset((char*)&sa,0,sizeof(sa));
  sa.sa_handler = TimerSignalHandler;

#ifdef SA_RESTART
  sa.sa_flags = SA_RESTART;
#endif

  sigaction(SIGALRM,&sa,NULL);
#else
  sigset(SIGALRM,TimerSignalHandler);
#endif

  itv.it_interval.tv_usec = 1000;
  itv.it_interval.tv_sec = 0;
     
  itv.it_value.tv_usec = 1;
  itv.it_value.tv_sec = 0;

  if (setitimer(ITIMER_REAL,&itv,NULL)) 
    fprintf(stderr,"Error - setitimer failed\n");

  QTM = NoTask;
  TimerEvent = false;
}

/*}}}*/

#else
static void Init_Timer() { (void)clock(); TimerEvent = false; }
#endif
/*}}}*/
/*{{{  sockets*/
#ifdef USE_NONBLOCKING_SOCKETS
static int io_limit;
static struct timeval io_zerotime;

static int    io_socket;
static tTask *io_task = NoTask;

/*{{{  void SocketHandler (int sig)*/
void SocketHandler (int sig)
{
  switch (sig)
  {
    case SOCKET_SIGNAL:
    {
      #ifdef MD_DEBUG
      fprintf(stderr,"Caught signal %d\n",sig);
      #endif
      
      SocketEvent = true;
      
      #ifdef solaris
      signal (SOCKET_SIGNAL, SocketHandler);
      #endif
      
      break;
    }
    default:
      fprintf(stderr,"Error - Caught unexpected signal %d - exiting\n",sig);
      fflush(stderr);
      exit(20);
  }  
}
/*}}}*/
 
/*{{{  void WaitSocket (int socket)*/
void WaitSocket (int socket)
{
  fd_set io_set;

  io_socket = socket;

  FD_ZERO (&io_set);
  FD_SET  (socket,&io_set);
  
  errno = 0;
  while (select (io_limit, &io_set, NULL, NULL, &io_zerotime) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
  
  if (!FD_ISSET(socket,&io_set))
  {
    if (io_task == NoTask)
      io_task = CURTASK;
    else
    {
      fprintf(stderr, "Error - Implementation restriction, only one signaling socket\n");
      exit(-1);
    }
    DeSchedule(TSOCK_p);
  }
}
/*}}}*/

/*{{{  void EnableSocket (int socket)*/
void EnableSocket (int socket)
{
  errno = 0;
  
  #ifdef solaris
  if (ioctl(socket,I_SETSIG,S_RDNORM) < 0)
  {
    fprintf(stderr,"Error - could not set signal handler for socket (errno %d)\n",errno);
    exit(-1);
  }
  #else
  if (fcntl(socket, F_SETOWN, getpid()) < 0)
  {
    fprintf(stderr,"Error - could not set owner on socket (errno %d)\n",errno);
    exit(-1);
  }
  if (fcntl(socket, F_SETFL, FASYNC)    < 0)
  {
    fprintf(stderr,"Error - could not set asynchronous socket (errno %d)\n",errno);
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void DisableSocket (int socket)*/
void DisableSocket (int socket)
{
  #ifdef sun4
  if (fcntl(socket, F_SETFL, FSYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
  #ifdef linux
  if (fcntl(socket, F_SETFL, FASYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void ServeSocket (void)*/
void ServeSocket (void)
{
  fd_set io_set;
  int res;

  /* In the general case there's a timing hazard here since a new signal
     could arrive and we can lose it. Really need test-and-set or a
     semaphore. For hostio, however, there's only ever one outstanding 
     communication and this thread is serving it. Hence, no problem here. */

  SocketEvent = false; 

  FD_ZERO (&io_set);
  FD_SET  (io_socket,&io_set);
  
  errno = 0;
  while ((res = select (io_limit, &io_set, NULL, NULL, &io_zerotime)) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
      
  if (res == 0)
  {
    /*fprintf(stderr,"Could not locate socket signal source, ignoring select\n");*/
    return;
  }
  
  if (!FD_ISSET(io_socket,&io_set))
  {
    fprintf(stderr,"Error - socket is not ready\n");
    exit(-1);
  }

  if (io_task != NoTask)
  {
    ReSchedule(io_task);
    io_task = NoTask;
  }
}
/*}}}*/

/*{{{  void Init_Sockets()*/
void Init_Sockets()
{
  io_limit = ulimit (4,0);

  timerclear (&io_zerotime);

  signal (SOCKET_SIGNAL, SocketHandler);
  #ifdef linux
  {
    struct sigaction action;
    sigaction(SIGIO,NULL,&action);
    action.sa_flags = (action.sa_flags & (~SA_ONESHOT));
    sigaction(SIGIO,&action,NULL);
  }
  #endif
}
/*}}}*/
#else
void WaitSocket (int socket)
{ 
  fprintf(stderr, "Error - No SIGSOCKETS\n"); 
}
#endif
/*}}}*/

/*{{{  static void Init_Scheduler()*/
static void Init_Scheduler()
{
  int i;

  for(i = 0; i < NUM_PRIORITY_LEVELS; ++i)
    QFP[i] = QBP[i] = NoTask;

  CURTASK = NoTask;

  Init_Timer();

  #ifdef USE_NONBLOCKING_SOCKETS
  Init_Sockets();  
  #endif
}
/*}}}*/
/*{{{  static void Scheduler()*/
static void Scheduler()
{
  if (setjmp(STOPP_env)) DeSchedule(0);
  
  while(CURTASK != NoTask || TimerEvent || SocketEvent)
  {
    int pri;

#ifdef USESIGTIMER
    /*{{{  if (TimerEvent)*/
    if (TimerEvent)
    {
    #ifdef DEBUG
	fprintf(stderr,"Timer = %d\n",TIMER);
    #endif
      TimerEvent = false;
      while(QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
      {
    #ifdef DEBUG
	{  
	  tTask *task = QTM;
    
	  fprintf(stderr,"Timer Queue contains:");
	  if (task == NoTask) fprintf(stderr,"No Tasks");
	  else while(task != NoTask) { fprintf(stderr,"%d(%d) ",task->TaskId,task->comms.timer.time); task = task->Next; }
	  fprintf(stderr,"\n");
	}  
    #endif
	if (QTM->AltMode == Waiting_p) QTM->AltMode = TReady_p;
	ReSchedule(QTM);
      }
    }
    /*}}}*/
#endif

#ifdef USE_NONBLOCKING_SOCKETS
    if (SocketEvent)
      ServeSocket();
#endif

    for(pri = 0; pri < NUM_PRIORITY_LEVELS; ++pri)
    {
#ifdef DEBUG
  {
    tTask *task = QFP[pri];
    fprintf(stderr,"Task Queue %d contains:",pri);
    if (task == NoTask) fprintf(stderr,"No Tasks");
    else while(task != NoTask) { fprintf(stderr,"%d ",task->TaskId); task = task->Next; }
    fprintf(stderr,"\n");
  }
#endif

      if ((CURTASK=QFP[pri]) != NoTask)
      {
	/*{{{  #ifdef SHOWTASKING*/
	#ifdef SHOWTASKING
		fprintf(stderr,"Scheduler - Current task is %c%d (%s) IP=%d\n",(CURTASK->TaskPriority)?'L':'H',CURTASK->TaskId,((tHeader *)CURTASK->FP)->ProcName,((tHeader *)CURTASK->FP)->IP); fflush(stderr); 
	#endif
	/*}}}*/
	/*{{{  #ifndef NO_DEBUG*/
	#ifndef NO_DEBUG
	MARK_SCHEDULE() ;
	#endif
	/*}}}*/
	CURTASK->Func (CURTASK->FP);
	break;
      }
    }

    /*{{{  catch any signals*/
    #if (defined USESIGTIMER && defined USE_NONBLOCKING_SOCKETS)
	if (CURTASK == NoTask && (QTM != NoTask || io_task != NoTask))
	  while(!TimerEvent && !SocketEvent)
	    pause();
    #else
      #if (defined USESIGTIMER)
	  if (CURTASK == NoTask && QTM != NoTask)
	    while(!TimerEvent)
	      pause();
      #endif
      
      #if (defined USE_NONBLOCKING_SOCKETS)
	  if (CURTASK == NoTask && io_task != NoTask)
	    while(!SocketEvent)
	      pause();
      #endif
    #endif
    /*}}}*/

  }

#ifdef DEBUG
  fprintf(stderr,"Scheduling Queue empty\n");
#endif
}

/*}}}*/
/*{{{  void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)
{
  static int NextTaskId = 0;
  process_count++;
  
  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = (CURTASK != NoTask && CURTASK->TaskPriority == HighPriority) ? HighPriority : Priority;
  ((tHeader *)FP)->ProcName = name;
  
  if (Priority < 0 || Priority >= NUM_PRIORITY_LEVELS) SETERR(MSG_PRI);
  
  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Processor)
{
  static int NextTaskId = 0;
  process_count++;

  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = LowPriority;

  ((tHeader *)FP)->ProcName = name;

  SETERR("PLACED PAR is not supported in this implementation");

  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void End_Process()*/
void End_Process()
{
  register tTask *task = CURTASK;
  process_count--;
    
  QFP[task->TaskPriority] = task->Next;
  if (QFP[task->TaskPriority] == NoTask) QBP[task->TaskPriority] = NoTask;
  task->Next = NoTask;
  if (task->Parent)
  {
    if (--(task->Parent->Children) == 0) ReSchedule(task->Parent);
  }
}
/*}}}*/

/*{{{  SPOC iserver definitions*/
#ifdef USE_SPOC_ISERVER
extern int CocoPops;
#include "spserver.hdr"

struct SF_P_spoc_iserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_iserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_iserver_spserver spserver;
} tSF_P_spoc_iserver_caller;

static tSF_P_spoc_iserver_caller spoc_iserver_data;
static tTask spoc_iserver_task;

static tFuncPtr P_spoc_iserver_caller (tSF_P_spoc_iserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_iserver_spserver,&FP->spserver,1,"P_spoc_iserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/
/*{{{  SPOC aserver definitions*/
#ifdef USE_SPOC_ASERVER
#include "spserver.hdr"

struct SF_P_spoc_aserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_aserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_aserver_spserver spserver;
} tSF_P_spoc_aserver_caller;

static tSF_P_spoc_aserver_caller spoc_aserver_data;
static tTask spoc_aserver_task;

static tFuncPtr P_spoc_aserver_caller (tSF_P_spoc_aserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_aserver_spserver,&FP->spserver,1,"P_spoc_aserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/

/*{{{  int main(int argc, char **argv)*/
int main(int argc, char **argv)
{
  void *FP=NULL;
  tSF_ *MAINFP=(tSF_ *)malloc(sizeof(tSF_));
  tTask main_t;
  INT mem_size = (argc>1 && atoi(argv[1])>0)?atoi(argv[1]):DEFAULT_MEMSIZE_IN_INTS;
  INT *mem=(INT*)malloc(mem_size*sizeof(INT));
  CHAN fs,ts;
  
  if (MAINFP==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s bytes for occam workspace failed\n",sizeof(tSF_));
    exit(-1);
  }
  if (mem_size>0 && mem==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s INTs for occam memory array failed\n",mem_size);
    exit(-1);
  }
  (void) clock();
  MAIN_ARGC = argc ;
  MAIN_ARGV = argv ;
  process_count = 0;
 
  CheckPrimitiveSizes();
  INITCH(&fs);
  INITCH(&ts);
  Init_Scheduler();
  
  STARTP(&main_t,,MAINFP,"",LowPriority);

  /*{{{  #ifdef USE_SPOC_ISERVER*/
  #ifdef USE_SPOC_ISERVER
  #ifdef SHOWTASKING
  CocoPops=true;
  #endif
  spoc_iserver_data.fs = &fs;
  spoc_iserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_iserver_task, P_spoc_iserver_caller, &spoc_iserver_data, "P_spoc_iserver_spserver",LowPriority);
  #endif
  /*}}}*/
  /*{{{  #ifdef USE_SPOC_ASERVER*/
  #ifdef USE_SPOC_ASERVER
  spoc_aserver_data.fs = &fs;
  spoc_aserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_aserver_task, P_spoc_aserver_caller, &spoc_aserver_data, "P_spoc_aserver_spserver",LowPriority);
  #endif
  /*}}}*/
/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_init(argc,argv);
#endif
/*}}}*/
  
  Scheduler();

/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_finish(0);
#endif
/*}}}*/
  if (process_count == 0)
    return 0;
  else
  {
    fprintf(stderr,"Deadlock: %d stopped process%s.\n", process_count,(process_count>1)?"es":"");
    return 1;
  }
}     
/*}}}*/
#endif

#ifndef GENPROTO
/*{{{  Insert DEBUG*/

/*}}}*/
/*{{{  Insert CODE*/
static void P_app_text_359 (INT *len_355,INT str_356_Dim0,BYTE *str_356,INT text_357_Dim0,BYTE *text_357)
#line   60 "parse.occ"
{
#line   60 "parse.occ"
  tSF_P_app_text_359 SF;
#line   60 "parse.occ"
  tSF_P_app_text_359 *FP = &SF;
#line   64 "parse.occ"
  {
#line   64 "parse.occ"
    INT this_len_358;
#line   65 "parse.occ"
    {
#line   67 "parse.occ"
      if (((*len_355 + (text_357_Dim0)) > (str_356_Dim0)))
#line   67 "parse.occ"
      {
#line   68 "parse.occ"
        this_len_358 = ((str_356_Dim0) - *len_355); 
#line   68 "parse.occ"
      }
#line   68 "parse.occ"
      else
#line   69 "parse.occ"
      if (true)
#line   69 "parse.occ"
      {
#line   70 "parse.occ"
        this_len_358 = (text_357_Dim0); 
#line   70 "parse.occ"
      }
#line   70 "parse.occ"
      else
#line   70 "parse.occ"
      {
#line   70 "parse.occ"
        SETERR(MSG_IF);
#line   70 "parse.occ"
      }
#line   72 "parse.occ"
      CHK(this_len_358==this_len_358,MSG_ASM);
#line   72 "parse.occ"
      ASSIGN(((BYTE*)(((BYTE*)str_356)+((RNGCHKUB(*len_355,this_len_358,str_356_Dim0),RNGCHKLB(*len_355))*sizeof(BYTE)))),((BYTE*)(((BYTE*)text_357)+((RNGCHKUB(0,this_len_358,text_357_Dim0),0)*sizeof(BYTE)))),(this_len_358*sizeof(BYTE))); 
#line   73 "parse.occ"
      *len_355 = (*len_355 + this_len_358); 
#line   73 "parse.occ"
    }
#line   73 "parse.occ"
  }
#line   73 "parse.occ"
}

#line   58 "parse.occ"
static void P_set_error_360 (tSF_P_so_parse_command_line_parse *PP,INT error_msg_353_Dim0,BYTE *error_msg_353,INT extra_msg_354_Dim0,BYTE *extra_msg_354)
#line   58 "parse.occ"
{
#line   58 "parse.occ"
  tSF_P_set_error_360 SF;
#line   58 "parse.occ"
  tSF_P_set_error_360 *FP = &SF;
#line   58 "parse.occ"
  FP->Chain = PP;
#line   76 "parse.occ"
  {
#line   77 "parse.occ"
    P_app_text_359(FP->Chain->error_len_346,FP->Chain->line_347_Dim0,(BYTE*)FP->Chain->line_347,20,(BYTE*)FP->Chain->command_line_error_msg_351);
#line   78 "parse.occ"
    P_app_text_359(FP->Chain->error_len_346,FP->Chain->line_347_Dim0,(BYTE*)FP->Chain->line_347,error_msg_353_Dim0,(BYTE*)error_msg_353);
#line   79 "parse.occ"
    P_app_text_359(FP->Chain->error_len_346,FP->Chain->line_347_Dim0,(BYTE*)FP->Chain->line_347,extra_msg_354_Dim0,(BYTE*)extra_msg_354);
#line   79 "parse.occ"
  }
#line   79 "parse.occ"
}

#line  167 "parse.occ"
static void P_get_next_string_386 (tSF_P_so_parse_command_line_parse *PP,INT *len_381,BYTE *str_382)
#line  167 "parse.occ"
{
#line  167 "parse.occ"
  tSF_P_get_next_string_386 SF;
#line  167 "parse.occ"
  tSF_P_get_next_string_386 *FP = &SF;
#line  167 "parse.occ"
  FP->Chain = PP;
#line  168 "parse.occ"
  {
#line  168 "parse.occ"
    INT end_383;
#line  169 "parse.occ"
    {
#line  171 "parse.occ"
      {
#line  171 "parse.occ"
        INT i_384;
#line  171 "parse.occ"
        INT i_384_End;
#line  171 "parse.occ"
        i_384 = FP->Chain->_U1._S2.ptr_377;i_384_End = i_384 + (FP->Chain->line_length_362 - FP->Chain->_U1._S2.ptr_377);
#line  171 "parse.occ"
        for (; i_384 != i_384_End; i_384++)
#line  171 "parse.occ"
        {
#line  172 "parse.occ"
          {
#line  172 "parse.occ"
            BYTE char_385;
#line  172 "parse.occ"
            char_385 = (BYTE)*((BYTE*)(((BYTE*)FP->Chain->line_347)+(RNGCHK(i_384,FP->Chain->line_347_Dim0)*sizeof(BYTE))));
#line  173 "parse.occ"
            if (((char_385 == 32) || (char_385 == FP->Chain->esc_char_361)))
#line  173 "parse.occ"
            {
#line  174 "parse.occ"
              end_383 = i_384; 
#line  174 "parse.occ"
            }
#line  174 "parse.occ"
            else
#line  174 "parse.occ"
            {
#line  174 "parse.occ"
              continue;
#line  174 "parse.occ"
            }
#line  174 "parse.occ"
          }
#line  174 "parse.occ"
          break;
#line  174 "parse.occ"
        }
#line  174 "parse.occ"
        if (i_384 == i_384_End) 
#line  175 "parse.occ"
        if (true)
#line  175 "parse.occ"
        {
#line  176 "parse.occ"
          end_383 = FP->Chain->line_length_362; 
#line  176 "parse.occ"
        }
#line  176 "parse.occ"
        else
#line  176 "parse.occ"
        {
#line  176 "parse.occ"
          SETERR(MSG_IF);
#line  176 "parse.occ"
        }
#line  176 "parse.occ"
      }
#line  177 "parse.occ"
      *len_381 = (end_383 - FP->Chain->_U1._S2.ptr_377); 
#line  179 "parse.occ"
      if ((*len_381 > 256))
#line  179 "parse.occ"
      {
#line  180 "parse.occ"
        *len_381 = 256; 
#line  180 "parse.occ"
      }
#line  180 "parse.occ"
      else
#line  181 "parse.occ"
      if (true)
#line  181 "parse.occ"
      {
#line  182 "parse.occ"
      }
#line  182 "parse.occ"
      else
#line  182 "parse.occ"
      {
#line  182 "parse.occ"
        SETERR(MSG_IF);
#line  182 "parse.occ"
      }
#line  183 "parse.occ"
      CHK(*len_381==*len_381,MSG_ASM);
#line  183 "parse.occ"
      ASSIGN(((BYTE*)(((BYTE*)str_382)+((RNGCHKUB(0,*len_381,256),0)*sizeof(BYTE)))),((BYTE*)(((BYTE*)FP->Chain->line_347)+((RNGCHKUB(FP->Chain->_U1._S2.ptr_377,*len_381,FP->Chain->line_347_Dim0),RNGCHKLB(FP->Chain->_U1._S2.ptr_377))*sizeof(BYTE)))),(*len_381*sizeof(BYTE))); 
#line  184 "parse.occ"
      FP->Chain->_U1._S2.ptr_377 = end_383; 
#line  184 "parse.occ"
    }
#line  184 "parse.occ"
  }
#line  184 "parse.occ"
}

#line    6 "parse.occ"
void P_so_parse_command_line_parse (tSF_P_so_parse_command_line_parse *FP)
#line    6 "parse.occ"
{
#line    6 "parse.occ"
  while(true)
#line    6 "parse.occ"
  {
#line    6 "parse.occ"
    switch(FP->_Header.IP)
#line    6 "parse.occ"
    {
#line    6 "parse.occ"
      CASE(0):  
#line   54 "parse.occ"
        {
#line   54 "parse.occ"
          static BYTE TMP[20] = {67,111,109,109,97,110,100,32,108,105,110,101,32,101,114,114,111,114,58,32};
#line   54 "parse.occ"
          FP->command_line_error_msg_351 = TMP;
#line   54 "parse.occ"
        }
#line   89 "parse.occ"
        *FP->error_len_346 = 0; 
#line   94 "parse.occ"
        if ((((((FP->option_strings_342_Dim0) == 0) || ((FP->option_strings_342_Dim0) != (FP->option_exists_344_Dim0))) || ((FP->option_strings_342_Dim0) != (FP->option_parameters_345_Dim0))) || ((FP->option_strings_342_Dim0) != (FP->option_parameters_required_343_Dim0))))
#line   94 "parse.occ"
        {
#line   96 "parse.occ"
          {
#line   96 "parse.occ"
            BYTE *_V0_364;
#line   96 "parse.occ"
            BYTE *_V1_365;
#line   96 "parse.occ"
            {
#line   96 "parse.occ"
              static BYTE TMP[18] = {99,97,108,108,101,100,32,105,110,99,111,114,114,101,99,116,108,121};
#line   96 "parse.occ"
              _V0_364 = TMP;
#line   96 "parse.occ"
            }
#line   96 "parse.occ"
            _V1_365 = NULL;
#line   96 "parse.occ"
            P_set_error_360(FP,18,(BYTE*)_V0_364,0,(BYTE*)_V1_365);
#line   96 "parse.occ"
          }
#line   96 "parse.occ"
        }
#line   96 "parse.occ"
        else
#line   97 "parse.occ"
        if (true)
#line   97 "parse.occ"
        {
#line   98 "parse.occ"
        }
#line   98 "parse.occ"
        else
#line   98 "parse.occ"
        {
#line   98 "parse.occ"
          SETERR(MSG_IF);
#line   98 "parse.occ"
        }
#line  102 "parse.occ"
        if ((*FP->error_len_346 == 0))
#line  102 "parse.occ"
        {
#line  103 "parse.occ"
          {
#line  104 "parse.occ"
            *((INT*)(((BYTE*)FP->option_parameters_345)+(1*sizeof(INT))+(0*(2*sizeof(INT))))) = 0; 
#line  105 "parse.occ"
            *((INT*)(((BYTE*)FP->option_parameters_345)+(0*sizeof(INT))+(0*(2*sizeof(INT))))) = 0; 
#line  106 "parse.occ"
            *((BOOL*)(((BYTE*)FP->option_exists_344)+(0*sizeof(BOOL)))) = false; 
#line  106 "parse.occ"
            {
#line  106 "parse.occ"
              INT i_366;
#line  106 "parse.occ"
              INT i_366_End;
#line  107 "parse.occ"
              i_366 = 1;i_366_End = i_366 + ((FP->option_parameters_345_Dim0) - 1);
#line  107 "parse.occ"
              for (; i_366 != i_366_End; i_366++)
#line  107 "parse.occ"
              {
#line  108 "parse.occ"
                {
#line  109 "parse.occ"
                  ASSIGN(((INT*)(((BYTE*)FP->option_parameters_345)+(RNGCHK(i_366,FP->option_parameters_345_Dim0)*(2*sizeof(INT))))),((INT*)(((BYTE*)FP->option_parameters_345)+(0*(2*sizeof(INT))))),(2*sizeof(INT))); 
#line  110 "parse.occ"
                  *((BOOL*)(((BYTE*)FP->option_exists_344)+(RNGCHK(i_366,FP->option_exists_344_Dim0)*sizeof(BOOL)))) = false; 
#line  110 "parse.occ"
                }
#line  110 "parse.occ"
              }
#line  107 "parse.occ"
            }
#line  112 "parse.occ"
            {
#line  112 "parse.occ"
              INT first_row_367_Dim1;
#line  112 "parse.occ"
              BYTE *first_row_367;
#line  112 "parse.occ"
              first_row_367 = (BYTE*)((BYTE*)(((BYTE*)FP->option_strings_342)+(0*(FP->option_strings_342_Dim1*sizeof(BYTE)))));
#line  112 "parse.occ"
              first_row_367_Dim1 = FP->option_strings_342_Dim1; 
#line  114 "parse.occ"
              {
#line  114 "parse.occ"
                INT i_368;
#line  114 "parse.occ"
                INT i_368_End;
#line  114 "parse.occ"
                i_368 = 0;i_368_End = i_368 + (first_row_367_Dim1);
#line  114 "parse.occ"
                for (; i_368 != i_368_End; i_368++)
#line  114 "parse.occ"
                {
#line  115 "parse.occ"
                  if ((*((BYTE*)(((BYTE*)first_row_367)+(RNGCHK(i_368,first_row_367_Dim1)*sizeof(BYTE)))) != 32))
#line  115 "parse.occ"
                  {
#line  116 "parse.occ"
                    FP->first_row_is_blank_363 = false; 
#line  116 "parse.occ"
                  }
#line  116 "parse.occ"
                  else
#line  116 "parse.occ"
                  {
#line  116 "parse.occ"
                    continue;
#line  116 "parse.occ"
                  }
#line  116 "parse.occ"
                  break;
#line  116 "parse.occ"
                }
#line  116 "parse.occ"
                if (i_368 == i_368_End) 
#line  117 "parse.occ"
                if (true)
#line  117 "parse.occ"
                {
#line  118 "parse.occ"
                  FP->first_row_is_blank_363 = true; 
#line  118 "parse.occ"
                }
#line  118 "parse.occ"
                else
#line  118 "parse.occ"
                {
#line  118 "parse.occ"
                  SETERR(MSG_IF);
#line  118 "parse.occ"
                }
#line  118 "parse.occ"
              }
#line  118 "parse.occ"
            }
#line  118 "parse.occ"
          }
#line  118 "parse.occ"
        }
#line  118 "parse.occ"
        else
#line  120 "parse.occ"
        if (true)
#line  120 "parse.occ"
        {
#line  121 "parse.occ"
        }
#line  121 "parse.occ"
        else
#line  121 "parse.occ"
        {
#line  121 "parse.occ"
          SETERR(MSG_IF);
#line  121 "parse.occ"
        }
#line  125 "parse.occ"
        if (!(*FP->error_len_346 == 0)) GOTO(2);
#line  129 "parse.occ"
        FP->_U1._S0._C4.Param0=FP->fs_340;
#line  129 "parse.occ"
        FP->_U1._S0._C4.Param1=FP->ts_341;
#line  129 "parse.occ"
        FP->_U1._S0._C4.Param2=&FP->_U1._S0.version_370;
#line  129 "parse.occ"
        FP->_U1._S0._C4.Param3=&FP->_U1._S0.host_371;
#line  129 "parse.occ"
        FP->_U1._S0._C4.Param4=&FP->_U1._S0.os_369;
#line  129 "parse.occ"
        FP->_U1._S0._C4.Param5=&FP->_U1._S0.board_372;
#line  129 "parse.occ"
        FP->_U1._S0._C4.Param6=&FP->_U1._S0.result_373;
#line  129 "parse.occ"
        FP->_U1._S0._C4.Chain = NULL;
#line  129 "parse.occ"
        CALL(P_sp_version_version,&FP->_U1._S0._C4,3,"P_sp_version_version");
#line  129 "parse.occ"
      CASE(3):  
#line  130 "parse.occ"
        switch(FP->_U1._S0.os_369)
#line  130 "parse.occ"
        {
#line  130 "parse.occ"
          case 1: case 3: 
#line  132 "parse.occ"
          FP->esc_char_361 = 47; 
#line  132 "parse.occ"
          break;
#line  132 "parse.occ"
          default: 
#line  134 "parse.occ"
          FP->esc_char_361 = 45; 
#line  134 "parse.occ"
          break;
#line  134 "parse.occ"
        }
#line  134 "parse.occ"
        GOTO(1);
#line  134 "parse.occ"
      CASE(2):  
#line  135 "parse.occ"
        if (!true) GOTO(4);
#line  136 "parse.occ"
        GOTO(1);
#line  136 "parse.occ"
      CASE(4):  
#line  136 "parse.occ"
        SETERR(MSG_IF);
#line  136 "parse.occ"
      CASE(1):  
#line  140 "parse.occ"
        if (!(*FP->error_len_346 == 0)) GOTO(6);
#line  143 "parse.occ"
        FP->_U1._S1._U2._C5.Param0=FP->fs_340;
#line  143 "parse.occ"
        FP->_U1._S1._U2._C5.Param1=FP->ts_341;
#line  143 "parse.occ"
        FP->_U1._S1._U2._C5.Param2=0;
#line  143 "parse.occ"
        FP->_U1._S1._U2._C5.Param3=&FP->line_length_362;
#line  143 "parse.occ"
        FP->_U1._S1._U2._C5.Param4_Dim0=FP->line_347_Dim0;
#line  143 "parse.occ"
        FP->_U1._S1._U2._C5.Param4= (BYTE*)FP->line_347;
#line  143 "parse.occ"
        FP->_U1._S1._U2._C5.Param5=&FP->_U1._S1.result_374;
#line  143 "parse.occ"
        FP->_U1._S1._U2._C5.Chain = NULL;
#line  143 "parse.occ"
        CALL(P_sp_commandline_command,&FP->_U1._S1._U2._C5,7,"P_sp_commandline_command");
#line  143 "parse.occ"
      CASE(7):  
#line  145 "parse.occ"
        if ((FP->_U1._S1.result_374 != 0))
#line  145 "parse.occ"
        {
#line  146 "parse.occ"
          {
#line  146 "parse.occ"
            BYTE *_V2_375;
#line  146 "parse.occ"
            BYTE *_V3_376;
#line  146 "parse.occ"
            {
#line  146 "parse.occ"
              static BYTE TMP[33] = {99,97,110,110,111,116,32,114,101,97,100,32,115,101,114,118,101,114,39,115,
#line  146 "parse.occ"
                 32,99,111,109,109,97,110,100,32,108,105,110,101};
#line  146 "parse.occ"
              _V2_375 = TMP;
#line  146 "parse.occ"
            }
#line  146 "parse.occ"
            _V3_376 = NULL;
#line  146 "parse.occ"
            P_set_error_360(FP,33,(BYTE*)_V2_375,0,(BYTE*)_V3_376);
#line  146 "parse.occ"
          }
#line  146 "parse.occ"
        }
#line  146 "parse.occ"
        else
#line  147 "parse.occ"
        if (true)
#line  147 "parse.occ"
        {
#line  148 "parse.occ"
        }
#line  148 "parse.occ"
        else
#line  148 "parse.occ"
        {
#line  148 "parse.occ"
          SETERR(MSG_IF);
#line  148 "parse.occ"
        }
#line  148 "parse.occ"
        GOTO(5);
#line  148 "parse.occ"
      CASE(6):  
#line  149 "parse.occ"
        if (!true) GOTO(8);
#line  150 "parse.occ"
        GOTO(5);
#line  150 "parse.occ"
      CASE(8):  
#line  150 "parse.occ"
        SETERR(MSG_IF);
#line  150 "parse.occ"
      CASE(5):  
#line  155 "parse.occ"
        {
#line  155 "parse.occ"
          BOOL waiting_for_parameter_378;
#line  156 "parse.occ"
          INT last_option_379;
#line  157 "parse.occ"
          BOOL found_filename_380;
#line  159 "parse.occ"
          {
#line  161 "parse.occ"
            waiting_for_parameter_378 = false; 
#line  162 "parse.occ"
            found_filename_380 = false; 
#line  163 "parse.occ"
            FP->_U1._S2.ptr_377 = 0; 
#line  165 "parse.occ"
            while (((*FP->error_len_346 == 0) && (FP->_U1._S2.ptr_377 < FP->line_length_362)))
#line  165 "parse.occ"
            {
#line  188 "parse.occ"
              {
#line  188 "parse.occ"
                BYTE str_387[256];
#line  189 "parse.occ"
                INT str_len_388;
#line  193 "parse.occ"
                if ((*((BYTE*)(((BYTE*)FP->line_347)+(RNGCHK(FP->_U1._S2.ptr_377,FP->line_347_Dim0)*sizeof(BYTE)))) == 32))
#line  193 "parse.occ"
                {
#line  194 "parse.occ"
                  FP->_U1._S2.ptr_377 = (FP->_U1._S2.ptr_377 + 1); 
#line  194 "parse.occ"
                }
#line  194 "parse.occ"
                else
#line  197 "parse.occ"
                if ((*((BYTE*)(((BYTE*)FP->line_347)+(RNGCHK(FP->_U1._S2.ptr_377,FP->line_347_Dim0)*sizeof(BYTE)))) == FP->esc_char_361))
#line  197 "parse.occ"
                {
#line  198 "parse.occ"
                  {
#line  199 "parse.occ"
                    FP->_U1._S2.ptr_377 = (FP->_U1._S2.ptr_377 + 1); 
#line  200 "parse.occ"
                    P_get_next_string_386(FP,&str_len_388,(BYTE*)str_387);
#line  202 "parse.occ"
                    if ((str_len_388 > 0))
#line  202 "parse.occ"
                    {
#line  203 "parse.occ"
                      {
#line  203 "parse.occ"
                        INT option_number_389;
#line  204 "parse.occ"
                        INT this_option_390_Dim0;/*SMW*/
#line  204 "parse.occ"
                        BYTE *this_option_390;
#line  204 "parse.occ"
                        this_option_390 = (BYTE*)((BYTE*)(((BYTE*)str_387)+((RNGCHKUB(0,str_len_388,256),0)*sizeof(BYTE))));
#line  204 "parse.occ"
                        this_option_390_Dim0 = str_len_388;
#line  205 "parse.occ"
                        {
#line  206 "parse.occ"
                          option_number_389 = -1; 
#line  208 "parse.occ"
                          {
#line  208 "parse.occ"
                            INT i_391;
#line  209 "parse.occ"
                            {
#line  211 "parse.occ"
                              if (FP->first_row_is_blank_363)
#line  211 "parse.occ"
                              {
#line  212 "parse.occ"
                                i_391 = 1; 
#line  212 "parse.occ"
                              }
#line  212 "parse.occ"
                              else
#line  213 "parse.occ"
                              if (true)
#line  213 "parse.occ"
                              {
#line  214 "parse.occ"
                                i_391 = 0; 
#line  214 "parse.occ"
                              }
#line  214 "parse.occ"
                              else
#line  214 "parse.occ"
                              {
#line  214 "parse.occ"
                                SETERR(MSG_IF);
#line  214 "parse.occ"
                              }
#line  215 "parse.occ"
                              while (((i_391 < (FP->option_strings_342_Dim0)) && (option_number_389 < 0)))
#line  215 "parse.occ"
                              {
#line  216 "parse.occ"
                                {
#line  217 "parse.occ"
                                  {
#line  217 "parse.occ"
                                    INT ith_option_392_Dim1;
#line  217 "parse.occ"
                                    BYTE *ith_option_392;
#line  218 "parse.occ"
                                    INT ith_option_len_393;
#line  217 "parse.occ"
                                    ith_option_392 = (BYTE*)((BYTE*)(((BYTE*)FP->option_strings_342)+(RNGCHK(i_391,FP->option_strings_342_Dim0)*(FP->option_strings_342_Dim1*sizeof(BYTE)))));
#line  217 "parse.occ"
                                    ith_option_392_Dim1 = FP->option_strings_342_Dim1; 
#line  219 "parse.occ"
                                    {
#line  222 "parse.occ"
                                      {
#line  222 "parse.occ"
                                        INT j_394;
#line  222 "parse.occ"
                                        INT j_394_End;
#line  222 "parse.occ"
                                        j_394 = 0;j_394_End = j_394 + (ith_option_392_Dim1);
#line  222 "parse.occ"
                                        for (; j_394 != j_394_End; j_394++)
#line  222 "parse.occ"
                                        {
#line  223 "parse.occ"
                                          if ((*((BYTE*)(((BYTE*)ith_option_392)+(RNGCHK(j_394,ith_option_392_Dim1)*sizeof(BYTE)))) == 32))
#line  223 "parse.occ"
                                          {
#line  224 "parse.occ"
                                            ith_option_len_393 = j_394; 
#line  224 "parse.occ"
                                          }
#line  224 "parse.occ"
                                          else
#line  224 "parse.occ"
                                          {
#line  224 "parse.occ"
                                            continue;
#line  224 "parse.occ"
                                          }
#line  224 "parse.occ"
                                          break;
#line  224 "parse.occ"
                                        }
#line  224 "parse.occ"
                                        if (j_394 == j_394_End) 
#line  225 "parse.occ"
                                        if (true)
#line  225 "parse.occ"
                                        {
#line  226 "parse.occ"
                                          ith_option_len_393 = (ith_option_392_Dim1); 
#line  226 "parse.occ"
                                        }
#line  226 "parse.occ"
                                        else
#line  226 "parse.occ"
                                        {
#line  226 "parse.occ"
                                          SETERR(MSG_IF);
#line  226 "parse.occ"
                                        }
#line  226 "parse.occ"
                                      }
#line  230 "parse.occ"
                                      if (((ith_option_len_393 > (this_option_390_Dim0)) || ((ith_option_len_393 < (this_option_390_Dim0)) && (*((INT*)(((BYTE*)FP->option_parameters_required_343)+(RNGCHK(i_391,FP->option_parameters_required_343_Dim0)*sizeof(INT)))) == 0))))
#line  230 "parse.occ"
                                      {
#line  233 "parse.occ"
                                      }
#line  233 "parse.occ"
                                      else
#line  236 "parse.occ"
                                      {
#line  236 "parse.occ"
                                        INT j_395;
#line  236 "parse.occ"
                                        INT j_395_End;
#line  236 "parse.occ"
                                        j_395 = 0;j_395_End = j_395 + ith_option_len_393;
#line  236 "parse.occ"
                                        for (; j_395 != j_395_End; j_395++)
#line  236 "parse.occ"
                                        {
#line  241 "parse.occ"
                                          {
#line  241 "parse.occ"
                                            BYTE c_396;
#line  241 "parse.occ"
                                            c_396 = (BYTE)*((BYTE*)(((BYTE*)this_option_390)+(RNGCHK(j_395,str_len_388)*sizeof(BYTE))));
#line  244 "parse.occ"
                                            if ((INTBYTE(*((BYTE*)(((BYTE*)ith_option_392)+(RNGCHK(j_395,ith_option_392_Dim1)*sizeof(BYTE))))) != (INTBYTE(c_396) + (-32 * INTBOOL(((c_396 >= 97) && (c_396 <= 122)))))))
#line  244 "parse.occ"
                                            {
#line  246 "parse.occ"
                                            }
#line  246 "parse.occ"
                                            else
#line  246 "parse.occ"
                                            {
#line  246 "parse.occ"
                                              continue;
#line  246 "parse.occ"
                                            }
#line  246 "parse.occ"
                                          }
#line  246 "parse.occ"
                                          break;
#line  246 "parse.occ"
                                        }
#line  246 "parse.occ"
                                        if (j_395 == j_395_End) 
#line  249 "parse.occ"
                                        if (true)
#line  249 "parse.occ"
                                        {
#line  250 "parse.occ"
                                          {
#line  251 "parse.occ"
                                            option_number_389 = i_391; 
#line  253 "parse.occ"
                                            FP->_U1._S2.ptr_377 = (FP->_U1._S2.ptr_377 - ((this_option_390_Dim0) - ith_option_len_393)); 
#line  253 "parse.occ"
                                          }
#line  253 "parse.occ"
                                        }
#line  253 "parse.occ"
                                        else
#line  253 "parse.occ"
                                        {
#line  253 "parse.occ"
                                          SETERR(MSG_IF);
#line  253 "parse.occ"
                                        }
#line  253 "parse.occ"
                                      }
#line  253 "parse.occ"
                                    }
#line  253 "parse.occ"
                                  }
#line  255 "parse.occ"
                                  i_391 = (i_391 + 1); 
#line  255 "parse.occ"
                                }
#line  215 "parse.occ"
                              }
#line  215 "parse.occ"
                            }
#line  215 "parse.occ"
                          }
#line  259 "parse.occ"
                          if ((*FP->error_len_346 != 0))
#line  259 "parse.occ"
                          {
#line  260 "parse.occ"
                          }
#line  260 "parse.occ"
                          else
#line  261 "parse.occ"
                          if ((option_number_389 == -1))
#line  261 "parse.occ"
                          {
#line  262 "parse.occ"
                            {
#line  262 "parse.occ"
                              BYTE *_V8_398;
#line  262 "parse.occ"
                              {
#line  262 "parse.occ"
                                static BYTE TMP[16] = {117,110,107,110,111,119,110,32,111,112,116,105,111,110,58,32};
#line  262 "parse.occ"
                                _V8_398 = TMP;
#line  262 "parse.occ"
                              }
#line  262 "parse.occ"
                              P_set_error_360(FP,16,(BYTE*)_V8_398,str_len_388,(BYTE*)this_option_390);
#line  262 "parse.occ"
                            }
#line  262 "parse.occ"
                          }
#line  262 "parse.occ"
                          else
#line  263 "parse.occ"
                          if ((( ! (*((INT*)(((BYTE*)FP->option_parameters_required_343)+(RNGCHK(option_number_389,FP->option_parameters_required_343_Dim0)*sizeof(INT)))) == 0)) && *((BOOL*)(((BYTE*)FP->option_exists_344)+(RNGCHK(option_number_389,FP->option_exists_344_Dim0)*sizeof(BOOL))))))
#line  263 "parse.occ"
                          {
#line  265 "parse.occ"
                            {
#line  265 "parse.occ"
                              BYTE *_V7_399;
#line  265 "parse.occ"
                              {
#line  265 "parse.occ"
                                static BYTE TMP[18] = {100,117,112,108,105,99,97,116,101,32,111,112,116,105,111,110,58,32};
#line  265 "parse.occ"
                                _V7_399 = TMP;
#line  265 "parse.occ"
                              }
#line  265 "parse.occ"
                              P_set_error_360(FP,18,(BYTE*)_V7_399,str_len_388,(BYTE*)this_option_390);
#line  265 "parse.occ"
                            }
#line  265 "parse.occ"
                          }
#line  265 "parse.occ"
                          else
#line  266 "parse.occ"
                          if (true)
#line  266 "parse.occ"
                          {
#line  267 "parse.occ"
                            {
#line  268 "parse.occ"
                              *((BOOL*)(((BYTE*)FP->option_exists_344)+(RNGCHK(option_number_389,FP->option_exists_344_Dim0)*sizeof(BOOL)))) = true; 
#line  269 "parse.occ"
                              last_option_379 = option_number_389; 
#line  270 "parse.occ"
                              waiting_for_parameter_378 = (*((INT*)(((BYTE*)FP->option_parameters_required_343)+(RNGCHK(option_number_389,FP->option_parameters_required_343_Dim0)*sizeof(INT)))) != 0); 
#line  270 "parse.occ"
                            }
#line  270 "parse.occ"
                          }
#line  270 "parse.occ"
                          else
#line  270 "parse.occ"
                          {
#line  270 "parse.occ"
                            SETERR(MSG_IF);
#line  270 "parse.occ"
                          }
#line  270 "parse.occ"
                        }
#line  270 "parse.occ"
                      }
#line  270 "parse.occ"
                    }
#line  270 "parse.occ"
                    else
#line  273 "parse.occ"
                    if (true)
#line  273 "parse.occ"
                    {
#line  274 "parse.occ"
                      {
#line  274 "parse.occ"
                        BYTE *_V5_400;
#line  274 "parse.occ"
                        BYTE _V6_401[1];
#line  274 "parse.occ"
                        {
#line  274 "parse.occ"
                          static BYTE TMP[29] = {101,115,99,97,112,101,32,99,104,97,114,97,99,116,101,114,32,111,110,32,
#line  274 "parse.occ"
                             105,116,115,32,111,119,110,58,32};
#line  274 "parse.occ"
                          _V5_400 = TMP;
#line  274 "parse.occ"
                        }
#line  274 "parse.occ"
                        _V6_401[0] = FP->esc_char_361;
#line  274 "parse.occ"
                        P_set_error_360(FP,29,(BYTE*)_V5_400,1,(BYTE*)_V6_401);
#line  274 "parse.occ"
                      }
#line  274 "parse.occ"
                    }
#line  274 "parse.occ"
                    else
#line  274 "parse.occ"
                    {
#line  274 "parse.occ"
                      SETERR(MSG_IF);
#line  274 "parse.occ"
                    }
#line  274 "parse.occ"
                  }
#line  274 "parse.occ"
                }
#line  274 "parse.occ"
                else
#line  277 "parse.occ"
                if (true)
#line  277 "parse.occ"
                {
#line  278 "parse.occ"
                  {
#line  278 "parse.occ"
                    INT start_ptr_402;
#line  279 "parse.occ"
                    {
#line  280 "parse.occ"
                      start_ptr_402 = FP->_U1._S2.ptr_377; 
#line  281 "parse.occ"
                      P_get_next_string_386(FP,&str_len_388,(BYTE*)str_387);
#line  286 "parse.occ"
                      if (( ! waiting_for_parameter_378))
#line  286 "parse.occ"
                      {
#line  288 "parse.occ"
                        if ((FP->first_row_is_blank_363 && ( ! found_filename_380)))
#line  288 "parse.occ"
                        {
#line  289 "parse.occ"
                          {
#line  290 "parse.occ"
                            last_option_379 = 0; 
#line  291 "parse.occ"
                            *((BOOL*)(((BYTE*)FP->option_exists_344)+(0*sizeof(BOOL)))) = true; 
#line  292 "parse.occ"
                            found_filename_380 = true; 
#line  292 "parse.occ"
                          }
#line  292 "parse.occ"
                        }
#line  292 "parse.occ"
                        else
#line  293 "parse.occ"
                        if (true)
#line  293 "parse.occ"
                        {
#line  294 "parse.occ"
                          {
#line  294 "parse.occ"
                            BYTE *_V4_403;
#line  294 "parse.occ"
                            {
#line  294 "parse.occ"
                              static BYTE TMP[20] = {110,111,32,111,112,116,105,111,110,32,115,117,112,112,108,105,101,100,58,32};
#line  294 "parse.occ"
                              _V4_403 = TMP;
#line  294 "parse.occ"
                            }
#line  294 "parse.occ"
                            P_set_error_360(FP,20,(BYTE*)_V4_403,str_len_388,(BYTE*)((BYTE*)(((BYTE*)str_387)+((RNGCHKUB(0,str_len_388,256),0)*sizeof(BYTE)))));
#line  294 "parse.occ"
                          }
#line  294 "parse.occ"
                        }
#line  294 "parse.occ"
                        else
#line  294 "parse.occ"
                        {
#line  294 "parse.occ"
                          SETERR(MSG_IF);
#line  294 "parse.occ"
                        }
#line  294 "parse.occ"
                      }
#line  294 "parse.occ"
                      else
#line  295 "parse.occ"
                      if (true)
#line  295 "parse.occ"
                      {
#line  296 "parse.occ"
                      }
#line  296 "parse.occ"
                      else
#line  296 "parse.occ"
                      {
#line  296 "parse.occ"
                        SETERR(MSG_IF);
#line  296 "parse.occ"
                      }
#line  300 "parse.occ"
                      if ((*FP->error_len_346 == 0))
#line  300 "parse.occ"
                      {
#line  301 "parse.occ"
                        {
#line  302 "parse.occ"
                          *((INT*)(((BYTE*)FP->option_parameters_345)+(1*sizeof(INT))+(RNGCHK(last_option_379,FP->option_parameters_345_Dim0)*(2*sizeof(INT))))) = str_len_388; 
#line  303 "parse.occ"
                          *((INT*)(((BYTE*)FP->option_parameters_345)+(0*sizeof(INT))+(RNGCHK(last_option_379,FP->option_parameters_345_Dim0)*(2*sizeof(INT))))) = start_ptr_402; 
#line  303 "parse.occ"
                        }
#line  303 "parse.occ"
                      }
#line  303 "parse.occ"
                      else
#line  304 "parse.occ"
                      if (true)
#line  304 "parse.occ"
                      {
#line  305 "parse.occ"
                      }
#line  305 "parse.occ"
                      else
#line  305 "parse.occ"
                      {
#line  305 "parse.occ"
                        SETERR(MSG_IF);
#line  305 "parse.occ"
                      }
#line  307 "parse.occ"
                      waiting_for_parameter_378 = false; 
#line  307 "parse.occ"
                    }
#line  307 "parse.occ"
                  }
#line  307 "parse.occ"
                }
#line  307 "parse.occ"
                else
#line  307 "parse.occ"
                {
#line  307 "parse.occ"
                  SETERR(MSG_IF);
#line  307 "parse.occ"
                }
#line  307 "parse.occ"
              }
#line  165 "parse.occ"
            }
#line  311 "parse.occ"
            if (((((*FP->error_len_346 == 0) && FP->first_row_is_blank_363) && ( ! found_filename_380)) && (*((INT*)(((BYTE*)FP->option_parameters_required_343)+(0*sizeof(INT)))) == 2)))
#line  311 "parse.occ"
            {
#line  314 "parse.occ"
              {
#line  314 "parse.occ"
                BYTE *_V9_404;
#line  314 "parse.occ"
                BYTE *_V10_405;
#line  314 "parse.occ"
                {
#line  314 "parse.occ"
                  static BYTE TMP[20] = {110,111,32,102,105,108,101,110,97,109,101,32,115,117,112,112,108,105,101,100};
#line  314 "parse.occ"
                  _V9_404 = TMP;
#line  314 "parse.occ"
                }
#line  314 "parse.occ"
                _V10_405 = NULL;
#line  314 "parse.occ"
                P_set_error_360(FP,20,(BYTE*)_V9_404,0,(BYTE*)_V10_405);
#line  314 "parse.occ"
              }
#line  314 "parse.occ"
            }
#line  314 "parse.occ"
            else
#line  315 "parse.occ"
            if (true)
#line  315 "parse.occ"
            {
#line  316 "parse.occ"
            }
#line  316 "parse.occ"
            else
#line  316 "parse.occ"
            {
#line  316 "parse.occ"
              SETERR(MSG_IF);
#line  316 "parse.occ"
            }
#line  316 "parse.occ"
          }
#line  316 "parse.occ"
        }
#line  321 "parse.occ"
        if ((*FP->error_len_346 != 0))
#line  321 "parse.occ"
        {
#line  322 "parse.occ"
        }
#line  322 "parse.occ"
        else
#line  323 "parse.occ"
        {
#line  323 "parse.occ"
          INT i_406;
#line  323 "parse.occ"
          INT i_406_End;
#line  323 "parse.occ"
          i_406 = 0;i_406_End = i_406 + (FP->option_parameters_required_343_Dim0);
#line  323 "parse.occ"
          for (; i_406 != i_406_End; i_406++)
#line  323 "parse.occ"
          {
#line  325 "parse.occ"
            if (((*((BOOL*)(((BYTE*)FP->option_exists_344)+(RNGCHK(i_406,FP->option_exists_344_Dim0)*sizeof(BOOL)))) && (*((INT*)(((BYTE*)FP->option_parameters_required_343)+(RNGCHK(i_406,FP->option_parameters_required_343_Dim0)*sizeof(INT)))) == 2)) && (*((INT*)(((BYTE*)FP->option_parameters_345)+(1*sizeof(INT))+(RNGCHK(i_406,FP->option_parameters_345_Dim0)*(2*sizeof(INT))))) == 0)))
#line  325 "parse.occ"
            {
#line  328 "parse.occ"
              {
#line  328 "parse.occ"
                BYTE *_V11_407;
#line  328 "parse.occ"
                {
#line  328 "parse.occ"
                  static BYTE TMP[45] = {116,104,105,115,32,111,112,116,105,111,110,32,109,117,115,116,32,98,101,32,
#line  328 "parse.occ"
                     102,111,108,108,111,119,101,100,32,98,121,32,97,32,112,97,114,97,109,101,
#line  328 "parse.occ"
                     116,101,114,58,32};
#line  328 "parse.occ"
                  _V11_407 = TMP;
#line  328 "parse.occ"
                }
#line  328 "parse.occ"
                P_set_error_360(FP,45,(BYTE*)_V11_407,FP->option_strings_342_Dim1,(BYTE*)((BYTE*)(((BYTE*)FP->option_strings_342)+(RNGCHK(i_406,FP->option_strings_342_Dim0)*(FP->option_strings_342_Dim1*sizeof(BYTE))))));
#line  328 "parse.occ"
              }
#line  328 "parse.occ"
            }
#line  328 "parse.occ"
            else
#line  328 "parse.occ"
            {
#line  328 "parse.occ"
              continue;
#line  328 "parse.occ"
            }
#line  328 "parse.occ"
            break;
#line  328 "parse.occ"
          }
#line  328 "parse.occ"
          if (i_406 == i_406_End) 
#line  330 "parse.occ"
          if (true)
#line  330 "parse.occ"
          {
#line  331 "parse.occ"
          }
#line  331 "parse.occ"
          else
#line  331 "parse.occ"
          {
#line  331 "parse.occ"
            SETERR(MSG_IF);
#line  331 "parse.occ"
          }
#line  331 "parse.occ"
        }
#line  331 "parse.occ"
        RETURN();
#line  331 "parse.occ"
      default: SETERR(MSG_IP);
#line  331 "parse.occ"
    }
#line  331 "parse.occ"
  }
#line  331 "parse.occ"
}


/*}}}*/
#endif
