/*{{{  File banner*/
/*@(#)=====================================================*\
||@(#)  Project : GPMIMD ESPRIT P5404
||@(#)  Authors : Mark Debbage, Mark Hill, Denis Nicole and Sean Wykes
||@(#)            University of Southampton
||  
||@(#)    Title : Prototype Source File for generated C
||@(#)   System : Occam 2 C
||@(#)  Version : 1.3
||@(#) Filename : Occam2C.c
||@(#)     Date : 3/4/97
\*@(#)====================================================*/
/*}}}*/

/*{{{  Insert SWITCHES*/
#define LIBRARY_UNIT
#define BYTES_PER_WORD 4
#define TERMINATE_ON_ERROR
#define CHECK_CONVERSIONS
#define CHECK_ARRAYS
#define CHECK_RANGES
#define NO_DEBUG
#define FASTGOTOS
#define SOURCE LITTLE

/*}}}*/
/*{{{  defines*/
#define DEFAULT_MEMSIZE_IN_INTS 1000
#define OCCAM_MAIN

/*}}}*/
/*{{{  includes*/
#include <stdio.h>
#include <errno.h>

#if  (defined USESIGTIMER) || (defined USE_NONBLOCKING_SOCKETS)
#include <signal.h>
#include <sys/time.h>
#endif

#ifdef USE_NONBLOCKING_SOCKETS
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef solaris
#include <stropts.h>
#include <sys/file.h>
#include <sys/conf.h>
#endif
#endif

#ifdef CALL_NAG_F90
#include <f90.h>
#endif

#include "Occam2C.h"

#ifdef USE_NONBLOCKING_SOCKETS
  #ifdef solaris
  #define SOCKET_SIGNAL SIGPOLL
  #else
  #define SOCKET_SIGNAL SIGIO
  #endif
#endif
/*}}}*/
/*{{{  Insert HEADER*/
#include "splib.hdr"
struct SF_P_sp_open_open
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  BYTE *Param2;
  INT Param2_Dim0;
  BYTE Param3;
  BYTE Param4;
  INT32 *Param5;
  BYTE *Param6;
  char WS[WS_P_sp_open_open];
};
struct SF_P_sp_getenv_getenv
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  BYTE *Param2;
  INT Param2_Dim0;
  INT *Param3;
  BYTE *Param4;
  INT Param4_Dim0;
  BYTE *Param5;
  char WS[WS_P_sp_getenv_getenv];
};
typedef struct SF_P_test_for_directory_354 tSF_P_test_for_directory_354;
typedef struct SF_P_concatenate_359 tSF_P_concatenate_359;
typedef struct SF_P_assemble_name_367 tSF_P_assemble_name_367;
typedef struct SF_P_so_popen_read_popen tSF_P_so_popen_read_popen;
void P_so_popen_read_popen (tSF_P_so_popen_read_popen *FP);
struct SF_P_test_for_directory_354
{
  tHeader _Header;
  tSF_P_so_popen_read_popen *Chain;
};
struct SF_P_concatenate_359
{
  tHeader _Header;
  tSF_P_so_popen_read_popen *Chain;
};
struct SF_P_assemble_name_367
{
  tHeader _Header;
  tSF_P_so_popen_read_popen *Chain;
  union
  {
    INT _P_dummy;
  } _U0;
};
struct SF_P_so_popen_read_popen
{
  tHeader _Header;
  void *Chain;
  CHAN *fs_340;
  CHAN *ts_341;
  BYTE *filename_342;
  INT filename_342_Dim0;
  BYTE *path_variable_name_343;
  INT path_variable_name_343_Dim0;
  BYTE open_type_344;
  INT *full_len_345;
  BYTE *full_name_346;
  INT full_name_346_Dim0;
  INT32 *stream_id_347;
  BYTE *result_348;
  INT ptr_350;
  union
  {
    tSF_P_sp_open_open _C3;
    struct
    {
      BOOL found_dir_368;
      union
      {
        struct
        {
          BYTE path_369[256];
          INT path_len_370;
          BOOL more_on_path_371;
          union
          {
            struct
            {
              BYTE local_result_372;
              tSF_P_sp_getenv_getenv _C5;
            } _S2;
            tSF_P_sp_open_open _C7;
          } _U3;
        } _S1;
      } _U2;
    } _S0;
  } _U1;
};

/*}}}*/

#if (defined GENPROTO) || !(defined LIBRARY_UNIT)
/*{{{  statics*/
jmp_buf STOPP_env;
int MAIN_ARGC ;
char **MAIN_ARGV;
tTask *QFP[NUM_PRIORITY_LEVELS],*QBP[NUM_PRIORITY_LEVELS],*CURTASK,*QTM; 
static volatile int TimerEvent = false;
static volatile int SocketEvent = false;
tTimer TIMER;
static int process_count;


/*}}}*/
#endif

#ifdef GENPROTO
/*{{{  seterr*/
void seterr(char *M,int L,char *F) {}
/*}}}*/
/*{{{  struct Prototypes*/
struct Prototypes
{
  char *Proto;
  char *Define;
  int Space;
};
/*}}}*/
/*{{{  static struct Prototypes Table[] =*/
static struct Prototypes Table[] =
{
  {"void P_so_popen_read_popen (tSF_P_so_popen_read_popen *FP);","P_so_popen_read_popen",sizeof(tSF_P_so_popen_read_popen)},

 {NULL,NULL,0}
} ;
/*}}}*/
/*{{{  int main(int argc, char**argv)*/
int main(int argc, char**argv)
{
  char *name;
  FILE *f;
  int fcnt;
  
  CheckPrimitiveSizes();

  if (argc<2)
  {
    name="popen.hdr";
    f=fopen(name,"w");
  }
  else
  {
    name = argv[argc-1];
    if (name[0]=='-')
    {
      name = "stdout";
      f=stdout;
    }
    else
    {
      f=fopen(name,"w");
    }
  }
  fcnt=argc-1;
  
  if (f==NULL)
    { fprintf(stderr,"Error - could not open file %s\n",name);exit(-1); }
  else
  {
    int arg;
    int i;
    fprintf(f,"#ifndef __popen_INCLUDES__\n");
    fprintf(f,"#define __popen_INCLUDES__\n");
    
    for(arg = 1; arg < fcnt; ++arg)
    {
      FILE *fh = fopen(argv[arg],"r");
      if (fh == NULL) { fprintf(stderr,"Error - could not read file %s\n",name); exit(-1); }
      while(!feof(fh))
      {
	char line[256];

	if (fgets(line,256,fh) == NULL) break;
	if (line[0] == '#')
	  if (strncmp(line,"#define WS",10)!=0) continue;
	fputs(line,f);
      }
      fclose(fh);
    }      
      
    i = 0;
    while (Table[i].Proto!=NULL)
    {
      if (Table[i].Define != NULL)
      {
	fprintf(f,"typedef struct SF_%s tSF_%s;\n",Table[i].Define,Table[i].Define);
	fprintf(f,"#define WS_%s (%d)\n",Table[i].Define,Table[i].Space);
      }
      fprintf(f,"%s\n",Table[i].Proto);
      i++;
    }
    fprintf(f,"#endif\n");

    if (f!=stdout) fclose(f);
  }
  return(0);
}     
/*}}}*/
#endif

#ifndef LIBRARY_UNIT
/*{{{  seterr*/
static void DONE_SETERR() {}

void seterr(char *M,int L,char *F)
{
  if (M!=NULL) fputs(M,stderr);
  fprintf(stderr,MSG_EFROL,L,F);
  DONE_SETERR();
  SETERR_PROCEED;
}
/*}}}*/
/*{{{  DEBUGDONE,MARK_SCHEDULE*/
#ifndef NO_DEBUG
void DEBUGDONE(void) {}
void MARK_SCHEDULE(void) {}
#endif

/*}}}*/
/*{{{  timer*/
#ifdef USESIGTIMER
static struct timeval tv_start;
/*{{{  static void TimerSignalHandler(int sig)*/
static void TimerSignalHandler(int sig)
{
  switch(sig)
  {
    case SIGALRM:
      {
	struct timeval tv;
	tTask *task;

	gettimeofday(&tv,NULL);
	TIMER = ((tv.tv_usec - tv_start.tv_usec)>>6) + (1000000>>6) * (tv.tv_sec - tv_start.tv_sec);
	if (QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
	  TimerEvent = true;
      }
      break;

    default:
      fprintf(stderr,"Error - Caught signal %d - Exiting\n",sig);
      fflush(stderr);
      exit(20);
  }
}
/*}}}*/
/*{{{  static void Init_Timer()*/
static void Init_Timer()
{
  struct itimerval itv;
#ifndef solaris
  struct sigaction sa;
#endif

  TIMER = 0;
  gettimeofday(&tv_start,NULL);
  TimerSignalHandler(SIGALRM);
  
#ifndef solaris
  memset((char*)&sa,0,sizeof(sa));
  sa.sa_handler = TimerSignalHandler;

#ifdef SA_RESTART
  sa.sa_flags = SA_RESTART;
#endif

  sigaction(SIGALRM,&sa,NULL);
#else
  sigset(SIGALRM,TimerSignalHandler);
#endif

  itv.it_interval.tv_usec = 1000;
  itv.it_interval.tv_sec = 0;
     
  itv.it_value.tv_usec = 1;
  itv.it_value.tv_sec = 0;

  if (setitimer(ITIMER_REAL,&itv,NULL)) 
    fprintf(stderr,"Error - setitimer failed\n");

  QTM = NoTask;
  TimerEvent = false;
}

/*}}}*/

#else
static void Init_Timer() { (void)clock(); TimerEvent = false; }
#endif
/*}}}*/
/*{{{  sockets*/
#ifdef USE_NONBLOCKING_SOCKETS
static int io_limit;
static struct timeval io_zerotime;

static int    io_socket;
static tTask *io_task = NoTask;

/*{{{  void SocketHandler (int sig)*/
void SocketHandler (int sig)
{
  switch (sig)
  {
    case SOCKET_SIGNAL:
    {
      #ifdef MD_DEBUG
      fprintf(stderr,"Caught signal %d\n",sig);
      #endif
      
      SocketEvent = true;
      
      #ifdef solaris
      signal (SOCKET_SIGNAL, SocketHandler);
      #endif
      
      break;
    }
    default:
      fprintf(stderr,"Error - Caught unexpected signal %d - exiting\n",sig);
      fflush(stderr);
      exit(20);
  }  
}
/*}}}*/
 
/*{{{  void WaitSocket (int socket)*/
void WaitSocket (int socket)
{
  fd_set io_set;

  io_socket = socket;

  FD_ZERO (&io_set);
  FD_SET  (socket,&io_set);
  
  errno = 0;
  while (select (io_limit, &io_set, NULL, NULL, &io_zerotime) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
  
  if (!FD_ISSET(socket,&io_set))
  {
    if (io_task == NoTask)
      io_task = CURTASK;
    else
    {
      fprintf(stderr, "Error - Implementation restriction, only one signaling socket\n");
      exit(-1);
    }
    DeSchedule(TSOCK_p);
  }
}
/*}}}*/

/*{{{  void EnableSocket (int socket)*/
void EnableSocket (int socket)
{
  errno = 0;
  
  #ifdef solaris
  if (ioctl(socket,I_SETSIG,S_RDNORM) < 0)
  {
    fprintf(stderr,"Error - could not set signal handler for socket (errno %d)\n",errno);
    exit(-1);
  }
  #else
  if (fcntl(socket, F_SETOWN, getpid()) < 0)
  {
    fprintf(stderr,"Error - could not set owner on socket (errno %d)\n",errno);
    exit(-1);
  }
  if (fcntl(socket, F_SETFL, FASYNC)    < 0)
  {
    fprintf(stderr,"Error - could not set asynchronous socket (errno %d)\n",errno);
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void DisableSocket (int socket)*/
void DisableSocket (int socket)
{
  #ifdef sun4
  if (fcntl(socket, F_SETFL, FSYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
  #ifdef linux
  if (fcntl(socket, F_SETFL, FASYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void ServeSocket (void)*/
void ServeSocket (void)
{
  fd_set io_set;
  int res;

  /* In the general case there's a timing hazard here since a new signal
     could arrive and we can lose it. Really need test-and-set or a
     semaphore. For hostio, however, there's only ever one outstanding 
     communication and this thread is serving it. Hence, no problem here. */

  SocketEvent = false; 

  FD_ZERO (&io_set);
  FD_SET  (io_socket,&io_set);
  
  errno = 0;
  while ((res = select (io_limit, &io_set, NULL, NULL, &io_zerotime)) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
      
  if (res == 0)
  {
    /*fprintf(stderr,"Could not locate socket signal source, ignoring select\n");*/
    return;
  }
  
  if (!FD_ISSET(io_socket,&io_set))
  {
    fprintf(stderr,"Error - socket is not ready\n");
    exit(-1);
  }

  if (io_task != NoTask)
  {
    ReSchedule(io_task);
    io_task = NoTask;
  }
}
/*}}}*/

/*{{{  void Init_Sockets()*/
void Init_Sockets()
{
  io_limit = ulimit (4,0);

  timerclear (&io_zerotime);

  signal (SOCKET_SIGNAL, SocketHandler);
  #ifdef linux
  {
    struct sigaction action;
    sigaction(SIGIO,NULL,&action);
    action.sa_flags = (action.sa_flags & (~SA_ONESHOT));
    sigaction(SIGIO,&action,NULL);
  }
  #endif
}
/*}}}*/
#else
void WaitSocket (int socket)
{ 
  fprintf(stderr, "Error - No SIGSOCKETS\n"); 
}
#endif
/*}}}*/

/*{{{  static void Init_Scheduler()*/
static void Init_Scheduler()
{
  int i;

  for(i = 0; i < NUM_PRIORITY_LEVELS; ++i)
    QFP[i] = QBP[i] = NoTask;

  CURTASK = NoTask;

  Init_Timer();

  #ifdef USE_NONBLOCKING_SOCKETS
  Init_Sockets();  
  #endif
}
/*}}}*/
/*{{{  static void Scheduler()*/
static void Scheduler()
{
  if (setjmp(STOPP_env)) DeSchedule(0);
  
  while(CURTASK != NoTask || TimerEvent || SocketEvent)
  {
    int pri;

#ifdef USESIGTIMER
    /*{{{  if (TimerEvent)*/
    if (TimerEvent)
    {
    #ifdef DEBUG
	fprintf(stderr,"Timer = %d\n",TIMER);
    #endif
      TimerEvent = false;
      while(QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
      {
    #ifdef DEBUG
	{  
	  tTask *task = QTM;
    
	  fprintf(stderr,"Timer Queue contains:");
	  if (task == NoTask) fprintf(stderr,"No Tasks");
	  else while(task != NoTask) { fprintf(stderr,"%d(%d) ",task->TaskId,task->comms.timer.time); task = task->Next; }
	  fprintf(stderr,"\n");
	}  
    #endif
	if (QTM->AltMode == Waiting_p) QTM->AltMode = TReady_p;
	ReSchedule(QTM);
      }
    }
    /*}}}*/
#endif

#ifdef USE_NONBLOCKING_SOCKETS
    if (SocketEvent)
      ServeSocket();
#endif

    for(pri = 0; pri < NUM_PRIORITY_LEVELS; ++pri)
    {
#ifdef DEBUG
  {
    tTask *task = QFP[pri];
    fprintf(stderr,"Task Queue %d contains:",pri);
    if (task == NoTask) fprintf(stderr,"No Tasks");
    else while(task != NoTask) { fprintf(stderr,"%d ",task->TaskId); task = task->Next; }
    fprintf(stderr,"\n");
  }
#endif

      if ((CURTASK=QFP[pri]) != NoTask)
      {
	/*{{{  #ifdef SHOWTASKING*/
	#ifdef SHOWTASKING
		fprintf(stderr,"Scheduler - Current task is %c%d (%s) IP=%d\n",(CURTASK->TaskPriority)?'L':'H',CURTASK->TaskId,((tHeader *)CURTASK->FP)->ProcName,((tHeader *)CURTASK->FP)->IP); fflush(stderr); 
	#endif
	/*}}}*/
	/*{{{  #ifndef NO_DEBUG*/
	#ifndef NO_DEBUG
	MARK_SCHEDULE() ;
	#endif
	/*}}}*/
	CURTASK->Func (CURTASK->FP);
	break;
      }
    }

    /*{{{  catch any signals*/
    #if (defined USESIGTIMER && defined USE_NONBLOCKING_SOCKETS)
	if (CURTASK == NoTask && (QTM != NoTask || io_task != NoTask))
	  while(!TimerEvent && !SocketEvent)
	    pause();
    #else
      #if (defined USESIGTIMER)
	  if (CURTASK == NoTask && QTM != NoTask)
	    while(!TimerEvent)
	      pause();
      #endif
      
      #if (defined USE_NONBLOCKING_SOCKETS)
	  if (CURTASK == NoTask && io_task != NoTask)
	    while(!SocketEvent)
	      pause();
      #endif
    #endif
    /*}}}*/

  }

#ifdef DEBUG
  fprintf(stderr,"Scheduling Queue empty\n");
#endif
}

/*}}}*/
/*{{{  void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)
{
  static int NextTaskId = 0;
  process_count++;
  
  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = (CURTASK != NoTask && CURTASK->TaskPriority == HighPriority) ? HighPriority : Priority;
  ((tHeader *)FP)->ProcName = name;
  
  if (Priority < 0 || Priority >= NUM_PRIORITY_LEVELS) SETERR(MSG_PRI);
  
  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Processor)
{
  static int NextTaskId = 0;
  process_count++;

  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = LowPriority;

  ((tHeader *)FP)->ProcName = name;

  SETERR("PLACED PAR is not supported in this implementation");

  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void End_Process()*/
void End_Process()
{
  register tTask *task = CURTASK;
  process_count--;
    
  QFP[task->TaskPriority] = task->Next;
  if (QFP[task->TaskPriority] == NoTask) QBP[task->TaskPriority] = NoTask;
  task->Next = NoTask;
  if (task->Parent)
  {
    if (--(task->Parent->Children) == 0) ReSchedule(task->Parent);
  }
}
/*}}}*/

/*{{{  SPOC iserver definitions*/
#ifdef USE_SPOC_ISERVER
extern int CocoPops;
#include "spserver.hdr"

struct SF_P_spoc_iserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_iserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_iserver_spserver spserver;
} tSF_P_spoc_iserver_caller;

static tSF_P_spoc_iserver_caller spoc_iserver_data;
static tTask spoc_iserver_task;

static tFuncPtr P_spoc_iserver_caller (tSF_P_spoc_iserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_iserver_spserver,&FP->spserver,1,"P_spoc_iserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/
/*{{{  SPOC aserver definitions*/
#ifdef USE_SPOC_ASERVER
#include "spserver.hdr"

struct SF_P_spoc_aserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_aserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_aserver_spserver spserver;
} tSF_P_spoc_aserver_caller;

static tSF_P_spoc_aserver_caller spoc_aserver_data;
static tTask spoc_aserver_task;

static tFuncPtr P_spoc_aserver_caller (tSF_P_spoc_aserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_aserver_spserver,&FP->spserver,1,"P_spoc_aserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/

/*{{{  int main(int argc, char **argv)*/
int main(int argc, char **argv)
{
  void *FP=NULL;
  tSF_ *MAINFP=(tSF_ *)malloc(sizeof(tSF_));
  tTask main_t;
  INT mem_size = (argc>1 && atoi(argv[1])>0)?atoi(argv[1]):DEFAULT_MEMSIZE_IN_INTS;
  INT *mem=(INT*)malloc(mem_size*sizeof(INT));
  CHAN fs,ts;
  
  if (MAINFP==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s bytes for occam workspace failed\n",sizeof(tSF_));
    exit(-1);
  }
  if (mem_size>0 && mem==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s INTs for occam memory array failed\n",mem_size);
    exit(-1);
  }
  (void) clock();
  MAIN_ARGC = argc ;
  MAIN_ARGV = argv ;
  process_count = 0;
 
  CheckPrimitiveSizes();
  INITCH(&fs);
  INITCH(&ts);
  Init_Scheduler();
  
  STARTP(&main_t,,MAINFP,"",LowPriority);

  /*{{{  #ifdef USE_SPOC_ISERVER*/
  #ifdef USE_SPOC_ISERVER
  #ifdef SHOWTASKING
  CocoPops=true;
  #endif
  spoc_iserver_data.fs = &fs;
  spoc_iserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_iserver_task, P_spoc_iserver_caller, &spoc_iserver_data, "P_spoc_iserver_spserver",LowPriority);
  #endif
  /*}}}*/
  /*{{{  #ifdef USE_SPOC_ASERVER*/
  #ifdef USE_SPOC_ASERVER
  spoc_aserver_data.fs = &fs;
  spoc_aserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_aserver_task, P_spoc_aserver_caller, &spoc_aserver_data, "P_spoc_aserver_spserver",LowPriority);
  #endif
  /*}}}*/
/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_init(argc,argv);
#endif
/*}}}*/
  
  Scheduler();

/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_finish(0);
#endif
/*}}}*/
  if (process_count == 0)
    return 0;
  else
  {
    fprintf(stderr,"Deadlock: %d stopped process%s.\n", process_count,(process_count>1)?"es":"");
    return 1;
  }
}     
/*}}}*/
#endif

#ifndef GENPROTO
/*{{{  Insert DEBUG*/

/*}}}*/
/*{{{  Insert CODE*/
static void P_test_for_directory_354 (INT filename_351_Dim0,BYTE *filename_351,BOOL *found_dir_352)
#line   79 "popen.occ"
{
#line   79 "popen.occ"
  tSF_P_test_for_directory_354 SF;
#line   79 "popen.occ"
  tSF_P_test_for_directory_354 *FP = &SF;
#line   86 "popen.occ"
  {
#line   86 "popen.occ"
    INT i_353;
#line   86 "popen.occ"
    INT i_353_End;
#line   86 "popen.occ"
    i_353 = 0;i_353_End = i_353 + (filename_351_Dim0);
#line   86 "popen.occ"
    for (; i_353 != i_353_End; i_353++)
#line   86 "popen.occ"
    {
#line   89 "popen.occ"
      if ((((((((*((BYTE*)(((BYTE*)filename_351)+(RNGCHK(i_353,filename_351_Dim0)*sizeof(BYTE)))) == 60) || (*((BYTE*)(((BYTE*)filename_351)+(RNGCHK(i_353,filename_351_Dim0)*sizeof(BYTE)))) == 62)) || (*((BYTE*)(((BYTE*)filename_351)+(RNGCHK(i_353,filename_351_Dim0)*sizeof(BYTE)))) == 91)) || (*((BYTE*)(((BYTE*)filename_351)+(RNGCHK(i_353,filename_351_Dim0)*sizeof(BYTE)))) == 93)) || (*((BYTE*)(((BYTE*)filename_351)+(RNGCHK(i_353,filename_351_Dim0)*sizeof(BYTE)))) == 47)) || (*((BYTE*)(((BYTE*)filename_351)+(RNGCHK(i_353,filename_351_Dim0)*sizeof(BYTE)))) == 92)) || (*((BYTE*)(((BYTE*)filename_351)+(RNGCHK(i_353,filename_351_Dim0)*sizeof(BYTE)))) == 58)))
#line   89 "popen.occ"
      {
#line   90 "popen.occ"
        *found_dir_352 = true; 
#line   90 "popen.occ"
      }
#line   90 "popen.occ"
      else
#line   90 "popen.occ"
      {
#line   90 "popen.occ"
        continue;
#line   90 "popen.occ"
      }
#line   90 "popen.occ"
      break;
#line   90 "popen.occ"
    }
#line   90 "popen.occ"
    if (i_353 == i_353_End) 
#line   91 "popen.occ"
    if (true)
#line   91 "popen.occ"
    {
#line   92 "popen.occ"
      *found_dir_352 = false; 
#line   92 "popen.occ"
    }
#line   92 "popen.occ"
    else
#line   92 "popen.occ"
    {
#line   92 "popen.occ"
      SETERR(MSG_IF);
#line   92 "popen.occ"
    }
#line   92 "popen.occ"
  }
#line   92 "popen.occ"
}

#line   96 "popen.occ"
static void P_concatenate_359 (INT *length1_355,INT string1_356_Dim0,BYTE *string1_356,INT string2_357_Dim0,BYTE *string2_357)
#line   96 "popen.occ"
{
#line   96 "popen.occ"
  tSF_P_concatenate_359 SF;
#line   96 "popen.occ"
  tSF_P_concatenate_359 *FP = &SF;
#line  104 "popen.occ"
  if (((*length1_355 < (string1_356_Dim0)) && ((string2_357_Dim0) != 0)))
#line  104 "popen.occ"
  {
#line  105 "popen.occ"
    {
#line  105 "popen.occ"
      INT bytes_to_copy_358;
#line  106 "popen.occ"
      {
#line  108 "popen.occ"
        if (((*length1_355 + (string2_357_Dim0)) > (string1_356_Dim0)))
#line  108 "popen.occ"
        {
#line  109 "popen.occ"
          bytes_to_copy_358 = ((string1_356_Dim0) - *length1_355); 
#line  109 "popen.occ"
        }
#line  109 "popen.occ"
        else
#line  110 "popen.occ"
        if (true)
#line  110 "popen.occ"
        {
#line  111 "popen.occ"
          bytes_to_copy_358 = (string2_357_Dim0); 
#line  111 "popen.occ"
        }
#line  111 "popen.occ"
        else
#line  111 "popen.occ"
        {
#line  111 "popen.occ"
          SETERR(MSG_IF);
#line  111 "popen.occ"
        }
#line  112 "popen.occ"
        CHK(bytes_to_copy_358==bytes_to_copy_358,MSG_ASM);
#line  112 "popen.occ"
        ASSIGN(((BYTE*)(((BYTE*)string1_356)+((RNGCHKUB(*length1_355,bytes_to_copy_358,string1_356_Dim0),RNGCHKLB(*length1_355))*sizeof(BYTE)))),((BYTE*)(((BYTE*)string2_357)+((RNGCHKUB(0,bytes_to_copy_358,string2_357_Dim0),0)*sizeof(BYTE)))),(bytes_to_copy_358*sizeof(BYTE))); 
#line  114 "popen.occ"
        *length1_355 = (*length1_355 + bytes_to_copy_358); 
#line  114 "popen.occ"
      }
#line  114 "popen.occ"
    }
#line  114 "popen.occ"
  }
#line  114 "popen.occ"
  else
#line  115 "popen.occ"
  if (true)
#line  115 "popen.occ"
  {
#line  116 "popen.occ"
  }
#line  116 "popen.occ"
  else
#line  116 "popen.occ"
  {
#line  116 "popen.occ"
    SETERR(MSG_IF);
#line  116 "popen.occ"
  }
#line  116 "popen.occ"
}

#line  120 "popen.occ"
static void P_assemble_name_367 (tSF_P_so_popen_read_popen *PP,BOOL *more_on_path_360,BYTE *path_361,INT path_len_362,INT filename_363_Dim0,BYTE *filename_363,INT *full_len_364,INT full_name_365_Dim0,BYTE *full_name_365)
#line  120 "popen.occ"
{
#line  120 "popen.occ"
  tSF_P_assemble_name_367 SF;
#line  120 "popen.occ"
  tSF_P_assemble_name_367 *FP = &SF;
#line  120 "popen.occ"
  FP->Chain = PP;
#line  130 "popen.occ"
  {
#line  130 "popen.occ"
    INT start_ptr_366;
#line  131 "popen.occ"
    {
#line  132 "popen.occ"
      *full_len_364 = 0; 
#line  136 "popen.occ"
      while (((FP->Chain->ptr_350 < path_len_362) && ((*((BYTE*)(((BYTE*)path_361)+(RNGCHK(FP->Chain->ptr_350,256)*sizeof(BYTE)))) == 59) || (*((BYTE*)(((BYTE*)path_361)+(RNGCHK(FP->Chain->ptr_350,256)*sizeof(BYTE)))) == 32))))
#line  136 "popen.occ"
      {
#line  137 "popen.occ"
        FP->Chain->ptr_350 = (FP->Chain->ptr_350 + 1); 
#line  136 "popen.occ"
      }
#line  139 "popen.occ"
      start_ptr_366 = FP->Chain->ptr_350; 
#line  141 "popen.occ"
      while ((((FP->Chain->ptr_350 < path_len_362) && (*((BYTE*)(((BYTE*)path_361)+(RNGCHK(FP->Chain->ptr_350,256)*sizeof(BYTE)))) != 59)) && (*((BYTE*)(((BYTE*)path_361)+(RNGCHK(FP->Chain->ptr_350,256)*sizeof(BYTE)))) != 32)))
#line  141 "popen.occ"
      {
#line  142 "popen.occ"
        FP->Chain->ptr_350 = (FP->Chain->ptr_350 + 1); 
#line  141 "popen.occ"
      }
#line  145 "popen.occ"
      if ((FP->Chain->ptr_350 == start_ptr_366))
#line  145 "popen.occ"
      {
#line  146 "popen.occ"
        *more_on_path_360 = false; 
#line  146 "popen.occ"
      }
#line  146 "popen.occ"
      else
#line  147 "popen.occ"
      if (true)
#line  147 "popen.occ"
      {
#line  148 "popen.occ"
        {
#line  149 "popen.occ"
          *more_on_path_360 = true; 
#line  150 "popen.occ"
          P_concatenate_359(full_len_364,full_name_365_Dim0,(BYTE*)full_name_365,(FP->Chain->ptr_350 - start_ptr_366),(BYTE*)((BYTE*)(((BYTE*)path_361)+((RNGCHKUB(start_ptr_366,(FP->Chain->ptr_350 - start_ptr_366),256),RNGCHKLB(start_ptr_366))*sizeof(BYTE)))));
#line  152 "popen.occ"
          P_concatenate_359(full_len_364,full_name_365_Dim0,(BYTE*)full_name_365,filename_363_Dim0,(BYTE*)filename_363);
#line  156 "popen.occ"
          if (((full_name_365_Dim0) < ((FP->Chain->ptr_350 - start_ptr_366) + (filename_363_Dim0))))
#line  156 "popen.occ"
          {
#line  157 "popen.occ"
            *full_len_364 = -1; 
#line  157 "popen.occ"
          }
#line  157 "popen.occ"
          else
#line  158 "popen.occ"
          if (true)
#line  158 "popen.occ"
          {
#line  159 "popen.occ"
          }
#line  159 "popen.occ"
          else
#line  159 "popen.occ"
          {
#line  159 "popen.occ"
            SETERR(MSG_IF);
#line  159 "popen.occ"
          }
#line  159 "popen.occ"
        }
#line  159 "popen.occ"
      }
#line  159 "popen.occ"
      else
#line  159 "popen.occ"
      {
#line  159 "popen.occ"
        SETERR(MSG_IF);
#line  159 "popen.occ"
      }
#line  159 "popen.occ"
    }
#line  159 "popen.occ"
  }
#line  159 "popen.occ"
}

#line    6 "popen.occ"
void P_so_popen_read_popen (tSF_P_so_popen_read_popen *FP)
#line    6 "popen.occ"
{
#line    6 "popen.occ"
  while(true)
#line    6 "popen.occ"
  {
#line    6 "popen.occ"
    switch(FP->_Header.IP)
#line    6 "popen.occ"
    {
#line    6 "popen.occ"
      CASE(0):  
#line  164 "popen.occ"
        if (!((FP->filename_342_Dim0) > 505)) GOTO(2);
#line  165 "popen.occ"
        *FP->result_348 = 8; 
#line  165 "popen.occ"
        GOTO(1);
#line  165 "popen.occ"
      CASE(2):  
#line  166 "popen.occ"
        if (!((FP->filename_342_Dim0) == 0)) GOTO(3);
#line  167 "popen.occ"
        *FP->result_348 = 2; 
#line  167 "popen.occ"
        GOTO(1);
#line  167 "popen.occ"
      CASE(3):  
#line  168 "popen.occ"
        if (!((FP->open_type_344 != 1) && (FP->open_type_344 != 2))) GOTO(4);
#line  169 "popen.occ"
        *FP->result_348 = 3; 
#line  169 "popen.occ"
        GOTO(1);
#line  169 "popen.occ"
      CASE(4):  
#line  170 "popen.occ"
        if (!((FP->full_name_346_Dim0) < (FP->filename_342_Dim0))) GOTO(5);
#line  171 "popen.occ"
        *FP->result_348 = 10; 
#line  171 "popen.occ"
        GOTO(1);
#line  171 "popen.occ"
      CASE(5):  
#line  172 "popen.occ"
        if (!true) GOTO(6);
#line  175 "popen.occ"
        *FP->full_len_345 = 0; 
#line  176 "popen.occ"
        P_concatenate_359(FP->full_len_345,FP->full_name_346_Dim0,(BYTE*)FP->full_name_346,FP->filename_342_Dim0,(BYTE*)FP->filename_342);
#line  179 "popen.occ"
        FP->_U1._C3.Param0=FP->fs_340;
#line  179 "popen.occ"
        FP->_U1._C3.Param1=FP->ts_341;
#line  179 "popen.occ"
        FP->_U1._C3.Param2_Dim0=*FP->full_len_345;
#line  179 "popen.occ"
        FP->_U1._C3.Param2= (BYTE*)((BYTE*)(((BYTE*)FP->full_name_346)+((RNGCHKUB(0,*FP->full_len_345,FP->full_name_346_Dim0),0)*sizeof(BYTE))));
#line  179 "popen.occ"
        FP->_U1._C3.Param3=FP->open_type_344;
#line  179 "popen.occ"
        FP->_U1._C3.Param4=1;
#line  179 "popen.occ"
        FP->_U1._C3.Param5=FP->stream_id_347;
#line  179 "popen.occ"
        FP->_U1._C3.Param6=FP->result_348;
#line  179 "popen.occ"
        FP->_U1._C3.Chain = NULL;
#line  179 "popen.occ"
        CALL(P_sp_open_open,&FP->_U1._C3,7,"P_sp_open_open");
#line  179 "popen.occ"
      CASE(7):  
#line  182 "popen.occ"
        if (!(*FP->result_348 == 0)) GOTO(9);
#line  183 "popen.occ"
        GOTO(8);
#line  183 "popen.occ"
      CASE(9):  
#line  184 "popen.occ"
        if (!((FP->path_variable_name_343_Dim0) != 0)) GOTO(10);
#line  187 "popen.occ"
        P_test_for_directory_354(FP->filename_342_Dim0,(BYTE*)FP->filename_342,&FP->_U1._S0.found_dir_368);
#line  189 "popen.occ"
        if (!( ! FP->_U1._S0.found_dir_368)) GOTO(12);
#line  197 "popen.occ"
        FP->ptr_350 = 0; 
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Param0=FP->fs_340;
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Param1=FP->ts_341;
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Param2_Dim0=FP->path_variable_name_343_Dim0;
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Param2= (BYTE*)FP->path_variable_name_343;
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Param3=&FP->_U1._S0._U2._S1.path_len_370;
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Param4_Dim0=256;
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Param4= (BYTE*)FP->_U1._S0._U2._S1.path_369;
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Param5=&FP->_U1._S0._U2._S1._U3._S2.local_result_372;
#line  201 "popen.occ"
        FP->_U1._S0._U2._S1._U3._S2._C5.Chain = NULL;
#line  201 "popen.occ"
        CALL(P_sp_getenv_getenv,&FP->_U1._S0._U2._S1._U3._S2._C5,13,"P_sp_getenv_getenv");
#line  201 "popen.occ"
      CASE(13):  
#line  202 "popen.occ"
        FP->_U1._S0._U2._S1.more_on_path_371 = (FP->_U1._S0._U2._S1._U3._S2.local_result_372 == 0); 
#line  204 "popen.occ"
        if (FP->_U1._S0._U2._S1.more_on_path_371)
#line  204 "popen.occ"
        {
#line  205 "popen.occ"
        }
#line  205 "popen.occ"
        else
#line  206 "popen.occ"
        if (true)
#line  206 "popen.occ"
        {
#line  207 "popen.occ"
          *FP->result_348 = FP->_U1._S0._U2._S1._U3._S2.local_result_372; 
#line  207 "popen.occ"
        }
#line  207 "popen.occ"
        else
#line  207 "popen.occ"
        {
#line  207 "popen.occ"
          SETERR(MSG_IF);
#line  207 "popen.occ"
        }
#line  209 "popen.occ"
        GOTO(14);
#line  209 "popen.occ"
      CASE(15):  
#line  213 "popen.occ"
        P_assemble_name_367(FP,&FP->_U1._S0._U2._S1.more_on_path_371,(BYTE*)FP->_U1._S0._U2._S1.path_369,FP->_U1._S0._U2._S1.path_len_370,FP->filename_342_Dim0,(BYTE*)FP->filename_342,FP->full_len_345,FP->full_name_346_Dim0,(BYTE*)FP->full_name_346);
#line  216 "popen.occ"
        if (!(FP->_U1._S0._U2._S1.more_on_path_371 && (*FP->full_len_345 > 0))) GOTO(17);
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Param0=FP->fs_340;
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Param1=FP->ts_341;
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Param2_Dim0=*FP->full_len_345;
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Param2= (BYTE*)((BYTE*)(((BYTE*)FP->full_name_346)+((RNGCHKUB(0,*FP->full_len_345,FP->full_name_346_Dim0),0)*sizeof(BYTE))));
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Param3=FP->open_type_344;
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Param4=1;
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Param5=FP->stream_id_347;
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Param6=FP->result_348;
#line  219 "popen.occ"
        FP->_U1._S0._U2._S1._U3._C7.Chain = NULL;
#line  219 "popen.occ"
        CALL(P_sp_open_open,&FP->_U1._S0._U2._S1._U3._C7,18,"P_sp_open_open");
#line  219 "popen.occ"
      CASE(18):  
#line  219 "popen.occ"
        GOTO(16);
#line  219 "popen.occ"
      CASE(17):  
#line  222 "popen.occ"
        if (!true) GOTO(19);
#line  223 "popen.occ"
        GOTO(16);
#line  223 "popen.occ"
      CASE(19):  
#line  223 "popen.occ"
        SETERR(MSG_IF);
#line  223 "popen.occ"
      CASE(16):  
#line  209 "popen.occ"
      CASE(14):  
#line  209 "popen.occ"
        if ((((*FP->result_348 != 0) && FP->_U1._S0._U2._S1.more_on_path_371) && (*FP->full_len_345 >= 0)))
#line  209 "popen.occ"
        {
#line  209 "popen.occ"
          GOTO(15);
#line  209 "popen.occ"
        }
#line  225 "popen.occ"
        if ((*FP->full_len_345 < 0))
#line  225 "popen.occ"
        {
#line  226 "popen.occ"
          {
#line  227 "popen.occ"
            *FP->result_348 = 10; 
#line  228 "popen.occ"
            *FP->full_len_345 = 0; 
#line  228 "popen.occ"
          }
#line  228 "popen.occ"
        }
#line  228 "popen.occ"
        else
#line  229 "popen.occ"
        if (true)
#line  229 "popen.occ"
        {
#line  230 "popen.occ"
        }
#line  230 "popen.occ"
        else
#line  230 "popen.occ"
        {
#line  230 "popen.occ"
          SETERR(MSG_IF);
#line  230 "popen.occ"
        }
#line  230 "popen.occ"
        GOTO(11);
#line  230 "popen.occ"
      CASE(12):  
#line  232 "popen.occ"
        if (!true) GOTO(20);
#line  233 "popen.occ"
        GOTO(11);
#line  233 "popen.occ"
      CASE(20):  
#line  233 "popen.occ"
        SETERR(MSG_IF);
#line  233 "popen.occ"
      CASE(11):  
#line  233 "popen.occ"
        GOTO(8);
#line  233 "popen.occ"
      CASE(10):  
#line  234 "popen.occ"
        if (!true) GOTO(21);
#line  235 "popen.occ"
        GOTO(8);
#line  235 "popen.occ"
      CASE(21):  
#line  235 "popen.occ"
        SETERR(MSG_IF);
#line  235 "popen.occ"
      CASE(8):  
#line  235 "popen.occ"
        GOTO(1);
#line  235 "popen.occ"
      CASE(6):  
#line  235 "popen.occ"
        SETERR(MSG_IF);
#line  235 "popen.occ"
      CASE(1):  
#line  235 "popen.occ"
        RETURN();
#line  235 "popen.occ"
      default: SETERR(MSG_IP);
#line  235 "popen.occ"
    }
#line  235 "popen.occ"
  }
#line  235 "popen.occ"
}


/*}}}*/
#endif
