/*{{{  File banner*/
/*@(#)=====================================================*\
||@(#)  Project : GPMIMD ESPRIT P5404
||@(#)  Authors : Mark Debbage, Mark Hill, Denis Nicole and Sean Wykes
||@(#)            University of Southampton
||  
||@(#)    Title : Prototype Source File for generated C
||@(#)   System : Occam 2 C
||@(#)  Version : 1.3
||@(#) Filename : Occam2C.c
||@(#)     Date : 3/4/97
\*@(#)====================================================*/
/*}}}*/

/*{{{  Insert SWITCHES*/
#define LIBRARY_UNIT
#define BYTES_PER_WORD 4
#define TERMINATE_ON_ERROR
#define CHECK_CONVERSIONS
#define CHECK_ARRAYS
#define CHECK_RANGES
#define NO_DEBUG
#define FASTGOTOS
#define SOURCE LITTLE

/*}}}*/
/*{{{  defines*/
#define DEFAULT_MEMSIZE_IN_INTS 1000
#define OCCAM_MAIN

/*}}}*/
/*{{{  includes*/
#include <stdio.h>
#include <errno.h>

#if  (defined USESIGTIMER) || (defined USE_NONBLOCKING_SOCKETS)
#include <signal.h>
#include <sys/time.h>
#endif

#ifdef USE_NONBLOCKING_SOCKETS
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef solaris
#include <stropts.h>
#include <sys/file.h>
#include <sys/conf.h>
#endif
#endif

#ifdef CALL_NAG_F90
#include <f90.h>
#endif

#include "Occam2C.h"

#ifdef USE_NONBLOCKING_SOCKETS
  #ifdef solaris
  #define SOCKET_SIGNAL SIGPOLL
  #else
  #define SOCKET_SIGNAL SIGIO
  #endif
#endif
/*}}}*/
/*{{{  Insert HEADER*/
#include "splib.hdr"
struct SF_P_sp_time_time
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  INT32 *Param2;
  INT32 *Param3;
  BYTE *Param4;
  char WS[WS_P_sp_time_time];
};
typedef struct SF_P_so_time_to_date_times tSF_P_so_time_to_date_times;
typedef struct SF_P_number_to_two_digits_366 tSF_P_number_to_two_digits_366;
typedef struct SF_P_so_date_to_ascii_times tSF_P_so_date_to_ascii_times;
typedef struct SF_P_so_time_to_ascii_times tSF_P_so_time_to_ascii_times;
typedef struct SF_P_so_today_date_times tSF_P_so_today_date_times;
typedef struct SF_P_so_today_ascii_times tSF_P_so_today_ascii_times;
void P_so_today_ascii_times (tSF_P_so_today_ascii_times *FP);
struct SF_P_so_time_to_date_times
{
  tHeader _Header;
  void *Chain;
};
struct SF_P_number_to_two_digits_366
{
  tHeader _Header;
  tSF_P_so_date_to_ascii_times *Chain;
};
struct SF_P_so_date_to_ascii_times
{
  tHeader _Header;
  void *Chain;
  union
  {
    INT _P_dummy;
  } _U0;
};
struct SF_P_so_time_to_ascii_times
{
  tHeader _Header;
  void *Chain;
  union
  {
    INT _P_dummy;
  } _U1;
};
struct SF_P_so_today_date_times
{
  tHeader _Header;
  void *Chain;
  CHAN *fs_375;
  CHAN *ts_376;
  INT *date_377;
  INT32 local_time_378;
  INT32 UTC_time_379;
  BYTE result_380;
  union
  {
    tSF_P_sp_time_time _C0;
  } _U2;
};
struct SF_P_so_today_ascii_times
{
  tHeader _Header;
  void *Chain;
  CHAN *fs_383;
  CHAN *ts_384;
  BOOL long_years_385;
  BOOL days_first_386;
  BYTE *string_387;
  INT32 local_time_388;
  INT32 UTC_time_389;
  BYTE result_390;
  union
  {
    tSF_P_sp_time_time _C0;
  } _U3;
};

/*}}}*/

#if (defined GENPROTO) || !(defined LIBRARY_UNIT)
/*{{{  statics*/
jmp_buf STOPP_env;
int MAIN_ARGC ;
char **MAIN_ARGV;
tTask *QFP[NUM_PRIORITY_LEVELS],*QBP[NUM_PRIORITY_LEVELS],*CURTASK,*QTM; 
static volatile int TimerEvent = false;
static volatile int SocketEvent = false;
tTimer TIMER;
static int process_count;


/*}}}*/
#endif

#ifdef GENPROTO
/*{{{  seterr*/
void seterr(char *M,int L,char *F) {}
/*}}}*/
/*{{{  struct Prototypes*/
struct Prototypes
{
  char *Proto;
  char *Define;
  int Space;
};
/*}}}*/
/*{{{  static struct Prototypes Table[] =*/
static struct Prototypes Table[] =
{
  {"void P_so_time_to_date_times (INT32 input_time_340,INT *date_341);",NULL,0},
  {"void P_so_date_to_ascii_times (INT *date_360,BOOL long_years_361,BOOL days_first_362,BYTE *string_363);",NULL,0},
  {"void P_so_time_to_ascii_times (INT32 time_369,BOOL long_years_370,BOOL days_first_371,BYTE *string_372);",NULL,0},
  {"void P_so_today_date_times (tSF_P_so_today_date_times *FP);","P_so_today_date_times",sizeof(tSF_P_so_today_date_times)},
  {"void P_so_today_ascii_times (tSF_P_so_today_ascii_times *FP);","P_so_today_ascii_times",sizeof(tSF_P_so_today_ascii_times)},

 {NULL,NULL,0}
} ;
/*}}}*/
/*{{{  int main(int argc, char**argv)*/
int main(int argc, char**argv)
{
  char *name;
  FILE *f;
  int fcnt;
  
  CheckPrimitiveSizes();

  if (argc<2)
  {
    name="times.hdr";
    f=fopen(name,"w");
  }
  else
  {
    name = argv[argc-1];
    if (name[0]=='-')
    {
      name = "stdout";
      f=stdout;
    }
    else
    {
      f=fopen(name,"w");
    }
  }
  fcnt=argc-1;
  
  if (f==NULL)
    { fprintf(stderr,"Error - could not open file %s\n",name);exit(-1); }
  else
  {
    int arg;
    int i;
    fprintf(f,"#ifndef __times_INCLUDES__\n");
    fprintf(f,"#define __times_INCLUDES__\n");
    
    for(arg = 1; arg < fcnt; ++arg)
    {
      FILE *fh = fopen(argv[arg],"r");
      if (fh == NULL) { fprintf(stderr,"Error - could not read file %s\n",name); exit(-1); }
      while(!feof(fh))
      {
	char line[256];

	if (fgets(line,256,fh) == NULL) break;
	if (line[0] == '#')
	  if (strncmp(line,"#define WS",10)!=0) continue;
	fputs(line,f);
      }
      fclose(fh);
    }      
      
    i = 0;
    while (Table[i].Proto!=NULL)
    {
      if (Table[i].Define != NULL)
      {
	fprintf(f,"typedef struct SF_%s tSF_%s;\n",Table[i].Define,Table[i].Define);
	fprintf(f,"#define WS_%s (%d)\n",Table[i].Define,Table[i].Space);
      }
      fprintf(f,"%s\n",Table[i].Proto);
      i++;
    }
    fprintf(f,"#endif\n");

    if (f!=stdout) fclose(f);
  }
  return(0);
}     
/*}}}*/
#endif

#ifndef LIBRARY_UNIT
/*{{{  seterr*/
static void DONE_SETERR() {}

void seterr(char *M,int L,char *F)
{
  if (M!=NULL) fputs(M,stderr);
  fprintf(stderr,MSG_EFROL,L,F);
  DONE_SETERR();
  SETERR_PROCEED;
}
/*}}}*/
/*{{{  DEBUGDONE,MARK_SCHEDULE*/
#ifndef NO_DEBUG
void DEBUGDONE(void) {}
void MARK_SCHEDULE(void) {}
#endif

/*}}}*/
/*{{{  timer*/
#ifdef USESIGTIMER
static struct timeval tv_start;
/*{{{  static void TimerSignalHandler(int sig)*/
static void TimerSignalHandler(int sig)
{
  switch(sig)
  {
    case SIGALRM:
      {
	struct timeval tv;
	tTask *task;

	gettimeofday(&tv,NULL);
	TIMER = ((tv.tv_usec - tv_start.tv_usec)>>6) + (1000000>>6) * (tv.tv_sec - tv_start.tv_sec);
	if (QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
	  TimerEvent = true;
      }
      break;

    default:
      fprintf(stderr,"Error - Caught signal %d - Exiting\n",sig);
      fflush(stderr);
      exit(20);
  }
}
/*}}}*/
/*{{{  static void Init_Timer()*/
static void Init_Timer()
{
  struct itimerval itv;
#ifndef solaris
  struct sigaction sa;
#endif

  TIMER = 0;
  gettimeofday(&tv_start,NULL);
  TimerSignalHandler(SIGALRM);
  
#ifndef solaris
  memset((char*)&sa,0,sizeof(sa));
  sa.sa_handler = TimerSignalHandler;

#ifdef SA_RESTART
  sa.sa_flags = SA_RESTART;
#endif

  sigaction(SIGALRM,&sa,NULL);
#else
  sigset(SIGALRM,TimerSignalHandler);
#endif

  itv.it_interval.tv_usec = 1000;
  itv.it_interval.tv_sec = 0;
     
  itv.it_value.tv_usec = 1;
  itv.it_value.tv_sec = 0;

  if (setitimer(ITIMER_REAL,&itv,NULL)) 
    fprintf(stderr,"Error - setitimer failed\n");

  QTM = NoTask;
  TimerEvent = false;
}

/*}}}*/

#else
static void Init_Timer() { (void)clock(); TimerEvent = false; }
#endif
/*}}}*/
/*{{{  sockets*/
#ifdef USE_NONBLOCKING_SOCKETS
static int io_limit;
static struct timeval io_zerotime;

static int    io_socket;
static tTask *io_task = NoTask;

/*{{{  void SocketHandler (int sig)*/
void SocketHandler (int sig)
{
  switch (sig)
  {
    case SOCKET_SIGNAL:
    {
      #ifdef MD_DEBUG
      fprintf(stderr,"Caught signal %d\n",sig);
      #endif
      
      SocketEvent = true;
      
      #ifdef solaris
      signal (SOCKET_SIGNAL, SocketHandler);
      #endif
      
      break;
    }
    default:
      fprintf(stderr,"Error - Caught unexpected signal %d - exiting\n",sig);
      fflush(stderr);
      exit(20);
  }  
}
/*}}}*/
 
/*{{{  void WaitSocket (int socket)*/
void WaitSocket (int socket)
{
  fd_set io_set;

  io_socket = socket;

  FD_ZERO (&io_set);
  FD_SET  (socket,&io_set);
  
  errno = 0;
  while (select (io_limit, &io_set, NULL, NULL, &io_zerotime) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
  
  if (!FD_ISSET(socket,&io_set))
  {
    if (io_task == NoTask)
      io_task = CURTASK;
    else
    {
      fprintf(stderr, "Error - Implementation restriction, only one signaling socket\n");
      exit(-1);
    }
    DeSchedule(TSOCK_p);
  }
}
/*}}}*/

/*{{{  void EnableSocket (int socket)*/
void EnableSocket (int socket)
{
  errno = 0;
  
  #ifdef solaris
  if (ioctl(socket,I_SETSIG,S_RDNORM) < 0)
  {
    fprintf(stderr,"Error - could not set signal handler for socket (errno %d)\n",errno);
    exit(-1);
  }
  #else
  if (fcntl(socket, F_SETOWN, getpid()) < 0)
  {
    fprintf(stderr,"Error - could not set owner on socket (errno %d)\n",errno);
    exit(-1);
  }
  if (fcntl(socket, F_SETFL, FASYNC)    < 0)
  {
    fprintf(stderr,"Error - could not set asynchronous socket (errno %d)\n",errno);
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void DisableSocket (int socket)*/
void DisableSocket (int socket)
{
  #ifdef sun4
  if (fcntl(socket, F_SETFL, FSYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
  #ifdef linux
  if (fcntl(socket, F_SETFL, FASYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void ServeSocket (void)*/
void ServeSocket (void)
{
  fd_set io_set;
  int res;

  /* In the general case there's a timing hazard here since a new signal
     could arrive and we can lose it. Really need test-and-set or a
     semaphore. For hostio, however, there's only ever one outstanding 
     communication and this thread is serving it. Hence, no problem here. */

  SocketEvent = false; 

  FD_ZERO (&io_set);
  FD_SET  (io_socket,&io_set);
  
  errno = 0;
  while ((res = select (io_limit, &io_set, NULL, NULL, &io_zerotime)) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
      
  if (res == 0)
  {
    /*fprintf(stderr,"Could not locate socket signal source, ignoring select\n");*/
    return;
  }
  
  if (!FD_ISSET(io_socket,&io_set))
  {
    fprintf(stderr,"Error - socket is not ready\n");
    exit(-1);
  }

  if (io_task != NoTask)
  {
    ReSchedule(io_task);
    io_task = NoTask;
  }
}
/*}}}*/

/*{{{  void Init_Sockets()*/
void Init_Sockets()
{
  io_limit = ulimit (4,0);

  timerclear (&io_zerotime);

  signal (SOCKET_SIGNAL, SocketHandler);
  #ifdef linux
  {
    struct sigaction action;
    sigaction(SIGIO,NULL,&action);
    action.sa_flags = (action.sa_flags & (~SA_ONESHOT));
    sigaction(SIGIO,&action,NULL);
  }
  #endif
}
/*}}}*/
#else
void WaitSocket (int socket)
{ 
  fprintf(stderr, "Error - No SIGSOCKETS\n"); 
}
#endif
/*}}}*/

/*{{{  static void Init_Scheduler()*/
static void Init_Scheduler()
{
  int i;

  for(i = 0; i < NUM_PRIORITY_LEVELS; ++i)
    QFP[i] = QBP[i] = NoTask;

  CURTASK = NoTask;

  Init_Timer();

  #ifdef USE_NONBLOCKING_SOCKETS
  Init_Sockets();  
  #endif
}
/*}}}*/
/*{{{  static void Scheduler()*/
static void Scheduler()
{
  if (setjmp(STOPP_env)) DeSchedule(0);
  
  while(CURTASK != NoTask || TimerEvent || SocketEvent)
  {
    int pri;

#ifdef USESIGTIMER
    /*{{{  if (TimerEvent)*/
    if (TimerEvent)
    {
    #ifdef DEBUG
	fprintf(stderr,"Timer = %d\n",TIMER);
    #endif
      TimerEvent = false;
      while(QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
      {
    #ifdef DEBUG
	{  
	  tTask *task = QTM;
    
	  fprintf(stderr,"Timer Queue contains:");
	  if (task == NoTask) fprintf(stderr,"No Tasks");
	  else while(task != NoTask) { fprintf(stderr,"%d(%d) ",task->TaskId,task->comms.timer.time); task = task->Next; }
	  fprintf(stderr,"\n");
	}  
    #endif
	if (QTM->AltMode == Waiting_p) QTM->AltMode = TReady_p;
	ReSchedule(QTM);
      }
    }
    /*}}}*/
#endif

#ifdef USE_NONBLOCKING_SOCKETS
    if (SocketEvent)
      ServeSocket();
#endif

    for(pri = 0; pri < NUM_PRIORITY_LEVELS; ++pri)
    {
#ifdef DEBUG
  {
    tTask *task = QFP[pri];
    fprintf(stderr,"Task Queue %d contains:",pri);
    if (task == NoTask) fprintf(stderr,"No Tasks");
    else while(task != NoTask) { fprintf(stderr,"%d ",task->TaskId); task = task->Next; }
    fprintf(stderr,"\n");
  }
#endif

      if ((CURTASK=QFP[pri]) != NoTask)
      {
	/*{{{  #ifdef SHOWTASKING*/
	#ifdef SHOWTASKING
		fprintf(stderr,"Scheduler - Current task is %c%d (%s) IP=%d\n",(CURTASK->TaskPriority)?'L':'H',CURTASK->TaskId,((tHeader *)CURTASK->FP)->ProcName,((tHeader *)CURTASK->FP)->IP); fflush(stderr); 
	#endif
	/*}}}*/
	/*{{{  #ifndef NO_DEBUG*/
	#ifndef NO_DEBUG
	MARK_SCHEDULE() ;
	#endif
	/*}}}*/
	CURTASK->Func (CURTASK->FP);
	break;
      }
    }

    /*{{{  catch any signals*/
    #if (defined USESIGTIMER && defined USE_NONBLOCKING_SOCKETS)
	if (CURTASK == NoTask && (QTM != NoTask || io_task != NoTask))
	  while(!TimerEvent && !SocketEvent)
	    pause();
    #else
      #if (defined USESIGTIMER)
	  if (CURTASK == NoTask && QTM != NoTask)
	    while(!TimerEvent)
	      pause();
      #endif
      
      #if (defined USE_NONBLOCKING_SOCKETS)
	  if (CURTASK == NoTask && io_task != NoTask)
	    while(!SocketEvent)
	      pause();
      #endif
    #endif
    /*}}}*/

  }

#ifdef DEBUG
  fprintf(stderr,"Scheduling Queue empty\n");
#endif
}

/*}}}*/
/*{{{  void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)
{
  static int NextTaskId = 0;
  process_count++;
  
  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = (CURTASK != NoTask && CURTASK->TaskPriority == HighPriority) ? HighPriority : Priority;
  ((tHeader *)FP)->ProcName = name;
  
  if (Priority < 0 || Priority >= NUM_PRIORITY_LEVELS) SETERR(MSG_PRI);
  
  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Processor)
{
  static int NextTaskId = 0;
  process_count++;

  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = LowPriority;

  ((tHeader *)FP)->ProcName = name;

  SETERR("PLACED PAR is not supported in this implementation");

  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void End_Process()*/
void End_Process()
{
  register tTask *task = CURTASK;
  process_count--;
    
  QFP[task->TaskPriority] = task->Next;
  if (QFP[task->TaskPriority] == NoTask) QBP[task->TaskPriority] = NoTask;
  task->Next = NoTask;
  if (task->Parent)
  {
    if (--(task->Parent->Children) == 0) ReSchedule(task->Parent);
  }
}
/*}}}*/

/*{{{  SPOC iserver definitions*/
#ifdef USE_SPOC_ISERVER
extern int CocoPops;
#include "spserver.hdr"

struct SF_P_spoc_iserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_iserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_iserver_spserver spserver;
} tSF_P_spoc_iserver_caller;

static tSF_P_spoc_iserver_caller spoc_iserver_data;
static tTask spoc_iserver_task;

static tFuncPtr P_spoc_iserver_caller (tSF_P_spoc_iserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_iserver_spserver,&FP->spserver,1,"P_spoc_iserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/
/*{{{  SPOC aserver definitions*/
#ifdef USE_SPOC_ASERVER
#include "spserver.hdr"

struct SF_P_spoc_aserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_aserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_aserver_spserver spserver;
} tSF_P_spoc_aserver_caller;

static tSF_P_spoc_aserver_caller spoc_aserver_data;
static tTask spoc_aserver_task;

static tFuncPtr P_spoc_aserver_caller (tSF_P_spoc_aserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_aserver_spserver,&FP->spserver,1,"P_spoc_aserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/

/*{{{  int main(int argc, char **argv)*/
int main(int argc, char **argv)
{
  void *FP=NULL;
  tSF_ *MAINFP=(tSF_ *)malloc(sizeof(tSF_));
  tTask main_t;
  INT mem_size = (argc>1 && atoi(argv[1])>0)?atoi(argv[1]):DEFAULT_MEMSIZE_IN_INTS;
  INT *mem=(INT*)malloc(mem_size*sizeof(INT));
  CHAN fs,ts;
  
  if (MAINFP==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s bytes for occam workspace failed\n",sizeof(tSF_));
    exit(-1);
  }
  if (mem_size>0 && mem==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s INTs for occam memory array failed\n",mem_size);
    exit(-1);
  }
  (void) clock();
  MAIN_ARGC = argc ;
  MAIN_ARGV = argv ;
  process_count = 0;
 
  CheckPrimitiveSizes();
  INITCH(&fs);
  INITCH(&ts);
  Init_Scheduler();
  
  STARTP(&main_t,,MAINFP,"",LowPriority);

  /*{{{  #ifdef USE_SPOC_ISERVER*/
  #ifdef USE_SPOC_ISERVER
  #ifdef SHOWTASKING
  CocoPops=true;
  #endif
  spoc_iserver_data.fs = &fs;
  spoc_iserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_iserver_task, P_spoc_iserver_caller, &spoc_iserver_data, "P_spoc_iserver_spserver",LowPriority);
  #endif
  /*}}}*/
  /*{{{  #ifdef USE_SPOC_ASERVER*/
  #ifdef USE_SPOC_ASERVER
  spoc_aserver_data.fs = &fs;
  spoc_aserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_aserver_task, P_spoc_aserver_caller, &spoc_aserver_data, "P_spoc_aserver_spserver",LowPriority);
  #endif
  /*}}}*/
/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_init(argc,argv);
#endif
/*}}}*/
  
  Scheduler();

/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_finish(0);
#endif
/*}}}*/
  if (process_count == 0)
    return 0;
  else
  {
    fprintf(stderr,"Deadlock: %d stopped process%s.\n", process_count,(process_count>1)?"es":"");
    return 1;
  }
}     
/*}}}*/
#endif

#ifndef GENPROTO
/*{{{  Insert DEBUG*/

/*}}}*/
/*{{{  Insert CODE*/
void P_so_time_to_date_times (INT32 input_time_340,INT *date_341)
#line    6 "times.occ"
{
#line    6 "times.occ"
  tSF_P_so_time_to_date_times SF;
#line    6 "times.occ"
  tSF_P_so_time_to_date_times *FP = &SF;
#line   27 "times.occ"
  {
#line   27 "times.occ"
    INT32 day_number_342;
#line   28 "times.occ"
    {
#line   30 "times.occ"
      {
#line   30 "times.occ"
        INT32 time_343;
#line   31 "times.occ"
        INT adjusted_for_overflow_344;
#line   41 "times.occ"
        {
#line   42 "times.occ"
          time_343 = input_time_340; 
#line   48 "times.occ"
          {
#line   49 "times.occ"
            adjusted_for_overflow_344 = 0; 
#line   50 "times.occ"
            while (((time_343 & MOSTNEGINT32) != 0))
#line   50 "times.occ"
            {
#line   51 "times.occ"
              {
#line   52 "times.occ"
                time_343 = (time_343 - 0x7FFFD280); 
#line   53 "times.occ"
                adjusted_for_overflow_344 = (adjusted_for_overflow_344 + 1); 
#line   53 "times.occ"
              }
#line   50 "times.occ"
            }
#line   50 "times.occ"
          }
#line   56 "times.occ"
          *((INT*)(((BYTE*)date_341)+(0*sizeof(INT)))) = INTINT32((time_343 % 60)); 
#line   57 "times.occ"
          time_343 = (time_343 / 60); 
#line   58 "times.occ"
          *((INT*)(((BYTE*)date_341)+(1*sizeof(INT)))) = INTINT32((time_343 % 60)); 
#line   59 "times.occ"
          time_343 = (time_343 / 60); 
#line   60 "times.occ"
          *((INT*)(((BYTE*)date_341)+(2*sizeof(INT)))) = INTINT32((time_343 % 24)); 
#line   61 "times.occ"
          time_343 = (time_343 / 24); 
#line   61 "times.occ"
          {
#line   61 "times.occ"
            INT i_347;
#line   61 "times.occ"
            INT i_347_End;
#line   64 "times.occ"
            i_347 = 0;i_347_End = i_347 + adjusted_for_overflow_344;
#line   64 "times.occ"
            for (; i_347 != i_347_End; i_347++)
#line   64 "times.occ"
            {
#line   65 "times.occ"
              time_343 = (time_343 + 24855); 
#line   65 "times.occ"
            }
#line   64 "times.occ"
          }
#line   73 "times.occ"
          day_number_342 = (time_343 + 1); 
#line   73 "times.occ"
        }
#line   73 "times.occ"
      }
#line   76 "times.occ"
      {
#line   76 "times.occ"
        INT days_348;
#line   76 "times.occ"
        INT month_349;
#line   76 "times.occ"
        INT year_350;
#line   77 "times.occ"
        BOOL leap_year_351;
#line   78 "times.occ"
        {
#line   80 "times.occ"
          {
#line   84 "times.occ"
            INT days_in_year_355;
#line   85 "times.occ"
            {
#line   86 "times.occ"
              year_350 = 1970; 
#line   87 "times.occ"
              days_in_year_355 = 365; 
#line   88 "times.occ"
              leap_year_351 = false; 
#line   90 "times.occ"
              while ((day_number_342 > INT32INT(days_in_year_355)))
#line   90 "times.occ"
              {
#line   91 "times.occ"
                {
#line   92 "times.occ"
                  day_number_342 = (day_number_342 - INT32INT(days_in_year_355)); 
#line   93 "times.occ"
                  year_350 = (year_350 + 1); 
#line  100 "times.occ"
                  {
#line  102 "times.occ"
                    leap_year_351 = (((year_350 & 3) == 0) && (year_350 != 2100)); 
#line  104 "times.occ"
                    if (leap_year_351)
#line  104 "times.occ"
                    {
#line  105 "times.occ"
                      days_in_year_355 = 366; 
#line  105 "times.occ"
                    }
#line  105 "times.occ"
                    else
#line  106 "times.occ"
                    if (true)
#line  106 "times.occ"
                    {
#line  107 "times.occ"
                      days_in_year_355 = 365; 
#line  107 "times.occ"
                    }
#line  107 "times.occ"
                    else
#line  107 "times.occ"
                    {
#line  107 "times.occ"
                      SETERR(MSG_IF);
#line  107 "times.occ"
                    }
#line  107 "times.occ"
                  }
#line  107 "times.occ"
                }
#line   90 "times.occ"
              }
#line  110 "times.occ"
              days_348 = INTINT32(day_number_342); 
#line  110 "times.occ"
            }
#line  110 "times.occ"
          }
#line  115 "times.occ"
          {
#line  115 "times.occ"
            INT *days_in_months_357;
#line  117 "times.occ"
            INT days_in_month_358;
#line  115 "times.occ"
            {
#line  115 "times.occ"
              static INT TMP[12] = {31,28,31,30,31,30,31,31,30,31,30,31};
#line  115 "times.occ"
              days_in_months_357 = (INT*)TMP;
#line  115 "times.occ"
            }
#line  118 "times.occ"
            {
#line  119 "times.occ"
              month_349 = 0; 
#line  120 "times.occ"
              days_in_month_358 = 31; 
#line  122 "times.occ"
              while ((days_348 > days_in_month_358))
#line  122 "times.occ"
              {
#line  123 "times.occ"
                {
#line  124 "times.occ"
                  days_348 = (days_348 - days_in_month_358); 
#line  125 "times.occ"
                  month_349 = (month_349 + 1); 
#line  128 "times.occ"
                  if ((leap_year_351 && (month_349 == 1)))
#line  128 "times.occ"
                  {
#line  129 "times.occ"
                    days_in_month_358 = 29; 
#line  129 "times.occ"
                  }
#line  129 "times.occ"
                  else
#line  130 "times.occ"
                  if (true)
#line  130 "times.occ"
                  {
#line  131 "times.occ"
                    days_in_month_358 = *((INT*)(((BYTE*)days_in_months_357)+(RNGCHK(month_349,12)*sizeof(INT)))); 
#line  131 "times.occ"
                  }
#line  131 "times.occ"
                  else
#line  131 "times.occ"
                  {
#line  131 "times.occ"
                    SETERR(MSG_IF);
#line  131 "times.occ"
                  }
#line  131 "times.occ"
                }
#line  122 "times.occ"
              }
#line  135 "times.occ"
              month_349 = (month_349 + 1); 
#line  135 "times.occ"
            }
#line  135 "times.occ"
          }
#line  138 "times.occ"
          *((INT*)(((BYTE*)date_341)+(3*sizeof(INT)))) = days_348; 
#line  139 "times.occ"
          *((INT*)(((BYTE*)date_341)+(4*sizeof(INT)))) = month_349; 
#line  140 "times.occ"
          *((INT*)(((BYTE*)date_341)+(5*sizeof(INT)))) = year_350; 
#line  140 "times.occ"
        }
#line  140 "times.occ"
      }
#line  140 "times.occ"
    }
#line  140 "times.occ"
  }
#line  140 "times.occ"
}

#line  175 "times.occ"
static void P_number_to_two_digits_366 (tSF_P_so_date_to_ascii_times *PP,INT n_364,BYTE *digits_365)
#line  175 "times.occ"
{
#line  175 "times.occ"
  tSF_P_number_to_two_digits_366 SF;
#line  175 "times.occ"
  tSF_P_number_to_two_digits_366 *FP = &SF;
#line  175 "times.occ"
  FP->Chain = PP;
#line  176 "times.occ"
  {
#line  177 "times.occ"
    *((BYTE*)(((BYTE*)digits_365)+(1*sizeof(BYTE)))) = BYTEINT(((n_364 % 10) + 48)); 
#line  178 "times.occ"
    *((BYTE*)(((BYTE*)digits_365)+(0*sizeof(BYTE)))) = BYTEINT(((n_364 / 10) + 48)); 
#line  178 "times.occ"
  }
#line  178 "times.occ"
}

#line  145 "times.occ"
void P_so_date_to_ascii_times (INT *date_360,BOOL long_years_361,BOOL days_first_362,BYTE *string_363)
#line  145 "times.occ"
{
#line  145 "times.occ"
  tSF_P_so_date_to_ascii_times SF;
#line  145 "times.occ"
  tSF_P_so_date_to_ascii_times *FP = &SF;
#line  182 "times.occ"
  {
#line  184 "times.occ"
    P_number_to_two_digits_366(FP,*((INT*)(((BYTE*)date_360)+(2*sizeof(INT)))),(BYTE*)((BYTE*)(((BYTE*)string_363)+((0)*sizeof(BYTE)))));
#line  185 "times.occ"
    P_number_to_two_digits_366(FP,*((INT*)(((BYTE*)date_360)+(1*sizeof(INT)))),(BYTE*)((BYTE*)(((BYTE*)string_363)+((3)*sizeof(BYTE)))));
#line  186 "times.occ"
    P_number_to_two_digits_366(FP,*((INT*)(((BYTE*)date_360)+(0*sizeof(INT)))),(BYTE*)((BYTE*)(((BYTE*)string_363)+((6)*sizeof(BYTE)))));
#line  190 "times.occ"
    if (days_first_362)
#line  190 "times.occ"
    {
#line  191 "times.occ"
      {
#line  192 "times.occ"
        P_number_to_two_digits_366(FP,*((INT*)(((BYTE*)date_360)+(3*sizeof(INT)))),(BYTE*)((BYTE*)(((BYTE*)string_363)+((9)*sizeof(BYTE)))));
#line  193 "times.occ"
        P_number_to_two_digits_366(FP,*((INT*)(((BYTE*)date_360)+(4*sizeof(INT)))),(BYTE*)((BYTE*)(((BYTE*)string_363)+((12)*sizeof(BYTE)))));
#line  193 "times.occ"
      }
#line  193 "times.occ"
    }
#line  193 "times.occ"
    else
#line  194 "times.occ"
    if (true)
#line  194 "times.occ"
    {
#line  195 "times.occ"
      {
#line  196 "times.occ"
        P_number_to_two_digits_366(FP,*((INT*)(((BYTE*)date_360)+(3*sizeof(INT)))),(BYTE*)((BYTE*)(((BYTE*)string_363)+((12)*sizeof(BYTE)))));
#line  197 "times.occ"
        P_number_to_two_digits_366(FP,*((INT*)(((BYTE*)date_360)+(4*sizeof(INT)))),(BYTE*)((BYTE*)(((BYTE*)string_363)+((9)*sizeof(BYTE)))));
#line  197 "times.occ"
      }
#line  197 "times.occ"
    }
#line  197 "times.occ"
    else
#line  197 "times.occ"
    {
#line  197 "times.occ"
      SETERR(MSG_IF);
#line  197 "times.occ"
    }
#line  201 "times.occ"
    if (long_years_361)
#line  201 "times.occ"
    {
#line  202 "times.occ"
      {
#line  203 "times.occ"
        P_number_to_two_digits_366(FP,(*((INT*)(((BYTE*)date_360)+(5*sizeof(INT)))) / 100),(BYTE*)((BYTE*)(((BYTE*)string_363)+((15)*sizeof(BYTE)))));
#line  204 "times.occ"
        P_number_to_two_digits_366(FP,(*((INT*)(((BYTE*)date_360)+(5*sizeof(INT)))) % 100),(BYTE*)((BYTE*)(((BYTE*)string_363)+((17)*sizeof(BYTE)))));
#line  204 "times.occ"
      }
#line  204 "times.occ"
    }
#line  204 "times.occ"
    else
#line  205 "times.occ"
    if (true)
#line  205 "times.occ"
    {
#line  206 "times.occ"
      {
#line  207 "times.occ"
        P_number_to_two_digits_366(FP,(*((INT*)(((BYTE*)date_360)+(5*sizeof(INT)))) % 100),(BYTE*)((BYTE*)(((BYTE*)string_363)+((15)*sizeof(BYTE)))));
#line  208 "times.occ"
        {
#line  208 "times.occ"
          BYTE *_V0_367;
#line  208 "times.occ"
          {
#line  208 "times.occ"
            static BYTE TMP[2] = {32,32};
#line  208 "times.occ"
            _V0_367 = TMP;
#line  208 "times.occ"
          }
#line  208 "times.occ"
          ASSIGN(((BYTE*)(((BYTE*)string_363)+((17)*sizeof(BYTE)))),_V0_367,(2*sizeof(BYTE))); 
#line  208 "times.occ"
        }
#line  208 "times.occ"
      }
#line  208 "times.occ"
    }
#line  208 "times.occ"
    else
#line  208 "times.occ"
    {
#line  208 "times.occ"
      SETERR(MSG_IF);
#line  208 "times.occ"
    }
#line  211 "times.occ"
    *((BYTE*)(((BYTE*)string_363)+(2*sizeof(BYTE)))) = 58; 
#line  212 "times.occ"
    *((BYTE*)(((BYTE*)string_363)+(5*sizeof(BYTE)))) = 58; 
#line  213 "times.occ"
    *((BYTE*)(((BYTE*)string_363)+(8*sizeof(BYTE)))) = 32; 
#line  214 "times.occ"
    *((BYTE*)(((BYTE*)string_363)+(11*sizeof(BYTE)))) = 47; 
#line  215 "times.occ"
    *((BYTE*)(((BYTE*)string_363)+(14*sizeof(BYTE)))) = 47; 
#line  215 "times.occ"
  }
#line  215 "times.occ"
}

#line  220 "times.occ"
void P_so_time_to_ascii_times (INT32 time_369,BOOL long_years_370,BOOL days_first_371,BYTE *string_372)
#line  220 "times.occ"
{
#line  220 "times.occ"
  tSF_P_so_time_to_ascii_times SF;
#line  220 "times.occ"
  tSF_P_so_time_to_ascii_times *FP = &SF;
#line  244 "times.occ"
  {
#line  244 "times.occ"
    INT date_373[6];
#line  245 "times.occ"
    {
#line  246 "times.occ"
      P_so_time_to_date_times(time_369,(INT*)date_373);
#line  247 "times.occ"
      P_so_date_to_ascii_times((INT*)date_373,long_years_370,days_first_371,(BYTE*)string_372);
#line  247 "times.occ"
    }
#line  247 "times.occ"
  }
#line  247 "times.occ"
}

#line  251 "times.occ"
void P_so_today_date_times (tSF_P_so_today_date_times *FP)
#line  251 "times.occ"
{
#line  251 "times.occ"
  while(true)
#line  251 "times.occ"
  {
#line  251 "times.occ"
    switch(FP->_Header.IP)
#line  251 "times.occ"
    {
#line  251 "times.occ"
      CASE(0):  
#line  275 "times.occ"
        FP->_U2._C0.Param0=FP->fs_375;
#line  275 "times.occ"
        FP->_U2._C0.Param1=FP->ts_376;
#line  275 "times.occ"
        FP->_U2._C0.Param2=&FP->local_time_378;
#line  275 "times.occ"
        FP->_U2._C0.Param3=&FP->UTC_time_379;
#line  275 "times.occ"
        FP->_U2._C0.Param4=&FP->result_380;
#line  275 "times.occ"
        FP->_U2._C0.Chain = NULL;
#line  275 "times.occ"
        CALL(P_sp_time_time,&FP->_U2._C0,1,"P_sp_time_time");
#line  275 "times.occ"
      CASE(1):  
#line  277 "times.occ"
        if ((FP->result_380 == 0))
#line  277 "times.occ"
        {
#line  278 "times.occ"
          P_so_time_to_date_times(FP->local_time_378,(INT*)FP->date_377);
#line  278 "times.occ"
        }
#line  278 "times.occ"
        else
#line  279 "times.occ"
        if (true)
#line  279 "times.occ"
        {
#line  279 "times.occ"
          {
#line  279 "times.occ"
            INT i_381;
#line  280 "times.occ"
            for (i_381 = 0; i_381 != 0 + 6; i_381++)
#line  280 "times.occ"
            {
#line  281 "times.occ"
              *((INT*)(((BYTE*)FP->date_377)+(i_381*sizeof(INT)))) = 0; 
#line  281 "times.occ"
            }
#line  280 "times.occ"
          }
#line  280 "times.occ"
        }
#line  280 "times.occ"
        else
#line  280 "times.occ"
        {
#line  280 "times.occ"
          SETERR(MSG_IF);
#line  280 "times.occ"
        }
#line  280 "times.occ"
        RETURN();
#line  280 "times.occ"
      default: SETERR(MSG_IP);
#line  280 "times.occ"
    }
#line  280 "times.occ"
  }
#line  280 "times.occ"
}

#line  285 "times.occ"
void P_so_today_ascii_times (tSF_P_so_today_ascii_times *FP)
#line  285 "times.occ"
{
#line  285 "times.occ"
  while(true)
#line  285 "times.occ"
  {
#line  285 "times.occ"
    switch(FP->_Header.IP)
#line  285 "times.occ"
    {
#line  285 "times.occ"
      CASE(0):  
#line  315 "times.occ"
        FP->_U3._C0.Param0=FP->fs_383;
#line  315 "times.occ"
        FP->_U3._C0.Param1=FP->ts_384;
#line  315 "times.occ"
        FP->_U3._C0.Param2=&FP->local_time_388;
#line  315 "times.occ"
        FP->_U3._C0.Param3=&FP->UTC_time_389;
#line  315 "times.occ"
        FP->_U3._C0.Param4=&FP->result_390;
#line  315 "times.occ"
        FP->_U3._C0.Chain = NULL;
#line  315 "times.occ"
        CALL(P_sp_time_time,&FP->_U3._C0,1,"P_sp_time_time");
#line  315 "times.occ"
      CASE(1):  
#line  317 "times.occ"
        if ((FP->result_390 == 0))
#line  317 "times.occ"
        {
#line  318 "times.occ"
          P_so_time_to_ascii_times(FP->local_time_388,FP->long_years_385,FP->days_first_386,(BYTE*)FP->string_387);
#line  318 "times.occ"
        }
#line  318 "times.occ"
        else
#line  319 "times.occ"
        if (true)
#line  319 "times.occ"
        {
#line  319 "times.occ"
          {
#line  319 "times.occ"
            INT i_391;
#line  320 "times.occ"
            for (i_391 = 0; i_391 != 0 + 19; i_391++)
#line  320 "times.occ"
            {
#line  321 "times.occ"
              *((BYTE*)(((BYTE*)FP->string_387)+(i_391*sizeof(BYTE)))) = 32; 
#line  321 "times.occ"
            }
#line  320 "times.occ"
          }
#line  320 "times.occ"
        }
#line  320 "times.occ"
        else
#line  320 "times.occ"
        {
#line  320 "times.occ"
          SETERR(MSG_IF);
#line  320 "times.occ"
        }
#line  320 "times.occ"
        RETURN();
#line  320 "times.occ"
      default: SETERR(MSG_IP);
#line  320 "times.occ"
    }
#line  320 "times.occ"
  }
#line  320 "times.occ"
}


/*}}}*/
#endif
