/*{{{  File banner*/
/*@(#)=====================================================*\
||@(#)  Project : GPMIMD ESPRIT P5404
||@(#)  Authors : Mark Debbage, Mark Hill, Denis Nicole and Sean Wykes
||@(#)            University of Southampton
||  
||@(#)    Title : Prototype Source File for generated C
||@(#)   System : Occam 2 C
||@(#)  Version : 1.3
||@(#) Filename : Occam2C.c
||@(#)     Date : 3/4/97
\*@(#)====================================================*/
/*}}}*/

/*{{{  Insert SWITCHES*/
#define LIBRARY_UNIT
#define BYTES_PER_WORD 4
#define TERMINATE_ON_ERROR
#define CHECK_CONVERSIONS
#define CHECK_ARRAYS
#define CHECK_RANGES
#define NO_DEBUG
#define FASTGOTOS
#define SOURCE LITTLE

/*}}}*/
/*{{{  defines*/
#define DEFAULT_MEMSIZE_IN_INTS 1000
#define OCCAM_MAIN

/*}}}*/
/*{{{  includes*/
#include <stdio.h>
#include <errno.h>

#if  (defined USESIGTIMER) || (defined USE_NONBLOCKING_SOCKETS)
#include <signal.h>
#include <sys/time.h>
#endif

#ifdef USE_NONBLOCKING_SOCKETS
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef solaris
#include <stropts.h>
#include <sys/file.h>
#include <sys/conf.h>
#endif
#endif

#ifdef CALL_NAG_F90
#include <f90.h>
#endif

#include "Occam2C.h"

#ifdef USE_NONBLOCKING_SOCKETS
  #ifdef solaris
  #define SOCKET_SIGNAL SIGPOLL
  #else
  #define SOCKET_SIGNAL SIGIO
  #endif
#endif
/*}}}*/
/*{{{  Insert HEADER*/
typedef struct SF_P_check_current_source_89 tSF_P_check_current_source_89;
typedef struct SF_P_ss_scrstream_multiplexor_scrmux tSF_P_ss_scrstream_multiplexor_scrmux;
void P_ss_scrstream_multiplexor_scrmux (tSF_P_ss_scrstream_multiplexor_scrmux *FP);
struct SF_P_check_current_source_89
{
  tHeader _Header;
  tSF_P_ss_scrstream_multiplexor_scrmux *Chain;
  INT *prev_85;
  INT new_86;
  BYTE annotate_string_87[4];
};
struct SF_P_ss_scrstream_multiplexor_scrmux
{
  tHeader _Header;
  void *Chain;
  CHAN **screen_in_82;
  INT screen_in_82_Dim0;
  CHAN *screen_out_83;
  CHAN *stopper_84;
  union
  {
    INT any_90;
    struct
    {
      BOOL going_91;
      INT current_source_92;
      INT split_93;
      INT modulus_94;
      INT modulus_minus_1_95;
      INT index_98_Alt;
      INT index_98;
      INT index_98_End;
      INT index_106_Alt;
      INT index_106;
      INT index_106_End;
      union
      {
        struct
        {
          INT any_96;
          BYTE *_V1_97;
        } _S1;
        struct
        {
          BYTE str_99[256];
          INT32 len_100;
          tSF_P_check_current_source_89 _C5;
        } _S2;
        struct
        {
          BYTE ch_101;
          tSF_P_check_current_source_89 _C6;
        } _S3;
        struct
        {
          BYTE ch_102;
          tSF_P_check_current_source_89 _C7;
        } _S4;
        struct
        {
          INT32 x_103;
          tSF_P_check_current_source_89 _C8;
        } _S5;
        struct
        {
          INT32 x_104;
          INT32 y_105;
          tSF_P_check_current_source_89 _C9;
        } _S6;
        struct
        {
          BYTE str_107[256];
          INT32 len_108;
          tSF_P_check_current_source_89 _C0;
        } _S7;
        struct
        {
          BYTE ch_109;
          tSF_P_check_current_source_89 _C1;
        } _S8;
        struct
        {
          BYTE ch_110;
          tSF_P_check_current_source_89 _C2;
        } _S9;
        struct
        {
          INT32 x_111;
          tSF_P_check_current_source_89 _C3;
        } _S10;
        struct
        {
          INT32 x_112;
          INT32 y_113;
          tSF_P_check_current_source_89 _C4;
        } _S11;
      } _U1;
    } _S0;
  } _U0;
};

/*}}}*/

#if (defined GENPROTO) || !(defined LIBRARY_UNIT)
/*{{{  statics*/
jmp_buf STOPP_env;
int MAIN_ARGC ;
char **MAIN_ARGV;
tTask *QFP[NUM_PRIORITY_LEVELS],*QBP[NUM_PRIORITY_LEVELS],*CURTASK,*QTM; 
static volatile int TimerEvent = false;
static volatile int SocketEvent = false;
tTimer TIMER;
static int process_count;


/*}}}*/
#endif

#ifdef GENPROTO
/*{{{  seterr*/
void seterr(char *M,int L,char *F) {}
/*}}}*/
/*{{{  struct Prototypes*/
struct Prototypes
{
  char *Proto;
  char *Define;
  int Space;
};
/*}}}*/
/*{{{  static struct Prototypes Table[] =*/
static struct Prototypes Table[] =
{
  {"void P_ss_scrstream_multiplexor_scrmux (tSF_P_ss_scrstream_multiplexor_scrmux *FP);","P_ss_scrstream_multiplexor_scrmux",sizeof(tSF_P_ss_scrstream_multiplexor_scrmux)},

 {NULL,NULL,0}
} ;
/*}}}*/
/*{{{  int main(int argc, char**argv)*/
int main(int argc, char**argv)
{
  char *name;
  FILE *f;
  int fcnt;
  
  CheckPrimitiveSizes();

  if (argc<2)
  {
    name="scrmux.hdr";
    f=fopen(name,"w");
  }
  else
  {
    name = argv[argc-1];
    if (name[0]=='-')
    {
      name = "stdout";
      f=stdout;
    }
    else
    {
      f=fopen(name,"w");
    }
  }
  fcnt=argc-1;
  
  if (f==NULL)
    { fprintf(stderr,"Error - could not open file %s\n",name);exit(-1); }
  else
  {
    int arg;
    int i;
    fprintf(f,"#ifndef __scrmux_INCLUDES__\n");
    fprintf(f,"#define __scrmux_INCLUDES__\n");
    
    for(arg = 1; arg < fcnt; ++arg)
    {
      FILE *fh = fopen(argv[arg],"r");
      if (fh == NULL) { fprintf(stderr,"Error - could not read file %s\n",name); exit(-1); }
      while(!feof(fh))
      {
	char line[256];

	if (fgets(line,256,fh) == NULL) break;
	if (line[0] == '#')
	  if (strncmp(line,"#define WS",10)!=0) continue;
	fputs(line,f);
      }
      fclose(fh);
    }      
      
    i = 0;
    while (Table[i].Proto!=NULL)
    {
      if (Table[i].Define != NULL)
      {
	fprintf(f,"typedef struct SF_%s tSF_%s;\n",Table[i].Define,Table[i].Define);
	fprintf(f,"#define WS_%s (%d)\n",Table[i].Define,Table[i].Space);
      }
      fprintf(f,"%s\n",Table[i].Proto);
      i++;
    }
    fprintf(f,"#endif\n");

    if (f!=stdout) fclose(f);
  }
  return(0);
}     
/*}}}*/
#endif

#ifndef LIBRARY_UNIT
/*{{{  seterr*/
static void DONE_SETERR() {}

void seterr(char *M,int L,char *F)
{
  if (M!=NULL) fputs(M,stderr);
  fprintf(stderr,MSG_EFROL,L,F);
  DONE_SETERR();
  SETERR_PROCEED;
}
/*}}}*/
/*{{{  DEBUGDONE,MARK_SCHEDULE*/
#ifndef NO_DEBUG
void DEBUGDONE(void) {}
void MARK_SCHEDULE(void) {}
#endif

/*}}}*/
/*{{{  timer*/
#ifdef USESIGTIMER
static struct timeval tv_start;
/*{{{  static void TimerSignalHandler(int sig)*/
static void TimerSignalHandler(int sig)
{
  switch(sig)
  {
    case SIGALRM:
      {
	struct timeval tv;
	tTask *task;

	gettimeofday(&tv,NULL);
	TIMER = ((tv.tv_usec - tv_start.tv_usec)>>6) + (1000000>>6) * (tv.tv_sec - tv_start.tv_sec);
	if (QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
	  TimerEvent = true;
      }
      break;

    default:
      fprintf(stderr,"Error - Caught signal %d - Exiting\n",sig);
      fflush(stderr);
      exit(20);
  }
}
/*}}}*/
/*{{{  static void Init_Timer()*/
static void Init_Timer()
{
  struct itimerval itv;
#ifndef solaris
  struct sigaction sa;
#endif

  TIMER = 0;
  gettimeofday(&tv_start,NULL);
  TimerSignalHandler(SIGALRM);
  
#ifndef solaris
  memset((char*)&sa,0,sizeof(sa));
  sa.sa_handler = TimerSignalHandler;

#ifdef SA_RESTART
  sa.sa_flags = SA_RESTART;
#endif

  sigaction(SIGALRM,&sa,NULL);
#else
  sigset(SIGALRM,TimerSignalHandler);
#endif

  itv.it_interval.tv_usec = 1000;
  itv.it_interval.tv_sec = 0;
     
  itv.it_value.tv_usec = 1;
  itv.it_value.tv_sec = 0;

  if (setitimer(ITIMER_REAL,&itv,NULL)) 
    fprintf(stderr,"Error - setitimer failed\n");

  QTM = NoTask;
  TimerEvent = false;
}

/*}}}*/

#else
static void Init_Timer() { (void)clock(); TimerEvent = false; }
#endif
/*}}}*/
/*{{{  sockets*/
#ifdef USE_NONBLOCKING_SOCKETS
static int io_limit;
static struct timeval io_zerotime;

static int    io_socket;
static tTask *io_task = NoTask;

/*{{{  void SocketHandler (int sig)*/
void SocketHandler (int sig)
{
  switch (sig)
  {
    case SOCKET_SIGNAL:
    {
      #ifdef MD_DEBUG
      fprintf(stderr,"Caught signal %d\n",sig);
      #endif
      
      SocketEvent = true;
      
      #ifdef solaris
      signal (SOCKET_SIGNAL, SocketHandler);
      #endif
      
      break;
    }
    default:
      fprintf(stderr,"Error - Caught unexpected signal %d - exiting\n",sig);
      fflush(stderr);
      exit(20);
  }  
}
/*}}}*/
 
/*{{{  void WaitSocket (int socket)*/
void WaitSocket (int socket)
{
  fd_set io_set;

  io_socket = socket;

  FD_ZERO (&io_set);
  FD_SET  (socket,&io_set);
  
  errno = 0;
  while (select (io_limit, &io_set, NULL, NULL, &io_zerotime) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
  
  if (!FD_ISSET(socket,&io_set))
  {
    if (io_task == NoTask)
      io_task = CURTASK;
    else
    {
      fprintf(stderr, "Error - Implementation restriction, only one signaling socket\n");
      exit(-1);
    }
    DeSchedule(TSOCK_p);
  }
}
/*}}}*/

/*{{{  void EnableSocket (int socket)*/
void EnableSocket (int socket)
{
  errno = 0;
  
  #ifdef solaris
  if (ioctl(socket,I_SETSIG,S_RDNORM) < 0)
  {
    fprintf(stderr,"Error - could not set signal handler for socket (errno %d)\n",errno);
    exit(-1);
  }
  #else
  if (fcntl(socket, F_SETOWN, getpid()) < 0)
  {
    fprintf(stderr,"Error - could not set owner on socket (errno %d)\n",errno);
    exit(-1);
  }
  if (fcntl(socket, F_SETFL, FASYNC)    < 0)
  {
    fprintf(stderr,"Error - could not set asynchronous socket (errno %d)\n",errno);
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void DisableSocket (int socket)*/
void DisableSocket (int socket)
{
  #ifdef sun4
  if (fcntl(socket, F_SETFL, FSYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
  #ifdef linux
  if (fcntl(socket, F_SETFL, FASYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void ServeSocket (void)*/
void ServeSocket (void)
{
  fd_set io_set;
  int res;

  /* In the general case there's a timing hazard here since a new signal
     could arrive and we can lose it. Really need test-and-set or a
     semaphore. For hostio, however, there's only ever one outstanding 
     communication and this thread is serving it. Hence, no problem here. */

  SocketEvent = false; 

  FD_ZERO (&io_set);
  FD_SET  (io_socket,&io_set);
  
  errno = 0;
  while ((res = select (io_limit, &io_set, NULL, NULL, &io_zerotime)) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
      
  if (res == 0)
  {
    /*fprintf(stderr,"Could not locate socket signal source, ignoring select\n");*/
    return;
  }
  
  if (!FD_ISSET(io_socket,&io_set))
  {
    fprintf(stderr,"Error - socket is not ready\n");
    exit(-1);
  }

  if (io_task != NoTask)
  {
    ReSchedule(io_task);
    io_task = NoTask;
  }
}
/*}}}*/

/*{{{  void Init_Sockets()*/
void Init_Sockets()
{
  io_limit = ulimit (4,0);

  timerclear (&io_zerotime);

  signal (SOCKET_SIGNAL, SocketHandler);
  #ifdef linux
  {
    struct sigaction action;
    sigaction(SIGIO,NULL,&action);
    action.sa_flags = (action.sa_flags & (~SA_ONESHOT));
    sigaction(SIGIO,&action,NULL);
  }
  #endif
}
/*}}}*/
#else
void WaitSocket (int socket)
{ 
  fprintf(stderr, "Error - No SIGSOCKETS\n"); 
}
#endif
/*}}}*/

/*{{{  static void Init_Scheduler()*/
static void Init_Scheduler()
{
  int i;

  for(i = 0; i < NUM_PRIORITY_LEVELS; ++i)
    QFP[i] = QBP[i] = NoTask;

  CURTASK = NoTask;

  Init_Timer();

  #ifdef USE_NONBLOCKING_SOCKETS
  Init_Sockets();  
  #endif
}
/*}}}*/
/*{{{  static void Scheduler()*/
static void Scheduler()
{
  if (setjmp(STOPP_env)) DeSchedule(0);
  
  while(CURTASK != NoTask || TimerEvent || SocketEvent)
  {
    int pri;

#ifdef USESIGTIMER
    /*{{{  if (TimerEvent)*/
    if (TimerEvent)
    {
    #ifdef DEBUG
	fprintf(stderr,"Timer = %d\n",TIMER);
    #endif
      TimerEvent = false;
      while(QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
      {
    #ifdef DEBUG
	{  
	  tTask *task = QTM;
    
	  fprintf(stderr,"Timer Queue contains:");
	  if (task == NoTask) fprintf(stderr,"No Tasks");
	  else while(task != NoTask) { fprintf(stderr,"%d(%d) ",task->TaskId,task->comms.timer.time); task = task->Next; }
	  fprintf(stderr,"\n");
	}  
    #endif
	if (QTM->AltMode == Waiting_p) QTM->AltMode = TReady_p;
	ReSchedule(QTM);
      }
    }
    /*}}}*/
#endif

#ifdef USE_NONBLOCKING_SOCKETS
    if (SocketEvent)
      ServeSocket();
#endif

    for(pri = 0; pri < NUM_PRIORITY_LEVELS; ++pri)
    {
#ifdef DEBUG
  {
    tTask *task = QFP[pri];
    fprintf(stderr,"Task Queue %d contains:",pri);
    if (task == NoTask) fprintf(stderr,"No Tasks");
    else while(task != NoTask) { fprintf(stderr,"%d ",task->TaskId); task = task->Next; }
    fprintf(stderr,"\n");
  }
#endif

      if ((CURTASK=QFP[pri]) != NoTask)
      {
	/*{{{  #ifdef SHOWTASKING*/
	#ifdef SHOWTASKING
		fprintf(stderr,"Scheduler - Current task is %c%d (%s) IP=%d\n",(CURTASK->TaskPriority)?'L':'H',CURTASK->TaskId,((tHeader *)CURTASK->FP)->ProcName,((tHeader *)CURTASK->FP)->IP); fflush(stderr); 
	#endif
	/*}}}*/
	/*{{{  #ifndef NO_DEBUG*/
	#ifndef NO_DEBUG
	MARK_SCHEDULE() ;
	#endif
	/*}}}*/
	CURTASK->Func (CURTASK->FP);
	break;
      }
    }

    /*{{{  catch any signals*/
    #if (defined USESIGTIMER && defined USE_NONBLOCKING_SOCKETS)
	if (CURTASK == NoTask && (QTM != NoTask || io_task != NoTask))
	  while(!TimerEvent && !SocketEvent)
	    pause();
    #else
      #if (defined USESIGTIMER)
	  if (CURTASK == NoTask && QTM != NoTask)
	    while(!TimerEvent)
	      pause();
      #endif
      
      #if (defined USE_NONBLOCKING_SOCKETS)
	  if (CURTASK == NoTask && io_task != NoTask)
	    while(!SocketEvent)
	      pause();
      #endif
    #endif
    /*}}}*/

  }

#ifdef DEBUG
  fprintf(stderr,"Scheduling Queue empty\n");
#endif
}

/*}}}*/
/*{{{  void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)
{
  static int NextTaskId = 0;
  process_count++;
  
  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = (CURTASK != NoTask && CURTASK->TaskPriority == HighPriority) ? HighPriority : Priority;
  ((tHeader *)FP)->ProcName = name;
  
  if (Priority < 0 || Priority >= NUM_PRIORITY_LEVELS) SETERR(MSG_PRI);
  
  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Processor)
{
  static int NextTaskId = 0;
  process_count++;

  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = LowPriority;

  ((tHeader *)FP)->ProcName = name;

  SETERR("PLACED PAR is not supported in this implementation");

  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void End_Process()*/
void End_Process()
{
  register tTask *task = CURTASK;
  process_count--;
    
  QFP[task->TaskPriority] = task->Next;
  if (QFP[task->TaskPriority] == NoTask) QBP[task->TaskPriority] = NoTask;
  task->Next = NoTask;
  if (task->Parent)
  {
    if (--(task->Parent->Children) == 0) ReSchedule(task->Parent);
  }
}
/*}}}*/

/*{{{  SPOC iserver definitions*/
#ifdef USE_SPOC_ISERVER
extern int CocoPops;
#include "spserver.hdr"

struct SF_P_spoc_iserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_iserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_iserver_spserver spserver;
} tSF_P_spoc_iserver_caller;

static tSF_P_spoc_iserver_caller spoc_iserver_data;
static tTask spoc_iserver_task;

static tFuncPtr P_spoc_iserver_caller (tSF_P_spoc_iserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_iserver_spserver,&FP->spserver,1,"P_spoc_iserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/
/*{{{  SPOC aserver definitions*/
#ifdef USE_SPOC_ASERVER
#include "spserver.hdr"

struct SF_P_spoc_aserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_aserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_aserver_spserver spserver;
} tSF_P_spoc_aserver_caller;

static tSF_P_spoc_aserver_caller spoc_aserver_data;
static tTask spoc_aserver_task;

static tFuncPtr P_spoc_aserver_caller (tSF_P_spoc_aserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_aserver_spserver,&FP->spserver,1,"P_spoc_aserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/

/*{{{  int main(int argc, char **argv)*/
int main(int argc, char **argv)
{
  void *FP=NULL;
  tSF_ *MAINFP=(tSF_ *)malloc(sizeof(tSF_));
  tTask main_t;
  INT mem_size = (argc>1 && atoi(argv[1])>0)?atoi(argv[1]):DEFAULT_MEMSIZE_IN_INTS;
  INT *mem=(INT*)malloc(mem_size*sizeof(INT));
  CHAN fs,ts;
  
  if (MAINFP==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s bytes for occam workspace failed\n",sizeof(tSF_));
    exit(-1);
  }
  if (mem_size>0 && mem==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s INTs for occam memory array failed\n",mem_size);
    exit(-1);
  }
  (void) clock();
  MAIN_ARGC = argc ;
  MAIN_ARGV = argv ;
  process_count = 0;
 
  CheckPrimitiveSizes();
  INITCH(&fs);
  INITCH(&ts);
  Init_Scheduler();
  
  STARTP(&main_t,,MAINFP,"",LowPriority);

  /*{{{  #ifdef USE_SPOC_ISERVER*/
  #ifdef USE_SPOC_ISERVER
  #ifdef SHOWTASKING
  CocoPops=true;
  #endif
  spoc_iserver_data.fs = &fs;
  spoc_iserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_iserver_task, P_spoc_iserver_caller, &spoc_iserver_data, "P_spoc_iserver_spserver",LowPriority);
  #endif
  /*}}}*/
  /*{{{  #ifdef USE_SPOC_ASERVER*/
  #ifdef USE_SPOC_ASERVER
  spoc_aserver_data.fs = &fs;
  spoc_aserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_aserver_task, P_spoc_aserver_caller, &spoc_aserver_data, "P_spoc_aserver_spserver",LowPriority);
  #endif
  /*}}}*/
/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_init(argc,argv);
#endif
/*}}}*/
  
  Scheduler();

/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_finish(0);
#endif
/*}}}*/
  if (process_count == 0)
    return 0;
  else
  {
    fprintf(stderr,"Deadlock: %d stopped process%s.\n", process_count,(process_count>1)?"es":"");
    return 1;
  }
}     
/*}}}*/
#endif

#ifndef GENPROTO
/*{{{  Insert DEBUG*/

/*}}}*/
/*{{{  Insert CODE*/
static void P_check_current_source_89 (tSF_P_check_current_source_89 *FP)
#line   39 "scrmux.occ"
{
#line   39 "scrmux.occ"
  while(true)
#line   39 "scrmux.occ"
  {
#line   39 "scrmux.occ"
    switch(FP->_Header.IP)
#line   39 "scrmux.occ"
    {
#line   39 "scrmux.occ"
      CASE(0):  
#line   42 "scrmux.occ"
        if (!(FP->new_86 == *FP->prev_85)) GOTO(2);
#line   43 "scrmux.occ"
        GOTO(1);
#line   43 "scrmux.occ"
      CASE(2):  
#line   44 "scrmux.occ"
        if (!true) GOTO(3);
#line   48 "scrmux.occ"
        {
#line   48 "scrmux.occ"
          BYTE *_V0_88;
#line   48 "scrmux.occ"
          {
#line   48 "scrmux.occ"
            static BYTE TMP[4] = {13,10,32,62};
#line   48 "scrmux.occ"
            _V0_88 = TMP;
#line   48 "scrmux.occ"
          }
#line   48 "scrmux.occ"
          ASSIGN(((BYTE*)(((BYTE*)FP->annotate_string_87)+((0)*sizeof(BYTE)))),_V0_88,(4*sizeof(BYTE))); 
#line   48 "scrmux.occ"
        }
#line   49 "scrmux.occ"
        *((BYTE*)(((BYTE*)FP->annotate_string_87)+(2*sizeof(BYTE)))) = BYTEINT((48 + FP->new_86)); 
#line   50 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 8;
#line   50 "scrmux.occ"
        OUTPUT1(FP->Chain->screen_out_83,&FP->_Header.Temp.VBYTE,4);
#line   50 "scrmux.occ"
      CASE(4):  
#line   50 "scrmux.occ"
        FP->_Header.Temp.VINT32 = 4;
#line   50 "scrmux.occ"
        OUTPUT4(FP->Chain->screen_out_83,&FP->_Header.Temp.VINT32,5);
#line   50 "scrmux.occ"
      CASE(5):  
#line   50 "scrmux.occ"
        OUTPUT(FP->Chain->screen_out_83,FP->annotate_string_87,(4)*(sizeof(BYTE)),6);
#line   50 "scrmux.occ"
      CASE(6):  
#line   51 "scrmux.occ"
        *FP->prev_85 = FP->new_86; 
#line   51 "scrmux.occ"
        GOTO(1);
#line   51 "scrmux.occ"
      CASE(3):  
#line   51 "scrmux.occ"
        SETERR(MSG_IF);
#line   51 "scrmux.occ"
      CASE(1):  
#line   51 "scrmux.occ"
        RETURN();
#line   51 "scrmux.occ"
      default: SETERR(MSG_IP);
#line   51 "scrmux.occ"
    }
#line   51 "scrmux.occ"
  }
#line   51 "scrmux.occ"
}

#line    6 "scrmux.occ"
void P_ss_scrstream_multiplexor_scrmux (tSF_P_ss_scrstream_multiplexor_scrmux *FP)
#line    6 "scrmux.occ"
{
#line    6 "scrmux.occ"
  while(true)
#line    6 "scrmux.occ"
  {
#line    6 "scrmux.occ"
    switch(FP->_Header.IP)
#line    6 "scrmux.occ"
    {
#line    6 "scrmux.occ"
      CASE(0):  
#line   57 "scrmux.occ"
        if (!((FP->screen_in_82_Dim0) > 256)) GOTO(2);
#line   58 "scrmux.occ"
        SETERR(MSG_STOP);
#line   58 "scrmux.occ"
        GOTO(1);
#line   58 "scrmux.occ"
      CASE(2):  
#line   59 "scrmux.occ"
        if (!((FP->screen_in_82_Dim0) == 0)) GOTO(3);
#line   61 "scrmux.occ"
        INPUT4(FP->stopper_84,&FP->_U0.any_90,4);
#line   61 "scrmux.occ"
      CASE(4):  
#line   61 "scrmux.occ"
        GOTO(1);
#line   61 "scrmux.occ"
      CASE(3):  
#line   62 "scrmux.occ"
        if (!true) GOTO(5);
#line   67 "scrmux.occ"
        FP->_U0._S0.going_91 = true; 
#line   68 "scrmux.occ"
        FP->_U0._S0.current_source_92 = -1; 
#line   69 "scrmux.occ"
        FP->_U0._S0.split_93 = 0; 
#line   70 "scrmux.occ"
        GOTO(6);
#line   70 "scrmux.occ"
      CASE(7):  
#line   71 "scrmux.occ"
        FP->_U0._S0.modulus_94 = (INT)(FP->screen_in_82_Dim0);
#line   72 "scrmux.occ"
        FP->_U0._S0.modulus_minus_1_95 = (INT)(FP->_U0._S0.modulus_94 - 1);
#line   75 "scrmux.occ"
        ALT();
#line   76 "scrmux.occ"
        ENBC(true,FP->stopper_84);
#line   81 "scrmux.occ"
        FP->_U0._S0.index_98 = FP->_U0._S0.split_93;FP->_U0._S0.index_98_End = FP->_U0._S0.index_98 + (FP->_U0._S0.modulus_94 - FP->_U0._S0.split_93);
#line   81 "scrmux.occ"
        for (; FP->_U0._S0.index_98 != FP->_U0._S0.index_98_End; FP->_U0._S0.index_98++)
#line   81 "scrmux.occ"
        {
#line   81 "scrmux.occ"
          ENBC(true,*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))));
#line   81 "scrmux.occ"
        }
#line  198 "scrmux.occ"
        FP->_U0._S0.index_106 = 0;FP->_U0._S0.index_106_End = FP->_U0._S0.index_106 + FP->_U0._S0.split_93;
#line  198 "scrmux.occ"
        for (; FP->_U0._S0.index_106 != FP->_U0._S0.index_106_End; FP->_U0._S0.index_106++)
#line  198 "scrmux.occ"
        {
#line  198 "scrmux.occ"
          ENBC(true,*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))));
#line  198 "scrmux.occ"
        }
#line  198 "scrmux.occ"
        ALTWT(8);
#line  198 "scrmux.occ"
      CASE(8):  
#line  198 "scrmux.occ"
        {
#line  198 "scrmux.occ"
          BOOL TMP = false;
#line   76 "scrmux.occ"
          TMP |= DISC(9,true,FP->stopper_84);
#line   76 "scrmux.occ"
          {
#line   76 "scrmux.occ"
            BOOL OLDTMP = TMP;
#line   76 "scrmux.occ"
            FP->_U0._S0.index_98 = FP->_U0._S0.split_93;FP->_U0._S0.index_98_End = FP->_U0._S0.index_98 + (FP->_U0._S0.modulus_94 - FP->_U0._S0.split_93);
#line   76 "scrmux.occ"
            for (; FP->_U0._S0.index_98 != FP->_U0._S0.index_98_End; FP->_U0._S0.index_98++)
#line   76 "scrmux.occ"
            {
#line   76 "scrmux.occ"
              TMP |= DISC(10,true,*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))));
#line   76 "scrmux.occ"
              if (TMP && (!OLDTMP))FP->_U0._S0.index_98_Alt = FP->_U0._S0.index_98;
#line   76 "scrmux.occ"
              OLDTMP=TMP;
#line   76 "scrmux.occ"
            }
#line   76 "scrmux.occ"
          }
#line   76 "scrmux.occ"
          {
#line   76 "scrmux.occ"
            BOOL OLDTMP = TMP;
#line   76 "scrmux.occ"
            FP->_U0._S0.index_106 = 0;FP->_U0._S0.index_106_End = FP->_U0._S0.index_106 + FP->_U0._S0.split_93;
#line   76 "scrmux.occ"
            for (; FP->_U0._S0.index_106 != FP->_U0._S0.index_106_End; FP->_U0._S0.index_106++)
#line   76 "scrmux.occ"
            {
#line   76 "scrmux.occ"
              TMP |= DISC(11,true,*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))));
#line   76 "scrmux.occ"
              if (TMP && (!OLDTMP))FP->_U0._S0.index_106_Alt = FP->_U0._S0.index_106;
#line   76 "scrmux.occ"
              OLDTMP=TMP;
#line   76 "scrmux.occ"
            }
#line   76 "scrmux.occ"
          }
#line   76 "scrmux.occ"
          FP->_U0._S0.index_98 = FP->_U0._S0.index_98_Alt;
#line   76 "scrmux.occ"
          FP->_U0._S0.index_106 = FP->_U0._S0.index_106_Alt;
#line   76 "scrmux.occ"
        }
#line   76 "scrmux.occ"
        ALTEND();
#line   76 "scrmux.occ"
      CASE(9):  
#line   76 "scrmux.occ"
        INPUT4(FP->stopper_84,&FP->_U0._S0._U1._S1.any_96,13);
#line   76 "scrmux.occ"
      CASE(13):  
#line   79 "scrmux.occ"
        {
#line   79 "scrmux.occ"
          static BYTE TMP[2] = {13,10};
#line   79 "scrmux.occ"
          FP->_U0._S0._U1._S1._V1_97 = TMP;
#line   79 "scrmux.occ"
        }
#line   79 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 8;
#line   79 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,14);
#line   79 "scrmux.occ"
      CASE(14):  
#line   79 "scrmux.occ"
        FP->_Header.Temp.VINT32 = 2;
#line   79 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_Header.Temp.VINT32,15);
#line   79 "scrmux.occ"
      CASE(15):  
#line   79 "scrmux.occ"
        OUTPUT(FP->screen_out_83,FP->_U0._S0._U1._S1._V1_97,(2)*(sizeof(BYTE)),16);
#line   79 "scrmux.occ"
      CASE(16):  
#line   80 "scrmux.occ"
        FP->_U0._S0.going_91 = false; 
#line   80 "scrmux.occ"
        GOTO(12);
#line   80 "scrmux.occ"
      CASE(10):  
#line   80 "scrmux.occ"
        INPUT1(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_Header.Temp.VBYTE,17);
#line   80 "scrmux.occ"
      CASE(17):  
#line   80 "scrmux.occ"
        switch(FP->_Header.Temp.VBYTE)
#line   80 "scrmux.occ"
        {
#line   80 "scrmux.occ"
          case 8: GOTO (19);
#line   80 "scrmux.occ"
          case 18: GOTO (20);
#line   80 "scrmux.occ"
          case 6: GOTO (21);
#line   80 "scrmux.occ"
          case 19: GOTO (22);
#line   80 "scrmux.occ"
          case 5: GOTO (23);
#line   80 "scrmux.occ"
          case 0: GOTO (24);
#line   80 "scrmux.occ"
          case 1: GOTO (25);
#line   80 "scrmux.occ"
          case 2: GOTO (26);
#line   80 "scrmux.occ"
          case 3: GOTO (27);
#line   80 "scrmux.occ"
          case 4: GOTO (28);
#line   80 "scrmux.occ"
          case 7: GOTO (29);
#line   80 "scrmux.occ"
          case 9: GOTO (30);
#line   80 "scrmux.occ"
          case 10: GOTO (31);
#line   80 "scrmux.occ"
          case 11: GOTO (32);
#line   80 "scrmux.occ"
          case 12: GOTO (33);
#line   80 "scrmux.occ"
          case 13: GOTO (34);
#line   80 "scrmux.occ"
          case 15: GOTO (35);
#line   80 "scrmux.occ"
          case 16: GOTO (36);
#line   80 "scrmux.occ"
          case 17: GOTO (37);
#line   80 "scrmux.occ"
          case 20: GOTO (38);
#line   80 "scrmux.occ"
          case 21: GOTO (39);
#line   80 "scrmux.occ"
          case 22: GOTO (40);
#line   80 "scrmux.occ"
          case 23: GOTO (41);
#line   80 "scrmux.occ"
          case 24: GOTO (42);
#line   80 "scrmux.occ"
          default: SETERR(MSG_CASEIN);
#line   80 "scrmux.occ"
        }
#line   80 "scrmux.occ"
        break;
#line   80 "scrmux.occ"
      CASE(19):  
#line   87 "scrmux.occ"
        INPUT4(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S2.len_100,43);
#line   87 "scrmux.occ"
      CASE(43):  
#line   87 "scrmux.occ"
        CHK(FP->_U0._S0._U1._S2.len_100<=256,MSG_CITL);
#line   87 "scrmux.occ"
        INPUT(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),FP->_U0._S0._U1._S2.str_99,(FP->_U0._S0._U1._S2.len_100)*(sizeof(BYTE)),44);
#line   87 "scrmux.occ"
      CASE(44):  
#line   89 "scrmux.occ"
        FP->_U0._S0._U1._S2._C5.prev_85=&FP->_U0._S0.current_source_92;
#line   89 "scrmux.occ"
        FP->_U0._S0._U1._S2._C5.new_86=FP->_U0._S0.index_98;
#line   89 "scrmux.occ"
        FP->_U0._S0._U1._S2._C5.Chain = FP;
#line   89 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S2._C5,45,"P_check_current_source_89");
#line   89 "scrmux.occ"
      CASE(45):  
#line   90 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 8;
#line   90 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,46);
#line   90 "scrmux.occ"
      CASE(46):  
#line   90 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_U0._S0._U1._S2.len_100,47);
#line   90 "scrmux.occ"
      CASE(47):  
#line   90 "scrmux.occ"
        OUTPUT(FP->screen_out_83,FP->_U0._S0._U1._S2.str_99,(FP->_U0._S0._U1._S2.len_100)*(sizeof(BYTE)),48);
#line   90 "scrmux.occ"
      CASE(48):  
#line   90 "scrmux.occ"
        GOTO(18);
#line   90 "scrmux.occ"
      CASE(20):  
#line   94 "scrmux.occ"
        INPUT1(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S3.ch_101,49);
#line   94 "scrmux.occ"
      CASE(49):  
#line   96 "scrmux.occ"
        FP->_U0._S0._U1._S3._C6.prev_85=&FP->_U0._S0.current_source_92;
#line   96 "scrmux.occ"
        FP->_U0._S0._U1._S3._C6.new_86=FP->_U0._S0.index_98;
#line   96 "scrmux.occ"
        FP->_U0._S0._U1._S3._C6.Chain = FP;
#line   96 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S3._C6,50,"P_check_current_source_89");
#line   96 "scrmux.occ"
      CASE(50):  
#line   97 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 18;
#line   97 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,51);
#line   97 "scrmux.occ"
      CASE(51):  
#line   97 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_U0._S0._U1._S3.ch_101,52);
#line   97 "scrmux.occ"
      CASE(52):  
#line   97 "scrmux.occ"
        GOTO(18);
#line   97 "scrmux.occ"
      CASE(21):  
#line  101 "scrmux.occ"
        INPUT1(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S4.ch_102,53);
#line  101 "scrmux.occ"
      CASE(53):  
#line  103 "scrmux.occ"
        FP->_U0._S0._U1._S4._C7.prev_85=&FP->_U0._S0.current_source_92;
#line  103 "scrmux.occ"
        FP->_U0._S0._U1._S4._C7.new_86=FP->_U0._S0.index_98;
#line  103 "scrmux.occ"
        FP->_U0._S0._U1._S4._C7.Chain = FP;
#line  103 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S4._C7,54,"P_check_current_source_89");
#line  103 "scrmux.occ"
      CASE(54):  
#line  104 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 6;
#line  104 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,55);
#line  104 "scrmux.occ"
      CASE(55):  
#line  104 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_U0._S0._U1._S4.ch_102,56);
#line  104 "scrmux.occ"
      CASE(56):  
#line  104 "scrmux.occ"
        GOTO(18);
#line  104 "scrmux.occ"
      CASE(22):  
#line  108 "scrmux.occ"
        INPUT4(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S5.x_103,57);
#line  108 "scrmux.occ"
      CASE(57):  
#line  110 "scrmux.occ"
        FP->_U0._S0._U1._S5._C8.prev_85=&FP->_U0._S0.current_source_92;
#line  110 "scrmux.occ"
        FP->_U0._S0._U1._S5._C8.new_86=FP->_U0._S0.index_98;
#line  110 "scrmux.occ"
        FP->_U0._S0._U1._S5._C8.Chain = FP;
#line  110 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S5._C8,58,"P_check_current_source_89");
#line  110 "scrmux.occ"
      CASE(58):  
#line  111 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 19;
#line  111 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,59);
#line  111 "scrmux.occ"
      CASE(59):  
#line  111 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_U0._S0._U1._S5.x_103,60);
#line  111 "scrmux.occ"
      CASE(60):  
#line  111 "scrmux.occ"
        GOTO(18);
#line  111 "scrmux.occ"
      CASE(23):  
#line  115 "scrmux.occ"
        INPUT4(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S6.x_104,61);
#line  115 "scrmux.occ"
      CASE(61):  
#line  115 "scrmux.occ"
        INPUT4(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_98,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S6.y_105,62);
#line  115 "scrmux.occ"
      CASE(62):  
#line  117 "scrmux.occ"
        FP->_U0._S0._U1._S6._C9.prev_85=&FP->_U0._S0.current_source_92;
#line  117 "scrmux.occ"
        FP->_U0._S0._U1._S6._C9.new_86=FP->_U0._S0.index_98;
#line  117 "scrmux.occ"
        FP->_U0._S0._U1._S6._C9.Chain = FP;
#line  117 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S6._C9,63,"P_check_current_source_89");
#line  117 "scrmux.occ"
      CASE(63):  
#line  118 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 5;
#line  118 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,64);
#line  118 "scrmux.occ"
      CASE(64):  
#line  118 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_U0._S0._U1._S6.x_104,65);
#line  118 "scrmux.occ"
      CASE(65):  
#line  118 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_U0._S0._U1._S6.y_105,66);
#line  118 "scrmux.occ"
      CASE(66):  
#line  118 "scrmux.occ"
        GOTO(18);
#line  118 "scrmux.occ"
      CASE(24):  
#line  122 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 0;
#line  122 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,67);
#line  122 "scrmux.occ"
      CASE(67):  
#line  122 "scrmux.occ"
        GOTO(18);
#line  122 "scrmux.occ"
      CASE(25):  
#line  126 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 1;
#line  126 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,68);
#line  126 "scrmux.occ"
      CASE(68):  
#line  126 "scrmux.occ"
        GOTO(18);
#line  126 "scrmux.occ"
      CASE(26):  
#line  130 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 2;
#line  130 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,69);
#line  130 "scrmux.occ"
      CASE(69):  
#line  130 "scrmux.occ"
        GOTO(18);
#line  130 "scrmux.occ"
      CASE(27):  
#line  134 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 3;
#line  134 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,70);
#line  134 "scrmux.occ"
      CASE(70):  
#line  134 "scrmux.occ"
        GOTO(18);
#line  134 "scrmux.occ"
      CASE(28):  
#line  138 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 4;
#line  138 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,71);
#line  138 "scrmux.occ"
      CASE(71):  
#line  138 "scrmux.occ"
        GOTO(18);
#line  138 "scrmux.occ"
      CASE(29):  
#line  142 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 7;
#line  142 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,72);
#line  142 "scrmux.occ"
      CASE(72):  
#line  142 "scrmux.occ"
        GOTO(18);
#line  142 "scrmux.occ"
      CASE(30):  
#line  146 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 9;
#line  146 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,73);
#line  146 "scrmux.occ"
      CASE(73):  
#line  146 "scrmux.occ"
        GOTO(18);
#line  146 "scrmux.occ"
      CASE(31):  
#line  150 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 10;
#line  150 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,74);
#line  150 "scrmux.occ"
      CASE(74):  
#line  150 "scrmux.occ"
        GOTO(18);
#line  150 "scrmux.occ"
      CASE(32):  
#line  154 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 11;
#line  154 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,75);
#line  154 "scrmux.occ"
      CASE(75):  
#line  154 "scrmux.occ"
        GOTO(18);
#line  154 "scrmux.occ"
      CASE(33):  
#line  158 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 12;
#line  158 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,76);
#line  158 "scrmux.occ"
      CASE(76):  
#line  158 "scrmux.occ"
        GOTO(18);
#line  158 "scrmux.occ"
      CASE(34):  
#line  162 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 13;
#line  162 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,77);
#line  162 "scrmux.occ"
      CASE(77):  
#line  162 "scrmux.occ"
        GOTO(18);
#line  162 "scrmux.occ"
      CASE(35):  
#line  166 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 15;
#line  166 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,78);
#line  166 "scrmux.occ"
      CASE(78):  
#line  166 "scrmux.occ"
        GOTO(18);
#line  166 "scrmux.occ"
      CASE(36):  
#line  170 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 16;
#line  170 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,79);
#line  170 "scrmux.occ"
      CASE(79):  
#line  170 "scrmux.occ"
        GOTO(18);
#line  170 "scrmux.occ"
      CASE(37):  
#line  174 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 17;
#line  174 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,80);
#line  174 "scrmux.occ"
      CASE(80):  
#line  174 "scrmux.occ"
        GOTO(18);
#line  174 "scrmux.occ"
      CASE(38):  
#line  178 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 20;
#line  178 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,81);
#line  178 "scrmux.occ"
      CASE(81):  
#line  178 "scrmux.occ"
        GOTO(18);
#line  178 "scrmux.occ"
      CASE(39):  
#line  182 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 21;
#line  182 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,82);
#line  182 "scrmux.occ"
      CASE(82):  
#line  182 "scrmux.occ"
        GOTO(18);
#line  182 "scrmux.occ"
      CASE(40):  
#line  186 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 22;
#line  186 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,83);
#line  186 "scrmux.occ"
      CASE(83):  
#line  186 "scrmux.occ"
        GOTO(18);
#line  186 "scrmux.occ"
      CASE(41):  
#line  190 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 23;
#line  190 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,84);
#line  190 "scrmux.occ"
      CASE(84):  
#line  190 "scrmux.occ"
        GOTO(18);
#line  190 "scrmux.occ"
      CASE(42):  
#line  194 "scrmux.occ"
        GOTO(18);
#line  194 "scrmux.occ"
      CASE(18):  
#line  194 "scrmux.occ"
        GOTO(12);
#line  194 "scrmux.occ"
      CASE(11):  
#line  194 "scrmux.occ"
        INPUT1(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_Header.Temp.VBYTE,85);
#line  194 "scrmux.occ"
      CASE(85):  
#line  194 "scrmux.occ"
        switch(FP->_Header.Temp.VBYTE)
#line  194 "scrmux.occ"
        {
#line  194 "scrmux.occ"
          case 8: GOTO (87);
#line  194 "scrmux.occ"
          case 18: GOTO (88);
#line  194 "scrmux.occ"
          case 6: GOTO (89);
#line  194 "scrmux.occ"
          case 19: GOTO (90);
#line  194 "scrmux.occ"
          case 5: GOTO (91);
#line  194 "scrmux.occ"
          case 0: GOTO (92);
#line  194 "scrmux.occ"
          case 1: GOTO (93);
#line  194 "scrmux.occ"
          case 2: GOTO (94);
#line  194 "scrmux.occ"
          case 3: GOTO (95);
#line  194 "scrmux.occ"
          case 4: GOTO (96);
#line  194 "scrmux.occ"
          case 7: GOTO (97);
#line  194 "scrmux.occ"
          case 9: GOTO (98);
#line  194 "scrmux.occ"
          case 10: GOTO (99);
#line  194 "scrmux.occ"
          case 11: GOTO (100);
#line  194 "scrmux.occ"
          case 12: GOTO (101);
#line  194 "scrmux.occ"
          case 13: GOTO (102);
#line  194 "scrmux.occ"
          case 15: GOTO (103);
#line  194 "scrmux.occ"
          case 16: GOTO (104);
#line  194 "scrmux.occ"
          case 17: GOTO (105);
#line  194 "scrmux.occ"
          case 20: GOTO (106);
#line  194 "scrmux.occ"
          case 21: GOTO (107);
#line  194 "scrmux.occ"
          case 22: GOTO (108);
#line  194 "scrmux.occ"
          case 23: GOTO (109);
#line  194 "scrmux.occ"
          case 24: GOTO (110);
#line  194 "scrmux.occ"
          default: SETERR(MSG_CASEIN);
#line  194 "scrmux.occ"
        }
#line  194 "scrmux.occ"
        break;
#line  194 "scrmux.occ"
      CASE(87):  
#line  204 "scrmux.occ"
        INPUT4(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S7.len_108,111);
#line  204 "scrmux.occ"
      CASE(111):  
#line  204 "scrmux.occ"
        CHK(FP->_U0._S0._U1._S7.len_108<=256,MSG_CITL);
#line  204 "scrmux.occ"
        INPUT(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),FP->_U0._S0._U1._S7.str_107,(FP->_U0._S0._U1._S7.len_108)*(sizeof(BYTE)),112);
#line  204 "scrmux.occ"
      CASE(112):  
#line  206 "scrmux.occ"
        FP->_U0._S0._U1._S7._C0.prev_85=&FP->_U0._S0.current_source_92;
#line  206 "scrmux.occ"
        FP->_U0._S0._U1._S7._C0.new_86=FP->_U0._S0.index_106;
#line  206 "scrmux.occ"
        FP->_U0._S0._U1._S7._C0.Chain = FP;
#line  206 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S7._C0,113,"P_check_current_source_89");
#line  206 "scrmux.occ"
      CASE(113):  
#line  207 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 8;
#line  207 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,114);
#line  207 "scrmux.occ"
      CASE(114):  
#line  207 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_U0._S0._U1._S7.len_108,115);
#line  207 "scrmux.occ"
      CASE(115):  
#line  207 "scrmux.occ"
        OUTPUT(FP->screen_out_83,FP->_U0._S0._U1._S7.str_107,(FP->_U0._S0._U1._S7.len_108)*(sizeof(BYTE)),116);
#line  207 "scrmux.occ"
      CASE(116):  
#line  207 "scrmux.occ"
        GOTO(86);
#line  207 "scrmux.occ"
      CASE(88):  
#line  211 "scrmux.occ"
        INPUT1(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S8.ch_109,117);
#line  211 "scrmux.occ"
      CASE(117):  
#line  213 "scrmux.occ"
        FP->_U0._S0._U1._S8._C1.prev_85=&FP->_U0._S0.current_source_92;
#line  213 "scrmux.occ"
        FP->_U0._S0._U1._S8._C1.new_86=FP->_U0._S0.index_106;
#line  213 "scrmux.occ"
        FP->_U0._S0._U1._S8._C1.Chain = FP;
#line  213 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S8._C1,118,"P_check_current_source_89");
#line  213 "scrmux.occ"
      CASE(118):  
#line  214 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 18;
#line  214 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,119);
#line  214 "scrmux.occ"
      CASE(119):  
#line  214 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_U0._S0._U1._S8.ch_109,120);
#line  214 "scrmux.occ"
      CASE(120):  
#line  214 "scrmux.occ"
        GOTO(86);
#line  214 "scrmux.occ"
      CASE(89):  
#line  218 "scrmux.occ"
        INPUT1(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S9.ch_110,121);
#line  218 "scrmux.occ"
      CASE(121):  
#line  220 "scrmux.occ"
        FP->_U0._S0._U1._S9._C2.prev_85=&FP->_U0._S0.current_source_92;
#line  220 "scrmux.occ"
        FP->_U0._S0._U1._S9._C2.new_86=FP->_U0._S0.index_106;
#line  220 "scrmux.occ"
        FP->_U0._S0._U1._S9._C2.Chain = FP;
#line  220 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S9._C2,122,"P_check_current_source_89");
#line  220 "scrmux.occ"
      CASE(122):  
#line  221 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 6;
#line  221 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,123);
#line  221 "scrmux.occ"
      CASE(123):  
#line  221 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_U0._S0._U1._S9.ch_110,124);
#line  221 "scrmux.occ"
      CASE(124):  
#line  221 "scrmux.occ"
        GOTO(86);
#line  221 "scrmux.occ"
      CASE(90):  
#line  225 "scrmux.occ"
        INPUT4(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S10.x_111,125);
#line  225 "scrmux.occ"
      CASE(125):  
#line  227 "scrmux.occ"
        FP->_U0._S0._U1._S10._C3.prev_85=&FP->_U0._S0.current_source_92;
#line  227 "scrmux.occ"
        FP->_U0._S0._U1._S10._C3.new_86=FP->_U0._S0.index_106;
#line  227 "scrmux.occ"
        FP->_U0._S0._U1._S10._C3.Chain = FP;
#line  227 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S10._C3,126,"P_check_current_source_89");
#line  227 "scrmux.occ"
      CASE(126):  
#line  228 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 19;
#line  228 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,127);
#line  228 "scrmux.occ"
      CASE(127):  
#line  228 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_U0._S0._U1._S10.x_111,128);
#line  228 "scrmux.occ"
      CASE(128):  
#line  228 "scrmux.occ"
        GOTO(86);
#line  228 "scrmux.occ"
      CASE(91):  
#line  232 "scrmux.occ"
        INPUT4(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S11.x_112,129);
#line  232 "scrmux.occ"
      CASE(129):  
#line  232 "scrmux.occ"
        INPUT4(*((CHAN**)(((BYTE*)FP->screen_in_82)+(RNGCHK(FP->_U0._S0.index_106,FP->screen_in_82_Dim0)*sizeof(CHAN *)))),&FP->_U0._S0._U1._S11.y_113,130);
#line  232 "scrmux.occ"
      CASE(130):  
#line  234 "scrmux.occ"
        FP->_U0._S0._U1._S11._C4.prev_85=&FP->_U0._S0.current_source_92;
#line  234 "scrmux.occ"
        FP->_U0._S0._U1._S11._C4.new_86=FP->_U0._S0.index_106;
#line  234 "scrmux.occ"
        FP->_U0._S0._U1._S11._C4.Chain = FP;
#line  234 "scrmux.occ"
        CALL(P_check_current_source_89,&FP->_U0._S0._U1._S11._C4,131,"P_check_current_source_89");
#line  234 "scrmux.occ"
      CASE(131):  
#line  235 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 5;
#line  235 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,132);
#line  235 "scrmux.occ"
      CASE(132):  
#line  235 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_U0._S0._U1._S11.x_112,133);
#line  235 "scrmux.occ"
      CASE(133):  
#line  235 "scrmux.occ"
        OUTPUT4(FP->screen_out_83,&FP->_U0._S0._U1._S11.y_113,134);
#line  235 "scrmux.occ"
      CASE(134):  
#line  235 "scrmux.occ"
        GOTO(86);
#line  235 "scrmux.occ"
      CASE(92):  
#line  239 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 0;
#line  239 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,135);
#line  239 "scrmux.occ"
      CASE(135):  
#line  239 "scrmux.occ"
        GOTO(86);
#line  239 "scrmux.occ"
      CASE(93):  
#line  243 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 1;
#line  243 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,136);
#line  243 "scrmux.occ"
      CASE(136):  
#line  243 "scrmux.occ"
        GOTO(86);
#line  243 "scrmux.occ"
      CASE(94):  
#line  247 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 2;
#line  247 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,137);
#line  247 "scrmux.occ"
      CASE(137):  
#line  247 "scrmux.occ"
        GOTO(86);
#line  247 "scrmux.occ"
      CASE(95):  
#line  251 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 3;
#line  251 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,138);
#line  251 "scrmux.occ"
      CASE(138):  
#line  251 "scrmux.occ"
        GOTO(86);
#line  251 "scrmux.occ"
      CASE(96):  
#line  255 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 4;
#line  255 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,139);
#line  255 "scrmux.occ"
      CASE(139):  
#line  255 "scrmux.occ"
        GOTO(86);
#line  255 "scrmux.occ"
      CASE(97):  
#line  259 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 7;
#line  259 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,140);
#line  259 "scrmux.occ"
      CASE(140):  
#line  259 "scrmux.occ"
        GOTO(86);
#line  259 "scrmux.occ"
      CASE(98):  
#line  263 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 9;
#line  263 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,141);
#line  263 "scrmux.occ"
      CASE(141):  
#line  263 "scrmux.occ"
        GOTO(86);
#line  263 "scrmux.occ"
      CASE(99):  
#line  267 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 10;
#line  267 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,142);
#line  267 "scrmux.occ"
      CASE(142):  
#line  267 "scrmux.occ"
        GOTO(86);
#line  267 "scrmux.occ"
      CASE(100):  
#line  271 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 11;
#line  271 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,143);
#line  271 "scrmux.occ"
      CASE(143):  
#line  271 "scrmux.occ"
        GOTO(86);
#line  271 "scrmux.occ"
      CASE(101):  
#line  275 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 12;
#line  275 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,144);
#line  275 "scrmux.occ"
      CASE(144):  
#line  275 "scrmux.occ"
        GOTO(86);
#line  275 "scrmux.occ"
      CASE(102):  
#line  279 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 13;
#line  279 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,145);
#line  279 "scrmux.occ"
      CASE(145):  
#line  279 "scrmux.occ"
        GOTO(86);
#line  279 "scrmux.occ"
      CASE(103):  
#line  283 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 15;
#line  283 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,146);
#line  283 "scrmux.occ"
      CASE(146):  
#line  283 "scrmux.occ"
        GOTO(86);
#line  283 "scrmux.occ"
      CASE(104):  
#line  287 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 16;
#line  287 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,147);
#line  287 "scrmux.occ"
      CASE(147):  
#line  287 "scrmux.occ"
        GOTO(86);
#line  287 "scrmux.occ"
      CASE(105):  
#line  291 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 17;
#line  291 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,148);
#line  291 "scrmux.occ"
      CASE(148):  
#line  291 "scrmux.occ"
        GOTO(86);
#line  291 "scrmux.occ"
      CASE(106):  
#line  295 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 20;
#line  295 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,149);
#line  295 "scrmux.occ"
      CASE(149):  
#line  295 "scrmux.occ"
        GOTO(86);
#line  295 "scrmux.occ"
      CASE(107):  
#line  299 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 21;
#line  299 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,150);
#line  299 "scrmux.occ"
      CASE(150):  
#line  299 "scrmux.occ"
        GOTO(86);
#line  299 "scrmux.occ"
      CASE(108):  
#line  303 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 22;
#line  303 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,151);
#line  303 "scrmux.occ"
      CASE(151):  
#line  303 "scrmux.occ"
        GOTO(86);
#line  303 "scrmux.occ"
      CASE(109):  
#line  307 "scrmux.occ"
        FP->_Header.Temp.VBYTE = 23;
#line  307 "scrmux.occ"
        OUTPUT1(FP->screen_out_83,&FP->_Header.Temp.VBYTE,152);
#line  307 "scrmux.occ"
      CASE(152):  
#line  307 "scrmux.occ"
        GOTO(86);
#line  307 "scrmux.occ"
      CASE(110):  
#line  311 "scrmux.occ"
        GOTO(86);
#line  311 "scrmux.occ"
      CASE(86):  
#line  311 "scrmux.occ"
        GOTO(12);
#line  311 "scrmux.occ"
      CASE(12):  
#line  317 "scrmux.occ"
        if ((FP->_U0._S0.split_93 == FP->_U0._S0.modulus_minus_1_95))
#line  317 "scrmux.occ"
        {
#line  318 "scrmux.occ"
          FP->_U0._S0.split_93 = 0; 
#line  318 "scrmux.occ"
        }
#line  318 "scrmux.occ"
        else
#line  319 "scrmux.occ"
        if (true)
#line  319 "scrmux.occ"
        {
#line  320 "scrmux.occ"
          FP->_U0._S0.split_93 = (FP->_U0._S0.split_93 + 1); 
#line  320 "scrmux.occ"
        }
#line  320 "scrmux.occ"
        else
#line  320 "scrmux.occ"
        {
#line  320 "scrmux.occ"
          SETERR(MSG_IF);
#line  320 "scrmux.occ"
        }
#line   70 "scrmux.occ"
      CASE(6):  
#line   70 "scrmux.occ"
        if (FP->_U0._S0.going_91)
#line   70 "scrmux.occ"
        {
#line   70 "scrmux.occ"
          GOTO(7);
#line   70 "scrmux.occ"
        }
#line   70 "scrmux.occ"
        GOTO(1);
#line   70 "scrmux.occ"
      CASE(5):  
#line   70 "scrmux.occ"
        SETERR(MSG_IF);
#line   70 "scrmux.occ"
      CASE(1):  
#line   70 "scrmux.occ"
        RETURN();
#line   70 "scrmux.occ"
      default: SETERR(MSG_IP);
#line   70 "scrmux.occ"
    }
#line   70 "scrmux.occ"
  }
#line   70 "scrmux.occ"
}


/*}}}*/
#endif
