/*{{{  File banner*/
/*@(#)=====================================================*\
||@(#)  Project : GPMIMD ESPRIT P5404
||@(#)  Authors : Mark Debbage, Mark Hill, Denis Nicole and Sean Wykes
||@(#)            University of Southampton
||  
||@(#)    Title : Prototype Source File for generated C
||@(#)   System : Occam 2 C
||@(#)  Version : 1.3
||@(#) Filename : Occam2C.c
||@(#)     Date : 3/4/97
\*@(#)====================================================*/
/*}}}*/

/*{{{  Insert SWITCHES*/
#define LIBRARY_UNIT
#define BYTES_PER_WORD 4
#define TERMINATE_ON_ERROR
#define CHECK_CONVERSIONS
#define CHECK_ARRAYS
#define CHECK_RANGES
#define NO_DEBUG
#define FASTGOTOS
#define SOURCE LITTLE

/*}}}*/
/*{{{  defines*/
#define DEFAULT_MEMSIZE_IN_INTS 1000
#define OCCAM_MAIN

/*}}}*/
/*{{{  includes*/
#include <stdio.h>
#include <errno.h>

#if  (defined USESIGTIMER) || (defined USE_NONBLOCKING_SOCKETS)
#include <signal.h>
#include <sys/time.h>
#endif

#ifdef USE_NONBLOCKING_SOCKETS
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef solaris
#include <stropts.h>
#include <sys/file.h>
#include <sys/conf.h>
#endif
#endif

#ifdef CALL_NAG_F90
#include <f90.h>
#endif

#include "Occam2C.h"

#ifdef USE_NONBLOCKING_SOCKETS
  #ifdef solaris
  #define SOCKET_SIGNAL SIGPOLL
  #else
  #define SOCKET_SIGNAL SIGIO
  #endif
#endif
/*}}}*/
/*{{{  Insert HEADER*/
typedef struct SF_P_ss_scrstream_to_array_scrtfarr tSF_P_ss_scrstream_to_array_scrtfarr;
typedef struct SF_P_ss_scrstream_from_array_scrtfarr tSF_P_ss_scrstream_from_array_scrtfarr;
void P_ss_scrstream_from_array_scrtfarr (tSF_P_ss_scrstream_from_array_scrtfarr *FP);
struct SF_P_ss_scrstream_to_array_scrtfarr
{
  tHeader _Header;
  void *Chain;
  CHAN *scrn_106;
  BYTE *buffer_107;
  INT buffer_107_Dim0;
  BOOL going_108;
  INT tp_109;
  union
  {
    struct
    {
      INT32 len_110;
    } _S0;
    struct
    {
      BYTE tt_char_112;
    } _S1;
    struct
    {
      BYTE tt_char_113;
    } _S2;
    struct
    {
      INT32 x_114;
    } _S3;
    struct
    {
      INT32 x_116;
      INT32 y_117;
    } _S4;
  } _U0;
};
struct SF_P_ss_scrstream_from_array_scrtfarr
{
  tHeader _Header;
  void *Chain;
  CHAN *scrn_121;
  BYTE *buffer_122;
  INT buffer_122_Dim0;
  BYTE tt_bcom_123;
  INT tp_124;
  union
  {
    struct
    {
      INT maxlen_125;
      INT32 len_126;
    } _S5;
    struct
    {
      INT32 x_128;
    } _S6;
    struct
    {
      INT32 x_130;
      INT32 y_131;
    } _S7;
  } _U1;
};

/*}}}*/

#if (defined GENPROTO) || !(defined LIBRARY_UNIT)
/*{{{  statics*/
jmp_buf STOPP_env;
int MAIN_ARGC ;
char **MAIN_ARGV;
tTask *QFP[NUM_PRIORITY_LEVELS],*QBP[NUM_PRIORITY_LEVELS],*CURTASK,*QTM; 
static volatile int TimerEvent = false;
static volatile int SocketEvent = false;
tTimer TIMER;
static int process_count;


/*}}}*/
#endif

#ifdef GENPROTO
/*{{{  seterr*/
void seterr(char *M,int L,char *F) {}
/*}}}*/
/*{{{  struct Prototypes*/
struct Prototypes
{
  char *Proto;
  char *Define;
  int Space;
};
/*}}}*/
/*{{{  static struct Prototypes Table[] =*/
static struct Prototypes Table[] =
{
  {"void P_ss_scrstream_to_array_scrtfarr (tSF_P_ss_scrstream_to_array_scrtfarr *FP);","P_ss_scrstream_to_array_scrtfarr",sizeof(tSF_P_ss_scrstream_to_array_scrtfarr)},
  {"void P_ss_scrstream_from_array_scrtfarr (tSF_P_ss_scrstream_from_array_scrtfarr *FP);","P_ss_scrstream_from_array_scrtfarr",sizeof(tSF_P_ss_scrstream_from_array_scrtfarr)},

 {NULL,NULL,0}
} ;
/*}}}*/
/*{{{  int main(int argc, char**argv)*/
int main(int argc, char**argv)
{
  char *name;
  FILE *f;
  int fcnt;
  
  CheckPrimitiveSizes();

  if (argc<2)
  {
    name="scrtfarr.hdr";
    f=fopen(name,"w");
  }
  else
  {
    name = argv[argc-1];
    if (name[0]=='-')
    {
      name = "stdout";
      f=stdout;
    }
    else
    {
      f=fopen(name,"w");
    }
  }
  fcnt=argc-1;
  
  if (f==NULL)
    { fprintf(stderr,"Error - could not open file %s\n",name);exit(-1); }
  else
  {
    int arg;
    int i;
    fprintf(f,"#ifndef __scrtfarr_INCLUDES__\n");
    fprintf(f,"#define __scrtfarr_INCLUDES__\n");
    
    for(arg = 1; arg < fcnt; ++arg)
    {
      FILE *fh = fopen(argv[arg],"r");
      if (fh == NULL) { fprintf(stderr,"Error - could not read file %s\n",name); exit(-1); }
      while(!feof(fh))
      {
	char line[256];

	if (fgets(line,256,fh) == NULL) break;
	if (line[0] == '#')
	  if (strncmp(line,"#define WS",10)!=0) continue;
	fputs(line,f);
      }
      fclose(fh);
    }      
      
    i = 0;
    while (Table[i].Proto!=NULL)
    {
      if (Table[i].Define != NULL)
      {
	fprintf(f,"typedef struct SF_%s tSF_%s;\n",Table[i].Define,Table[i].Define);
	fprintf(f,"#define WS_%s (%d)\n",Table[i].Define,Table[i].Space);
      }
      fprintf(f,"%s\n",Table[i].Proto);
      i++;
    }
    fprintf(f,"#endif\n");

    if (f!=stdout) fclose(f);
  }
  return(0);
}     
/*}}}*/
#endif

#ifndef LIBRARY_UNIT
/*{{{  seterr*/
static void DONE_SETERR() {}

void seterr(char *M,int L,char *F)
{
  if (M!=NULL) fputs(M,stderr);
  fprintf(stderr,MSG_EFROL,L,F);
  DONE_SETERR();
  SETERR_PROCEED;
}
/*}}}*/
/*{{{  DEBUGDONE,MARK_SCHEDULE*/
#ifndef NO_DEBUG
void DEBUGDONE(void) {}
void MARK_SCHEDULE(void) {}
#endif

/*}}}*/
/*{{{  timer*/
#ifdef USESIGTIMER
static struct timeval tv_start;
/*{{{  static void TimerSignalHandler(int sig)*/
static void TimerSignalHandler(int sig)
{
  switch(sig)
  {
    case SIGALRM:
      {
	struct timeval tv;
	tTask *task;

	gettimeofday(&tv,NULL);
	TIMER = ((tv.tv_usec - tv_start.tv_usec)>>6) + (1000000>>6) * (tv.tv_sec - tv_start.tv_sec);
	if (QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
	  TimerEvent = true;
      }
      break;

    default:
      fprintf(stderr,"Error - Caught signal %d - Exiting\n",sig);
      fflush(stderr);
      exit(20);
  }
}
/*}}}*/
/*{{{  static void Init_Timer()*/
static void Init_Timer()
{
  struct itimerval itv;
#ifndef solaris
  struct sigaction sa;
#endif

  TIMER = 0;
  gettimeofday(&tv_start,NULL);
  TimerSignalHandler(SIGALRM);
  
#ifndef solaris
  memset((char*)&sa,0,sizeof(sa));
  sa.sa_handler = TimerSignalHandler;

#ifdef SA_RESTART
  sa.sa_flags = SA_RESTART;
#endif

  sigaction(SIGALRM,&sa,NULL);
#else
  sigset(SIGALRM,TimerSignalHandler);
#endif

  itv.it_interval.tv_usec = 1000;
  itv.it_interval.tv_sec = 0;
     
  itv.it_value.tv_usec = 1;
  itv.it_value.tv_sec = 0;

  if (setitimer(ITIMER_REAL,&itv,NULL)) 
    fprintf(stderr,"Error - setitimer failed\n");

  QTM = NoTask;
  TimerEvent = false;
}

/*}}}*/

#else
static void Init_Timer() { (void)clock(); TimerEvent = false; }
#endif
/*}}}*/
/*{{{  sockets*/
#ifdef USE_NONBLOCKING_SOCKETS
static int io_limit;
static struct timeval io_zerotime;

static int    io_socket;
static tTask *io_task = NoTask;

/*{{{  void SocketHandler (int sig)*/
void SocketHandler (int sig)
{
  switch (sig)
  {
    case SOCKET_SIGNAL:
    {
      #ifdef MD_DEBUG
      fprintf(stderr,"Caught signal %d\n",sig);
      #endif
      
      SocketEvent = true;
      
      #ifdef solaris
      signal (SOCKET_SIGNAL, SocketHandler);
      #endif
      
      break;
    }
    default:
      fprintf(stderr,"Error - Caught unexpected signal %d - exiting\n",sig);
      fflush(stderr);
      exit(20);
  }  
}
/*}}}*/
 
/*{{{  void WaitSocket (int socket)*/
void WaitSocket (int socket)
{
  fd_set io_set;

  io_socket = socket;

  FD_ZERO (&io_set);
  FD_SET  (socket,&io_set);
  
  errno = 0;
  while (select (io_limit, &io_set, NULL, NULL, &io_zerotime) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
  
  if (!FD_ISSET(socket,&io_set))
  {
    if (io_task == NoTask)
      io_task = CURTASK;
    else
    {
      fprintf(stderr, "Error - Implementation restriction, only one signaling socket\n");
      exit(-1);
    }
    DeSchedule(TSOCK_p);
  }
}
/*}}}*/

/*{{{  void EnableSocket (int socket)*/
void EnableSocket (int socket)
{
  errno = 0;
  
  #ifdef solaris
  if (ioctl(socket,I_SETSIG,S_RDNORM) < 0)
  {
    fprintf(stderr,"Error - could not set signal handler for socket (errno %d)\n",errno);
    exit(-1);
  }
  #else
  if (fcntl(socket, F_SETOWN, getpid()) < 0)
  {
    fprintf(stderr,"Error - could not set owner on socket (errno %d)\n",errno);
    exit(-1);
  }
  if (fcntl(socket, F_SETFL, FASYNC)    < 0)
  {
    fprintf(stderr,"Error - could not set asynchronous socket (errno %d)\n",errno);
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void DisableSocket (int socket)*/
void DisableSocket (int socket)
{
  #ifdef sun4
  if (fcntl(socket, F_SETFL, FSYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
  #ifdef linux
  if (fcntl(socket, F_SETFL, FASYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void ServeSocket (void)*/
void ServeSocket (void)
{
  fd_set io_set;
  int res;

  /* In the general case there's a timing hazard here since a new signal
     could arrive and we can lose it. Really need test-and-set or a
     semaphore. For hostio, however, there's only ever one outstanding 
     communication and this thread is serving it. Hence, no problem here. */

  SocketEvent = false; 

  FD_ZERO (&io_set);
  FD_SET  (io_socket,&io_set);
  
  errno = 0;
  while ((res = select (io_limit, &io_set, NULL, NULL, &io_zerotime)) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
      
  if (res == 0)
  {
    /*fprintf(stderr,"Could not locate socket signal source, ignoring select\n");*/
    return;
  }
  
  if (!FD_ISSET(io_socket,&io_set))
  {
    fprintf(stderr,"Error - socket is not ready\n");
    exit(-1);
  }

  if (io_task != NoTask)
  {
    ReSchedule(io_task);
    io_task = NoTask;
  }
}
/*}}}*/

/*{{{  void Init_Sockets()*/
void Init_Sockets()
{
  io_limit = ulimit (4,0);

  timerclear (&io_zerotime);

  signal (SOCKET_SIGNAL, SocketHandler);
  #ifdef linux
  {
    struct sigaction action;
    sigaction(SIGIO,NULL,&action);
    action.sa_flags = (action.sa_flags & (~SA_ONESHOT));
    sigaction(SIGIO,&action,NULL);
  }
  #endif
}
/*}}}*/
#else
void WaitSocket (int socket)
{ 
  fprintf(stderr, "Error - No SIGSOCKETS\n"); 
}
#endif
/*}}}*/

/*{{{  static void Init_Scheduler()*/
static void Init_Scheduler()
{
  int i;

  for(i = 0; i < NUM_PRIORITY_LEVELS; ++i)
    QFP[i] = QBP[i] = NoTask;

  CURTASK = NoTask;

  Init_Timer();

  #ifdef USE_NONBLOCKING_SOCKETS
  Init_Sockets();  
  #endif
}
/*}}}*/
/*{{{  static void Scheduler()*/
static void Scheduler()
{
  if (setjmp(STOPP_env)) DeSchedule(0);
  
  while(CURTASK != NoTask || TimerEvent || SocketEvent)
  {
    int pri;

#ifdef USESIGTIMER
    /*{{{  if (TimerEvent)*/
    if (TimerEvent)
    {
    #ifdef DEBUG
	fprintf(stderr,"Timer = %d\n",TIMER);
    #endif
      TimerEvent = false;
      while(QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
      {
    #ifdef DEBUG
	{  
	  tTask *task = QTM;
    
	  fprintf(stderr,"Timer Queue contains:");
	  if (task == NoTask) fprintf(stderr,"No Tasks");
	  else while(task != NoTask) { fprintf(stderr,"%d(%d) ",task->TaskId,task->comms.timer.time); task = task->Next; }
	  fprintf(stderr,"\n");
	}  
    #endif
	if (QTM->AltMode == Waiting_p) QTM->AltMode = TReady_p;
	ReSchedule(QTM);
      }
    }
    /*}}}*/
#endif

#ifdef USE_NONBLOCKING_SOCKETS
    if (SocketEvent)
      ServeSocket();
#endif

    for(pri = 0; pri < NUM_PRIORITY_LEVELS; ++pri)
    {
#ifdef DEBUG
  {
    tTask *task = QFP[pri];
    fprintf(stderr,"Task Queue %d contains:",pri);
    if (task == NoTask) fprintf(stderr,"No Tasks");
    else while(task != NoTask) { fprintf(stderr,"%d ",task->TaskId); task = task->Next; }
    fprintf(stderr,"\n");
  }
#endif

      if ((CURTASK=QFP[pri]) != NoTask)
      {
	/*{{{  #ifdef SHOWTASKING*/
	#ifdef SHOWTASKING
		fprintf(stderr,"Scheduler - Current task is %c%d (%s) IP=%d\n",(CURTASK->TaskPriority)?'L':'H',CURTASK->TaskId,((tHeader *)CURTASK->FP)->ProcName,((tHeader *)CURTASK->FP)->IP); fflush(stderr); 
	#endif
	/*}}}*/
	/*{{{  #ifndef NO_DEBUG*/
	#ifndef NO_DEBUG
	MARK_SCHEDULE() ;
	#endif
	/*}}}*/
	CURTASK->Func (CURTASK->FP);
	break;
      }
    }

    /*{{{  catch any signals*/
    #if (defined USESIGTIMER && defined USE_NONBLOCKING_SOCKETS)
	if (CURTASK == NoTask && (QTM != NoTask || io_task != NoTask))
	  while(!TimerEvent && !SocketEvent)
	    pause();
    #else
      #if (defined USESIGTIMER)
	  if (CURTASK == NoTask && QTM != NoTask)
	    while(!TimerEvent)
	      pause();
      #endif
      
      #if (defined USE_NONBLOCKING_SOCKETS)
	  if (CURTASK == NoTask && io_task != NoTask)
	    while(!SocketEvent)
	      pause();
      #endif
    #endif
    /*}}}*/

  }

#ifdef DEBUG
  fprintf(stderr,"Scheduling Queue empty\n");
#endif
}

/*}}}*/
/*{{{  void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)
{
  static int NextTaskId = 0;
  process_count++;
  
  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = (CURTASK != NoTask && CURTASK->TaskPriority == HighPriority) ? HighPriority : Priority;
  ((tHeader *)FP)->ProcName = name;
  
  if (Priority < 0 || Priority >= NUM_PRIORITY_LEVELS) SETERR(MSG_PRI);
  
  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Processor)
{
  static int NextTaskId = 0;
  process_count++;

  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = LowPriority;

  ((tHeader *)FP)->ProcName = name;

  SETERR("PLACED PAR is not supported in this implementation");

  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void End_Process()*/
void End_Process()
{
  register tTask *task = CURTASK;
  process_count--;
    
  QFP[task->TaskPriority] = task->Next;
  if (QFP[task->TaskPriority] == NoTask) QBP[task->TaskPriority] = NoTask;
  task->Next = NoTask;
  if (task->Parent)
  {
    if (--(task->Parent->Children) == 0) ReSchedule(task->Parent);
  }
}
/*}}}*/

/*{{{  SPOC iserver definitions*/
#ifdef USE_SPOC_ISERVER
extern int CocoPops;
#include "spserver.hdr"

struct SF_P_spoc_iserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_iserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_iserver_spserver spserver;
} tSF_P_spoc_iserver_caller;

static tSF_P_spoc_iserver_caller spoc_iserver_data;
static tTask spoc_iserver_task;

static tFuncPtr P_spoc_iserver_caller (tSF_P_spoc_iserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_iserver_spserver,&FP->spserver,1,"P_spoc_iserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/
/*{{{  SPOC aserver definitions*/
#ifdef USE_SPOC_ASERVER
#include "spserver.hdr"

struct SF_P_spoc_aserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_aserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_aserver_spserver spserver;
} tSF_P_spoc_aserver_caller;

static tSF_P_spoc_aserver_caller spoc_aserver_data;
static tTask spoc_aserver_task;

static tFuncPtr P_spoc_aserver_caller (tSF_P_spoc_aserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_aserver_spserver,&FP->spserver,1,"P_spoc_aserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/

/*{{{  int main(int argc, char **argv)*/
int main(int argc, char **argv)
{
  void *FP=NULL;
  tSF_ *MAINFP=(tSF_ *)malloc(sizeof(tSF_));
  tTask main_t;
  INT mem_size = (argc>1 && atoi(argv[1])>0)?atoi(argv[1]):DEFAULT_MEMSIZE_IN_INTS;
  INT *mem=(INT*)malloc(mem_size*sizeof(INT));
  CHAN fs,ts;
  
  if (MAINFP==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s bytes for occam workspace failed\n",sizeof(tSF_));
    exit(-1);
  }
  if (mem_size>0 && mem==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s INTs for occam memory array failed\n",mem_size);
    exit(-1);
  }
  (void) clock();
  MAIN_ARGC = argc ;
  MAIN_ARGV = argv ;
  process_count = 0;
 
  CheckPrimitiveSizes();
  INITCH(&fs);
  INITCH(&ts);
  Init_Scheduler();
  
  STARTP(&main_t,,MAINFP,"",LowPriority);

  /*{{{  #ifdef USE_SPOC_ISERVER*/
  #ifdef USE_SPOC_ISERVER
  #ifdef SHOWTASKING
  CocoPops=true;
  #endif
  spoc_iserver_data.fs = &fs;
  spoc_iserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_iserver_task, P_spoc_iserver_caller, &spoc_iserver_data, "P_spoc_iserver_spserver",LowPriority);
  #endif
  /*}}}*/
  /*{{{  #ifdef USE_SPOC_ASERVER*/
  #ifdef USE_SPOC_ASERVER
  spoc_aserver_data.fs = &fs;
  spoc_aserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_aserver_task, P_spoc_aserver_caller, &spoc_aserver_data, "P_spoc_aserver_spserver",LowPriority);
  #endif
  /*}}}*/
/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_init(argc,argv);
#endif
/*}}}*/
  
  Scheduler();

/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_finish(0);
#endif
/*}}}*/
  if (process_count == 0)
    return 0;
  else
  {
    fprintf(stderr,"Deadlock: %d stopped process%s.\n", process_count,(process_count>1)?"es":"");
    return 1;
  }
}     
/*}}}*/
#endif

#ifndef GENPROTO
/*{{{  Insert DEBUG*/

/*}}}*/
/*{{{  Insert CODE*/
void P_ss_scrstream_to_array_scrtfarr (tSF_P_ss_scrstream_to_array_scrtfarr *FP)
#line   39 "scrtfarr.occ"
{
#line   39 "scrtfarr.occ"
  while(true)
#line   39 "scrtfarr.occ"
  {
#line   39 "scrtfarr.occ"
    switch(FP->_Header.IP)
#line   39 "scrtfarr.occ"
    {
#line   39 "scrtfarr.occ"
      CASE(0):  
#line   58 "scrtfarr.occ"
        FP->going_108 = true; 
#line   59 "scrtfarr.occ"
        FP->tp_109 = 0; 
#line   60 "scrtfarr.occ"
        GOTO(1);
#line   60 "scrtfarr.occ"
      CASE(2):  
#line   62 "scrtfarr.occ"
        INPUT1(FP->scrn_106,&FP->_Header.Temp.VBYTE,3);
#line   62 "scrtfarr.occ"
      CASE(3):  
#line   62 "scrtfarr.occ"
        switch(FP->_Header.Temp.VBYTE)
#line   62 "scrtfarr.occ"
        {
#line   62 "scrtfarr.occ"
          case 8: GOTO (5);
#line   62 "scrtfarr.occ"
          case 18: GOTO (6);
#line   62 "scrtfarr.occ"
          case 6: GOTO (7);
#line   62 "scrtfarr.occ"
          case 19: GOTO (8);
#line   62 "scrtfarr.occ"
          case 5: GOTO (9);
#line   62 "scrtfarr.occ"
          case 0: GOTO (10);
#line   62 "scrtfarr.occ"
          case 1: GOTO (11);
#line   62 "scrtfarr.occ"
          case 2: GOTO (12);
#line   62 "scrtfarr.occ"
          case 3: GOTO (13);
#line   62 "scrtfarr.occ"
          case 4: GOTO (14);
#line   62 "scrtfarr.occ"
          case 7: GOTO (15);
#line   62 "scrtfarr.occ"
          case 9: GOTO (16);
#line   62 "scrtfarr.occ"
          case 10: GOTO (17);
#line   62 "scrtfarr.occ"
          case 11: GOTO (18);
#line   62 "scrtfarr.occ"
          case 12: GOTO (19);
#line   62 "scrtfarr.occ"
          case 13: GOTO (20);
#line   62 "scrtfarr.occ"
          case 15: GOTO (21);
#line   62 "scrtfarr.occ"
          case 16: GOTO (22);
#line   62 "scrtfarr.occ"
          case 17: GOTO (23);
#line   62 "scrtfarr.occ"
          case 20: GOTO (24);
#line   62 "scrtfarr.occ"
          case 21: GOTO (25);
#line   62 "scrtfarr.occ"
          case 22: GOTO (26);
#line   62 "scrtfarr.occ"
          case 23: GOTO (27);
#line   62 "scrtfarr.occ"
          case 24: GOTO (28);
#line   62 "scrtfarr.occ"
          default: SETERR(MSG_CASEIN);
#line   62 "scrtfarr.occ"
        }
#line   62 "scrtfarr.occ"
        break;
#line   62 "scrtfarr.occ"
      CASE(5):  
#line   64 "scrtfarr.occ"
        INPUT4(FP->scrn_106,&FP->_U0._S0.len_110,29);
#line   64 "scrtfarr.occ"
      CASE(29):  
#line   64 "scrtfarr.occ"
        CHK(FP->_U0._S0.len_110<=((FP->buffer_107_Dim0) - (FP->tp_109 + 5)),MSG_CITL);
#line   64 "scrtfarr.occ"
        INPUT(FP->scrn_106,((BYTE*)(((BYTE*)FP->buffer_107)+((RNGCHKUB((FP->tp_109 + 5),((FP->buffer_107_Dim0) - (FP->tp_109 + 5)),FP->buffer_107_Dim0),RNGCHKLB((FP->tp_109 + 5)))*sizeof(BYTE)))),(FP->_U0._S0.len_110)*(sizeof(BYTE)),30);
#line   64 "scrtfarr.occ"
      CASE(30):  
#line   65 "scrtfarr.occ"
        {
#line   66 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 8; 
#line   67 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line   68 "scrtfarr.occ"
          {
#line   68 "scrtfarr.occ"
            BYTE lenb32_111[4];
#line   68 "scrtfarr.occ"
            RETYPE(0^3,4,lenb32_111,&FP->_U0._S0.len_110);
#line   69 "scrtfarr.occ"
            ASSIGN(((BYTE*)(((BYTE*)FP->buffer_107)+((RNGCHKUB(FP->tp_109,4,FP->buffer_107_Dim0),RNGCHKLB(FP->tp_109))*sizeof(BYTE)))),lenb32_111,(4*sizeof(BYTE))); 
#line   69 "scrtfarr.occ"
            RETYPE(0^3,4,&FP->_U0._S0.len_110,lenb32_111);
#line   69 "scrtfarr.occ"
          }
#line   70 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + (INTINT32(FP->_U0._S0.len_110) + 4)); 
#line   70 "scrtfarr.occ"
        }
#line   70 "scrtfarr.occ"
        GOTO(4);
#line   70 "scrtfarr.occ"
      CASE(6):  
#line   72 "scrtfarr.occ"
        INPUT1(FP->scrn_106,&FP->_U0._S1.tt_char_112,31);
#line   72 "scrtfarr.occ"
      CASE(31):  
#line   73 "scrtfarr.occ"
        {
#line   74 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 18; 
#line   75 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK((FP->tp_109 + 1),FP->buffer_107_Dim0)*sizeof(BYTE)))) = FP->_U0._S1.tt_char_112; 
#line   76 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 2); 
#line   76 "scrtfarr.occ"
        }
#line   76 "scrtfarr.occ"
        GOTO(4);
#line   76 "scrtfarr.occ"
      CASE(7):  
#line   78 "scrtfarr.occ"
        INPUT1(FP->scrn_106,&FP->_U0._S2.tt_char_113,32);
#line   78 "scrtfarr.occ"
      CASE(32):  
#line   79 "scrtfarr.occ"
        {
#line   80 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 6; 
#line   81 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK((FP->tp_109 + 1),FP->buffer_107_Dim0)*sizeof(BYTE)))) = FP->_U0._S2.tt_char_113; 
#line   82 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 2); 
#line   82 "scrtfarr.occ"
        }
#line   82 "scrtfarr.occ"
        GOTO(4);
#line   82 "scrtfarr.occ"
      CASE(8):  
#line   84 "scrtfarr.occ"
        INPUT4(FP->scrn_106,&FP->_U0._S3.x_114,33);
#line   84 "scrtfarr.occ"
      CASE(33):  
#line   85 "scrtfarr.occ"
        {
#line   86 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 19; 
#line   87 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line   88 "scrtfarr.occ"
          {
#line   88 "scrtfarr.occ"
            BYTE xb32_115[4];
#line   88 "scrtfarr.occ"
            RETYPE(0^3,4,xb32_115,&FP->_U0._S3.x_114);
#line   89 "scrtfarr.occ"
            ASSIGN(((BYTE*)(((BYTE*)FP->buffer_107)+((RNGCHKUB(FP->tp_109,4,FP->buffer_107_Dim0),RNGCHKLB(FP->tp_109))*sizeof(BYTE)))),xb32_115,(4*sizeof(BYTE))); 
#line   89 "scrtfarr.occ"
            RETYPE(0^3,4,&FP->_U0._S3.x_114,xb32_115);
#line   89 "scrtfarr.occ"
          }
#line   90 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 4); 
#line   90 "scrtfarr.occ"
        }
#line   90 "scrtfarr.occ"
        GOTO(4);
#line   90 "scrtfarr.occ"
      CASE(9):  
#line   92 "scrtfarr.occ"
        INPUT4(FP->scrn_106,&FP->_U0._S4.x_116,34);
#line   92 "scrtfarr.occ"
      CASE(34):  
#line   92 "scrtfarr.occ"
        INPUT4(FP->scrn_106,&FP->_U0._S4.y_117,35);
#line   92 "scrtfarr.occ"
      CASE(35):  
#line   93 "scrtfarr.occ"
        {
#line   94 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 5; 
#line   95 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line   96 "scrtfarr.occ"
          {
#line   96 "scrtfarr.occ"
            BYTE xb32_118[4];
#line   96 "scrtfarr.occ"
            RETYPE(0^3,4,xb32_118,&FP->_U0._S4.x_116);
#line   97 "scrtfarr.occ"
            ASSIGN(((BYTE*)(((BYTE*)FP->buffer_107)+((RNGCHKUB(FP->tp_109,4,FP->buffer_107_Dim0),RNGCHKLB(FP->tp_109))*sizeof(BYTE)))),xb32_118,(4*sizeof(BYTE))); 
#line   97 "scrtfarr.occ"
            RETYPE(0^3,4,&FP->_U0._S4.x_116,xb32_118);
#line   97 "scrtfarr.occ"
          }
#line   98 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 4); 
#line   99 "scrtfarr.occ"
          {
#line   99 "scrtfarr.occ"
            BYTE yb32_119[4];
#line   99 "scrtfarr.occ"
            RETYPE(0^3,4,yb32_119,&FP->_U0._S4.y_117);
#line  100 "scrtfarr.occ"
            ASSIGN(((BYTE*)(((BYTE*)FP->buffer_107)+((RNGCHKUB(FP->tp_109,4,FP->buffer_107_Dim0),RNGCHKLB(FP->tp_109))*sizeof(BYTE)))),yb32_119,(4*sizeof(BYTE))); 
#line  100 "scrtfarr.occ"
            RETYPE(0^3,4,&FP->_U0._S4.y_117,yb32_119);
#line  100 "scrtfarr.occ"
          }
#line  101 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 4); 
#line  101 "scrtfarr.occ"
        }
#line  101 "scrtfarr.occ"
        GOTO(4);
#line  101 "scrtfarr.occ"
      CASE(10):  
#line  103 "scrtfarr.occ"
        {
#line  104 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 0; 
#line  105 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  105 "scrtfarr.occ"
        }
#line  105 "scrtfarr.occ"
        GOTO(4);
#line  105 "scrtfarr.occ"
      CASE(11):  
#line  107 "scrtfarr.occ"
        {
#line  108 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 1; 
#line  109 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  109 "scrtfarr.occ"
        }
#line  109 "scrtfarr.occ"
        GOTO(4);
#line  109 "scrtfarr.occ"
      CASE(12):  
#line  111 "scrtfarr.occ"
        {
#line  112 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 2; 
#line  113 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  113 "scrtfarr.occ"
        }
#line  113 "scrtfarr.occ"
        GOTO(4);
#line  113 "scrtfarr.occ"
      CASE(13):  
#line  115 "scrtfarr.occ"
        {
#line  116 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 3; 
#line  117 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  117 "scrtfarr.occ"
        }
#line  117 "scrtfarr.occ"
        GOTO(4);
#line  117 "scrtfarr.occ"
      CASE(14):  
#line  119 "scrtfarr.occ"
        {
#line  120 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 4; 
#line  121 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  121 "scrtfarr.occ"
        }
#line  121 "scrtfarr.occ"
        GOTO(4);
#line  121 "scrtfarr.occ"
      CASE(15):  
#line  123 "scrtfarr.occ"
        {
#line  124 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 7; 
#line  125 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  125 "scrtfarr.occ"
        }
#line  125 "scrtfarr.occ"
        GOTO(4);
#line  125 "scrtfarr.occ"
      CASE(16):  
#line  127 "scrtfarr.occ"
        {
#line  128 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 9; 
#line  129 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  129 "scrtfarr.occ"
        }
#line  129 "scrtfarr.occ"
        GOTO(4);
#line  129 "scrtfarr.occ"
      CASE(17):  
#line  131 "scrtfarr.occ"
        {
#line  132 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 10; 
#line  133 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  133 "scrtfarr.occ"
        }
#line  133 "scrtfarr.occ"
        GOTO(4);
#line  133 "scrtfarr.occ"
      CASE(18):  
#line  135 "scrtfarr.occ"
        {
#line  136 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 11; 
#line  137 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  137 "scrtfarr.occ"
        }
#line  137 "scrtfarr.occ"
        GOTO(4);
#line  137 "scrtfarr.occ"
      CASE(19):  
#line  139 "scrtfarr.occ"
        {
#line  140 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 12; 
#line  141 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  141 "scrtfarr.occ"
        }
#line  141 "scrtfarr.occ"
        GOTO(4);
#line  141 "scrtfarr.occ"
      CASE(20):  
#line  143 "scrtfarr.occ"
        {
#line  144 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 13; 
#line  145 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  145 "scrtfarr.occ"
        }
#line  145 "scrtfarr.occ"
        GOTO(4);
#line  145 "scrtfarr.occ"
      CASE(21):  
#line  147 "scrtfarr.occ"
        {
#line  148 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 15; 
#line  149 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  149 "scrtfarr.occ"
        }
#line  149 "scrtfarr.occ"
        GOTO(4);
#line  149 "scrtfarr.occ"
      CASE(22):  
#line  151 "scrtfarr.occ"
        {
#line  152 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 16; 
#line  153 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  153 "scrtfarr.occ"
        }
#line  153 "scrtfarr.occ"
        GOTO(4);
#line  153 "scrtfarr.occ"
      CASE(23):  
#line  155 "scrtfarr.occ"
        {
#line  156 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 17; 
#line  157 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  157 "scrtfarr.occ"
        }
#line  157 "scrtfarr.occ"
        GOTO(4);
#line  157 "scrtfarr.occ"
      CASE(24):  
#line  159 "scrtfarr.occ"
        {
#line  160 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 20; 
#line  161 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  161 "scrtfarr.occ"
        }
#line  161 "scrtfarr.occ"
        GOTO(4);
#line  161 "scrtfarr.occ"
      CASE(25):  
#line  163 "scrtfarr.occ"
        {
#line  164 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 21; 
#line  165 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  165 "scrtfarr.occ"
        }
#line  165 "scrtfarr.occ"
        GOTO(4);
#line  165 "scrtfarr.occ"
      CASE(26):  
#line  167 "scrtfarr.occ"
        {
#line  168 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 22; 
#line  169 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  169 "scrtfarr.occ"
        }
#line  169 "scrtfarr.occ"
        GOTO(4);
#line  169 "scrtfarr.occ"
      CASE(27):  
#line  171 "scrtfarr.occ"
        {
#line  172 "scrtfarr.occ"
          *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 23; 
#line  173 "scrtfarr.occ"
          FP->tp_109 = (FP->tp_109 + 1); 
#line  173 "scrtfarr.occ"
        }
#line  173 "scrtfarr.occ"
        GOTO(4);
#line  173 "scrtfarr.occ"
      CASE(28):  
#line  175 "scrtfarr.occ"
        FP->going_108 = false; 
#line  175 "scrtfarr.occ"
        GOTO(4);
#line  175 "scrtfarr.occ"
      CASE(4):  
#line   60 "scrtfarr.occ"
      CASE(1):  
#line   60 "scrtfarr.occ"
        if (FP->going_108)
#line   60 "scrtfarr.occ"
        {
#line   60 "scrtfarr.occ"
          GOTO(2);
#line   60 "scrtfarr.occ"
        }
#line  177 "scrtfarr.occ"
        *((BYTE*)(((BYTE*)FP->buffer_107)+(RNGCHK(FP->tp_109,FP->buffer_107_Dim0)*sizeof(BYTE)))) = 24; 
#line  177 "scrtfarr.occ"
        RETURN();
#line  177 "scrtfarr.occ"
      default: SETERR(MSG_IP);
#line  177 "scrtfarr.occ"
    }
#line  177 "scrtfarr.occ"
  }
#line  177 "scrtfarr.occ"
}

#line  181 "scrtfarr.occ"
void P_ss_scrstream_from_array_scrtfarr (tSF_P_ss_scrstream_from_array_scrtfarr *FP)
#line  181 "scrtfarr.occ"
{
#line  181 "scrtfarr.occ"
  while(true)
#line  181 "scrtfarr.occ"
  {
#line  181 "scrtfarr.occ"
    switch(FP->_Header.IP)
#line  181 "scrtfarr.occ"
    {
#line  181 "scrtfarr.occ"
      CASE(0):  
#line  199 "scrtfarr.occ"
        FP->tt_bcom_123 = *((BYTE*)(((BYTE*)FP->buffer_122)+(0*sizeof(BYTE)))); 
#line  200 "scrtfarr.occ"
        FP->tp_124 = 1; 
#line  201 "scrtfarr.occ"
        GOTO(1);
#line  201 "scrtfarr.occ"
      CASE(2):  
#line  203 "scrtfarr.occ"
        switch(FP->tt_bcom_123)
#line  203 "scrtfarr.occ"
        {
#line  203 "scrtfarr.occ"
          case 8: GOTO (4);
#line  203 "scrtfarr.occ"
          case 18: GOTO (5);
#line  203 "scrtfarr.occ"
          case 6: GOTO (6);
#line  203 "scrtfarr.occ"
          case 19: GOTO (7);
#line  203 "scrtfarr.occ"
          case 5: GOTO (8);
#line  203 "scrtfarr.occ"
          case 0: GOTO (9);
#line  203 "scrtfarr.occ"
          case 1: GOTO (10);
#line  203 "scrtfarr.occ"
          case 2: GOTO (11);
#line  203 "scrtfarr.occ"
          case 3: GOTO (12);
#line  203 "scrtfarr.occ"
          case 4: GOTO (13);
#line  203 "scrtfarr.occ"
          case 7: GOTO (14);
#line  203 "scrtfarr.occ"
          case 9: GOTO (15);
#line  203 "scrtfarr.occ"
          case 10: GOTO (16);
#line  203 "scrtfarr.occ"
          case 11: GOTO (17);
#line  203 "scrtfarr.occ"
          case 12: GOTO (18);
#line  203 "scrtfarr.occ"
          case 13: GOTO (19);
#line  203 "scrtfarr.occ"
          case 15: GOTO (20);
#line  203 "scrtfarr.occ"
          case 16: GOTO (21);
#line  203 "scrtfarr.occ"
          case 17: GOTO (22);
#line  203 "scrtfarr.occ"
          case 20: GOTO (23);
#line  203 "scrtfarr.occ"
          case 21: GOTO (24);
#line  203 "scrtfarr.occ"
          case 22: GOTO (25);
#line  203 "scrtfarr.occ"
          case 23: GOTO (26);
#line  203 "scrtfarr.occ"
          default: SETERR(MSG_CASE);
#line  203 "scrtfarr.occ"
        }
#line  203 "scrtfarr.occ"
        break;
#line  203 "scrtfarr.occ"
      CASE(4):  
#line  208 "scrtfarr.occ"
        {
#line  208 "scrtfarr.occ"
          BYTE lenb32_127[4];
#line  208 "scrtfarr.occ"
          RETYPE(0^3,4,lenb32_127,&FP->_U1._S5.len_126);
#line  209 "scrtfarr.occ"
          CHK(4==4,MSG_ASM);
#line  209 "scrtfarr.occ"
          ASSIGN(lenb32_127,((BYTE*)(((BYTE*)FP->buffer_122)+((RNGCHKUB(FP->tp_124,4,FP->buffer_122_Dim0),RNGCHKLB(FP->tp_124))*sizeof(BYTE)))),(4*sizeof(BYTE))); 
#line  209 "scrtfarr.occ"
          RETYPE(0^3,4,&FP->_U1._S5.len_126,lenb32_127);
#line  209 "scrtfarr.occ"
        }
#line  210 "scrtfarr.occ"
        FP->tp_124 = (FP->tp_124 + 4); 
#line  211 "scrtfarr.occ"
        FP->_U1._S5.maxlen_125 = ((FP->buffer_122_Dim0) - FP->tp_124); 
#line  212 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 8;
#line  212 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,27);
#line  212 "scrtfarr.occ"
      CASE(27):  
#line  212 "scrtfarr.occ"
        OUTPUT4(FP->scrn_121,&FP->_U1._S5.len_126,28);
#line  212 "scrtfarr.occ"
      CASE(28):  
#line  212 "scrtfarr.occ"
        OUTPUT(FP->scrn_121,((BYTE*)(((BYTE*)FP->buffer_122)+((RNGCHKUB(FP->tp_124,FP->_U1._S5.maxlen_125,FP->buffer_122_Dim0),RNGCHKLB(FP->tp_124))*sizeof(BYTE)))),(FP->_U1._S5.len_126)*(sizeof(BYTE)),29);
#line  212 "scrtfarr.occ"
      CASE(29):  
#line  213 "scrtfarr.occ"
        FP->tp_124 = (FP->tp_124 + INTINT32(FP->_U1._S5.len_126)); 
#line  213 "scrtfarr.occ"
        GOTO(3);
#line  213 "scrtfarr.occ"
      CASE(5):  
#line  216 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 18;
#line  216 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,30);
#line  216 "scrtfarr.occ"
      CASE(30):  
#line  216 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,((BYTE*)(((BYTE*)FP->buffer_122)+(RNGCHK(FP->tp_124,FP->buffer_122_Dim0)*sizeof(BYTE)))),31);
#line  216 "scrtfarr.occ"
      CASE(31):  
#line  217 "scrtfarr.occ"
        FP->tp_124 = (FP->tp_124 + 1); 
#line  217 "scrtfarr.occ"
        GOTO(3);
#line  217 "scrtfarr.occ"
      CASE(6):  
#line  220 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 6;
#line  220 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,32);
#line  220 "scrtfarr.occ"
      CASE(32):  
#line  220 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,((BYTE*)(((BYTE*)FP->buffer_122)+(RNGCHK(FP->tp_124,FP->buffer_122_Dim0)*sizeof(BYTE)))),33);
#line  220 "scrtfarr.occ"
      CASE(33):  
#line  221 "scrtfarr.occ"
        FP->tp_124 = (FP->tp_124 + 1); 
#line  221 "scrtfarr.occ"
        GOTO(3);
#line  221 "scrtfarr.occ"
      CASE(7):  
#line  225 "scrtfarr.occ"
        {
#line  225 "scrtfarr.occ"
          BYTE bx_129[4];
#line  225 "scrtfarr.occ"
          RETYPE(0^3,4,bx_129,&FP->_U1._S6.x_128);
#line  226 "scrtfarr.occ"
          {
#line  227 "scrtfarr.occ"
            CHK(4==4,MSG_ASM);
#line  227 "scrtfarr.occ"
            ASSIGN(bx_129,((BYTE*)(((BYTE*)FP->buffer_122)+((RNGCHKUB(FP->tp_124,4,FP->buffer_122_Dim0),RNGCHKLB(FP->tp_124))*sizeof(BYTE)))),(4*sizeof(BYTE))); 
#line  228 "scrtfarr.occ"
            FP->tp_124 = (FP->tp_124 + 4); 
#line  228 "scrtfarr.occ"
          }
#line  228 "scrtfarr.occ"
          RETYPE(0^3,4,&FP->_U1._S6.x_128,bx_129);
#line  228 "scrtfarr.occ"
        }
#line  229 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 19;
#line  229 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,34);
#line  229 "scrtfarr.occ"
      CASE(34):  
#line  229 "scrtfarr.occ"
        OUTPUT4(FP->scrn_121,&FP->_U1._S6.x_128,35);
#line  229 "scrtfarr.occ"
      CASE(35):  
#line  229 "scrtfarr.occ"
        GOTO(3);
#line  229 "scrtfarr.occ"
      CASE(8):  
#line  233 "scrtfarr.occ"
        {
#line  233 "scrtfarr.occ"
          BYTE bx_132[4];
#line  233 "scrtfarr.occ"
          RETYPE(0^3,4,bx_132,&FP->_U1._S7.x_130);
#line  234 "scrtfarr.occ"
          {
#line  235 "scrtfarr.occ"
            CHK(4==4,MSG_ASM);
#line  235 "scrtfarr.occ"
            ASSIGN(bx_132,((BYTE*)(((BYTE*)FP->buffer_122)+((RNGCHKUB(FP->tp_124,4,FP->buffer_122_Dim0),RNGCHKLB(FP->tp_124))*sizeof(BYTE)))),(4*sizeof(BYTE))); 
#line  236 "scrtfarr.occ"
            FP->tp_124 = (FP->tp_124 + 4); 
#line  236 "scrtfarr.occ"
          }
#line  236 "scrtfarr.occ"
          RETYPE(0^3,4,&FP->_U1._S7.x_130,bx_132);
#line  236 "scrtfarr.occ"
        }
#line  237 "scrtfarr.occ"
        {
#line  237 "scrtfarr.occ"
          BYTE by_133[4];
#line  237 "scrtfarr.occ"
          RETYPE(0^3,4,by_133,&FP->_U1._S7.y_131);
#line  238 "scrtfarr.occ"
          {
#line  239 "scrtfarr.occ"
            CHK(4==4,MSG_ASM);
#line  239 "scrtfarr.occ"
            ASSIGN(by_133,((BYTE*)(((BYTE*)FP->buffer_122)+((RNGCHKUB(FP->tp_124,4,FP->buffer_122_Dim0),RNGCHKLB(FP->tp_124))*sizeof(BYTE)))),(4*sizeof(BYTE))); 
#line  240 "scrtfarr.occ"
            FP->tp_124 = (FP->tp_124 + 4); 
#line  240 "scrtfarr.occ"
          }
#line  240 "scrtfarr.occ"
          RETYPE(0^3,4,&FP->_U1._S7.y_131,by_133);
#line  240 "scrtfarr.occ"
        }
#line  241 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 5;
#line  241 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,36);
#line  241 "scrtfarr.occ"
      CASE(36):  
#line  241 "scrtfarr.occ"
        OUTPUT4(FP->scrn_121,&FP->_U1._S7.x_130,37);
#line  241 "scrtfarr.occ"
      CASE(37):  
#line  241 "scrtfarr.occ"
        OUTPUT4(FP->scrn_121,&FP->_U1._S7.y_131,38);
#line  241 "scrtfarr.occ"
      CASE(38):  
#line  241 "scrtfarr.occ"
        GOTO(3);
#line  241 "scrtfarr.occ"
      CASE(9):  
#line  243 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 0;
#line  243 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,39);
#line  243 "scrtfarr.occ"
      CASE(39):  
#line  243 "scrtfarr.occ"
        GOTO(3);
#line  243 "scrtfarr.occ"
      CASE(10):  
#line  245 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 1;
#line  245 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,40);
#line  245 "scrtfarr.occ"
      CASE(40):  
#line  245 "scrtfarr.occ"
        GOTO(3);
#line  245 "scrtfarr.occ"
      CASE(11):  
#line  247 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 2;
#line  247 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,41);
#line  247 "scrtfarr.occ"
      CASE(41):  
#line  247 "scrtfarr.occ"
        GOTO(3);
#line  247 "scrtfarr.occ"
      CASE(12):  
#line  249 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 3;
#line  249 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,42);
#line  249 "scrtfarr.occ"
      CASE(42):  
#line  249 "scrtfarr.occ"
        GOTO(3);
#line  249 "scrtfarr.occ"
      CASE(13):  
#line  251 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 4;
#line  251 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,43);
#line  251 "scrtfarr.occ"
      CASE(43):  
#line  251 "scrtfarr.occ"
        GOTO(3);
#line  251 "scrtfarr.occ"
      CASE(14):  
#line  253 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 7;
#line  253 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,44);
#line  253 "scrtfarr.occ"
      CASE(44):  
#line  253 "scrtfarr.occ"
        GOTO(3);
#line  253 "scrtfarr.occ"
      CASE(15):  
#line  255 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 9;
#line  255 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,45);
#line  255 "scrtfarr.occ"
      CASE(45):  
#line  255 "scrtfarr.occ"
        GOTO(3);
#line  255 "scrtfarr.occ"
      CASE(16):  
#line  257 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 10;
#line  257 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,46);
#line  257 "scrtfarr.occ"
      CASE(46):  
#line  257 "scrtfarr.occ"
        GOTO(3);
#line  257 "scrtfarr.occ"
      CASE(17):  
#line  259 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 11;
#line  259 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,47);
#line  259 "scrtfarr.occ"
      CASE(47):  
#line  259 "scrtfarr.occ"
        GOTO(3);
#line  259 "scrtfarr.occ"
      CASE(18):  
#line  261 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 12;
#line  261 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,48);
#line  261 "scrtfarr.occ"
      CASE(48):  
#line  261 "scrtfarr.occ"
        GOTO(3);
#line  261 "scrtfarr.occ"
      CASE(19):  
#line  263 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 13;
#line  263 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,49);
#line  263 "scrtfarr.occ"
      CASE(49):  
#line  263 "scrtfarr.occ"
        GOTO(3);
#line  263 "scrtfarr.occ"
      CASE(20):  
#line  265 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 15;
#line  265 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,50);
#line  265 "scrtfarr.occ"
      CASE(50):  
#line  265 "scrtfarr.occ"
        GOTO(3);
#line  265 "scrtfarr.occ"
      CASE(21):  
#line  267 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 16;
#line  267 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,51);
#line  267 "scrtfarr.occ"
      CASE(51):  
#line  267 "scrtfarr.occ"
        GOTO(3);
#line  267 "scrtfarr.occ"
      CASE(22):  
#line  269 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 17;
#line  269 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,52);
#line  269 "scrtfarr.occ"
      CASE(52):  
#line  269 "scrtfarr.occ"
        GOTO(3);
#line  269 "scrtfarr.occ"
      CASE(23):  
#line  271 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 20;
#line  271 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,53);
#line  271 "scrtfarr.occ"
      CASE(53):  
#line  271 "scrtfarr.occ"
        GOTO(3);
#line  271 "scrtfarr.occ"
      CASE(24):  
#line  273 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 21;
#line  273 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,54);
#line  273 "scrtfarr.occ"
      CASE(54):  
#line  273 "scrtfarr.occ"
        GOTO(3);
#line  273 "scrtfarr.occ"
      CASE(25):  
#line  275 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 22;
#line  275 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,55);
#line  275 "scrtfarr.occ"
      CASE(55):  
#line  275 "scrtfarr.occ"
        GOTO(3);
#line  275 "scrtfarr.occ"
      CASE(26):  
#line  277 "scrtfarr.occ"
        FP->_Header.Temp.VBYTE = 23;
#line  277 "scrtfarr.occ"
        OUTPUT1(FP->scrn_121,&FP->_Header.Temp.VBYTE,56);
#line  277 "scrtfarr.occ"
      CASE(56):  
#line  277 "scrtfarr.occ"
        GOTO(3);
#line  277 "scrtfarr.occ"
      CASE(3):  
#line  278 "scrtfarr.occ"
        FP->tt_bcom_123 = *((BYTE*)(((BYTE*)FP->buffer_122)+(RNGCHK(FP->tp_124,FP->buffer_122_Dim0)*sizeof(BYTE)))); 
#line  279 "scrtfarr.occ"
        FP->tp_124 = (FP->tp_124 + 1); 
#line  201 "scrtfarr.occ"
      CASE(1):  
#line  201 "scrtfarr.occ"
        if ((FP->tt_bcom_123 != 24))
#line  201 "scrtfarr.occ"
        {
#line  201 "scrtfarr.occ"
          GOTO(2);
#line  201 "scrtfarr.occ"
        }
#line  201 "scrtfarr.occ"
        RETURN();
#line  201 "scrtfarr.occ"
      default: SETERR(MSG_IP);
#line  201 "scrtfarr.occ"
    }
#line  201 "scrtfarr.occ"
  }
#line  201 "scrtfarr.occ"
}


/*}}}*/
#endif
