/*{{{  File banner*/
/*@(#)=====================================================*\
||@(#)  Project : GPMIMD ESPRIT P5404
||@(#)  Authors : Mark Debbage, Mark Hill, Denis Nicole and Sean Wykes
||@(#)            University of Southampton
||  
||@(#)    Title : Prototype Source File for generated C
||@(#)   System : Occam 2 C
||@(#)  Version : 1.3
||@(#) Filename : Occam2C.c
||@(#)     Date : 3/4/97
\*@(#)====================================================*/
/*}}}*/

/*{{{  Insert SWITCHES*/
#define LIBRARY_UNIT
#define BYTES_PER_WORD 4
#define TERMINATE_ON_ERROR
#define CHECK_CONVERSIONS
#define CHECK_ARRAYS
#define CHECK_RANGES
#define NO_DEBUG
#define FASTGOTOS
#define SOURCE LITTLE

/*}}}*/
/*{{{  defines*/
#define DEFAULT_MEMSIZE_IN_INTS 1000
#define OCCAM_MAIN

/*}}}*/
/*{{{  includes*/
#include <stdio.h>
#include <errno.h>

#if  (defined USESIGTIMER) || (defined USE_NONBLOCKING_SOCKETS)
#include <signal.h>
#include <sys/time.h>
#endif

#ifdef USE_NONBLOCKING_SOCKETS
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef solaris
#include <stropts.h>
#include <sys/file.h>
#include <sys/conf.h>
#endif
#endif

#ifdef CALL_NAG_F90
#include <f90.h>
#endif

#include "Occam2C.h"

#ifdef USE_NONBLOCKING_SOCKETS
  #ifdef solaris
  #define SOCKET_SIGNAL SIGPOLL
  #else
  #define SOCKET_SIGNAL SIGIO
  #endif
#endif
/*}}}*/
/*{{{  Insert HEADER*/
#include "convert.hdr"
typedef struct SF_P_ss_write_int64_swint64 tSF_P_ss_write_int64_swint64;
typedef struct SF_P_sign_extend_129 tSF_P_sign_extend_129;
typedef struct SF_P_ss_write_hex_int64_swint64 tSF_P_ss_write_hex_int64_swint64;
void P_ss_write_hex_int64_swint64 (tSF_P_ss_write_hex_int64_swint64 *FP);
struct SF_P_ss_write_int64_swint64
{
  tHeader _Header;
  void *Chain;
  CHAN *scrn_105;
  INT64 number_106;
  INT field_107;
  BYTE string_108[20];
  INT len_109;
  union
  {
    struct
    {
      BYTE *spaces_111;
      INT number_of_spaces_112;
      INT fill_this_time_113;
    } _S0;
  } _U0;
};
struct SF_P_sign_extend_129
{
  tHeader _Header;
  tSF_P_ss_write_hex_int64_swint64 *Chain;
  INT how_many_125;
  BYTE *fill_string_126;
  INT number_to_fill_127;
  INT fill_this_time_128;
};
struct SF_P_ss_write_hex_int64_swint64
{
  tHeader _Header;
  void *Chain;
  CHAN *scrn_115;
  INT64 number_116;
  INT field_117;
  BYTE string_118[16];
  INT len_119;
  union
  {
    struct
    {
      BYTE *zeroes_122;
      BYTE *effs_124;
      union
      {
        tSF_P_sign_extend_129 _C2;
        tSF_P_sign_extend_129 _C1;
      } _U2;
    } _S1;
    struct
    {
      INT start_130;
    } _S2;
  } _U1;
};

/*}}}*/

#if (defined GENPROTO) || !(defined LIBRARY_UNIT)
/*{{{  statics*/
jmp_buf STOPP_env;
int MAIN_ARGC ;
char **MAIN_ARGV;
tTask *QFP[NUM_PRIORITY_LEVELS],*QBP[NUM_PRIORITY_LEVELS],*CURTASK,*QTM; 
static volatile int TimerEvent = false;
static volatile int SocketEvent = false;
tTimer TIMER;
static int process_count;


/*}}}*/
#endif

#ifdef GENPROTO
/*{{{  seterr*/
void seterr(char *M,int L,char *F) {}
/*}}}*/
/*{{{  struct Prototypes*/
struct Prototypes
{
  char *Proto;
  char *Define;
  int Space;
};
/*}}}*/
/*{{{  static struct Prototypes Table[] =*/
static struct Prototypes Table[] =
{
  {"void P_ss_write_int64_swint64 (tSF_P_ss_write_int64_swint64 *FP);","P_ss_write_int64_swint64",sizeof(tSF_P_ss_write_int64_swint64)},
  {"void P_ss_write_hex_int64_swint64 (tSF_P_ss_write_hex_int64_swint64 *FP);","P_ss_write_hex_int64_swint64",sizeof(tSF_P_ss_write_hex_int64_swint64)},

 {NULL,NULL,0}
} ;
/*}}}*/
/*{{{  int main(int argc, char**argv)*/
int main(int argc, char**argv)
{
  char *name;
  FILE *f;
  int fcnt;
  
  CheckPrimitiveSizes();

  if (argc<2)
  {
    name="swint64.hdr";
    f=fopen(name,"w");
  }
  else
  {
    name = argv[argc-1];
    if (name[0]=='-')
    {
      name = "stdout";
      f=stdout;
    }
    else
    {
      f=fopen(name,"w");
    }
  }
  fcnt=argc-1;
  
  if (f==NULL)
    { fprintf(stderr,"Error - could not open file %s\n",name);exit(-1); }
  else
  {
    int arg;
    int i;
    fprintf(f,"#ifndef __swint64_INCLUDES__\n");
    fprintf(f,"#define __swint64_INCLUDES__\n");
    
    for(arg = 1; arg < fcnt; ++arg)
    {
      FILE *fh = fopen(argv[arg],"r");
      if (fh == NULL) { fprintf(stderr,"Error - could not read file %s\n",name); exit(-1); }
      while(!feof(fh))
      {
	char line[256];

	if (fgets(line,256,fh) == NULL) break;
	if (line[0] == '#')
	  if (strncmp(line,"#define WS",10)!=0) continue;
	fputs(line,f);
      }
      fclose(fh);
    }      
      
    i = 0;
    while (Table[i].Proto!=NULL)
    {
      if (Table[i].Define != NULL)
      {
	fprintf(f,"typedef struct SF_%s tSF_%s;\n",Table[i].Define,Table[i].Define);
	fprintf(f,"#define WS_%s (%d)\n",Table[i].Define,Table[i].Space);
      }
      fprintf(f,"%s\n",Table[i].Proto);
      i++;
    }
    fprintf(f,"#endif\n");

    if (f!=stdout) fclose(f);
  }
  return(0);
}     
/*}}}*/
#endif

#ifndef LIBRARY_UNIT
/*{{{  seterr*/
static void DONE_SETERR() {}

void seterr(char *M,int L,char *F)
{
  if (M!=NULL) fputs(M,stderr);
  fprintf(stderr,MSG_EFROL,L,F);
  DONE_SETERR();
  SETERR_PROCEED;
}
/*}}}*/
/*{{{  DEBUGDONE,MARK_SCHEDULE*/
#ifndef NO_DEBUG
void DEBUGDONE(void) {}
void MARK_SCHEDULE(void) {}
#endif

/*}}}*/
/*{{{  timer*/
#ifdef USESIGTIMER
static struct timeval tv_start;
/*{{{  static void TimerSignalHandler(int sig)*/
static void TimerSignalHandler(int sig)
{
  switch(sig)
  {
    case SIGALRM:
      {
	struct timeval tv;
	tTask *task;

	gettimeofday(&tv,NULL);
	TIMER = ((tv.tv_usec - tv_start.tv_usec)>>6) + (1000000>>6) * (tv.tv_sec - tv_start.tv_sec);
	if (QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
	  TimerEvent = true;
      }
      break;

    default:
      fprintf(stderr,"Error - Caught signal %d - Exiting\n",sig);
      fflush(stderr);
      exit(20);
  }
}
/*}}}*/
/*{{{  static void Init_Timer()*/
static void Init_Timer()
{
  struct itimerval itv;
#ifndef solaris
  struct sigaction sa;
#endif

  TIMER = 0;
  gettimeofday(&tv_start,NULL);
  TimerSignalHandler(SIGALRM);
  
#ifndef solaris
  memset((char*)&sa,0,sizeof(sa));
  sa.sa_handler = TimerSignalHandler;

#ifdef SA_RESTART
  sa.sa_flags = SA_RESTART;
#endif

  sigaction(SIGALRM,&sa,NULL);
#else
  sigset(SIGALRM,TimerSignalHandler);
#endif

  itv.it_interval.tv_usec = 1000;
  itv.it_interval.tv_sec = 0;
     
  itv.it_value.tv_usec = 1;
  itv.it_value.tv_sec = 0;

  if (setitimer(ITIMER_REAL,&itv,NULL)) 
    fprintf(stderr,"Error - setitimer failed\n");

  QTM = NoTask;
  TimerEvent = false;
}

/*}}}*/

#else
static void Init_Timer() { (void)clock(); TimerEvent = false; }
#endif
/*}}}*/
/*{{{  sockets*/
#ifdef USE_NONBLOCKING_SOCKETS
static int io_limit;
static struct timeval io_zerotime;

static int    io_socket;
static tTask *io_task = NoTask;

/*{{{  void SocketHandler (int sig)*/
void SocketHandler (int sig)
{
  switch (sig)
  {
    case SOCKET_SIGNAL:
    {
      #ifdef MD_DEBUG
      fprintf(stderr,"Caught signal %d\n",sig);
      #endif
      
      SocketEvent = true;
      
      #ifdef solaris
      signal (SOCKET_SIGNAL, SocketHandler);
      #endif
      
      break;
    }
    default:
      fprintf(stderr,"Error - Caught unexpected signal %d - exiting\n",sig);
      fflush(stderr);
      exit(20);
  }  
}
/*}}}*/
 
/*{{{  void WaitSocket (int socket)*/
void WaitSocket (int socket)
{
  fd_set io_set;

  io_socket = socket;

  FD_ZERO (&io_set);
  FD_SET  (socket,&io_set);
  
  errno = 0;
  while (select (io_limit, &io_set, NULL, NULL, &io_zerotime) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
  
  if (!FD_ISSET(socket,&io_set))
  {
    if (io_task == NoTask)
      io_task = CURTASK;
    else
    {
      fprintf(stderr, "Error - Implementation restriction, only one signaling socket\n");
      exit(-1);
    }
    DeSchedule(TSOCK_p);
  }
}
/*}}}*/

/*{{{  void EnableSocket (int socket)*/
void EnableSocket (int socket)
{
  errno = 0;
  
  #ifdef solaris
  if (ioctl(socket,I_SETSIG,S_RDNORM) < 0)
  {
    fprintf(stderr,"Error - could not set signal handler for socket (errno %d)\n",errno);
    exit(-1);
  }
  #else
  if (fcntl(socket, F_SETOWN, getpid()) < 0)
  {
    fprintf(stderr,"Error - could not set owner on socket (errno %d)\n",errno);
    exit(-1);
  }
  if (fcntl(socket, F_SETFL, FASYNC)    < 0)
  {
    fprintf(stderr,"Error - could not set asynchronous socket (errno %d)\n",errno);
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void DisableSocket (int socket)*/
void DisableSocket (int socket)
{
  #ifdef sun4
  if (fcntl(socket, F_SETFL, FSYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
  #ifdef linux
  if (fcntl(socket, F_SETFL, FASYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void ServeSocket (void)*/
void ServeSocket (void)
{
  fd_set io_set;
  int res;

  /* In the general case there's a timing hazard here since a new signal
     could arrive and we can lose it. Really need test-and-set or a
     semaphore. For hostio, however, there's only ever one outstanding 
     communication and this thread is serving it. Hence, no problem here. */

  SocketEvent = false; 

  FD_ZERO (&io_set);
  FD_SET  (io_socket,&io_set);
  
  errno = 0;
  while ((res = select (io_limit, &io_set, NULL, NULL, &io_zerotime)) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
      
  if (res == 0)
  {
    /*fprintf(stderr,"Could not locate socket signal source, ignoring select\n");*/
    return;
  }
  
  if (!FD_ISSET(io_socket,&io_set))
  {
    fprintf(stderr,"Error - socket is not ready\n");
    exit(-1);
  }

  if (io_task != NoTask)
  {
    ReSchedule(io_task);
    io_task = NoTask;
  }
}
/*}}}*/

/*{{{  void Init_Sockets()*/
void Init_Sockets()
{
  io_limit = ulimit (4,0);

  timerclear (&io_zerotime);

  signal (SOCKET_SIGNAL, SocketHandler);
  #ifdef linux
  {
    struct sigaction action;
    sigaction(SIGIO,NULL,&action);
    action.sa_flags = (action.sa_flags & (~SA_ONESHOT));
    sigaction(SIGIO,&action,NULL);
  }
  #endif
}
/*}}}*/
#else
void WaitSocket (int socket)
{ 
  fprintf(stderr, "Error - No SIGSOCKETS\n"); 
}
#endif
/*}}}*/

/*{{{  static void Init_Scheduler()*/
static void Init_Scheduler()
{
  int i;

  for(i = 0; i < NUM_PRIORITY_LEVELS; ++i)
    QFP[i] = QBP[i] = NoTask;

  CURTASK = NoTask;

  Init_Timer();

  #ifdef USE_NONBLOCKING_SOCKETS
  Init_Sockets();  
  #endif
}
/*}}}*/
/*{{{  static void Scheduler()*/
static void Scheduler()
{
  if (setjmp(STOPP_env)) DeSchedule(0);
  
  while(CURTASK != NoTask || TimerEvent || SocketEvent)
  {
    int pri;

#ifdef USESIGTIMER
    /*{{{  if (TimerEvent)*/
    if (TimerEvent)
    {
    #ifdef DEBUG
	fprintf(stderr,"Timer = %d\n",TIMER);
    #endif
      TimerEvent = false;
      while(QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
      {
    #ifdef DEBUG
	{  
	  tTask *task = QTM;
    
	  fprintf(stderr,"Timer Queue contains:");
	  if (task == NoTask) fprintf(stderr,"No Tasks");
	  else while(task != NoTask) { fprintf(stderr,"%d(%d) ",task->TaskId,task->comms.timer.time); task = task->Next; }
	  fprintf(stderr,"\n");
	}  
    #endif
	if (QTM->AltMode == Waiting_p) QTM->AltMode = TReady_p;
	ReSchedule(QTM);
      }
    }
    /*}}}*/
#endif

#ifdef USE_NONBLOCKING_SOCKETS
    if (SocketEvent)
      ServeSocket();
#endif

    for(pri = 0; pri < NUM_PRIORITY_LEVELS; ++pri)
    {
#ifdef DEBUG
  {
    tTask *task = QFP[pri];
    fprintf(stderr,"Task Queue %d contains:",pri);
    if (task == NoTask) fprintf(stderr,"No Tasks");
    else while(task != NoTask) { fprintf(stderr,"%d ",task->TaskId); task = task->Next; }
    fprintf(stderr,"\n");
  }
#endif

      if ((CURTASK=QFP[pri]) != NoTask)
      {
	/*{{{  #ifdef SHOWTASKING*/
	#ifdef SHOWTASKING
		fprintf(stderr,"Scheduler - Current task is %c%d (%s) IP=%d\n",(CURTASK->TaskPriority)?'L':'H',CURTASK->TaskId,((tHeader *)CURTASK->FP)->ProcName,((tHeader *)CURTASK->FP)->IP); fflush(stderr); 
	#endif
	/*}}}*/
	/*{{{  #ifndef NO_DEBUG*/
	#ifndef NO_DEBUG
	MARK_SCHEDULE() ;
	#endif
	/*}}}*/
	CURTASK->Func (CURTASK->FP);
	break;
      }
    }

    /*{{{  catch any signals*/
    #if (defined USESIGTIMER && defined USE_NONBLOCKING_SOCKETS)
	if (CURTASK == NoTask && (QTM != NoTask || io_task != NoTask))
	  while(!TimerEvent && !SocketEvent)
	    pause();
    #else
      #if (defined USESIGTIMER)
	  if (CURTASK == NoTask && QTM != NoTask)
	    while(!TimerEvent)
	      pause();
      #endif
      
      #if (defined USE_NONBLOCKING_SOCKETS)
	  if (CURTASK == NoTask && io_task != NoTask)
	    while(!SocketEvent)
	      pause();
      #endif
    #endif
    /*}}}*/

  }

#ifdef DEBUG
  fprintf(stderr,"Scheduling Queue empty\n");
#endif
}

/*}}}*/
/*{{{  void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)
{
  static int NextTaskId = 0;
  process_count++;
  
  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = (CURTASK != NoTask && CURTASK->TaskPriority == HighPriority) ? HighPriority : Priority;
  ((tHeader *)FP)->ProcName = name;
  
  if (Priority < 0 || Priority >= NUM_PRIORITY_LEVELS) SETERR(MSG_PRI);
  
  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Processor)
{
  static int NextTaskId = 0;
  process_count++;

  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = LowPriority;

  ((tHeader *)FP)->ProcName = name;

  SETERR("PLACED PAR is not supported in this implementation");

  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void End_Process()*/
void End_Process()
{
  register tTask *task = CURTASK;
  process_count--;
    
  QFP[task->TaskPriority] = task->Next;
  if (QFP[task->TaskPriority] == NoTask) QBP[task->TaskPriority] = NoTask;
  task->Next = NoTask;
  if (task->Parent)
  {
    if (--(task->Parent->Children) == 0) ReSchedule(task->Parent);
  }
}
/*}}}*/

/*{{{  SPOC iserver definitions*/
#ifdef USE_SPOC_ISERVER
extern int CocoPops;
#include "spserver.hdr"

struct SF_P_spoc_iserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_iserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_iserver_spserver spserver;
} tSF_P_spoc_iserver_caller;

static tSF_P_spoc_iserver_caller spoc_iserver_data;
static tTask spoc_iserver_task;

static tFuncPtr P_spoc_iserver_caller (tSF_P_spoc_iserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_iserver_spserver,&FP->spserver,1,"P_spoc_iserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/
/*{{{  SPOC aserver definitions*/
#ifdef USE_SPOC_ASERVER
#include "spserver.hdr"

struct SF_P_spoc_aserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_aserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_aserver_spserver spserver;
} tSF_P_spoc_aserver_caller;

static tSF_P_spoc_aserver_caller spoc_aserver_data;
static tTask spoc_aserver_task;

static tFuncPtr P_spoc_aserver_caller (tSF_P_spoc_aserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_aserver_spserver,&FP->spserver,1,"P_spoc_aserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/

/*{{{  int main(int argc, char **argv)*/
int main(int argc, char **argv)
{
  void *FP=NULL;
  tSF_ *MAINFP=(tSF_ *)malloc(sizeof(tSF_));
  tTask main_t;
  INT mem_size = (argc>1 && atoi(argv[1])>0)?atoi(argv[1]):DEFAULT_MEMSIZE_IN_INTS;
  INT *mem=(INT*)malloc(mem_size*sizeof(INT));
  CHAN fs,ts;
  
  if (MAINFP==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s bytes for occam workspace failed\n",sizeof(tSF_));
    exit(-1);
  }
  if (mem_size>0 && mem==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s INTs for occam memory array failed\n",mem_size);
    exit(-1);
  }
  (void) clock();
  MAIN_ARGC = argc ;
  MAIN_ARGV = argv ;
  process_count = 0;
 
  CheckPrimitiveSizes();
  INITCH(&fs);
  INITCH(&ts);
  Init_Scheduler();
  
  STARTP(&main_t,,MAINFP,"",LowPriority);

  /*{{{  #ifdef USE_SPOC_ISERVER*/
  #ifdef USE_SPOC_ISERVER
  #ifdef SHOWTASKING
  CocoPops=true;
  #endif
  spoc_iserver_data.fs = &fs;
  spoc_iserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_iserver_task, P_spoc_iserver_caller, &spoc_iserver_data, "P_spoc_iserver_spserver",LowPriority);
  #endif
  /*}}}*/
  /*{{{  #ifdef USE_SPOC_ASERVER*/
  #ifdef USE_SPOC_ASERVER
  spoc_aserver_data.fs = &fs;
  spoc_aserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_aserver_task, P_spoc_aserver_caller, &spoc_aserver_data, "P_spoc_aserver_spserver",LowPriority);
  #endif
  /*}}}*/
/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_init(argc,argv);
#endif
/*}}}*/
  
  Scheduler();

/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_finish(0);
#endif
/*}}}*/
  if (process_count == 0)
    return 0;
  else
  {
    fprintf(stderr,"Deadlock: %d stopped process%s.\n", process_count,(process_count>1)?"es":"");
    return 1;
  }
}     
/*}}}*/
#endif

#ifndef GENPROTO
/*{{{  Insert DEBUG*/

/*}}}*/
/*{{{  Insert CODE*/
void P_ss_write_int64_swint64 (tSF_P_ss_write_int64_swint64 *FP)
#line   14 "swint64.occ"
{
#line   14 "swint64.occ"
  while(true)
#line   14 "swint64.occ"
  {
#line   14 "swint64.occ"
    switch(FP->_Header.IP)
#line   14 "swint64.occ"
    {
#line   14 "swint64.occ"
      CASE(0):  
#line   29 "swint64.occ"
        if (!(FP->field_107 < 0)) GOTO(2);
#line   30 "swint64.occ"
        SETERR(MSG_STOP);
#line   30 "swint64.occ"
        GOTO(1);
#line   30 "swint64.occ"
      CASE(2):  
#line   31 "swint64.occ"
        if (!true) GOTO(3);
#line   35 "swint64.occ"
        P_INT64TOSTRING_convert(&FP->len_109,20,(BYTE*)FP->string_108,FP->number_106);
#line   37 "swint64.occ"
        {
#line   37 "swint64.occ"
          static BYTE TMP[20] = {32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32};
#line   37 "swint64.occ"
          FP->_U0._S0.spaces_111 = TMP;
#line   37 "swint64.occ"
        }
#line   40 "swint64.occ"
        FP->_U0._S0.number_of_spaces_112 = (FP->field_107 - FP->len_109); 
#line   41 "swint64.occ"
        GOTO(4);
#line   41 "swint64.occ"
      CASE(5):  
#line   44 "swint64.occ"
        if ((FP->_U0._S0.number_of_spaces_112 > 20))
#line   44 "swint64.occ"
        {
#line   45 "swint64.occ"
          FP->_U0._S0.fill_this_time_113 = 20; 
#line   45 "swint64.occ"
        }
#line   45 "swint64.occ"
        else
#line   46 "swint64.occ"
        if (true)
#line   46 "swint64.occ"
        {
#line   47 "swint64.occ"
          FP->_U0._S0.fill_this_time_113 = FP->_U0._S0.number_of_spaces_112; 
#line   47 "swint64.occ"
        }
#line   47 "swint64.occ"
        else
#line   47 "swint64.occ"
        {
#line   47 "swint64.occ"
          SETERR(MSG_IF);
#line   47 "swint64.occ"
        }
#line   48 "swint64.occ"
        FP->_Header.Temp.VBYTE = 8;
#line   48 "swint64.occ"
        OUTPUT1(FP->scrn_105,&FP->_Header.Temp.VBYTE,6);
#line   48 "swint64.occ"
      CASE(6):  
#line   48 "swint64.occ"
        FP->_Header.Temp.VINT32 = INT32INT(FP->_U0._S0.fill_this_time_113);
#line   48 "swint64.occ"
        OUTPUT4(FP->scrn_105,&FP->_Header.Temp.VINT32,7);
#line   48 "swint64.occ"
      CASE(7):  
#line   48 "swint64.occ"
        OUTPUT(FP->scrn_105,((BYTE*)(((BYTE*)FP->_U0._S0.spaces_111)+((RNGCHKUB(0,FP->_U0._S0.fill_this_time_113,20),0)*sizeof(BYTE)))),(INT32INT(FP->_U0._S0.fill_this_time_113))*(sizeof(BYTE)),8);
#line   48 "swint64.occ"
      CASE(8):  
#line   50 "swint64.occ"
        FP->_U0._S0.number_of_spaces_112 = (FP->_U0._S0.number_of_spaces_112 - FP->_U0._S0.fill_this_time_113); 
#line   41 "swint64.occ"
      CASE(4):  
#line   41 "swint64.occ"
        if ((FP->_U0._S0.number_of_spaces_112 > 0))
#line   41 "swint64.occ"
        {
#line   41 "swint64.occ"
          GOTO(5);
#line   41 "swint64.occ"
        }
#line   53 "swint64.occ"
        FP->_Header.Temp.VBYTE = 8;
#line   53 "swint64.occ"
        OUTPUT1(FP->scrn_105,&FP->_Header.Temp.VBYTE,9);
#line   53 "swint64.occ"
      CASE(9):  
#line   53 "swint64.occ"
        FP->_Header.Temp.VINT32 = INT32INT(FP->len_109);
#line   53 "swint64.occ"
        OUTPUT4(FP->scrn_105,&FP->_Header.Temp.VINT32,10);
#line   53 "swint64.occ"
      CASE(10):  
#line   53 "swint64.occ"
        OUTPUT(FP->scrn_105,((BYTE*)(((BYTE*)FP->string_108)+((RNGCHKUB(0,FP->len_109,20),0)*sizeof(BYTE)))),(INT32INT(FP->len_109))*(sizeof(BYTE)),11);
#line   53 "swint64.occ"
      CASE(11):  
#line   53 "swint64.occ"
        GOTO(1);
#line   53 "swint64.occ"
      CASE(3):  
#line   53 "swint64.occ"
        SETERR(MSG_IF);
#line   53 "swint64.occ"
      CASE(1):  
#line   53 "swint64.occ"
        RETURN();
#line   53 "swint64.occ"
      default: SETERR(MSG_IP);
#line   53 "swint64.occ"
    }
#line   53 "swint64.occ"
  }
#line   53 "swint64.occ"
}

#line   87 "swint64.occ"
static void P_sign_extend_129 (tSF_P_sign_extend_129 *FP)
#line   87 "swint64.occ"
{
#line   87 "swint64.occ"
  while(true)
#line   87 "swint64.occ"
  {
#line   87 "swint64.occ"
    switch(FP->_Header.IP)
#line   87 "swint64.occ"
    {
#line   87 "swint64.occ"
      CASE(0):  
#line   90 "swint64.occ"
        FP->number_to_fill_127 = FP->how_many_125; 
#line   91 "swint64.occ"
        GOTO(1);
#line   91 "swint64.occ"
      CASE(2):  
#line   94 "swint64.occ"
        if ((FP->number_to_fill_127 > 10))
#line   94 "swint64.occ"
        {
#line   95 "swint64.occ"
          FP->fill_this_time_128 = 10; 
#line   95 "swint64.occ"
        }
#line   95 "swint64.occ"
        else
#line   96 "swint64.occ"
        if (true)
#line   96 "swint64.occ"
        {
#line   97 "swint64.occ"
          FP->fill_this_time_128 = FP->number_to_fill_127; 
#line   97 "swint64.occ"
        }
#line   97 "swint64.occ"
        else
#line   97 "swint64.occ"
        {
#line   97 "swint64.occ"
          SETERR(MSG_IF);
#line   97 "swint64.occ"
        }
#line   98 "swint64.occ"
        FP->_Header.Temp.VBYTE = 8;
#line   98 "swint64.occ"
        OUTPUT1(FP->Chain->scrn_115,&FP->_Header.Temp.VBYTE,3);
#line   98 "swint64.occ"
      CASE(3):  
#line   98 "swint64.occ"
        FP->_Header.Temp.VINT32 = INT32INT(FP->fill_this_time_128);
#line   98 "swint64.occ"
        OUTPUT4(FP->Chain->scrn_115,&FP->_Header.Temp.VINT32,4);
#line   98 "swint64.occ"
      CASE(4):  
#line   98 "swint64.occ"
        OUTPUT(FP->Chain->scrn_115,((BYTE*)(((BYTE*)FP->fill_string_126)+((RNGCHKUB(0,FP->fill_this_time_128,10),0)*sizeof(BYTE)))),(INT32INT(FP->fill_this_time_128))*(sizeof(BYTE)),5);
#line   98 "swint64.occ"
      CASE(5):  
#line  100 "swint64.occ"
        FP->number_to_fill_127 = (FP->number_to_fill_127 - FP->fill_this_time_128); 
#line   91 "swint64.occ"
      CASE(1):  
#line   91 "swint64.occ"
        if ((FP->number_to_fill_127 > 0))
#line   91 "swint64.occ"
        {
#line   91 "swint64.occ"
          GOTO(2);
#line   91 "swint64.occ"
        }
#line   91 "swint64.occ"
        RETURN();
#line   91 "swint64.occ"
      default: SETERR(MSG_IP);
#line   91 "swint64.occ"
    }
#line   91 "swint64.occ"
  }
#line   91 "swint64.occ"
}

#line   57 "swint64.occ"
void P_ss_write_hex_int64_swint64 (tSF_P_ss_write_hex_int64_swint64 *FP)
#line   57 "swint64.occ"
{
#line   57 "swint64.occ"
  while(true)
#line   57 "swint64.occ"
  {
#line   57 "swint64.occ"
    switch(FP->_Header.IP)
#line   57 "swint64.occ"
    {
#line   57 "swint64.occ"
      CASE(0):  
#line   74 "swint64.occ"
        if (!(FP->field_117 < 0)) GOTO(2);
#line   75 "swint64.occ"
        SETERR(MSG_STOP);
#line   75 "swint64.occ"
        GOTO(1);
#line   75 "swint64.occ"
      CASE(2):  
#line   76 "swint64.occ"
        if (!true) GOTO(3);
#line   80 "swint64.occ"
        P_HEX64TOSTRING_convert(&FP->len_119,16,(BYTE*)FP->string_118,FP->number_116);
#line   81 "swint64.occ"
        FP->_Header.Temp.VBYTE = 18;
#line   81 "swint64.occ"
        OUTPUT1(FP->scrn_115,&FP->_Header.Temp.VBYTE,4);
#line   81 "swint64.occ"
      CASE(4):  
#line   81 "swint64.occ"
        FP->_Header.Temp.VBYTE = 35;
#line   81 "swint64.occ"
        OUTPUT1(FP->scrn_115,&FP->_Header.Temp.VBYTE,5);
#line   81 "swint64.occ"
      CASE(5):  
#line   84 "swint64.occ"
        {
#line   84 "swint64.occ"
          static BYTE TMP[10] = {48,48,48,48,48,48,48,48,48,48};
#line   84 "swint64.occ"
          FP->_U1._S1.zeroes_122 = TMP;
#line   84 "swint64.occ"
        }
#line   85 "swint64.occ"
        {
#line   85 "swint64.occ"
          static BYTE TMP[10] = {70,70,70,70,70,70,70,70,70,70};
#line   85 "swint64.occ"
          FP->_U1._S1.effs_124 = TMP;
#line   85 "swint64.occ"
        }
#line  104 "swint64.occ"
        if (!(FP->number_116 < 0)) GOTO(7);
#line  105 "swint64.occ"
        FP->_U1._S1._U2._C2.how_many_125=(FP->field_117 - FP->len_119);
#line  105 "swint64.occ"
        FP->_U1._S1._U2._C2.fill_string_126= (BYTE*)FP->_U1._S1.effs_124;
#line  105 "swint64.occ"
        FP->_U1._S1._U2._C2.Chain = FP;
#line  105 "swint64.occ"
        CALL(P_sign_extend_129,&FP->_U1._S1._U2._C2,8,"P_sign_extend_129");
#line  105 "swint64.occ"
      CASE(8):  
#line  105 "swint64.occ"
        GOTO(6);
#line  105 "swint64.occ"
      CASE(7):  
#line  106 "swint64.occ"
        if (!true) GOTO(9);
#line  107 "swint64.occ"
        FP->_U1._S1._U2._C1.how_many_125=(FP->field_117 - FP->len_119);
#line  107 "swint64.occ"
        FP->_U1._S1._U2._C1.fill_string_126= (BYTE*)FP->_U1._S1.zeroes_122;
#line  107 "swint64.occ"
        FP->_U1._S1._U2._C1.Chain = FP;
#line  107 "swint64.occ"
        CALL(P_sign_extend_129,&FP->_U1._S1._U2._C1,10,"P_sign_extend_129");
#line  107 "swint64.occ"
      CASE(10):  
#line  107 "swint64.occ"
        GOTO(6);
#line  107 "swint64.occ"
      CASE(9):  
#line  107 "swint64.occ"
        SETERR(MSG_IF);
#line  107 "swint64.occ"
      CASE(6):  
#line  113 "swint64.occ"
        if ((FP->len_119 > FP->field_117))
#line  113 "swint64.occ"
        {
#line  114 "swint64.occ"
          {
#line  115 "swint64.occ"
            FP->_U1._S2.start_130 = (FP->len_119 - FP->field_117); 
#line  116 "swint64.occ"
            FP->len_119 = FP->field_117; 
#line  116 "swint64.occ"
          }
#line  116 "swint64.occ"
        }
#line  116 "swint64.occ"
        else
#line  117 "swint64.occ"
        if (true)
#line  117 "swint64.occ"
        {
#line  118 "swint64.occ"
          FP->_U1._S2.start_130 = 0; 
#line  118 "swint64.occ"
        }
#line  118 "swint64.occ"
        else
#line  118 "swint64.occ"
        {
#line  118 "swint64.occ"
          SETERR(MSG_IF);
#line  118 "swint64.occ"
        }
#line  119 "swint64.occ"
        FP->_Header.Temp.VBYTE = 8;
#line  119 "swint64.occ"
        OUTPUT1(FP->scrn_115,&FP->_Header.Temp.VBYTE,11);
#line  119 "swint64.occ"
      CASE(11):  
#line  119 "swint64.occ"
        FP->_Header.Temp.VINT32 = INT32INT(FP->len_119);
#line  119 "swint64.occ"
        OUTPUT4(FP->scrn_115,&FP->_Header.Temp.VINT32,12);
#line  119 "swint64.occ"
      CASE(12):  
#line  119 "swint64.occ"
        OUTPUT(FP->scrn_115,((BYTE*)(((BYTE*)FP->string_118)+((RNGCHKUB(FP->_U1._S2.start_130,FP->len_119,16),RNGCHKLB(FP->_U1._S2.start_130))*sizeof(BYTE)))),(INT32INT(FP->len_119))*(sizeof(BYTE)),13);
#line  119 "swint64.occ"
      CASE(13):  
#line  119 "swint64.occ"
        GOTO(1);
#line  119 "swint64.occ"
      CASE(3):  
#line  119 "swint64.occ"
        SETERR(MSG_IF);
#line  119 "swint64.occ"
      CASE(1):  
#line  119 "swint64.occ"
        RETURN();
#line  119 "swint64.occ"
      default: SETERR(MSG_IP);
#line  119 "swint64.occ"
    }
#line  119 "swint64.occ"
  }
#line  119 "swint64.occ"
}


/*}}}*/
#endif
