/*{{{  File banner*/
/*@(#)=====================================================*\
||@(#)  Project : GPMIMD ESPRIT P5404
||@(#)  Authors : Mark Debbage, Mark Hill, Denis Nicole and Sean Wykes
||@(#)            University of Southampton
||  
||@(#)    Title : Prototype Source File for generated C
||@(#)   System : Occam 2 C
||@(#)  Version : 1.3
||@(#) Filename : Occam2C.c
||@(#)     Date : 3/4/97
\*@(#)====================================================*/
/*}}}*/

/*{{{  Insert SWITCHES*/
#define LIBRARY_UNIT
#define BYTES_PER_WORD 4
#define TERMINATE_ON_ERROR
#define CHECK_CONVERSIONS
#define CHECK_ARRAYS
#define CHECK_RANGES
#define NO_DEBUG
#define FASTGOTOS
#define SOURCE LITTLE

/*}}}*/
/*{{{  defines*/
#define DEFAULT_MEMSIZE_IN_INTS 1000
#define OCCAM_MAIN

/*}}}*/
/*{{{  includes*/
#include <stdio.h>
#include <errno.h>

#if  (defined USESIGTIMER) || (defined USE_NONBLOCKING_SOCKETS)
#include <signal.h>
#include <sys/time.h>
#endif

#ifdef USE_NONBLOCKING_SOCKETS
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#ifdef solaris
#include <stropts.h>
#include <sys/file.h>
#include <sys/conf.h>
#endif
#endif

#ifdef CALL_NAG_F90
#include <f90.h>
#endif

#include "Occam2C.h"

#ifdef USE_NONBLOCKING_SOCKETS
  #ifdef solaris
  #define SOCKET_SIGNAL SIGPOLL
  #else
  #define SOCKET_SIGNAL SIGIO
  #endif
#endif
/*}}}*/
/*{{{  Insert HEADER*/
typedef struct SF_F_compare_strings_string1 tSF_F_compare_strings_string1;
typedef struct SF_F_eqstr_string1 tSF_F_eqstr_string1;
typedef struct SF_P_str_shift_string1 tSF_P_str_shift_string1;
typedef struct SF_P_delete_string_string1 tSF_P_delete_string_string1;
typedef struct SF_P_insert_string_string1 tSF_P_insert_string_string1;
typedef struct SF_F_string_pos_string1 tSF_F_string_pos_string1;
typedef struct SF_F_char_pos_string1 tSF_F_char_pos_string1;
typedef struct SF_F_search_match_string1 tSF_F_search_match_string1;
typedef struct SF_F_search_no_match_string1 tSF_F_search_no_match_string1;
void F_search_no_match_string1(INT possibles_130_Dim0,BYTE *possibles_130,INT str_131_Dim0,BYTE *str_131,INT *Param0,BYTE *Param1);
struct SF_F_compare_strings_string1
{
  tHeader _Header;
  void *Chain;
};
struct SF_F_eqstr_string1
{
  tHeader _Header;
  void *Chain;
};
struct SF_P_str_shift_string1
{
  tHeader _Header;
  void *Chain;
};
struct SF_P_delete_string_string1
{
  tHeader _Header;
  void *Chain;
};
struct SF_P_insert_string_string1
{
  tHeader _Header;
  void *Chain;
};
struct SF_F_string_pos_string1
{
  tHeader _Header;
  void *Chain;
};
struct SF_F_char_pos_string1
{
  tHeader _Header;
  void *Chain;
};
struct SF_F_search_match_string1
{
  tHeader _Header;
  void *Chain;
};
struct SF_F_search_no_match_string1
{
  tHeader _Header;
  void *Chain;
};

/*}}}*/

#if (defined GENPROTO) || !(defined LIBRARY_UNIT)
/*{{{  statics*/
jmp_buf STOPP_env;
int MAIN_ARGC ;
char **MAIN_ARGV;
tTask *QFP[NUM_PRIORITY_LEVELS],*QBP[NUM_PRIORITY_LEVELS],*CURTASK,*QTM; 
static volatile int TimerEvent = false;
static volatile int SocketEvent = false;
tTimer TIMER;
static int process_count;


/*}}}*/
#endif

#ifdef GENPROTO
/*{{{  seterr*/
void seterr(char *M,int L,char *F) {}
/*}}}*/
/*{{{  struct Prototypes*/
struct Prototypes
{
  char *Proto;
  char *Define;
  int Space;
};
/*}}}*/
/*{{{  static struct Prototypes Table[] =*/
static struct Prototypes Table[] =
{
  {"INT F_compare_strings_string1(INT str1_51_Dim0,BYTE *str1_51,INT str2_52_Dim0,BYTE *str2_52);",NULL,0},
  {"BOOL F_eqstr_string1(INT s1_60_Dim0,BYTE *s1_60,INT s2_61_Dim0,BYTE *s2_61);",NULL,0},
  {"void P_str_shift_string1 (INT str_68_Dim0,BYTE *str_68,INT start_69,INT len_70,INT shift_71,BOOL *not_done_72);",NULL,0},
  {"void P_delete_string_string1 (INT *len_87,INT str_88_Dim0,BYTE *str_88,INT start_89,INT size_90,BOOL *not_done_91);",NULL,0},
  {"void P_insert_string_string1 (INT new_str_94_Dim0,BYTE *new_str_94,INT *len_95,INT str_96_Dim0,BYTE *str_96,INT start_97,BOOL *not_done_98);",NULL,0},
  {"INT F_string_pos_string1(INT search_104_Dim0,BYTE *search_104,INT str_105_Dim0,BYTE *str_105);",NULL,0},
  {"INT F_char_pos_string1(BYTE search_116,INT str_117_Dim0,BYTE *str_117);",NULL,0},
  {"void F_search_match_string1(INT possibles_122_Dim0,BYTE *possibles_122,INT str_123_Dim0,BYTE *str_123,INT *Param0,BYTE *Param1);",NULL,0},
  {"void F_search_no_match_string1(INT possibles_130_Dim0,BYTE *possibles_130,INT str_131_Dim0,BYTE *str_131,INT *Param0,BYTE *Param1);",NULL,0},

 {NULL,NULL,0}
} ;
/*}}}*/
/*{{{  int main(int argc, char**argv)*/
int main(int argc, char**argv)
{
  char *name;
  FILE *f;
  int fcnt;
  
  CheckPrimitiveSizes();

  if (argc<2)
  {
    name="string1.hdr";
    f=fopen(name,"w");
  }
  else
  {
    name = argv[argc-1];
    if (name[0]=='-')
    {
      name = "stdout";
      f=stdout;
    }
    else
    {
      f=fopen(name,"w");
    }
  }
  fcnt=argc-1;
  
  if (f==NULL)
    { fprintf(stderr,"Error - could not open file %s\n",name);exit(-1); }
  else
  {
    int arg;
    int i;
    fprintf(f,"#ifndef __string1_INCLUDES__\n");
    fprintf(f,"#define __string1_INCLUDES__\n");
    
    for(arg = 1; arg < fcnt; ++arg)
    {
      FILE *fh = fopen(argv[arg],"r");
      if (fh == NULL) { fprintf(stderr,"Error - could not read file %s\n",name); exit(-1); }
      while(!feof(fh))
      {
	char line[256];

	if (fgets(line,256,fh) == NULL) break;
	if (line[0] == '#')
	  if (strncmp(line,"#define WS",10)!=0) continue;
	fputs(line,f);
      }
      fclose(fh);
    }      
      
    i = 0;
    while (Table[i].Proto!=NULL)
    {
      if (Table[i].Define != NULL)
      {
	fprintf(f,"typedef struct SF_%s tSF_%s;\n",Table[i].Define,Table[i].Define);
	fprintf(f,"#define WS_%s (%d)\n",Table[i].Define,Table[i].Space);
      }
      fprintf(f,"%s\n",Table[i].Proto);
      i++;
    }
    fprintf(f,"#endif\n");

    if (f!=stdout) fclose(f);
  }
  return(0);
}     
/*}}}*/
#endif

#ifndef LIBRARY_UNIT
/*{{{  seterr*/
static void DONE_SETERR() {}

void seterr(char *M,int L,char *F)
{
  if (M!=NULL) fputs(M,stderr);
  fprintf(stderr,MSG_EFROL,L,F);
  DONE_SETERR();
  SETERR_PROCEED;
}
/*}}}*/
/*{{{  DEBUGDONE,MARK_SCHEDULE*/
#ifndef NO_DEBUG
void DEBUGDONE(void) {}
void MARK_SCHEDULE(void) {}
#endif

/*}}}*/
/*{{{  timer*/
#ifdef USESIGTIMER
static struct timeval tv_start;
/*{{{  static void TimerSignalHandler(int sig)*/
static void TimerSignalHandler(int sig)
{
  switch(sig)
  {
    case SIGALRM:
      {
	struct timeval tv;
	tTask *task;

	gettimeofday(&tv,NULL);
	TIMER = ((tv.tv_usec - tv_start.tv_usec)>>6) + (1000000>>6) * (tv.tv_sec - tv_start.tv_sec);
	if (QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
	  TimerEvent = true;
      }
      break;

    default:
      fprintf(stderr,"Error - Caught signal %d - Exiting\n",sig);
      fflush(stderr);
      exit(20);
  }
}
/*}}}*/
/*{{{  static void Init_Timer()*/
static void Init_Timer()
{
  struct itimerval itv;
#ifndef solaris
  struct sigaction sa;
#endif

  TIMER = 0;
  gettimeofday(&tv_start,NULL);
  TimerSignalHandler(SIGALRM);
  
#ifndef solaris
  memset((char*)&sa,0,sizeof(sa));
  sa.sa_handler = TimerSignalHandler;

#ifdef SA_RESTART
  sa.sa_flags = SA_RESTART;
#endif

  sigaction(SIGALRM,&sa,NULL);
#else
  sigset(SIGALRM,TimerSignalHandler);
#endif

  itv.it_interval.tv_usec = 1000;
  itv.it_interval.tv_sec = 0;
     
  itv.it_value.tv_usec = 1;
  itv.it_value.tv_sec = 0;

  if (setitimer(ITIMER_REAL,&itv,NULL)) 
    fprintf(stderr,"Error - setitimer failed\n");

  QTM = NoTask;
  TimerEvent = false;
}

/*}}}*/

#else
static void Init_Timer() { (void)clock(); TimerEvent = false; }
#endif
/*}}}*/
/*{{{  sockets*/
#ifdef USE_NONBLOCKING_SOCKETS
static int io_limit;
static struct timeval io_zerotime;

static int    io_socket;
static tTask *io_task = NoTask;

/*{{{  void SocketHandler (int sig)*/
void SocketHandler (int sig)
{
  switch (sig)
  {
    case SOCKET_SIGNAL:
    {
      #ifdef MD_DEBUG
      fprintf(stderr,"Caught signal %d\n",sig);
      #endif
      
      SocketEvent = true;
      
      #ifdef solaris
      signal (SOCKET_SIGNAL, SocketHandler);
      #endif
      
      break;
    }
    default:
      fprintf(stderr,"Error - Caught unexpected signal %d - exiting\n",sig);
      fflush(stderr);
      exit(20);
  }  
}
/*}}}*/
 
/*{{{  void WaitSocket (int socket)*/
void WaitSocket (int socket)
{
  fd_set io_set;

  io_socket = socket;

  FD_ZERO (&io_set);
  FD_SET  (socket,&io_set);
  
  errno = 0;
  while (select (io_limit, &io_set, NULL, NULL, &io_zerotime) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
  
  if (!FD_ISSET(socket,&io_set))
  {
    if (io_task == NoTask)
      io_task = CURTASK;
    else
    {
      fprintf(stderr, "Error - Implementation restriction, only one signaling socket\n");
      exit(-1);
    }
    DeSchedule(TSOCK_p);
  }
}
/*}}}*/

/*{{{  void EnableSocket (int socket)*/
void EnableSocket (int socket)
{
  errno = 0;
  
  #ifdef solaris
  if (ioctl(socket,I_SETSIG,S_RDNORM) < 0)
  {
    fprintf(stderr,"Error - could not set signal handler for socket (errno %d)\n",errno);
    exit(-1);
  }
  #else
  if (fcntl(socket, F_SETOWN, getpid()) < 0)
  {
    fprintf(stderr,"Error - could not set owner on socket (errno %d)\n",errno);
    exit(-1);
  }
  if (fcntl(socket, F_SETFL, FASYNC)    < 0)
  {
    fprintf(stderr,"Error - could not set asynchronous socket (errno %d)\n",errno);
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void DisableSocket (int socket)*/
void DisableSocket (int socket)
{
  #ifdef sun4
  if (fcntl(socket, F_SETFL, FSYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
  #ifdef linux
  if (fcntl(socket, F_SETFL, FASYNC) < 0)
  {
    fprintf(stderr,"Error - could not set synchronous socket\n");
    exit(-1);
  }
  #endif
}
/*}}}*/

/*{{{  void ServeSocket (void)*/
void ServeSocket (void)
{
  fd_set io_set;
  int res;

  /* In the general case there's a timing hazard here since a new signal
     could arrive and we can lose it. Really need test-and-set or a
     semaphore. For hostio, however, there's only ever one outstanding 
     communication and this thread is serving it. Hence, no problem here. */

  SocketEvent = false; 

  FD_ZERO (&io_set);
  FD_SET  (io_socket,&io_set);
  
  errno = 0;
  while ((res = select (io_limit, &io_set, NULL, NULL, &io_zerotime)) < 0)
    if (errno != EINTR)
    {
      fprintf(stderr, "Error - Socket select failed\n");
      exit(-1);
    }
    else
      errno = 0;
      
  if (res == 0)
  {
    /*fprintf(stderr,"Could not locate socket signal source, ignoring select\n");*/
    return;
  }
  
  if (!FD_ISSET(io_socket,&io_set))
  {
    fprintf(stderr,"Error - socket is not ready\n");
    exit(-1);
  }

  if (io_task != NoTask)
  {
    ReSchedule(io_task);
    io_task = NoTask;
  }
}
/*}}}*/

/*{{{  void Init_Sockets()*/
void Init_Sockets()
{
  io_limit = ulimit (4,0);

  timerclear (&io_zerotime);

  signal (SOCKET_SIGNAL, SocketHandler);
  #ifdef linux
  {
    struct sigaction action;
    sigaction(SIGIO,NULL,&action);
    action.sa_flags = (action.sa_flags & (~SA_ONESHOT));
    sigaction(SIGIO,&action,NULL);
  }
  #endif
}
/*}}}*/
#else
void WaitSocket (int socket)
{ 
  fprintf(stderr, "Error - No SIGSOCKETS\n"); 
}
#endif
/*}}}*/

/*{{{  static void Init_Scheduler()*/
static void Init_Scheduler()
{
  int i;

  for(i = 0; i < NUM_PRIORITY_LEVELS; ++i)
    QFP[i] = QBP[i] = NoTask;

  CURTASK = NoTask;

  Init_Timer();

  #ifdef USE_NONBLOCKING_SOCKETS
  Init_Sockets();  
  #endif
}
/*}}}*/
/*{{{  static void Scheduler()*/
static void Scheduler()
{
  if (setjmp(STOPP_env)) DeSchedule(0);
  
  while(CURTASK != NoTask || TimerEvent || SocketEvent)
  {
    int pri;

#ifdef USESIGTIMER
    /*{{{  if (TimerEvent)*/
    if (TimerEvent)
    {
    #ifdef DEBUG
	fprintf(stderr,"Timer = %d\n",TIMER);
    #endif
      TimerEvent = false;
      while(QTM != NoTask && AFTER(TIMER,QTM->comms.timer.time))
      {
    #ifdef DEBUG
	{  
	  tTask *task = QTM;
    
	  fprintf(stderr,"Timer Queue contains:");
	  if (task == NoTask) fprintf(stderr,"No Tasks");
	  else while(task != NoTask) { fprintf(stderr,"%d(%d) ",task->TaskId,task->comms.timer.time); task = task->Next; }
	  fprintf(stderr,"\n");
	}  
    #endif
	if (QTM->AltMode == Waiting_p) QTM->AltMode = TReady_p;
	ReSchedule(QTM);
      }
    }
    /*}}}*/
#endif

#ifdef USE_NONBLOCKING_SOCKETS
    if (SocketEvent)
      ServeSocket();
#endif

    for(pri = 0; pri < NUM_PRIORITY_LEVELS; ++pri)
    {
#ifdef DEBUG
  {
    tTask *task = QFP[pri];
    fprintf(stderr,"Task Queue %d contains:",pri);
    if (task == NoTask) fprintf(stderr,"No Tasks");
    else while(task != NoTask) { fprintf(stderr,"%d ",task->TaskId); task = task->Next; }
    fprintf(stderr,"\n");
  }
#endif

      if ((CURTASK=QFP[pri]) != NoTask)
      {
	/*{{{  #ifdef SHOWTASKING*/
	#ifdef SHOWTASKING
		fprintf(stderr,"Scheduler - Current task is %c%d (%s) IP=%d\n",(CURTASK->TaskPriority)?'L':'H',CURTASK->TaskId,((tHeader *)CURTASK->FP)->ProcName,((tHeader *)CURTASK->FP)->IP); fflush(stderr); 
	#endif
	/*}}}*/
	/*{{{  #ifndef NO_DEBUG*/
	#ifndef NO_DEBUG
	MARK_SCHEDULE() ;
	#endif
	/*}}}*/
	CURTASK->Func (CURTASK->FP);
	break;
      }
    }

    /*{{{  catch any signals*/
    #if (defined USESIGTIMER && defined USE_NONBLOCKING_SOCKETS)
	if (CURTASK == NoTask && (QTM != NoTask || io_task != NoTask))
	  while(!TimerEvent && !SocketEvent)
	    pause();
    #else
      #if (defined USESIGTIMER)
	  if (CURTASK == NoTask && QTM != NoTask)
	    while(!TimerEvent)
	      pause();
      #endif
      
      #if (defined USE_NONBLOCKING_SOCKETS)
	  if (CURTASK == NoTask && io_task != NoTask)
	    while(!SocketEvent)
	      pause();
      #endif
    #endif
    /*}}}*/

  }

#ifdef DEBUG
  fprintf(stderr,"Scheduling Queue empty\n");
#endif
}

/*}}}*/
/*{{{  void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Process(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)
{
  static int NextTaskId = 0;
  process_count++;
  
  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = (CURTASK != NoTask && CURTASK->TaskPriority == HighPriority) ? HighPriority : Priority;
  ((tHeader *)FP)->ProcName = name;
  
  if (Priority < 0 || Priority >= NUM_PRIORITY_LEVELS) SETERR(MSG_PRI);
  
  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Priority)*/
void Start_Placed(register tTask *task, register tFuncPtr Func, register void *FP, register char *name,int Processor)
{
  static int NextTaskId = 0;
  process_count++;

  task->FP = FP;
  task->Func = Func;
  task->state = EXEC_p;
  task->name = name;
  task->Parent = CURTASK;
  task->Children = 0;
  task->Next = NoTask;
  task->AltMode = NotAlting_p;
  task->TaskId = NextTaskId++;
  task->TaskPriority = LowPriority;

  ((tHeader *)FP)->ProcName = name;

  SETERR("PLACED PAR is not supported in this implementation");

  if (QFP[task->TaskPriority])
    QBP[task->TaskPriority]->Next = task;
  else
    QFP[task->TaskPriority] = task;

  QBP[task->TaskPriority] = task;

  if (CURTASK != NoTask) CURTASK->Children++;
  else CURTASK = task;
  
#ifdef SHOWTASKING
  fprintf(stderr,"  New Task %c%d (%s) FP=%x\n",(task->TaskPriority)?'L':'H',task->TaskId,name,FP);
#endif
}
/*}}}*/
/*{{{  void End_Process()*/
void End_Process()
{
  register tTask *task = CURTASK;
  process_count--;
    
  QFP[task->TaskPriority] = task->Next;
  if (QFP[task->TaskPriority] == NoTask) QBP[task->TaskPriority] = NoTask;
  task->Next = NoTask;
  if (task->Parent)
  {
    if (--(task->Parent->Children) == 0) ReSchedule(task->Parent);
  }
}
/*}}}*/

/*{{{  SPOC iserver definitions*/
#ifdef USE_SPOC_ISERVER
extern int CocoPops;
#include "spserver.hdr"

struct SF_P_spoc_iserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_iserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_iserver_spserver spserver;
} tSF_P_spoc_iserver_caller;

static tSF_P_spoc_iserver_caller spoc_iserver_data;
static tTask spoc_iserver_task;

static tFuncPtr P_spoc_iserver_caller (tSF_P_spoc_iserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_iserver_spserver,&FP->spserver,1,"P_spoc_iserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/
/*{{{  SPOC aserver definitions*/
#ifdef USE_SPOC_ASERVER
#include "spserver.hdr"

struct SF_P_spoc_aserver_spserver
{
  tHeader _Header;
  void *Chain;
  CHAN *Param0;
  CHAN *Param1;
  char WS[WS_P_spoc_aserver_spserver];
};

typedef struct
{
  tHeader _Header;
  void *Chain;
  CHAN *fs;
  CHAN *ts;
  tSF_P_spoc_aserver_spserver spserver;
} tSF_P_spoc_aserver_caller;

static tSF_P_spoc_aserver_caller spoc_aserver_data;
static tTask spoc_aserver_task;

static tFuncPtr P_spoc_aserver_caller (tSF_P_spoc_aserver_caller *FP)
{
  while(true)
  {
    switch(FP->_Header.IP)
    {
      case  0:
		FP->spserver.Param0=FP->fs;
		FP->spserver.Param1=FP->ts;
		FP->spserver.Chain = NULL;
		CALL(P_spoc_aserver_spserver,&FP->spserver,1,"P_spoc_aserver_spserver");
      case  1:
		ENDP();
    }
  }
}
#endif
/*}}}*/

/*{{{  int main(int argc, char **argv)*/
int main(int argc, char **argv)
{
  void *FP=NULL;
  tSF_ *MAINFP=(tSF_ *)malloc(sizeof(tSF_));
  tTask main_t;
  INT mem_size = (argc>1 && atoi(argv[1])>0)?atoi(argv[1]):DEFAULT_MEMSIZE_IN_INTS;
  INT *mem=(INT*)malloc(mem_size*sizeof(INT));
  CHAN fs,ts;
  
  if (MAINFP==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s bytes for occam workspace failed\n",sizeof(tSF_));
    exit(-1);
  }
  if (mem_size>0 && mem==NULL)
  {
    fprintf(stderr,"Error - Malloc of %s INTs for occam memory array failed\n",mem_size);
    exit(-1);
  }
  (void) clock();
  MAIN_ARGC = argc ;
  MAIN_ARGV = argv ;
  process_count = 0;
 
  CheckPrimitiveSizes();
  INITCH(&fs);
  INITCH(&ts);
  Init_Scheduler();
  
  STARTP(&main_t,,MAINFP,"",LowPriority);

  /*{{{  #ifdef USE_SPOC_ISERVER*/
  #ifdef USE_SPOC_ISERVER
  #ifdef SHOWTASKING
  CocoPops=true;
  #endif
  spoc_iserver_data.fs = &fs;
  spoc_iserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_iserver_task, P_spoc_iserver_caller, &spoc_iserver_data, "P_spoc_iserver_spserver",LowPriority);
  #endif
  /*}}}*/
  /*{{{  #ifdef USE_SPOC_ASERVER*/
  #ifdef USE_SPOC_ASERVER
  spoc_aserver_data.fs = &fs;
  spoc_aserver_data.ts = &ts;
  CURTASK = NoTask;  /* needed because don't want this a child of main_t */
  STARTP(&spoc_aserver_task, P_spoc_aserver_caller, &spoc_aserver_data, "P_spoc_aserver_spserver",LowPriority);
  #endif
  /*}}}*/
/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_init(argc,argv);
#endif
/*}}}*/
  
  Scheduler();

/*{{{  #ifdef CALL_NAG_F90*/
#ifdef CALL_NAG_F90
  f90_finish(0);
#endif
/*}}}*/
  if (process_count == 0)
    return 0;
  else
  {
    fprintf(stderr,"Deadlock: %d stopped process%s.\n", process_count,(process_count>1)?"es":"");
    return 1;
  }
}     
/*}}}*/
#endif

#ifndef GENPROTO
/*{{{  Insert DEBUG*/

/*}}}*/
/*{{{  Insert CODE*/
INT F_compare_strings_string1(INT str1_51_Dim0,BYTE *str1_51,INT str2_52_Dim0,BYTE *str2_52)
#line   11 "string1.occ"
{
#line   11 "string1.occ"
  INT _Result;
#line   11 "string1.occ"
  tSF_F_compare_strings_string1 SF;
#line   11 "string1.occ"
  tSF_F_compare_strings_string1 *FP = &SF;
#line   26 "string1.occ"
  {
#line   26 "string1.occ"
    INT order_53;
#line   29 "string1.occ"
    {
#line   29 "string1.occ"
      INT len1_54;
#line   30 "string1.occ"
      INT len2_55;
#line   31 "string1.occ"
      INT len_56;
#line   29 "string1.occ"
      len1_54 = (INT)(str1_51_Dim0);
#line   30 "string1.occ"
      len2_55 = (INT)(str2_52_Dim0);
#line   32 "string1.occ"
      {
#line   34 "string1.occ"
        if ((len1_54 > len2_55))
#line   34 "string1.occ"
        {
#line   35 "string1.occ"
          len_56 = len2_55; 
#line   35 "string1.occ"
        }
#line   35 "string1.occ"
        else
#line   36 "string1.occ"
        if (true)
#line   36 "string1.occ"
        {
#line   37 "string1.occ"
          len_56 = len1_54; 
#line   37 "string1.occ"
        }
#line   37 "string1.occ"
        else
#line   37 "string1.occ"
        {
#line   37 "string1.occ"
          SETERR(MSG_IF);
#line   37 "string1.occ"
        }
#line   39 "string1.occ"
        {
#line   39 "string1.occ"
          INT j_57;
#line   39 "string1.occ"
          INT j_57_End;
#line   39 "string1.occ"
          j_57 = 0;j_57_End = j_57 + len_56;
#line   39 "string1.occ"
          for (; j_57 != j_57_End; j_57++)
#line   39 "string1.occ"
          {
#line   40 "string1.occ"
            if ((*((BYTE*)(((BYTE*)str1_51)+(RNGCHK(j_57,str1_51_Dim0)*sizeof(BYTE)))) != *((BYTE*)(((BYTE*)str2_52)+(RNGCHK(j_57,str2_52_Dim0)*sizeof(BYTE))))))
#line   40 "string1.occ"
            {
#line   43 "string1.occ"
              if ((*((BYTE*)(((BYTE*)str1_51)+(RNGCHK(j_57,str1_51_Dim0)*sizeof(BYTE)))) > *((BYTE*)(((BYTE*)str2_52)+(RNGCHK(j_57,str2_52_Dim0)*sizeof(BYTE))))))
#line   43 "string1.occ"
              {
#line   44 "string1.occ"
                order_53 = 2; 
#line   44 "string1.occ"
              }
#line   44 "string1.occ"
              else
#line   45 "string1.occ"
              if (true)
#line   45 "string1.occ"
              {
#line   46 "string1.occ"
                order_53 = -2; 
#line   46 "string1.occ"
              }
#line   46 "string1.occ"
              else
#line   46 "string1.occ"
              {
#line   46 "string1.occ"
                SETERR(MSG_IF);
#line   46 "string1.occ"
              }
#line   46 "string1.occ"
            }
#line   46 "string1.occ"
            else
#line   46 "string1.occ"
            {
#line   46 "string1.occ"
              continue;
#line   46 "string1.occ"
            }
#line   46 "string1.occ"
            break;
#line   46 "string1.occ"
          }
#line   46 "string1.occ"
          if (j_57 == j_57_End) 
#line   48 "string1.occ"
          if ((len1_54 > len2_55))
#line   48 "string1.occ"
          {
#line   49 "string1.occ"
            order_53 = 1; 
#line   49 "string1.occ"
          }
#line   49 "string1.occ"
          else
#line   50 "string1.occ"
          if ((len2_55 > len1_54))
#line   50 "string1.occ"
          {
#line   51 "string1.occ"
            order_53 = -1; 
#line   51 "string1.occ"
          }
#line   51 "string1.occ"
          else
#line   52 "string1.occ"
          if (true)
#line   52 "string1.occ"
          {
#line   53 "string1.occ"
            order_53 = 0; 
#line   53 "string1.occ"
          }
#line   53 "string1.occ"
          else
#line   53 "string1.occ"
          {
#line   53 "string1.occ"
            SETERR(MSG_IF);
#line   53 "string1.occ"
          }
#line   53 "string1.occ"
        }
#line   53 "string1.occ"
      }
#line   53 "string1.occ"
    }
#line   53 "string1.occ"
    _Result = order_53;
#line   53 "string1.occ"
  }
#line   53 "string1.occ"
  return _Result;
#line   53 "string1.occ"
}

#line   59 "string1.occ"
BOOL F_eqstr_string1(INT s1_60_Dim0,BYTE *s1_60,INT s2_61_Dim0,BYTE *s2_61)
#line   59 "string1.occ"
{
#line   59 "string1.occ"
  BOOL _Result;
#line   59 "string1.occ"
  tSF_F_eqstr_string1 SF;
#line   59 "string1.occ"
  tSF_F_eqstr_string1 *FP = &SF;
#line   68 "string1.occ"
  {
#line   68 "string1.occ"
    BOOL eq_62;
#line   70 "string1.occ"
    {
#line   70 "string1.occ"
      INT ls1_63;
#line   71 "string1.occ"
      INT ls2_64;
#line   70 "string1.occ"
      ls1_63 = (INT)(s1_60_Dim0);
#line   71 "string1.occ"
      ls2_64 = (INT)(s2_61_Dim0);
#line   73 "string1.occ"
      if ((ls1_63 != ls2_64))
#line   73 "string1.occ"
      {
#line   74 "string1.occ"
        eq_62 = false; 
#line   74 "string1.occ"
      }
#line   74 "string1.occ"
      else
#line   75 "string1.occ"
      {
#line   75 "string1.occ"
        INT i_65;
#line   75 "string1.occ"
        INT i_65_End;
#line   75 "string1.occ"
        i_65 = 0;i_65_End = i_65 + ls1_63;
#line   75 "string1.occ"
        for (; i_65 != i_65_End; i_65++)
#line   75 "string1.occ"
        {
#line   76 "string1.occ"
          if ((*((BYTE*)(((BYTE*)s1_60)+(RNGCHK(i_65,s1_60_Dim0)*sizeof(BYTE)))) != *((BYTE*)(((BYTE*)s2_61)+(RNGCHK(i_65,s2_61_Dim0)*sizeof(BYTE))))))
#line   76 "string1.occ"
          {
#line   77 "string1.occ"
            eq_62 = false; 
#line   77 "string1.occ"
          }
#line   77 "string1.occ"
          else
#line   77 "string1.occ"
          {
#line   77 "string1.occ"
            continue;
#line   77 "string1.occ"
          }
#line   77 "string1.occ"
          break;
#line   77 "string1.occ"
        }
#line   77 "string1.occ"
        if (i_65 == i_65_End) 
#line   78 "string1.occ"
        if (true)
#line   78 "string1.occ"
        {
#line   79 "string1.occ"
          eq_62 = true; 
#line   79 "string1.occ"
        }
#line   79 "string1.occ"
        else
#line   79 "string1.occ"
        {
#line   79 "string1.occ"
          SETERR(MSG_IF);
#line   79 "string1.occ"
        }
#line   79 "string1.occ"
      }
#line   79 "string1.occ"
    }
#line   79 "string1.occ"
    _Result = eq_62;
#line   79 "string1.occ"
  }
#line   79 "string1.occ"
  return _Result;
#line   79 "string1.occ"
}

#line   85 "string1.occ"
void P_str_shift_string1 (INT str_68_Dim0,BYTE *str_68,INT start_69,INT len_70,INT shift_71,BOOL *not_done_72)
#line   85 "string1.occ"
{
#line   85 "string1.occ"
  tSF_P_str_shift_string1 SF;
#line   85 "string1.occ"
  tSF_P_str_shift_string1 *FP = &SF;
#line  104 "string1.occ"
  {
#line  104 "string1.occ"
    INT maxlen_73;
#line  104 "string1.occ"
    maxlen_73 = (INT)(str_68_Dim0);
#line  105 "string1.occ"
    {
#line  106 "string1.occ"
      *not_done_72 = false; 
#line  108 "string1.occ"
      if (((shift_71 == 0) || (len_70 == 0)))
#line  108 "string1.occ"
      {
#line  109 "string1.occ"
      }
#line  109 "string1.occ"
      else
#line  110 "string1.occ"
      if ((shift_71 < 0))
#line  110 "string1.occ"
      {
#line  112 "string1.occ"
        {
#line  112 "string1.occ"
          INT from_74;
#line  112 "string1.occ"
          INT to_75;
#line  112 "string1.occ"
          INT fromend_76;
#line  112 "string1.occ"
          INT toend_77;
#line  112 "string1.occ"
          INT length_78;
#line  113 "string1.occ"
          {
#line  114 "string1.occ"
            to_75 = (start_69 + shift_71); 
#line  115 "string1.occ"
            from_74 = start_69; 
#line  116 "string1.occ"
            toend_77 = (to_75 + len_70); 
#line  117 "string1.occ"
            fromend_76 = (from_74 + len_70); 
#line  119 "string1.occ"
            if ((to_75 < 0))
#line  119 "string1.occ"
            {
#line  120 "string1.occ"
              {
#line  121 "string1.occ"
                from_74 = (from_74 - to_75); 
#line  122 "string1.occ"
                to_75 = 0; 
#line  123 "string1.occ"
                *not_done_72 = true; 
#line  123 "string1.occ"
              }
#line  123 "string1.occ"
            }
#line  123 "string1.occ"
            else
#line  124 "string1.occ"
            if (true)
#line  124 "string1.occ"
            {
#line  125 "string1.occ"
            }
#line  125 "string1.occ"
            else
#line  125 "string1.occ"
            {
#line  125 "string1.occ"
              SETERR(MSG_IF);
#line  125 "string1.occ"
            }
#line  127 "string1.occ"
            if ((fromend_76 > maxlen_73))
#line  127 "string1.occ"
            {
#line  128 "string1.occ"
              {
#line  129 "string1.occ"
                toend_77 = (toend_77 - (fromend_76 - maxlen_73)); 
#line  130 "string1.occ"
                fromend_76 = maxlen_73; 
#line  131 "string1.occ"
                *not_done_72 = true; 
#line  131 "string1.occ"
              }
#line  131 "string1.occ"
            }
#line  131 "string1.occ"
            else
#line  132 "string1.occ"
            if (true)
#line  132 "string1.occ"
            {
#line  133 "string1.occ"
            }
#line  133 "string1.occ"
            else
#line  133 "string1.occ"
            {
#line  133 "string1.occ"
              SETERR(MSG_IF);
#line  133 "string1.occ"
            }
#line  134 "string1.occ"
            length_78 = (fromend_76 - from_74); 
#line  136 "string1.occ"
            if ((length_78 <= 0))
#line  136 "string1.occ"
            {
#line  137 "string1.occ"
            }
#line  137 "string1.occ"
            else
#line  138 "string1.occ"
            if ((toend_77 > from_74))
#line  138 "string1.occ"
            {
#line  138 "string1.occ"
              {
#line  138 "string1.occ"
                INT i_79;
#line  138 "string1.occ"
                INT i_79_End;
#line  140 "string1.occ"
                i_79 = 0;i_79_End = i_79 + length_78;
#line  140 "string1.occ"
                for (; i_79 != i_79_End; i_79++)
#line  140 "string1.occ"
                {
#line  141 "string1.occ"
                  *((BYTE*)(((BYTE*)str_68)+(RNGCHK((to_75 + i_79),str_68_Dim0)*sizeof(BYTE)))) = *((BYTE*)(((BYTE*)str_68)+(RNGCHK((from_74 + i_79),str_68_Dim0)*sizeof(BYTE)))); 
#line  141 "string1.occ"
                }
#line  140 "string1.occ"
              }
#line  140 "string1.occ"
            }
#line  140 "string1.occ"
            else
#line  143 "string1.occ"
            if (true)
#line  143 "string1.occ"
            {
#line  145 "string1.occ"
              CHK(length_78==length_78,MSG_ASM);
#line  145 "string1.occ"
              ASSIGN(((BYTE*)(((BYTE*)str_68)+((RNGCHKUB(to_75,length_78,str_68_Dim0),RNGCHKLB(to_75))*sizeof(BYTE)))),((BYTE*)(((BYTE*)str_68)+((RNGCHKUB(from_74,length_78,str_68_Dim0),RNGCHKLB(from_74))*sizeof(BYTE)))),(length_78*sizeof(BYTE))); 
#line  145 "string1.occ"
            }
#line  145 "string1.occ"
            else
#line  145 "string1.occ"
            {
#line  145 "string1.occ"
              SETERR(MSG_IF);
#line  145 "string1.occ"
            }
#line  145 "string1.occ"
          }
#line  145 "string1.occ"
        }
#line  145 "string1.occ"
      }
#line  145 "string1.occ"
      else
#line  148 "string1.occ"
      if (true)
#line  148 "string1.occ"
      {
#line  150 "string1.occ"
        {
#line  150 "string1.occ"
          INT from_80;
#line  150 "string1.occ"
          INT to_81;
#line  150 "string1.occ"
          INT fromend_82;
#line  150 "string1.occ"
          INT toend_83;
#line  150 "string1.occ"
          INT length_84;
#line  151 "string1.occ"
          {
#line  152 "string1.occ"
            to_81 = (start_69 + shift_71); 
#line  153 "string1.occ"
            toend_83 = (to_81 + len_70); 
#line  154 "string1.occ"
            from_80 = start_69; 
#line  155 "string1.occ"
            fromend_82 = (from_80 + len_70); 
#line  157 "string1.occ"
            if ((from_80 < 0))
#line  157 "string1.occ"
            {
#line  158 "string1.occ"
              {
#line  159 "string1.occ"
                to_81 = (to_81 - from_80); 
#line  160 "string1.occ"
                from_80 = 0; 
#line  161 "string1.occ"
                *not_done_72 = true; 
#line  161 "string1.occ"
              }
#line  161 "string1.occ"
            }
#line  161 "string1.occ"
            else
#line  162 "string1.occ"
            if (true)
#line  162 "string1.occ"
            {
#line  163 "string1.occ"
            }
#line  163 "string1.occ"
            else
#line  163 "string1.occ"
            {
#line  163 "string1.occ"
              SETERR(MSG_IF);
#line  163 "string1.occ"
            }
#line  165 "string1.occ"
            if ((toend_83 > maxlen_73))
#line  165 "string1.occ"
            {
#line  166 "string1.occ"
              {
#line  167 "string1.occ"
                fromend_82 = (fromend_82 - (toend_83 - maxlen_73)); 
#line  168 "string1.occ"
                toend_83 = maxlen_73; 
#line  169 "string1.occ"
                *not_done_72 = true; 
#line  169 "string1.occ"
              }
#line  169 "string1.occ"
            }
#line  169 "string1.occ"
            else
#line  170 "string1.occ"
            if (true)
#line  170 "string1.occ"
            {
#line  171 "string1.occ"
            }
#line  171 "string1.occ"
            else
#line  171 "string1.occ"
            {
#line  171 "string1.occ"
              SETERR(MSG_IF);
#line  171 "string1.occ"
            }
#line  172 "string1.occ"
            length_84 = (fromend_82 - from_80); 
#line  174 "string1.occ"
            if ((length_84 <= 0))
#line  174 "string1.occ"
            {
#line  175 "string1.occ"
            }
#line  175 "string1.occ"
            else
#line  176 "string1.occ"
            if ((fromend_82 > to_81))
#line  176 "string1.occ"
            {
#line  176 "string1.occ"
              {
#line  176 "string1.occ"
                INT i_85;
#line  176 "string1.occ"
                INT i_85_End;
#line  178 "string1.occ"
                i_85 = 1;i_85_End = i_85 + length_84;
#line  178 "string1.occ"
                for (; i_85 != i_85_End; i_85++)
#line  178 "string1.occ"
                {
#line  179 "string1.occ"
                  *((BYTE*)(((BYTE*)str_68)+(RNGCHK((toend_83 - i_85),str_68_Dim0)*sizeof(BYTE)))) = *((BYTE*)(((BYTE*)str_68)+(RNGCHK((fromend_82 - i_85),str_68_Dim0)*sizeof(BYTE)))); 
#line  179 "string1.occ"
                }
#line  178 "string1.occ"
              }
#line  178 "string1.occ"
            }
#line  178 "string1.occ"
            else
#line  181 "string1.occ"
            if (true)
#line  181 "string1.occ"
            {
#line  183 "string1.occ"
              CHK(length_84==length_84,MSG_ASM);
#line  183 "string1.occ"
              ASSIGN(((BYTE*)(((BYTE*)str_68)+((RNGCHKUB(to_81,length_84,str_68_Dim0),RNGCHKLB(to_81))*sizeof(BYTE)))),((BYTE*)(((BYTE*)str_68)+((RNGCHKUB(from_80,length_84,str_68_Dim0),RNGCHKLB(from_80))*sizeof(BYTE)))),(length_84*sizeof(BYTE))); 
#line  183 "string1.occ"
            }
#line  183 "string1.occ"
            else
#line  183 "string1.occ"
            {
#line  183 "string1.occ"
              SETERR(MSG_IF);
#line  183 "string1.occ"
            }
#line  183 "string1.occ"
          }
#line  183 "string1.occ"
        }
#line  183 "string1.occ"
      }
#line  183 "string1.occ"
      else
#line  183 "string1.occ"
      {
#line  183 "string1.occ"
        SETERR(MSG_IF);
#line  183 "string1.occ"
      }
#line  183 "string1.occ"
    }
#line  183 "string1.occ"
  }
#line  183 "string1.occ"
}

#line  190 "string1.occ"
void P_delete_string_string1 (INT *len_87,INT str_88_Dim0,BYTE *str_88,INT start_89,INT size_90,BOOL *not_done_91)
#line  190 "string1.occ"
{
#line  190 "string1.occ"
  tSF_P_delete_string_string1 SF;
#line  190 "string1.occ"
  tSF_P_delete_string_string1 *FP = &SF;
#line  217 "string1.occ"
  if ((((size_90 < 0) || (start_89 < 0)) || ((start_89 + size_90) > *len_87)))
#line  217 "string1.occ"
  {
#line  218 "string1.occ"
    *not_done_91 = true; 
#line  218 "string1.occ"
  }
#line  218 "string1.occ"
  else
#line  219 "string1.occ"
  if (true)
#line  219 "string1.occ"
  {
#line  220 "string1.occ"
    {
#line  220 "string1.occ"
      BOOL shift_err_92;
#line  221 "string1.occ"
      {
#line  222 "string1.occ"
        P_str_shift_string1(str_88_Dim0,(BYTE*)str_88,(start_89 + size_90),(*len_87 - (start_89 + size_90)),( - size_90),&shift_err_92);
#line  223 "string1.occ"
        *len_87 = (*len_87 - size_90); 
#line  224 "string1.occ"
        *not_done_91 = false; 
#line  224 "string1.occ"
      }
#line  224 "string1.occ"
    }
#line  224 "string1.occ"
  }
#line  224 "string1.occ"
  else
#line  224 "string1.occ"
  {
#line  224 "string1.occ"
    SETERR(MSG_IF);
#line  224 "string1.occ"
  }
#line  224 "string1.occ"
}

#line  229 "string1.occ"
void P_insert_string_string1 (INT new_str_94_Dim0,BYTE *new_str_94,INT *len_95,INT str_96_Dim0,BYTE *str_96,INT start_97,BOOL *not_done_98)
#line  229 "string1.occ"
{
#line  229 "string1.occ"
  tSF_P_insert_string_string1 SF;
#line  229 "string1.occ"
  tSF_P_insert_string_string1 *FP = &SF;
#line  263 "string1.occ"
  {
#line  263 "string1.occ"
    INT maxlen_99;
#line  264 "string1.occ"
    INT extralen_100;
#line  263 "string1.occ"
    maxlen_99 = (INT)(str_96_Dim0);
#line  264 "string1.occ"
    extralen_100 = (INT)(new_str_94_Dim0);
#line  266 "string1.occ"
    if ((((start_97 < 0) || (start_97 > *len_95)) || (*len_95 < 0)))
#line  266 "string1.occ"
    {
#line  267 "string1.occ"
      *not_done_98 = true; 
#line  267 "string1.occ"
    }
#line  267 "string1.occ"
    else
#line  268 "string1.occ"
    if (((start_97 + extralen_100) > maxlen_99))
#line  268 "string1.occ"
    {
#line  269 "string1.occ"
      {
#line  269 "string1.occ"
        INT len1_101;
#line  269 "string1.occ"
        len1_101 = (INT)(maxlen_99 - start_97);
#line  270 "string1.occ"
        {
#line  271 "string1.occ"
          CHK(len1_101==len1_101,MSG_ASM);
#line  271 "string1.occ"
          ASSIGN(((BYTE*)(((BYTE*)str_96)+((RNGCHKUB(start_97,len1_101,str_96_Dim0),RNGCHKLB(start_97))*sizeof(BYTE)))),((BYTE*)(((BYTE*)new_str_94)+((RNGCHKUB(0,len1_101,new_str_94_Dim0),0)*sizeof(BYTE)))),(len1_101*sizeof(BYTE))); 
#line  272 "string1.occ"
          *len_95 = maxlen_99; 
#line  273 "string1.occ"
          *not_done_98 = true; 
#line  273 "string1.occ"
        }
#line  273 "string1.occ"
      }
#line  273 "string1.occ"
    }
#line  273 "string1.occ"
    else
#line  274 "string1.occ"
    if (true)
#line  274 "string1.occ"
    {
#line  275 "string1.occ"
      {
#line  275 "string1.occ"
        BOOL shift_err_102;
#line  276 "string1.occ"
        {
#line  277 "string1.occ"
          P_str_shift_string1(str_96_Dim0,(BYTE*)str_96,start_97,(*len_95 - start_97),extralen_100,&shift_err_102);
#line  279 "string1.occ"
          CHK(extralen_100==new_str_94_Dim0,MSG_ASM);
#line  279 "string1.occ"
          ASSIGN(((BYTE*)(((BYTE*)str_96)+((RNGCHKUB(start_97,extralen_100,str_96_Dim0),RNGCHKLB(start_97))*sizeof(BYTE)))),new_str_94,(extralen_100*sizeof(BYTE))); 
#line  281 "string1.occ"
          if (((*len_95 + extralen_100) > maxlen_99))
#line  281 "string1.occ"
          {
#line  282 "string1.occ"
            {
#line  283 "string1.occ"
              *len_95 = maxlen_99; 
#line  284 "string1.occ"
              *not_done_98 = true; 
#line  284 "string1.occ"
            }
#line  284 "string1.occ"
          }
#line  284 "string1.occ"
          else
#line  285 "string1.occ"
          if (true)
#line  285 "string1.occ"
          {
#line  286 "string1.occ"
            {
#line  287 "string1.occ"
              *len_95 = (*len_95 + extralen_100); 
#line  288 "string1.occ"
              *not_done_98 = shift_err_102; 
#line  288 "string1.occ"
            }
#line  288 "string1.occ"
          }
#line  288 "string1.occ"
          else
#line  288 "string1.occ"
          {
#line  288 "string1.occ"
            SETERR(MSG_IF);
#line  288 "string1.occ"
          }
#line  288 "string1.occ"
        }
#line  288 "string1.occ"
      }
#line  288 "string1.occ"
    }
#line  288 "string1.occ"
    else
#line  288 "string1.occ"
    {
#line  288 "string1.occ"
      SETERR(MSG_IF);
#line  288 "string1.occ"
    }
#line  288 "string1.occ"
  }
#line  288 "string1.occ"
}

#line  293 "string1.occ"
INT F_string_pos_string1(INT search_104_Dim0,BYTE *search_104,INT str_105_Dim0,BYTE *str_105)
#line  293 "string1.occ"
{
#line  293 "string1.occ"
  INT _Result;
#line  293 "string1.occ"
  tSF_F_string_pos_string1 SF;
#line  293 "string1.occ"
  tSF_F_string_pos_string1 *FP = &SF;
#line  306 "string1.occ"
  {
#line  306 "string1.occ"
    INT pos_106;
#line  309 "string1.occ"
    {
#line  309 "string1.occ"
      INT bytes_107;
#line  310 "string1.occ"
      INT len_108;
#line  309 "string1.occ"
      bytes_107 = (INT)((search_104_Dim0) - 1);
#line  310 "string1.occ"
      len_108 = (INT)(str_105_Dim0);
#line  313 "string1.occ"
      if ((bytes_107 > 0))
#line  313 "string1.occ"
      {
#line  314 "string1.occ"
        {
#line  314 "string1.occ"
          INT times_109;
#line  315 "string1.occ"
          INT n_110;
#line  316 "string1.occ"
          BOOL looking_111;
#line  314 "string1.occ"
          times_109 = (INT)(len_108 - bytes_107);
#line  317 "string1.occ"
          {
#line  318 "string1.occ"
            n_110 = 0; 
#line  319 "string1.occ"
            looking_111 = true; 
#line  320 "string1.occ"
            while (looking_111)
#line  320 "string1.occ"
            {
#line  321 "string1.occ"
              {
#line  323 "string1.occ"
                while (((n_110 < times_109) && (*((BYTE*)(((BYTE*)str_105)+(RNGCHK(n_110,str_105_Dim0)*sizeof(BYTE)))) != *((BYTE*)(((BYTE*)search_104)+(0*sizeof(BYTE)))))))
#line  323 "string1.occ"
                {
#line  324 "string1.occ"
                  n_110 = (n_110 + 1); 
#line  323 "string1.occ"
                }
#line  328 "string1.occ"
                if ((n_110 >= times_109))
#line  328 "string1.occ"
                {
#line  329 "string1.occ"
                  {
#line  330 "string1.occ"
                    looking_111 = false; 
#line  331 "string1.occ"
                    pos_106 = -1; 
#line  331 "string1.occ"
                  }
#line  331 "string1.occ"
                }
#line  331 "string1.occ"
                else
#line  334 "string1.occ"
                {
#line  334 "string1.occ"
                  INT i_112;
#line  334 "string1.occ"
                  INT i_112_End;
#line  334 "string1.occ"
                  i_112 = 1;i_112_End = i_112 + bytes_107;
#line  334 "string1.occ"
                  for (; i_112 != i_112_End; i_112++)
#line  334 "string1.occ"
                  {
#line  335 "string1.occ"
                    if ((*((BYTE*)(((BYTE*)str_105)+(RNGCHK((n_110 + i_112),str_105_Dim0)*sizeof(BYTE)))) != *((BYTE*)(((BYTE*)search_104)+(RNGCHK(i_112,search_104_Dim0)*sizeof(BYTE))))))
#line  335 "string1.occ"
                    {
#line  336 "string1.occ"
                      n_110 = (n_110 + 1); 
#line  336 "string1.occ"
                    }
#line  336 "string1.occ"
                    else
#line  336 "string1.occ"
                    {
#line  336 "string1.occ"
                      continue;
#line  336 "string1.occ"
                    }
#line  336 "string1.occ"
                    break;
#line  336 "string1.occ"
                  }
#line  336 "string1.occ"
                  if (i_112 == i_112_End) 
#line  337 "string1.occ"
                  if (true)
#line  337 "string1.occ"
                  {
#line  338 "string1.occ"
                    {
#line  339 "string1.occ"
                      looking_111 = false; 
#line  340 "string1.occ"
                      pos_106 = n_110; 
#line  340 "string1.occ"
                    }
#line  340 "string1.occ"
                  }
#line  340 "string1.occ"
                  else
#line  340 "string1.occ"
                  {
#line  340 "string1.occ"
                    SETERR(MSG_IF);
#line  340 "string1.occ"
                  }
#line  340 "string1.occ"
                }
#line  340 "string1.occ"
              }
#line  320 "string1.occ"
            }
#line  320 "string1.occ"
          }
#line  320 "string1.occ"
        }
#line  320 "string1.occ"
      }
#line  320 "string1.occ"
      else
#line  344 "string1.occ"
      if ((bytes_107 == 0))
#line  344 "string1.occ"
      {
#line  346 "string1.occ"
        {
#line  346 "string1.occ"
          INT i_113;
#line  346 "string1.occ"
          INT i_113_End;
#line  346 "string1.occ"
          i_113 = 0;i_113_End = i_113 + len_108;
#line  346 "string1.occ"
          for (; i_113 != i_113_End; i_113++)
#line  346 "string1.occ"
          {
#line  347 "string1.occ"
            if ((*((BYTE*)(((BYTE*)str_105)+(RNGCHK(i_113,str_105_Dim0)*sizeof(BYTE)))) == *((BYTE*)(((BYTE*)search_104)+(0*sizeof(BYTE))))))
#line  347 "string1.occ"
            {
#line  348 "string1.occ"
              pos_106 = i_113; 
#line  348 "string1.occ"
            }
#line  348 "string1.occ"
            else
#line  348 "string1.occ"
            {
#line  348 "string1.occ"
              continue;
#line  348 "string1.occ"
            }
#line  348 "string1.occ"
            break;
#line  348 "string1.occ"
          }
#line  348 "string1.occ"
          if (i_113 == i_113_End) 
#line  349 "string1.occ"
          if (true)
#line  349 "string1.occ"
          {
#line  350 "string1.occ"
            pos_106 = -1; 
#line  350 "string1.occ"
          }
#line  350 "string1.occ"
          else
#line  350 "string1.occ"
          {
#line  350 "string1.occ"
            SETERR(MSG_IF);
#line  350 "string1.occ"
          }
#line  350 "string1.occ"
        }
#line  350 "string1.occ"
      }
#line  350 "string1.occ"
      else
#line  353 "string1.occ"
      if (true)
#line  353 "string1.occ"
      {
#line  354 "string1.occ"
        pos_106 = -1; 
#line  354 "string1.occ"
      }
#line  354 "string1.occ"
      else
#line  354 "string1.occ"
      {
#line  354 "string1.occ"
        SETERR(MSG_IF);
#line  354 "string1.occ"
      }
#line  354 "string1.occ"
    }
#line  354 "string1.occ"
    _Result = pos_106;
#line  354 "string1.occ"
  }
#line  354 "string1.occ"
  return _Result;
#line  354 "string1.occ"
}

#line  361 "string1.occ"
INT F_char_pos_string1(BYTE search_116,INT str_117_Dim0,BYTE *str_117)
#line  361 "string1.occ"
{
#line  361 "string1.occ"
  INT _Result;
#line  361 "string1.occ"
  tSF_F_char_pos_string1 SF;
#line  361 "string1.occ"
  tSF_F_char_pos_string1 *FP = &SF;
#line  373 "string1.occ"
  {
#line  373 "string1.occ"
    INT pos_118;
#line  376 "string1.occ"
    {
#line  376 "string1.occ"
      INT i_119;
#line  376 "string1.occ"
      INT i_119_End;
#line  376 "string1.occ"
      i_119 = 0;i_119_End = i_119 + (str_117_Dim0);
#line  376 "string1.occ"
      for (; i_119 != i_119_End; i_119++)
#line  376 "string1.occ"
      {
#line  377 "string1.occ"
        if ((*((BYTE*)(((BYTE*)str_117)+(RNGCHK(i_119,str_117_Dim0)*sizeof(BYTE)))) == search_116))
#line  377 "string1.occ"
        {
#line  378 "string1.occ"
          pos_118 = i_119; 
#line  378 "string1.occ"
        }
#line  378 "string1.occ"
        else
#line  378 "string1.occ"
        {
#line  378 "string1.occ"
          continue;
#line  378 "string1.occ"
        }
#line  378 "string1.occ"
        break;
#line  378 "string1.occ"
      }
#line  378 "string1.occ"
      if (i_119 == i_119_End) 
#line  379 "string1.occ"
      if (true)
#line  379 "string1.occ"
      {
#line  380 "string1.occ"
        pos_118 = -1; 
#line  380 "string1.occ"
      }
#line  380 "string1.occ"
      else
#line  380 "string1.occ"
      {
#line  380 "string1.occ"
        SETERR(MSG_IF);
#line  380 "string1.occ"
      }
#line  380 "string1.occ"
    }
#line  380 "string1.occ"
    _Result = pos_118;
#line  380 "string1.occ"
  }
#line  380 "string1.occ"
  return _Result;
#line  380 "string1.occ"
}

#line  385 "string1.occ"
void F_search_match_string1(INT possibles_122_Dim0,BYTE *possibles_122,INT str_123_Dim0,BYTE *str_123,INT *Param0,BYTE *Param1)
#line  385 "string1.occ"
{
#line  385 "string1.occ"
  tSF_F_search_match_string1 SF;
#line  385 "string1.occ"
  tSF_F_search_match_string1 *FP = &SF;
#line  401 "string1.occ"
  {
#line  401 "string1.occ"
    INT pos_124;
#line  402 "string1.occ"
    BYTE char_125;
#line  405 "string1.occ"
    {
#line  405 "string1.occ"
      INT i_126;
#line  405 "string1.occ"
      INT i_126_End;
#line  405 "string1.occ"
      i_126 = 0;i_126_End = i_126 + (str_123_Dim0);
#line  405 "string1.occ"
      for (; i_126 != i_126_End; i_126++)
#line  405 "string1.occ"
      {
#line  406 "string1.occ"
        {
#line  406 "string1.occ"
          INT j_127;
#line  406 "string1.occ"
          INT j_127_End;
#line  406 "string1.occ"
          j_127 = 0;j_127_End = j_127 + (possibles_122_Dim0);
#line  406 "string1.occ"
          for (; j_127 != j_127_End; j_127++)
#line  406 "string1.occ"
          {
#line  407 "string1.occ"
            if ((*((BYTE*)(((BYTE*)str_123)+(RNGCHK(i_126,str_123_Dim0)*sizeof(BYTE)))) == *((BYTE*)(((BYTE*)possibles_122)+(RNGCHK(j_127,possibles_122_Dim0)*sizeof(BYTE))))))
#line  407 "string1.occ"
            {
#line  408 "string1.occ"
              {
#line  409 "string1.occ"
                char_125 = *((BYTE*)(((BYTE*)possibles_122)+(RNGCHK(j_127,possibles_122_Dim0)*sizeof(BYTE)))); 
#line  410 "string1.occ"
                pos_124 = i_126; 
#line  410 "string1.occ"
              }
#line  410 "string1.occ"
            }
#line  410 "string1.occ"
            else
#line  410 "string1.occ"
            {
#line  410 "string1.occ"
              continue;
#line  410 "string1.occ"
            }
#line  410 "string1.occ"
            break;
#line  410 "string1.occ"
          }
#line  410 "string1.occ"
          if (j_127 == j_127_End) 
#line  410 "string1.occ"
          {
#line  410 "string1.occ"
            continue;
#line  410 "string1.occ"
          }
#line  410 "string1.occ"
        }
#line  410 "string1.occ"
        break;
#line  410 "string1.occ"
      }
#line  410 "string1.occ"
      if (i_126 == i_126_End) 
#line  411 "string1.occ"
      if (true)
#line  411 "string1.occ"
      {
#line  412 "string1.occ"
        {
#line  413 "string1.occ"
          char_125 = 255; 
#line  414 "string1.occ"
          pos_124 = -1; 
#line  414 "string1.occ"
        }
#line  414 "string1.occ"
      }
#line  414 "string1.occ"
      else
#line  414 "string1.occ"
      {
#line  414 "string1.occ"
        SETERR(MSG_IF);
#line  414 "string1.occ"
      }
#line  414 "string1.occ"
    }
#line  414 "string1.occ"
    *Param0=pos_124;
#line  414 "string1.occ"
    *Param1=char_125;
#line  414 "string1.occ"
  }
#line  414 "string1.occ"
}

#line  419 "string1.occ"
void F_search_no_match_string1(INT possibles_130_Dim0,BYTE *possibles_130,INT str_131_Dim0,BYTE *str_131,INT *Param0,BYTE *Param1)
#line  419 "string1.occ"
{
#line  419 "string1.occ"
  tSF_F_search_no_match_string1 SF;
#line  419 "string1.occ"
  tSF_F_search_no_match_string1 *FP = &SF;
#line  435 "string1.occ"
  {
#line  435 "string1.occ"
    INT pos_132;
#line  436 "string1.occ"
    BYTE char_133;
#line  439 "string1.occ"
    {
#line  439 "string1.occ"
      INT i_134;
#line  439 "string1.occ"
      INT i_134_End;
#line  439 "string1.occ"
      i_134 = 0;i_134_End = i_134 + (str_131_Dim0);
#line  439 "string1.occ"
      for (; i_134 != i_134_End; i_134++)
#line  439 "string1.occ"
      {
#line  441 "string1.occ"
        if ((F_char_pos_string1(*((BYTE*)(((BYTE*)str_131)+(RNGCHK(i_134,str_131_Dim0)*sizeof(BYTE)))),possibles_130_Dim0,(BYTE*)possibles_130) < 0))
#line  441 "string1.occ"
        {
#line  442 "string1.occ"
          {
#line  443 "string1.occ"
            char_133 = *((BYTE*)(((BYTE*)str_131)+(RNGCHK(i_134,str_131_Dim0)*sizeof(BYTE)))); 
#line  444 "string1.occ"
            pos_132 = i_134; 
#line  444 "string1.occ"
          }
#line  444 "string1.occ"
        }
#line  444 "string1.occ"
        else
#line  444 "string1.occ"
        {
#line  444 "string1.occ"
          continue;
#line  444 "string1.occ"
        }
#line  444 "string1.occ"
        break;
#line  444 "string1.occ"
      }
#line  444 "string1.occ"
      if (i_134 == i_134_End) 
#line  445 "string1.occ"
      if (true)
#line  445 "string1.occ"
      {
#line  446 "string1.occ"
        {
#line  447 "string1.occ"
          char_133 = 255; 
#line  448 "string1.occ"
          pos_132 = -1; 
#line  448 "string1.occ"
        }
#line  448 "string1.occ"
      }
#line  448 "string1.occ"
      else
#line  448 "string1.occ"
      {
#line  448 "string1.occ"
        SETERR(MSG_IF);
#line  448 "string1.occ"
      }
#line  448 "string1.occ"
    }
#line  448 "string1.occ"
    *Param0=pos_132;
#line  448 "string1.occ"
    *Param1=char_133;
#line  448 "string1.occ"
  }
#line  448 "string1.occ"
}


/*}}}*/
#endif
