/* $Id: Parser.c,v 2.9 1992/08/07 15:28:42 grosch rel $ */

# define bool		char
# define true		1
# define false		0

# include "Parser.h"
# include "Errors.h"

# ifdef __cplusplus
extern "C" {
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
}
# else
#    include "Memory.h"
#    include "DynArray.h"
#    include "Sets.h"
#    ifndef BCOPY
#       include <memory.h>
#    endif
# endif

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifdef lex_interface
#    define GetToken	yylex
     extern int yylex ();
#    ifndef AttributeDef
#	include "Positions.h"
        typedef struct { tPosition Position; } tScanAttribute;
        static	tScanAttribute	Attribute = {{ 0, 0 }};
#    endif
#    ifndef ErrorAttributeDef
#	define ErrorAttribute(Token, RepairAttribute)
#    endif
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) * yyAttrStackPtr = yylval
#    endif
# else
#    include "Scanner.h"
#    ifndef yyGetAttribute
#	define yyGetAttribute(yyAttrStackPtr, Attribute) (yyAttrStackPtr)->Scan = Attribute
#    endif
# endif

/* line 11 "/tmp/lalr6706" */
/* line 24 "occam.lalr" */

  #include "Scanner.h"
  #include "TreeFix.h"
  #include "Tree.h"
  #include "Symbol.h"
  #include "TypeChk.h"
  
  #define InheritTypes(t)
  #define DEBUG(s) fprintf(stderr,"DEBUG: %s\n",s);

  typedef struct { tScanAttribute Scan; tTree Tree; } tParsAttribute;

  #define Posn(a)  ((a).Scan.Position)
  #define Val(a) ((a).Scan.Value)
  #define InsertASpec(a,s) a=mASpec(s,a)

  static tSymbol S;
  static tTree T;
  static last_type_was_chan = false;
  static tValue Vtrue,Vfalse;


# if defined lex_interface & ! defined yylvalDef
     tParsAttribute yylval;
# endif

# ifndef yyInitStackSize
#    define yyInitStackSize	100
# endif
# define yyNoState		0

# define yyFirstTerminal	0
# define yyLastTerminal		112
# define yyTableMax		3103
# define yyNTableMax		5418
# define yyFirstReadState	1
# define yyLastReadState	453
# define yyFirstReadTermState	454
# define yyLastReadTermState	606
# define yyLastReadNontermState	731
# define yyFirstReduceState	732
# define yyLastReduceState	1058
# define yyStartState		1
# define yyStopState		732

# define yyFirstFinalState	yyFirstReadTermState

typedef unsigned short	yyStateRange	;
typedef unsigned short	yySymbolRange	;
typedef struct	{ yyStateRange Check, Next; } yyTCombType ;

	char *		Parser_TokenName	[yyLastTerminal + 1] = {
"_EndOfFile",
"DECLCOMMA",
"ID",
"EOL",
"NUMBER",
"HEXNUMBER",
"CHCON",
"STR",
"CSTR",
"RNUMBER",
"BEGIN",
"END",
"LT",
"GT",
"LE",
"GE",
"EQ",
"NE",
"ADD",
"SUBTRACT",
"MULTIPLY",
"DIVIDE",
"BITEOR",
"LSHIFT",
"RSHIFT",
"DCOLON",
"ASSIGN",
"LP",
"RP",
"COLON",
"SEMICOLON",
"COMMA",
"AMPERSAND",
"LSB",
"RSB",
"QUERY",
"PLING",
"HASHC",
"HASHH",
"TYPEID",
"AFTER",
"ALT",
"AND",
"ANY",
"BITAND",
"BITNOT",
"BITOR",
"BOOL",
"BYTE",
"CASE",
"CHAN",
"ELSE",
"FALSE",
"FOR",
"FROM",
"FUNCTION",
"IF",
"INT",
"INT16",
"INT32",
"INT64",
"IS",
"MINUS",
"MOSTNEG",
"MOSTPOS",
"NOT",
"OF",
"OR",
"PAR",
"PLACED",
"PLUS",
"PORT",
"PRI",
"PROC",
"PROCESSOR",
"PROTOCOL",
"REAL32",
"REAL64",
"REM",
"RESULT",
"RETYPES",
"ROUND",
"SEQ",
"SIZE",
"SKIP",
"STOP",
"TIMER",
"TIMES",
"TRUE",
"TRUNC",
"VAL",
"VALOF",
"WHILE",
"EXTERN_OCCAM",
"EXTERN_ATOMIC",
"EXTERN_F90",
"EXTERN_F77",
"EXTERN_C",
"DATA",
"TYPE",
"RECORD",
"PACKED",
"BYTESIN",
"OFFSETOF",
"RESHAPES",
"ASM",
"AT",
"GUY",
"IN",
"INLINE",
"PLACE",
"WORKSPACE",
"VECSPACE",
};
static	yyTCombType	yyTComb		[yyTableMax + 1] = {
{451, 732},
{2, 940},
{21, 466},
{46, 47},
{140, 141},
{148, 149},
{157, 158},
{170, 171},
{128, 129},
{174, 175},
{101, 102},
{104, 105},
{104, 871},
{107, 524},
{115, 116},
{124, 125},
{133, 134},
{142, 143},
{153, 154},
{156, 157},
{156, 165},
{163, 164},
{184, 185},
{191, 192},
{194, 195},
{196, 197},
{2, 940},
{2, 3},
{3, 445},
{5, 604},
{8, 463},
{2, 940},
{11, 464},
{2, 940},
{14, 465},
{2, 940},
{2, 940},
{26, 27},
{1, 450},
{4, 940},
{4, 940},
{4, 940},
{27, 28},
{29, 469},
{33, 475},
{39, 479},
{40, 41},
{41, 42},
{43, 44},
{44, 45},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{47, 482},
{4, 5},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{4, 940},
{19, 20},
{20, 21},
{22, 23},
{45, 480},
{38, 454},
{4, 940},
{48, 49},
{4, 940},
{50, 429},
{4, 940},
{56, 483},
{4, 940},
{38, 455},
{38, 456},
{59, 484},
{62, 485},
{64, 65},
{65, 486},
{4, 940},
{4, 940},
{52, 53},
{19, 22},
{38, 457},
{38, 458},
{38, 459},
{38, 460},
{68, 487},
{4, 940},
{52, 391},
{74, 75},
{84, 513},
{76, 51},
{4, 940},
{45, 481},
{76, 489},
{4, 940},
{19, 468},
{88, 515},
{91, 92},
{93, 516},
{94, 517},
{38, 461},
{38, 462},
{4, 940},
{6, 1018},
{6, 1018},
{6, 1018},
{95, 945},
{96, 61},
{97, 955},
{86, 514},
{95, 55},
{4, 940},
{97, 17},
{98, 99},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{86, 87},
{6, 7},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{6, 1018},
{105, 17},
{6, 1018},
{108, 110},
{112, 109},
{116, 525},
{118, 119},
{36, 454},
{6, 1018},
{122, 123},
{6, 1018},
{126, 473},
{6, 1018},
{127, 512},
{6, 1018},
{36, 455},
{36, 456},
{131, 531},
{36, 20},
{135, 136},
{144, 531},
{6, 1018},
{149, 150},
{151, 532},
{151, 152},
{36, 457},
{36, 458},
{36, 459},
{36, 460},
{154, 155},
{6, 1018},
{159, 467},
{112, 113},
{162, 521},
{164, 533},
{6, 1018},
{165, 534},
{173, 536},
{6, 1018},
{36, 22},
{177, 539},
{162, 163},
{179, 540},
{181, 541},
{36, 461},
{36, 462},
{6, 1018},
{9, 1019},
{9, 1019},
{9, 1019},
{186, 187},
{188, 189},
{187, 518},
{189, 17},
{36, 468},
{6, 1018},
{158, 894},
{111, 873},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{190, 547},
{9, 10},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{9, 1019},
{111, 873},
{9, 1019},
{192, 193},
{160, 895},
{158, 159},
{193, 103},
{111, 873},
{9, 1019},
{175, 537},
{9, 1019},
{187, 519},
{9, 1019},
{195, 548},
{9, 1019},
{111, 873},
{111, 873},
{197, 549},
{111, 873},
{198, 199},
{200, 201},
{9, 1019},
{202, 203},
{204, 205},
{206, 207},
{111, 873},
{111, 873},
{111, 873},
{111, 873},
{208, 209},
{9, 1019},
{160, 152},
{207, 208},
{175, 538},
{207, 212},
{9, 1019},
{210, 550},
{211, 551},
{9, 1019},
{111, 873},
{212, 213},
{212, 214},
{213, 552},
{214, 553},
{111, 873},
{111, 873},
{9, 1019},
{12, 1022},
{12, 1022},
{12, 1022},
{217, 218},
{220, 221},
{224, 554},
{226, 521},
{111, 873},
{9, 1019},
{230, 555},
{114, 872},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{232, 233},
{12, 13},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{12, 1022},
{114, 872},
{12, 1022},
{234, 556},
{239, 521},
{241, 242},
{243, 557},
{114, 872},
{12, 1022},
{244, 133},
{12, 1022},
{247, 528},
{12, 1022},
{249, 521},
{12, 1022},
{114, 872},
{114, 872},
{251, 252},
{114, 872},
{253, 558},
{257, 559},
{12, 1022},
{255, 836},
{259, 560},
{260, 561},
{114, 872},
{114, 872},
{114, 872},
{114, 872},
{263, 538},
{12, 1022},
{265, 562},
{267, 563},
{269, 564},
{273, 274},
{12, 1022},
{275, 276},
{271, 272},
{12, 1022},
{114, 872},
{276, 277},
{278, 566},
{254, 924},
{254, 255},
{114, 872},
{114, 872},
{12, 1022},
{15, 956},
{15, 956},
{15, 956},
{255, 836},
{280, 281},
{261, 522},
{268, 4},
{114, 872},
{12, 1022},
{283, 488},
{270, 261},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{254, 924},
{15, 16},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{15, 956},
{262, 925},
{262, 263},
{285, 521},
{268, 73},
{270, 565},
{15, 956},
{286, 287},
{15, 956},
{261, 523},
{15, 956},
{271, 351},
{15, 956},
{288, 289},
{290, 291},
{291, 292},
{254, 924},
{294, 929},
{299, 931},
{15, 956},
{15, 956},
{255, 537},
{298, 938},
{298, 527},
{300, 569},
{301, 302},
{303, 304},
{305, 306},
{15, 956},
{306, 307},
{310, 311},
{262, 925},
{312, 570},
{15, 956},
{307, 568},
{307, 885},
{15, 956},
{316, 317},
{318, 898},
{331, 521},
{315, 521},
{337, 338},
{339, 573},
{340, 574},
{15, 956},
{18, 977},
{18, 977},
{18, 977},
{315, 571},
{298, 938},
{336, 572},
{343, 899},
{298, 938},
{15, 956},
{349, 350},
{262, 925},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{254, 924},
{18, 19},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{18, 977},
{347, 909},
{18, 977},
{321, 55},
{329, 940},
{336, 320},
{350, 575},
{322, 923},
{18, 977},
{351, 352},
{18, 977},
{352, 526},
{18, 977},
{353, 354},
{18, 977},
{355, 356},
{356, 357},
{358, 576},
{332, 916},
{359, 360},
{25, 1039},
{18, 977},
{25, 1039},
{321, 83},
{321, 85},
{362, 363},
{329, 940},
{323, 922},
{347, 348},
{334, 917},
{18, 977},
{329, 940},
{322, 923},
{262, 925},
{329, 940},
{18, 977},
{300, 296},
{322, 923},
{18, 977},
{322, 55},
{332, 333},
{345, 912},
{354, 927},
{363, 577},
{25, 26},
{332, 916},
{18, 977},
{25, 1039},
{25, 1039},
{25, 1039},
{25, 1039},
{25, 1039},
{323, 922},
{25, 1039},
{365, 366},
{18, 977},
{334, 917},
{323, 922},
{25, 1039},
{334, 55},
{367, 578},
{323, 324},
{323, 344},
{345, 346},
{31, 1021},
{31, 1021},
{31, 1021},
{368, 369},
{345, 912},
{369, 370},
{371, 372},
{373, 579},
{25, 1039},
{375, 376},
{25, 1039},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{361, 283},
{31, 32},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{31, 1021},
{377, 580},
{31, 1021},
{379, 380},
{381, 581},
{382, 55},
{383, 325},
{382, 383},
{31, 1021},
{354, 120},
{31, 1021},
{384, 520},
{31, 1021},
{385, 336},
{31, 1021},
{383, 529},
{386, 387},
{388, 582},
{394, 583},
{396, 397},
{398, 584},
{31, 1021},
{399, 585},
{401, 402},
{403, 586},
{361, 17},
{405, 406},
{407, 587},
{408, 588},
{410, 521},
{31, 1021},
{411, 51},
{412, 413},
{25, 1039},
{414, 589},
{31, 1021},
{415, 416},
{416, 590},
{31, 1021},
{417, 591},
{418, 592},
{419, 593},
{420, 594},
{422, 521},
{424, 595},
{425, 426},
{31, 1021},
{37, 1020},
{37, 1020},
{37, 1020},
{422, 423},
{389, 924},
{389, 390},
{426, 596},
{427, 597},
{31, 1021},
{428, 598},
{430, 431},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{390, 940},
{37, 38},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{37, 1020},
{423, 131},
{37, 1020},
{389, 924},
{431, 599},
{361, 567},
{423, 139},
{435, 436},
{37, 1020},
{437, 600},
{37, 1020},
{389, 523},
{37, 1020},
{438, 601},
{37, 1020},
{439, 602},
{443, 603},
{444, 605},
{390, 5},
{390, 940},
{450, 606},
{37, 1020},
{390, 940},
{390, 940},
{390, 940},
{447, 448},
{452, 520},
{389, 924},
{447, 51},
{0, 0},
{37, 1020},
{0, 0},
{0, 0},
{0, 0},
{453, 735},
{37, 1020},
{0, 0},
{0, 0},
{37, 1020},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{37, 1020},
{54, 972},
{54, 972},
{54, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{37, 1020},
{0, 0},
{0, 0},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{453, 450},
{0, 0},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{54, 972},
{0, 0},
{54, 972},
{389, 924},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 972},
{0, 0},
{54, 972},
{0, 0},
{54, 972},
{0, 0},
{54, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 972},
{0, 0},
{0, 0},
{54, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 972},
{57, 954},
{57, 954},
{57, 954},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{54, 972},
{0, 0},
{0, 0},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{0, 0},
{0, 0},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 954},
{57, 58},
{57, 954},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 954},
{0, 0},
{57, 954},
{0, 0},
{57, 954},
{0, 0},
{57, 954},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 954},
{57, 954},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 954},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 954},
{0, 0},
{0, 0},
{57, 954},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 954},
{60, 986},
{60, 986},
{60, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{57, 954},
{0, 0},
{0, 0},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{0, 0},
{0, 0},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{60, 986},
{0, 0},
{60, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 986},
{0, 0},
{60, 986},
{0, 0},
{60, 986},
{0, 0},
{60, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 986},
{0, 0},
{0, 0},
{60, 986},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 986},
{63, 955},
{63, 955},
{63, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{60, 986},
{0, 0},
{0, 0},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{63, 955},
{0, 0},
{63, 64},
{63, 955},
{0, 0},
{63, 955},
{63, 955},
{63, 955},
{0, 0},
{63, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 955},
{0, 0},
{63, 955},
{0, 0},
{63, 955},
{0, 0},
{63, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 955},
{63, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 955},
{0, 0},
{0, 0},
{0, 0},
{70, 71},
{63, 955},
{0, 0},
{0, 0},
{63, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 955},
{66, 974},
{66, 974},
{66, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{63, 955},
{0, 0},
{0, 0},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{0, 0},
{0, 0},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 974},
{66, 67},
{66, 974},
{0, 0},
{70, 98},
{0, 0},
{0, 0},
{0, 0},
{66, 974},
{0, 0},
{66, 974},
{0, 0},
{66, 974},
{0, 0},
{66, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{66, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{70, 117},
{0, 0},
{70, 148},
{66, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{66, 974},
{0, 0},
{0, 0},
{66, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{70, 170},
{70, 567},
{66, 974},
{70, 542},
{70, 543},
{70, 544},
{70, 545},
{70, 546},
{70, 186},
{0, 0},
{0, 0},
{66, 974},
{71, 940},
{0, 0},
{0, 0},
{0, 0},
{215, 470},
{215, 471},
{0, 0},
{70, 198},
{70, 206},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{71, 940},
{0, 0},
{0, 0},
{71, 5},
{71, 940},
{0, 0},
{0, 0},
{71, 940},
{71, 940},
{71, 940},
{215, 474},
{71, 940},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{71, 940},
{0, 0},
{71, 940},
{0, 0},
{71, 940},
{0, 0},
{71, 940},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{215, 476},
{0, 0},
{0, 0},
{215, 477},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{215, 478},
{0, 0},
{0, 0},
{71, 940},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{71, 940},
{0, 0},
{0, 0},
{71, 940},
{0, 0},
{215, 36},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{71, 940},
{77, 964},
{77, 964},
{77, 964},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{71, 940},
{0, 0},
{0, 0},
{77, 490},
{77, 491},
{77, 492},
{77, 493},
{77, 494},
{77, 495},
{77, 496},
{77, 497},
{77, 498},
{77, 499},
{77, 500},
{77, 501},
{77, 502},
{77, 964},
{0, 0},
{0, 0},
{77, 964},
{77, 964},
{77, 964},
{77, 964},
{77, 964},
{0, 0},
{77, 964},
{0, 0},
{80, 966},
{80, 966},
{80, 966},
{0, 0},
{77, 503},
{0, 0},
{0, 0},
{0, 0},
{77, 505},
{0, 0},
{77, 506},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{77, 964},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{80, 966},
{0, 0},
{77, 507},
{80, 966},
{80, 966},
{80, 966},
{80, 966},
{80, 966},
{0, 0},
{80, 966},
{77, 509},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{80, 504},
{77, 510},
{0, 0},
{0, 0},
{391, 6},
{391, 9},
{391, 12},
{391, 15},
{0, 0},
{391, 18},
{77, 511},
{80, 966},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{89, 973},
{80, 508},
{0, 0},
{391, 472},
{0, 0},
{0, 0},
{0, 0},
{89, 973},
{0, 0},
{391, 30},
{89, 973},
{0, 0},
{130, 750},
{0, 0},
{130, 750},
{0, 0},
{89, 973},
{0, 0},
{89, 973},
{0, 0},
{89, 973},
{0, 0},
{89, 973},
{130, 750},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{391, 31},
{0, 0},
{89, 90},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{89, 973},
{391, 34},
{391, 35},
{0, 0},
{0, 0},
{89, 973},
{0, 0},
{130, 750},
{89, 973},
{0, 0},
{0, 0},
{130, 750},
{0, 0},
{130, 750},
{0, 0},
{130, 750},
{89, 973},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{89, 973},
{391, 37},
{0, 0},
{0, 0},
{0, 0},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{391, 40},
{391, 43},
{130, 750},
{130, 750},
{0, 0},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{137, 787},
{130, 750},
{137, 787},
{0, 0},
{130, 750},
{0, 0},
{130, 750},
{130, 750},
{130, 750},
{0, 0},
{137, 138},
{137, 787},
{130, 750},
{0, 0},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{130, 750},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{130, 750},
{130, 750},
{137, 787},
{0, 0},
{0, 0},
{0, 0},
{137, 787},
{0, 0},
{137, 787},
{0, 0},
{137, 787},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{137, 787},
{137, 787},
{0, 0},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{146, 781},
{137, 787},
{146, 781},
{0, 0},
{137, 787},
{0, 0},
{137, 787},
{137, 787},
{137, 787},
{0, 0},
{146, 147},
{146, 781},
{137, 787},
{0, 0},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{137, 787},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{137, 787},
{137, 787},
{146, 781},
{0, 0},
{0, 0},
{0, 0},
{146, 781},
{0, 0},
{146, 781},
{0, 0},
{146, 781},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{146, 781},
{146, 781},
{0, 0},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{167, 743},
{146, 781},
{167, 743},
{0, 0},
{146, 781},
{0, 0},
{146, 781},
{146, 781},
{146, 781},
{0, 0},
{0, 0},
{167, 743},
{146, 781},
{0, 0},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{146, 781},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{146, 781},
{146, 781},
{167, 743},
{0, 0},
{0, 0},
{0, 0},
{167, 743},
{0, 0},
{167, 743},
{0, 0},
{167, 743},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 743},
{167, 743},
{0, 0},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{169, 744},
{167, 743},
{169, 744},
{0, 0},
{167, 743},
{0, 0},
{167, 743},
{167, 743},
{167, 743},
{0, 0},
{0, 0},
{169, 744},
{167, 743},
{0, 0},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{167, 743},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{167, 743},
{167, 743},
{169, 744},
{0, 0},
{0, 0},
{0, 0},
{169, 744},
{0, 0},
{169, 744},
{218, 71},
{169, 744},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{169, 744},
{169, 744},
{0, 0},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{0, 0},
{169, 744},
{0, 0},
{0, 0},
{169, 744},
{0, 0},
{169, 744},
{169, 744},
{169, 744},
{0, 0},
{218, 98},
{218, 219},
{169, 744},
{0, 0},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{169, 744},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{223, 742},
{0, 0},
{223, 742},
{0, 0},
{0, 0},
{169, 744},
{169, 744},
{218, 117},
{0, 0},
{218, 148},
{0, 0},
{223, 742},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{218, 170},
{0, 0},
{0, 0},
{218, 542},
{218, 543},
{218, 544},
{218, 545},
{218, 546},
{218, 186},
{223, 742},
{0, 0},
{0, 0},
{0, 0},
{223, 742},
{0, 0},
{223, 742},
{0, 0},
{223, 742},
{0, 0},
{218, 198},
{218, 206},
{0, 0},
{0, 0},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{223, 742},
{223, 742},
{0, 0},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{228, 772},
{223, 742},
{228, 772},
{0, 0},
{223, 742},
{0, 0},
{223, 742},
{223, 742},
{223, 742},
{0, 0},
{228, 229},
{228, 772},
{223, 742},
{0, 0},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{223, 742},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{223, 742},
{223, 742},
{228, 772},
{0, 0},
{0, 0},
{0, 0},
{228, 772},
{0, 0},
{228, 772},
{0, 0},
{228, 772},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{0, 0},
{229, 2},
{0, 0},
{0, 0},
{0, 0},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{228, 772},
{228, 772},
{0, 0},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{0, 0},
{228, 772},
{0, 0},
{0, 0},
{228, 772},
{0, 0},
{228, 772},
{228, 772},
{228, 772},
{229, 128},
{0, 0},
{0, 0},
{228, 772},
{229, 528},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{228, 772},
{229, 529},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{229, 530},
{0, 0},
{0, 0},
{228, 772},
{228, 772},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{229, 531},
{229, 131},
{0, 0},
{0, 0},
{229, 144},
{0, 0},
{229, 139},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{229, 535},
{0, 0},
{229, 166},
{229, 168},
{0, 0},
{0, 0},
{0, 0},
{236, 795},
{0, 0},
{236, 795},
{229, 182},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{0, 0},
{236, 795},
{236, 237},
{236, 795},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{236, 795},
{236, 795},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{236, 795},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{236, 795},
{0, 0},
{0, 0},
{0, 0},
{236, 795},
{0, 0},
{236, 795},
{0, 0},
{236, 795},
{0, 0},
{0, 0},
{0, 0},
{236, 795},
{0, 0},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{237, 71},
{236, 795},
{0, 0},
{0, 0},
{0, 0},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{0, 0},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{0, 0},
{0, 0},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{0, 0},
{236, 795},
{0, 0},
{0, 0},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{0, 0},
{236, 795},
{0, 0},
{236, 795},
{0, 0},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{236, 795},
{237, 98},
{0, 0},
{0, 0},
{236, 795},
{236, 795},
{0, 0},
{237, 530},
{0, 0},
{0, 0},
{0, 0},
{236, 795},
{236, 795},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 117},
{0, 0},
{237, 148},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{237, 170},
{0, 0},
{0, 0},
{237, 542},
{237, 543},
{237, 544},
{237, 545},
{237, 546},
{237, 186},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{393, 955},
{393, 955},
{393, 955},
{0, 0},
{0, 0},
{0, 0},
{237, 198},
{237, 206},
{245, 801},
{0, 0},
{245, 801},
{0, 0},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{0, 0},
{245, 801},
{245, 246},
{245, 801},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{393, 955},
{0, 0},
{245, 801},
{245, 801},
{393, 955},
{393, 955},
{393, 955},
{393, 955},
{0, 0},
{393, 955},
{0, 0},
{245, 801},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{245, 801},
{0, 0},
{0, 0},
{0, 0},
{245, 801},
{0, 0},
{245, 801},
{0, 0},
{245, 801},
{0, 0},
{0, 0},
{393, 955},
{245, 801},
{0, 0},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{0, 0},
{245, 801},
{0, 0},
{0, 0},
{0, 0},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{0, 0},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{246, 71},
{0, 0},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{0, 0},
{245, 801},
{0, 0},
{0, 0},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{0, 0},
{245, 801},
{0, 0},
{245, 801},
{0, 0},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{245, 801},
{0, 0},
{0, 0},
{0, 0},
{245, 801},
{245, 801},
{0, 0},
{246, 528},
{0, 0},
{0, 0},
{0, 0},
{245, 801},
{245, 801},
{0, 0},
{0, 0},
{0, 0},
{246, 98},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{246, 247},
{246, 117},
{0, 0},
{246, 148},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{246, 170},
{0, 0},
{0, 0},
{246, 542},
{246, 543},
{246, 544},
{246, 545},
{246, 546},
{246, 186},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{246, 198},
{246, 206},
{327, 901},
{0, 0},
{327, 901},
{0, 0},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{0, 0},
{327, 901},
{327, 328},
{327, 901},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{327, 901},
{327, 901},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{327, 901},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{327, 901},
{0, 0},
{0, 0},
{0, 0},
{327, 901},
{0, 0},
{327, 901},
{0, 0},
{327, 901},
{0, 0},
{0, 0},
{0, 0},
{327, 901},
{0, 0},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{0, 0},
{327, 901},
{0, 0},
{0, 0},
{0, 0},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{0, 0},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{0, 0},
{0, 0},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{0, 0},
{327, 901},
{328, 329},
{0, 0},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{0, 0},
{327, 901},
{0, 0},
{327, 901},
{0, 0},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{327, 901},
{0, 0},
{0, 0},
{0, 0},
{327, 901},
{327, 901},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{327, 901},
{327, 901},
{328, 126},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{328, 98},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{342, 903},
{0, 0},
{342, 903},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{328, 117},
{0, 0},
{328, 148},
{0, 0},
{342, 903},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{328, 170},
{0, 0},
{0, 0},
{328, 542},
{328, 543},
{328, 544},
{328, 545},
{328, 546},
{328, 186},
{342, 903},
{0, 0},
{0, 0},
{0, 0},
{342, 903},
{0, 0},
{342, 903},
{0, 0},
{342, 903},
{0, 0},
{328, 198},
{328, 206},
{0, 0},
{0, 0},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{342, 903},
{342, 903},
{360, 850},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{0, 0},
{342, 903},
{0, 0},
{0, 0},
{342, 903},
{0, 0},
{342, 903},
{342, 903},
{342, 903},
{0, 0},
{0, 0},
{0, 0},
{342, 903},
{0, 0},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{342, 903},
{0, 0},
{0, 0},
{360, 850},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{360, 850},
{0, 0},
{342, 903},
{342, 903},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{360, 850},
{360, 850},
{0, 0},
{360, 850},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{360, 850},
{360, 850},
{360, 850},
{360, 850},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{360, 850},
{0, 0},
{360, 850},
{0, 0},
{360, 850},
{360, 850},
{360, 850},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{360, 850},
{0, 0},
{0, 0},
{0, 0},
{360, 850},
{360, 850},
{0, 0},
{360, 850},
{360, 850},
{360, 850},
{360, 850},
{360, 850},
{360, 850},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{360, 850},
{360, 850},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{392, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{392, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{392, 972},
{0, 0},
{392, 972},
{0, 0},
{392, 972},
{0, 0},
{392, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{392, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{392, 972},
{0, 0},
{0, 0},
{392, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{392, 972},
{429, 948},
{429, 948},
{429, 948},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{392, 972},
{0, 0},
{0, 0},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{0, 0},
{429, 430},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{429, 948},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{429, 948},
{0, 0},
{429, 948},
{0, 0},
{429, 948},
{0, 0},
{429, 948},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{429, 948},
{429, 948},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{429, 948},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{429, 948},
{0, 0},
{0, 0},
{429, 948},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{429, 948},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{429, 948},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{432, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{432, 972},
{0, 0},
{0, 0},
{432, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{432, 972},
{0, 0},
{432, 972},
{0, 0},
{432, 972},
{0, 0},
{432, 972},
{0, 0},
{440, 1039},
{0, 0},
{440, 1039},
{440, 1039},
{440, 1039},
{440, 1039},
{0, 0},
{440, 1039},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{432, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{432, 972},
{0, 0},
{0, 0},
{432, 972},
{0, 0},
{0, 0},
{440, 1039},
{440, 1034},
{0, 0},
{0, 0},
{0, 0},
{432, 972},
{440, 1039},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{432, 972},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 1039},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 1039},
{440, 1039},
{0, 0},
{0, 0},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{441, 955},
{0, 0},
{440, 1039},
{441, 64},
{441, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{440, 1039},
{440, 1039},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{441, 955},
{0, 0},
{441, 955},
{0, 0},
{441, 955},
{0, 0},
{441, 955},
{440, 1039},
{440, 1039},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{441, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{441, 955},
{0, 0},
{0, 0},
{441, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{441, 955},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{441, 955},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{442, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{442, 974},
{0, 0},
{442, 67},
{442, 974},
{0, 0},
{446, 769},
{0, 0},
{446, 769},
{0, 0},
{442, 974},
{0, 0},
{442, 974},
{0, 0},
{442, 974},
{0, 0},
{442, 974},
{446, 769},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{442, 434},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{442, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{442, 974},
{0, 0},
{446, 769},
{442, 974},
{0, 0},
{0, 0},
{446, 769},
{0, 0},
{446, 769},
{0, 0},
{446, 769},
{442, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{442, 974},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{446, 769},
{446, 769},
{0, 0},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{449, 768},
{446, 769},
{449, 768},
{0, 0},
{446, 769},
{0, 0},
{446, 769},
{446, 769},
{446, 769},
{0, 0},
{0, 0},
{449, 768},
{446, 769},
{0, 0},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{446, 769},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{446, 769},
{446, 769},
{449, 768},
{0, 0},
{0, 0},
{0, 0},
{449, 768},
{0, 0},
{449, 768},
{0, 0},
{449, 768},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 768},
{449, 768},
{0, 0},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{0, 0},
{449, 768},
{0, 0},
{0, 0},
{449, 768},
{0, 0},
{449, 768},
{449, 768},
{449, 768},
{0, 0},
{0, 0},
{0, 0},
{449, 768},
{0, 0},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{449, 768},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{0, 0},
{449, 768},
{449, 768},
{0, 0},
{0, 0},
};
static	unsigned short	yyNComb		[yyNTableMax - yyLastTerminal] = {
726,
451,
727,
452,
101,
729,
730,
731,
215,
222,
104,
111,
650,
651,
652,
653,
114,
124,
655,
656,
657,
658,
130,
137,
142,
659,
660,
661,
662,
663,
227,
153,
156,
145,
666,
667,
132,
231,
721,
235,
421,
420,
244,
673,
447,
627,
162,
146,
167,
145,
720,
719,
254,
231,
262,
634,
72,
635,
244,
671,
118,
169,
172,
161,
184,
271,
176,
178,
180,
679,
680,
100,
188,
52,
115,
719,
286,
444,
627,
612,
643,
642,
316,
323,
191,
29,
196,
194,
200,
204,
46,
217,
220,
223,
226,
636,
232,
239,
241,
249,
612,
24,
251,
674,
54,
8,
52,
11,
308,
14,
81,
273,
612,
607,
608,
615,
614,
280,
624,
57,
60,
625,
63,
66,
69,
77,
78,
631,
80,
70,
79,
629,
279,
612,
607,
608,
615,
54,
127,
607,
608,
607,
608,
607,
608,
644,
607,
608,
282,
228,
236,
624,
57,
60,
625,
63,
66,
69,
77,
245,
631,
80,
70,
443,
629,
285,
52,
607,
608,
615,
645,
256,
258,
33,
609,
288,
610,
404,
400,
260,
681,
675,
609,
270,
610,
675,
682,
395,
295,
684,
616,
685,
24,
612,
264,
266,
268,
54,
611,
613,
617,
25,
300,
619,
607,
608,
615,
607,
608,
612,
94,
624,
57,
60,
625,
63,
66,
69,
77,
303,
631,
80,
70,
24,
629,
48,
612,
607,
608,
615,
609,
24,
610,
620,
95,
607,
608,
615,
621,
690,
39,
310,
313,
607,
608,
615,
618,
315,
633,
57,
96,
319,
97,
52,
322,
321,
331,
612,
334,
337,
607,
608,
614,
332,
342,
353,
615,
607,
608,
693,
644,
359,
607,
608,
607,
608,
361,
365,
371,
24,
612,
375,
379,
386,
82,
396,
401,
405,
190,
410,
438,
607,
608,
615,
609,
645,
610,
412,
89,
57,
60,
625,
63,
442,
69,
77,
327,
631,
80,
70,
724,
629,
722,
422,
607,
608,
615,
24,
52,
424,
644,
612,
446,
48,
449,
54,
453,
0,
0,
607,
608,
615,
0,
0,
0,
326,
0,
0,
439,
624,
57,
60,
625,
393,
66,
440,
725,
384,
0,
54,
70,
52,
629,
0,
0,
607,
608,
615,
0,
50,
627,
0,
0,
624,
57,
60,
625,
441,
66,
69,
77,
0,
631,
80,
70,
327,
629,
0,
612,
607,
608,
615,
432,
0,
0,
332,
341,
0,
52,
672,
0,
695,
0,
622,
374,
378,
89,
57,
60,
625,
63,
433,
69,
77,
0,
631,
80,
70,
0,
629,
332,
343,
607,
608,
615,
612,
695,
0,
0,
54,
0,
52,
332,
343,
0,
703,
704,
0,
695,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
332,
385,
0,
0,
382,
623,
695,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
54,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
0,
0,
52,
624,
57,
60,
625,
63,
66,
54,
708,
623,
0,
0,
70,
0,
629,
0,
0,
0,
0,
615,
0,
624,
57,
60,
625,
63,
66,
612,
723,
0,
0,
54,
70,
0,
629,
0,
0,
52,
0,
615,
0,
0,
623,
0,
56,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
612,
0,
0,
0,
54,
0,
52,
0,
0,
0,
0,
623,
0,
0,
609,
0,
610,
59,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
121,
629,
0,
612,
607,
608,
615,
54,
0,
52,
0,
612,
0,
0,
0,
0,
0,
0,
0,
0,
62,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
24,
629,
0,
612,
607,
608,
615,
54,
0,
0,
0,
0,
607,
608,
615,
0,
0,
0,
0,
0,
68,
624,
57,
60,
625,
63,
66,
69,
77,
54,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
647,
648,
649,
624,
57,
60,
625,
63,
66,
54,
626,
0,
284,
257,
70,
0,
629,
0,
0,
427,
0,
615,
0,
624,
57,
60,
625,
63,
66,
0,
628,
0,
0,
0,
70,
0,
629,
95,
0,
0,
0,
615,
0,
0,
0,
74,
0,
389,
0,
262,
0,
633,
57,
96,
0,
97,
0,
0,
0,
0,
271,
428,
0,
0,
679,
680,
0,
0,
0,
615,
0,
286,
0,
52,
612,
0,
0,
0,
54,
0,
0,
0,
76,
627,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
612,
631,
80,
70,
82,
629,
309,
0,
607,
608,
615,
52,
0,
0,
0,
0,
0,
0,
89,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
0,
612,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
623,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
54,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
0,
0,
52,
624,
57,
60,
625,
63,
66,
54,
630,
623,
0,
0,
70,
0,
629,
0,
0,
0,
0,
615,
0,
624,
57,
60,
625,
63,
66,
612,
632,
0,
0,
54,
70,
0,
629,
0,
0,
52,
0,
615,
0,
0,
623,
0,
84,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
612,
0,
0,
0,
54,
0,
52,
0,
0,
0,
0,
623,
0,
0,
609,
0,
610,
86,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
616,
629,
0,
612,
607,
608,
615,
54,
0,
52,
640,
25,
0,
0,
623,
0,
0,
0,
0,
0,
88,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
24,
629,
0,
612,
607,
608,
615,
54,
0,
52,
0,
0,
607,
608,
615,
0,
0,
0,
0,
0,
91,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
259,
0,
0,
0,
609,
0,
610,
0,
0,
0,
0,
93,
624,
57,
60,
625,
63,
66,
69,
77,
106,
631,
80,
70,
95,
629,
107,
112,
607,
608,
615,
612,
609,
0,
610,
609,
0,
610,
633,
57,
96,
0,
97,
0,
0,
0,
0,
122,
106,
0,
0,
293,
0,
24,
0,
108,
615,
0,
0,
612,
0,
0,
612,
0,
0,
607,
608,
615,
0,
0,
0,
0,
0,
0,
683,
294,
0,
0,
0,
0,
0,
24,
0,
0,
24,
0,
0,
0,
0,
0,
0,
0,
0,
607,
608,
615,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
425,
225,
655,
656,
657,
658,
265,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
127,
0,
95,
609,
0,
610,
0,
267,
254,
0,
262,
0,
0,
151,
0,
0,
633,
57,
96,
616,
97,
271,
0,
0,
0,
679,
680,
0,
52,
641,
25,
95,
286,
0,
615,
612,
0,
0,
316,
323,
637,
0,
0,
0,
0,
633,
57,
96,
0,
97,
0,
0,
24,
0,
0,
612,
0,
24,
0,
82,
0,
0,
135,
615,
607,
608,
615,
0,
52,
607,
608,
615,
0,
624,
57,
60,
625,
63,
66,
69,
77,
638,
631,
80,
70,
609,
629,
610,
0,
607,
608,
615,
0,
0,
0,
612,
0,
0,
0,
54,
0,
174,
0,
0,
639,
0,
0,
140,
0,
52,
0,
0,
612,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
0,
0,
24,
52,
612,
0,
0,
0,
54,
0,
0,
0,
0,
0,
607,
608,
615,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
612,
631,
80,
70,
54,
629,
0,
0,
607,
608,
615,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
419,
225,
655,
656,
657,
658,
269,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
95,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
633,
57,
96,
0,
97,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
615,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
717,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
418,
231,
0,
235,
0,
0,
244,
673,
0,
609,
0,
610,
0,
0,
173,
0,
254,
0,
262,
160,
0,
0,
0,
0,
0,
616,
0,
0,
0,
271,
0,
0,
0,
679,
680,
641,
25,
0,
0,
0,
286,
0,
52,
612,
0,
0,
316,
323,
0,
0,
0,
0,
177,
0,
0,
0,
0,
0,
24,
609,
0,
610,
0,
0,
0,
24,
0,
0,
0,
612,
607,
608,
615,
54,
0,
297,
0,
607,
608,
615,
52,
0,
0,
0,
0,
179,
612,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
0,
612,
24,
0,
0,
54,
0,
52,
0,
0,
0,
0,
181,
0,
607,
608,
615,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
52,
0,
0,
0,
0,
183,
0,
0,
609,
0,
610,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
691,
629,
0,
612,
607,
608,
615,
54,
0,
52,
0,
612,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
24,
629,
0,
612,
607,
608,
615,
54,
0,
0,
0,
0,
607,
608,
615,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
417,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
609,
0,
610,
609,
0,
610,
0,
254,
0,
262,
0,
0,
202,
0,
0,
275,
293,
0,
0,
293,
271,
0,
0,
0,
679,
680,
0,
612,
0,
0,
612,
286,
0,
0,
612,
0,
0,
316,
323,
683,
294,
0,
683,
294,
0,
0,
0,
0,
0,
24,
0,
0,
24,
0,
0,
0,
24,
0,
0,
0,
0,
607,
608,
615,
607,
608,
615,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
415,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
211,
0,
688,
0,
689,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
301,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
52,
612,
0,
0,
286,
210,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
24,
216,
0,
0,
612,
0,
24,
0,
54,
0,
52,
0,
607,
608,
615,
716,
0,
0,
607,
608,
615,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
52,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
647,
648,
649,
0,
624,
57,
60,
625,
63,
66,
69,
77,
284,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
647,
648,
649,
0,
0,
0,
408,
0,
0,
0,
0,
0,
409,
0,
0,
0,
0,
715,
411,
627,
0,
0,
0,
0,
254,
0,
262,
609,
0,
610,
0,
0,
0,
0,
0,
0,
0,
271,
349,
290,
0,
679,
680,
293,
0,
0,
0,
389,
286,
262,
0,
612,
0,
0,
612,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
683,
294,
0,
0,
0,
286,
0,
24,
612,
0,
24,
0,
54,
0,
0,
0,
0,
309,
0,
607,
608,
615,
607,
608,
615,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
224,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
54,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
624,
57,
60,
625,
63,
66,
254,
707,
262,
0,
0,
70,
0,
629,
0,
0,
0,
0,
615,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
654,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
664,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
230,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
665,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
234,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
609,
0,
610,
0,
0,
0,
0,
254,
0,
262,
0,
647,
648,
649,
0,
0,
298,
0,
0,
0,
271,
0,
0,
238,
679,
680,
0,
612,
0,
0,
668,
286,
0,
669,
612,
0,
0,
316,
323,
0,
0,
686,
299,
0,
0,
235,
399,
712,
0,
24,
0,
0,
0,
0,
240,
0,
24,
0,
389,
0,
262,
607,
608,
615,
0,
0,
0,
0,
607,
608,
615,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
647,
648,
649,
0,
624,
57,
60,
625,
393,
66,
69,
77,
284,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
647,
648,
649,
0,
0,
0,
0,
0,
0,
0,
0,
0,
238,
0,
0,
0,
0,
0,
0,
668,
0,
0,
669,
0,
254,
0,
262,
0,
609,
0,
610,
0,
0,
0,
235,
0,
670,
271,
678,
0,
0,
679,
680,
240,
298,
0,
0,
389,
286,
262,
0,
612,
0,
0,
0,
612,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
687,
299,
286,
0,
24,
612,
0,
0,
24,
54,
0,
0,
0,
0,
309,
0,
607,
608,
615,
0,
607,
608,
615,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
243,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
609,
0,
610,
0,
254,
0,
262,
0,
0,
0,
0,
0,
305,
0,
0,
0,
293,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
612,
286,
0,
0,
612,
0,
0,
316,
323,
647,
648,
649,
683,
294,
0,
0,
0,
0,
672,
0,
0,
248,
24,
250,
364,
0,
24,
0,
668,
0,
0,
0,
701,
0,
607,
608,
615,
0,
607,
608,
615,
0,
0,
0,
0,
0,
244,
673,
394,
710,
0,
0,
368,
705,
706,
704,
389,
0,
262,
0,
0,
0,
0,
0,
0,
0,
647,
648,
649,
271,
0,
0,
0,
679,
680,
0,
0,
0,
330,
0,
286,
0,
0,
612,
0,
0,
0,
392,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
254,
629,
262,
0,
607,
608,
615,
647,
648,
649,
0,
0,
0,
271,
0,
0,
672,
679,
680,
248,
0,
250,
364,
0,
286,
0,
668,
612,
0,
0,
701,
332,
335,
340,
697,
0,
0,
695,
0,
0,
0,
0,
0,
0,
244,
673,
0,
702,
0,
24,
368,
705,
706,
704,
389,
0,
262,
0,
0,
0,
0,
607,
608,
615,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
0,
392,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
253,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
676,
0,
609,
0,
610,
0,
0,
0,
254,
0,
262,
0,
0,
0,
355,
0,
0,
0,
293,
0,
0,
271,
0,
0,
0,
679,
680,
0,
52,
612,
0,
0,
286,
677,
0,
612,
0,
0,
316,
323,
0,
683,
294,
278,
0,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
612,
0,
24,
0,
54,
0,
52,
0,
607,
608,
615,
0,
0,
0,
607,
608,
615,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
312,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
314,
627,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
52,
0,
0,
286,
318,
627,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
612,
24,
0,
0,
54,
0,
52,
0,
0,
0,
0,
692,
0,
607,
608,
615,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
52,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
647,
648,
649,
0,
0,
0,
260,
0,
675,
0,
0,
0,
330,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
0,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
624,
57,
60,
625,
63,
66,
0,
708,
0,
0,
271,
70,
0,
629,
679,
680,
0,
0,
615,
0,
0,
286,
0,
0,
612,
0,
0,
0,
332,
335,
0,
694,
0,
0,
695,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
339,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
647,
648,
649,
0,
0,
0,
0,
254,
0,
262,
0,
0,
330,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
345,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
52,
607,
608,
615,
286,
698,
0,
612,
0,
0,
0,
332,
335,
0,
696,
0,
0,
695,
0,
0,
0,
0,
0,
0,
0,
0,
0,
612,
0,
24,
0,
54,
0,
52,
0,
347,
700,
0,
345,
0,
0,
607,
608,
615,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
52,
0,
0,
0,
0,
0,
0,
0,
0,
0,
676,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
612,
607,
608,
615,
54,
0,
0,
0,
0,
699,
0,
52,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
358,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
0,
612,
647,
648,
649,
54,
623,
0,
0,
0,
0,
0,
0,
0,
284,
0,
0,
0,
0,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
52,
607,
608,
615,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
612,
271,
362,
0,
54,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
435,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
24,
0,
0,
0,
0,
0,
0,
0,
0,
0,
309,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
367,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
373,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
377,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
381,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
388,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
647,
648,
649,
0,
0,
0,
0,
0,
0,
672,
0,
0,
248,
0,
250,
364,
0,
24,
0,
668,
0,
0,
0,
701,
0,
0,
0,
0,
0,
607,
608,
615,
0,
0,
0,
0,
0,
244,
673,
0,
709,
0,
0,
368,
705,
706,
704,
389,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
0,
392,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
647,
648,
649,
0,
0,
0,
0,
0,
0,
672,
0,
0,
248,
0,
250,
364,
0,
0,
0,
668,
0,
0,
0,
701,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
244,
673,
0,
398,
0,
0,
368,
705,
706,
704,
389,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
0,
392,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
647,
648,
649,
0,
0,
0,
0,
0,
0,
0,
0,
0,
238,
0,
0,
0,
0,
0,
0,
668,
0,
0,
669,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
235,
0,
711,
0,
0,
0,
0,
0,
0,
240,
0,
0,
0,
389,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
647,
648,
649,
0,
0,
0,
0,
0,
0,
0,
0,
0,
238,
0,
0,
0,
0,
0,
0,
668,
0,
0,
669,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
235,
0,
403,
0,
0,
0,
0,
0,
0,
240,
0,
0,
0,
389,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
407,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
647,
648,
649,
0,
0,
0,
0,
254,
0,
262,
0,
0,
409,
0,
0,
0,
0,
714,
411,
627,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
389,
0,
262,
0,
0,
0,
0,
0,
0,
24,
0,
0,
623,
271,
0,
0,
0,
679,
680,
0,
0,
607,
608,
615,
286,
0,
0,
612,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
52,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
647,
648,
649,
612,
0,
0,
0,
54,
0,
0,
0,
0,
409,
0,
0,
0,
0,
713,
411,
627,
437,
624,
57,
60,
625,
63,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
0,
0,
0,
0,
0,
0,
0,
389,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
0,
54,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
624,
57,
60,
625,
393,
66,
69,
77,
0,
631,
80,
70,
0,
629,
0,
0,
607,
608,
615,
646,
0,
0,
647,
648,
649,
215,
222,
0,
0,
650,
651,
652,
653,
414,
225,
655,
656,
657,
658,
0,
0,
0,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
646,
0,
0,
647,
648,
649,
215,
222,
24,
0,
650,
651,
652,
653,
718,
225,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
728,
0,
727,
452,
0,
729,
730,
731,
215,
222,
24,
0,
650,
651,
652,
653,
0,
0,
655,
656,
657,
658,
607,
608,
615,
659,
660,
661,
662,
663,
227,
0,
0,
145,
666,
667,
0,
231,
0,
235,
0,
0,
244,
673,
0,
0,
0,
0,
0,
0,
0,
0,
254,
0,
262,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
271,
0,
0,
0,
679,
680,
0,
0,
0,
0,
0,
286,
0,
0,
612,
0,
0,
316,
323,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
24,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
607,
608,
615,
0,
};
static	yyTCombType *	yyTBasePtr	[yyLastReadState + 1] = {
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [38],
& yyTComb [1],
& yyTComb [116],
& yyTComb [0],
& yyTComb [2],
& yyTComb [194],
& yyTComb [0],
& yyTComb [4],
& yyTComb [272],
& yyTComb [0],
& yyTComb [6],
& yyTComb [350],
& yyTComb [0],
& yyTComb [0],
& yyTComb [428],
& yyTComb [23],
& yyTComb [8],
& yyTComb [0],
& yyTComb [9],
& yyTComb [0],
& yyTComb [0],
& yyTComb [479],
& yyTComb [4],
& yyTComb [8],
& yyTComb [0],
& yyTComb [15],
& yyTComb [0],
& yyTComb [523],
& yyTComb [0],
& yyTComb [16],
& yyTComb [0],
& yyTComb [0],
& yyTComb [116],
& yyTComb [601],
& yyTComb [38],
& yyTComb [17],
& yyTComb [19],
& yyTComb [14],
& yyTComb [0],
& yyTComb [21],
& yyTComb [10],
& yyTComb [75],
& yyTComb [1],
& yyTComb [36],
& yyTComb [48],
& yyTComb [0],
& yyTComb [47],
& yyTComb [0],
& yyTComb [12],
& yyTComb [0],
& yyTComb [679],
& yyTComb [0],
& yyTComb [49],
& yyTComb [757],
& yyTComb [0],
& yyTComb [53],
& yyTComb [835],
& yyTComb [0],
& yyTComb [54],
& yyTComb [913],
& yyTComb [50],
& yyTComb [62],
& yyTComb [991],
& yyTComb [0],
& yyTComb [65],
& yyTComb [0],
& yyTComb [977],
& yyTComb [1076],
& yyTComb [0],
& yyTComb [0],
& yyTComb [71],
& yyTComb [0],
& yyTComb [73],
& yyTComb [1154],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1189],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [69],
& yyTComb [0],
& yyTComb [89],
& yyTComb [0],
& yyTComb [76],
& yyTComb [1231],
& yyTComb [0],
& yyTComb [58],
& yyTComb [0],
& yyTComb [78],
& yyTComb [84],
& yyTComb [91],
& yyTComb [88],
& yyTComb [93],
& yyTComb [28],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1],
& yyTComb [116],
& yyTComb [0],
& yyTComb [2],
& yyTComb [122],
& yyTComb [0],
& yyTComb [0],
& yyTComb [194],
& yyTComb [151],
& yyTComb [0],
& yyTComb [272],
& yyTComb [3],
& yyTComb [124],
& yyTComb [0],
& yyTComb [127],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [129],
& yyTComb [0],
& yyTComb [5],
& yyTComb [0],
& yyTComb [125],
& yyTComb [127],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1267],
& yyTComb [97],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [114],
& yyTComb [0],
& yyTComb [1345],
& yyTComb [0],
& yyTComb [0],
& yyTComb [2],
& yyTComb [0],
& yyTComb [7],
& yyTComb [0],
& yyTComb [100],
& yyTComb [0],
& yyTComb [1423],
& yyTComb [0],
& yyTComb [3],
& yyTComb [109],
& yyTComb [0],
& yyTComb [142],
& yyTComb [0],
& yyTComb [8],
& yyTComb [128],
& yyTComb [0],
& yyTComb [9],
& yyTComb [4],
& yyTComb [201],
& yyTComb [136],
& yyTComb [227],
& yyTComb [0],
& yyTComb [178],
& yyTComb [10],
& yyTComb [153],
& yyTComb [155],
& yyTComb [0],
& yyTComb [1501],
& yyTComb [0],
& yyTComb [1579],
& yyTComb [5],
& yyTComb [0],
& yyTComb [0],
& yyTComb [156],
& yyTComb [7],
& yyTComb [155],
& yyTComb [0],
& yyTComb [159],
& yyTComb [0],
& yyTComb [161],
& yyTComb [0],
& yyTComb [162],
& yyTComb [0],
& yyTComb [0],
& yyTComb [12],
& yyTComb [0],
& yyTComb [99],
& yyTComb [198],
& yyTComb [138],
& yyTComb [168],
& yyTComb [191],
& yyTComb [13],
& yyTComb [128],
& yyTComb [132],
& yyTComb [13],
& yyTComb [210],
& yyTComb [14],
& yyTComb [214],
& yyTComb [172],
& yyTComb [0],
& yyTComb [219],
& yyTComb [0],
& yyTComb [220],
& yyTComb [0],
& yyTComb [239],
& yyTComb [0],
& yyTComb [248],
& yyTComb [152],
& yyTComb [144],
& yyTComb [0],
& yyTComb [233],
& yyTComb [234],
& yyTComb [155],
& yyTComb [239],
& yyTComb [240],
& yyTComb [1065],
& yyTComb [0],
& yyTComb [266],
& yyTComb [1617],
& yyTComb [0],
& yyTComb [267],
& yyTComb [0],
& yyTComb [0],
& yyTComb [1683],
& yyTComb [267],
& yyTComb [0],
& yyTComb [276],
& yyTComb [0],
& yyTComb [1761],
& yyTComb [1811],
& yyTComb [271],
& yyTComb [0],
& yyTComb [288],
& yyTComb [0],
& yyTComb [296],
& yyTComb [0],
& yyTComb [1900],
& yyTComb [1949],
& yyTComb [0],
& yyTComb [305],
& yyTComb [0],
& yyTComb [299],
& yyTComb [0],
& yyTComb [299],
& yyTComb [311],
& yyTComb [2060],
& yyTComb [2124],
& yyTComb [274],
& yyTComb [0],
& yyTComb [314],
& yyTComb [0],
& yyTComb [311],
& yyTComb [0],
& yyTComb [312],
& yyTComb [345],
& yyTComb [325],
& yyTComb [0],
& yyTComb [295],
& yyTComb [0],
& yyTComb [298],
& yyTComb [299],
& yyTComb [354],
& yyTComb [384],
& yyTComb [229],
& yyTComb [0],
& yyTComb [306],
& yyTComb [0],
& yyTComb [307],
& yyTComb [355],
& yyTComb [308],
& yyTComb [360],
& yyTComb [286],
& yyTComb [0],
& yyTComb [311],
& yyTComb [0],
& yyTComb [312],
& yyTComb [283],
& yyTComb [0],
& yyTComb [316],
& yyTComb [0],
& yyTComb [345],
& yyTComb [0],
& yyTComb [0],
& yyTComb [299],
& yyTComb [0],
& yyTComb [384],
& yyTComb [318],
& yyTComb [0],
& yyTComb [370],
& yyTComb [0],
& yyTComb [370],
& yyTComb [370],
& yyTComb [0],
& yyTComb [0],
& yyTComb [373],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [405],
& yyTComb [374],
& yyTComb [406],
& yyTComb [354],
& yyTComb [0],
& yyTComb [383],
& yyTComb [0],
& yyTComb [383],
& yyTComb [384],
& yyTComb [416],
& yyTComb [0],
& yyTComb [0],
& yyTComb [404],
& yyTComb [0],
& yyTComb [337],
& yyTComb [0],
& yyTComb [0],
& yyTComb [421],
& yyTComb [395],
& yyTComb [0],
& yyTComb [419],
& yyTComb [0],
& yyTComb [0],
& yyTComb [430],
& yyTComb [466],
& yyTComb [486],
& yyTComb [0],
& yyTComb [0],
& yyTComb [0],
& yyTComb [2235],
& yyTComb [2313],
& yyTComb [461],
& yyTComb [0],
& yyTComb [420],
& yyTComb [475],
& yyTComb [0],
& yyTComb [486],
& yyTComb [0],
& yyTComb [432],
& yyTComb [415],
& yyTComb [0],
& yyTComb [415],
& yyTComb [416],
& yyTComb [0],
& yyTComb [2379],
& yyTComb [432],
& yyTComb [0],
& yyTComb [498],
& yyTComb [0],
& yyTComb [458],
& yyTComb [0],
& yyTComb [427],
& yyTComb [437],
& yyTComb [414],
& yyTComb [469],
& yyTComb [446],
& yyTComb [474],
& yyTComb [447],
& yyTComb [415],
& yyTComb [0],
& yyTComb [448],
& yyTComb [469],
& yyTComb [2447],
& yyTComb [547],
& yyTComb [474],
& yyTComb [474],
& yyTComb [0],
& yyTComb [504],
& yyTComb [0],
& yyTComb [509],
& yyTComb [495],
& yyTComb [445],
& yyTComb [0],
& yyTComb [520],
& yyTComb [0],
& yyTComb [520],
& yyTComb [0],
& yyTComb [523],
& yyTComb [0],
& yyTComb [545],
& yyTComb [0],
& yyTComb [548],
& yyTComb [0],
& yyTComb [548],
& yyTComb [527],
& yyTComb [521],
& yyTComb [563],
& yyTComb [538],
& yyTComb [561],
& yyTComb [0],
& yyTComb [561],
& yyTComb [605],
& yyTComb [624],
& yyTComb [1231],
& yyTComb [2546],
& yyTComb [2051],
& yyTComb [562],
& yyTComb [0],
& yyTComb [564],
& yyTComb [0],
& yyTComb [564],
& yyTComb [566],
& yyTComb [0],
& yyTComb [568],
& yyTComb [0],
& yyTComb [568],
& yyTComb [0],
& yyTComb [571],
& yyTComb [0],
& yyTComb [571],
& yyTComb [572],
& yyTComb [0],
& yyTComb [581],
& yyTComb [555],
& yyTComb [577],
& yyTComb [0],
& yyTComb [578],
& yyTComb [580],
& yyTComb [563],
& yyTComb [583],
& yyTComb [584],
& yyTComb [585],
& yyTComb [586],
& yyTComb [0],
& yyTComb [595],
& yyTComb [565],
& yyTComb [588],
& yyTComb [589],
& yyTComb [579],
& yyTComb [581],
& yyTComb [583],
& yyTComb [2624],
& yyTComb [573],
& yyTComb [609],
& yyTComb [2700],
& yyTComb [0],
& yyTComb [0],
& yyTComb [587],
& yyTComb [0],
& yyTComb [608],
& yyTComb [618],
& yyTComb [620],
& yyTComb [2746],
& yyTComb [2801],
& yyTComb [2877],
& yyTComb [621],
& yyTComb [622],
& yyTComb [0],
& yyTComb [2913],
& yyTComb [630],
& yyTComb [0],
& yyTComb [2991],
& yyTComb [645],
& yyTComb [0],
& yyTComb [656],
& yyTComb [667],
};
static	unsigned short*	yyNBasePtr	[yyLastReadState + 1] = {
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-92],
& yyNComb [-113],
& yyNComb [-59],
& yyNComb [-113],
& yyNComb [-87],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-85],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-83],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-22],
& yyNComb [1],
& yyNComb [-113],
& yyNComb [-80],
& yyNComb [-113],
& yyNComb [9],
& yyNComb [-113],
& yyNComb [17],
& yyNComb [34],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [65],
& yyNComb [-113],
& yyNComb [88],
& yyNComb [-113],
& yyNComb [-19],
& yyNComb [-113],
& yyNComb [41],
& yyNComb [46],
& yyNComb [129],
& yyNComb [-113],
& yyNComb [48],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [153],
& yyNComb [186],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [223],
& yyNComb [-113],
& yyNComb [256],
& yyNComb [278],
& yyNComb [298],
& yyNComb [-113],
& yyNComb [322],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [359],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [392],
& yyNComb [-113],
& yyNComb [-112],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [425],
& yyNComb [-113],
& yyNComb [447],
& yyNComb [536],
& yyNComb [-113],
& yyNComb [38],
& yyNComb [562],
& yyNComb [-113],
& yyNComb [600],
& yyNComb [-113],
& yyNComb [-92],
& yyNComb [467],
& yyNComb [622],
& yyNComb [-112],
& yyNComb [642],
& yyNComb [-113],
& yyNComb [666],
& yyNComb [-113],
& yyNComb [703],
& yyNComb [-113],
& yyNComb [736],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [769],
& yyNComb [-113],
& yyNComb [802],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-112],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-112],
& yyNComb [-107],
& yyNComb [-113],
& yyNComb [839],
& yyNComb [-113],
& yyNComb [867],
& yyNComb [-113],
& yyNComb [-111],
& yyNComb [-106],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-101],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [870],
& yyNComb [400],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-100],
& yyNComb [-113],
& yyNComb [984],
& yyNComb [1004],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-95],
& yyNComb [-113],
& yyNComb [-110],
& yyNComb [-94],
& yyNComb [-113],
& yyNComb [1044],
& yyNComb [-113],
& yyNComb [1085],
& yyNComb [-113],
& yyNComb [-110],
& yyNComb [1111],
& yyNComb [-113],
& yyNComb [-93],
& yyNComb [-113],
& yyNComb [1225],
& yyNComb [-97],
& yyNComb [-70],
& yyNComb [-113],
& yyNComb [1316],
& yyNComb [-113],
& yyNComb [-86],
& yyNComb [979],
& yyNComb [-113],
& yyNComb [744],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-85],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [1309],
& yyNComb [-113],
& yyNComb [-71],
& yyNComb [-112],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-69],
& yyNComb [-113],
& yyNComb [-56],
& yyNComb [-113],
& yyNComb [1061],
& yyNComb [-107],
& yyNComb [1342],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-103],
& yyNComb [1380],
& yyNComb [-113],
& yyNComb [1413],
& yyNComb [-113],
& yyNComb [1446],
& yyNComb [-113],
& yyNComb [1479],
& yyNComb [-53],
& yyNComb [-113],
& yyNComb [1593],
& yyNComb [-113],
& yyNComb [-112],
& yyNComb [-33],
& yyNComb [103],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-100],
& yyNComb [-99],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-85],
& yyNComb [-113],
& yyNComb [1586],
& yyNComb [-113],
& yyNComb [-28],
& yyNComb [-113],
& yyNComb [1707],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [1727],
& yyNComb [1760],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [1793],
& yyNComb [-26],
& yyNComb [-113],
& yyNComb [1904],
& yyNComb [-25],
& yyNComb [-113],
& yyNComb [2018],
& yyNComb [-24],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-23],
& yyNComb [2109],
& yyNComb [32],
& yyNComb [-113],
& yyNComb [2200],
& yyNComb [2291],
& yyNComb [-21],
& yyNComb [-113],
& yyNComb [2382],
& yyNComb [-113],
& yyNComb [33],
& yyNComb [-113],
& yyNComb [2433],
& yyNComb [-20],
& yyNComb [2544],
& yyNComb [-19],
& yyNComb [-113],
& yyNComb [2658],
& yyNComb [-113],
& yyNComb [42],
& yyNComb [-113],
& yyNComb [2737],
& yyNComb [-97],
& yyNComb [-18],
& yyNComb [2848],
& yyNComb [-15],
& yyNComb [-113],
& yyNComb [2962],
& yyNComb [-113],
& yyNComb [13],
& yyNComb [2],
& yyNComb [495],
& yyNComb [-113],
& yyNComb [828],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-65],
& yyNComb [17],
& yyNComb [25],
& yyNComb [947],
& yyNComb [-113],
& yyNComb [976],
& yyNComb [-113],
& yyNComb [1188],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-95],
& yyNComb [-62],
& yyNComb [-113],
& yyNComb [1589],
& yyNComb [-113],
& yyNComb [0],
& yyNComb [2982],
& yyNComb [-71],
& yyNComb [3015],
& yyNComb [-113],
& yyNComb [-26],
& yyNComb [1881],
& yyNComb [-113],
& yyNComb [48],
& yyNComb [2521],
& yyNComb [1701],
& yyNComb [2],
& yyNComb [-113],
& yyNComb [1884],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-10],
& yyNComb [-22],
& yyNComb [-15],
& yyNComb [2375],
& yyNComb [1359],
& yyNComb [-19],
& yyNComb [-17],
& yyNComb [-1],
& yyNComb [2525],
& yyNComb [-95],
& yyNComb [46],
& yyNComb [-113],
& yyNComb [2654],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [49],
& yyNComb [1454],
& yyNComb [124],
& yyNComb [-113],
& yyNComb [3129],
& yyNComb [17],
& yyNComb [3150],
& yyNComb [130],
& yyNComb [-113],
& yyNComb [48],
& yyNComb [3183],
& yyNComb [-113],
& yyNComb [58],
& yyNComb [59],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [214],
& yyNComb [3216],
& yyNComb [189],
& yyNComb [-113],
& yyNComb [2794],
& yyNComb [-113],
& yyNComb [139],
& yyNComb [3295],
& yyNComb [-113],
& yyNComb [62],
& yyNComb [-113],
& yyNComb [142],
& yyNComb [67],
& yyNComb [-113],
& yyNComb [3386],
& yyNComb [-113],
& yyNComb [3426],
& yyNComb [147],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [3446],
& yyNComb [-113],
& yyNComb [3479],
& yyNComb [-113],
& yyNComb [3512],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [92],
& yyNComb [-113],
& yyNComb [2956],
& yyNComb [-113],
& yyNComb [154],
& yyNComb [3550],
& yyNComb [-71],
& yyNComb [-113],
& yyNComb [102],
& yyNComb [3625],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [160],
& yyNComb [-113],
& yyNComb [3739],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [262],
& yyNComb [161],
& yyNComb [-113],
& yyNComb [3830],
& yyNComb [-113],
& yyNComb [164],
& yyNComb [-113],
& yyNComb [3921],
& yyNComb [-113],
& yyNComb [165],
& yyNComb [-113],
& yyNComb [4012],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [226],
& yyNComb [258],
& yyNComb [166],
& yyNComb [-113],
& yyNComb [4103],
& yyNComb [-113],
& yyNComb [3253],
& yyNComb [2],
& yyNComb [1967],
& yyNComb [-113],
& yyNComb [34],
& yyNComb [4182],
& yyNComb [168],
& yyNComb [-113],
& yyNComb [4293],
& yyNComb [-113],
& yyNComb [4404],
& yyNComb [169],
& yyNComb [-113],
& yyNComb [4515],
& yyNComb [-113],
& yyNComb [170],
& yyNComb [-113],
& yyNComb [4629],
& yyNComb [-113],
& yyNComb [4669],
& yyNComb [172],
& yyNComb [4780],
& yyNComb [180],
& yyNComb [-113],
& yyNComb [4894],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [4985],
& yyNComb [-113],
& yyNComb [164],
& yyNComb [196],
& yyNComb [-113],
& yyNComb [171],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [3610],
& yyNComb [-113],
& yyNComb [4709],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [34],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [205],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [207],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [-113],
& yyNComb [209],
& yyNComb [5076],
};
static	unsigned short	yyDefault	[yyLastReadState + 1] = {
0,
229,
283,
215,
0,
215,
0,
38,
0,
0,
38,
0,
0,
38,
0,
0,
189,
126,
0,
38,
0,
159,
0,
105,
105,
440,
0,
0,
105,
0,
126,
0,
38,
0,
38,
38,
391,
0,
0,
0,
0,
215,
126,
0,
0,
0,
0,
0,
127,
215,
76,
215,
391,
391,
95,
215,
0,
0,
215,
0,
96,
215,
0,
97,
0,
0,
0,
215,
0,
391,
215,
283,
268,
126,
127,
215,
0,
80,
391,
391,
0,
391,
432,
215,
0,
215,
0,
215,
0,
0,
215,
0,
215,
0,
0,
0,
0,
0,
20,
187,
452,
422,
193,
452,
422,
19,
261,
105,
112,
261,
452,
315,
0,
452,
315,
0,
0,
352,
0,
354,
105,
298,
0,
452,
422,
229,
215,
0,
0,
452,
315,
0,
244,
0,
215,
0,
215,
422,
423,
215,
0,
452,
422,
229,
247,
244,
422,
229,
0,
452,
159,
0,
159,
422,
0,
452,
422,
0,
0,
105,
0,
452,
157,
0,
0,
0,
452,
315,
452,
315,
105,
283,
215,
0,
0,
283,
215,
0,
215,
0,
215,
0,
215,
452,
422,
229,
0,
0,
452,
38,
0,
422,
193,
0,
0,
0,
0,
0,
0,
352,
0,
354,
0,
452,
422,
229,
0,
0,
215,
215,
0,
0,
0,
0,
0,
36,
452,
422,
215,
452,
422,
229,
452,
315,
0,
452,
229,
244,
422,
328,
229,
452,
422,
229,
0,
244,
422,
215,
452,
237,
452,
422,
229,
0,
452,
422,
215,
0,
452,
246,
452,
422,
229,
0,
261,
283,
268,
0,
268,
0,
270,
0,
261,
255,
268,
0,
268,
0,
0,
0,
0,
45,
352,
0,
354,
0,
452,
215,
45,
215,
422,
360,
361,
0,
452,
361,
105,
352,
0,
354,
0,
0,
307,
298,
45,
300,
105,
298,
0,
45,
105,
45,
352,
0,
354,
0,
0,
0,
105,
452,
422,
229,
0,
215,
411,
0,
45,
215,
411,
336,
336,
0,
0,
382,
383,
215,
384,
422,
19,
283,
452,
328,
334,
336,
0,
385,
0,
422,
229,
0,
328,
385,
315,
385,
215,
0,
215,
0,
215,
0,
0,
0,
0,
0,
105,
0,
452,
215,
45,
422,
0,
328,
0,
0,
452,
422,
229,
0,
0,
336,
452,
422,
229,
0,
452,
422,
229,
0,
452,
422,
229,
0,
0,
336,
336,
452,
422,
229,
0,
52,
255,
268,
382,
441,
246,
452,
422,
246,
0,
237,
452,
422,
237,
0,
452,
422,
229,
0,
218,
452,
218,
452,
422,
229,
0,
0,
0,
0,
229,
0,
423,
452,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
321,
442,
215,
0,
215,
0,
0,
0,
0,
105,
0,
0,
447,
452,
315,
0,
452,
315,
0,
0,
0,
226,
};
static	unsigned char	yyLength	[yyLastReduceState - yyFirstReduceState + 1] = {
2,
1,
1,
2,
3,
1,
1,
1,
2,
1,
2,
2,
2,
6,
1,
1,
1,
1,
3,
1,
3,
1,
1,
1,
1,
1,
2,
5,
5,
3,
1,
1,
1,
1,
1,
1,
5,
4,
1,
5,
2,
6,
1,
2,
1,
1,
2,
1,
5,
2,
5,
1,
2,
2,
6,
3,
6,
7,
1,
2,
1,
5,
6,
2,
1,
1,
2,
5,
6,
2,
6,
1,
2,
1,
2,
1,
2,
5,
1,
1,
5,
1,
3,
1,
3,
1,
7,
5,
7,
5,
7,
3,
1,
1,
1,
1,
1,
1,
3,
3,
5,
6,
5,
5,
1,
1,
1,
3,
1,
1,
1,
5,
5,
4,
5,
5,
5,
1,
0,
5,
8,
12,
10,
12,
9,
11,
13,
10,
5,
6,
6,
6,
1,
1,
6,
8,
9,
8,
5,
2,
3,
4,
2,
3,
1,
1,
1,
1,
1,
1,
1,
8,
9,
0,
1,
1,
5,
1,
1,
3,
1,
3,
1,
3,
1,
1,
3,
3,
4,
4,
7,
5,
8,
1,
2,
5,
3,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
3,
1,
1,
3,
0,
1,
1,
3,
1,
3,
2,
3,
2,
3,
1,
0,
1,
1,
4,
7,
5,
5,
1,
1,
1,
5,
4,
4,
7,
8,
4,
1,
1,
1,
4,
4,
7,
2,
2,
2,
3,
1,
1,
1,
1,
3,
3,
4,
3,
1,
1,
1,
1,
4,
1,
3,
3,
2,
2,
1,
4,
4,
6,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
3,
3,
1,
1,
1,
1,
1,
4,
4,
4,
4,
4,
1,
1,
8,
3,
1,
1,
1,
1,
3,
3,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
1,
2,
2,
3,
1,
2,
1,
1,
1,
};
static	yySymbolRange	yyLeftHandSide	[yyLastReduceState - yyFirstReduceState + 1] = {
229,
114,
113,
113,
113,
116,
116,
116,
116,
121,
115,
115,
115,
115,
115,
115,
115,
115,
115,
129,
129,
122,
122,
122,
122,
124,
124,
135,
135,
135,
123,
125,
125,
125,
125,
125,
126,
126,
143,
138,
138,
138,
144,
144,
146,
139,
139,
139,
147,
147,
147,
149,
149,
150,
148,
148,
148,
148,
151,
151,
152,
140,
140,
140,
155,
141,
141,
156,
156,
156,
142,
117,
117,
153,
153,
157,
157,
145,
159,
160,
154,
154,
154,
158,
158,
158,
162,
162,
162,
162,
162,
162,
162,
163,
163,
130,
130,
130,
120,
120,
120,
120,
120,
120,
168,
168,
166,
166,
169,
170,
171,
119,
119,
119,
119,
119,
119,
173,
174,
118,
118,
118,
118,
118,
118,
118,
118,
118,
118,
118,
118,
118,
118,
118,
183,
183,
183,
183,
186,
186,
187,
187,
188,
188,
184,
184,
189,
189,
189,
189,
189,
182,
182,
190,
190,
191,
191,
191,
175,
175,
176,
176,
193,
193,
194,
194,
131,
132,
133,
127,
127,
128,
164,
198,
198,
199,
199,
134,
200,
200,
201,
201,
197,
197,
202,
202,
136,
136,
180,
180,
195,
195,
178,
178,
178,
177,
177,
204,
204,
206,
206,
205,
205,
207,
207,
207,
208,
208,
196,
196,
196,
196,
196,
172,
172,
209,
211,
211,
211,
211,
213,
213,
210,
210,
215,
215,
215,
215,
137,
137,
137,
137,
137,
137,
137,
221,
220,
220,
212,
212,
217,
217,
217,
217,
217,
217,
217,
217,
217,
217,
217,
217,
217,
217,
217,
216,
216,
216,
216,
216,
216,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
218,
222,
222,
219,
219,
219,
223,
223,
223,
223,
223,
223,
223,
223,
223,
223,
224,
225,
179,
179,
181,
181,
185,
185,
165,
165,
165,
165,
192,
192,
192,
226,
226,
226,
226,
226,
226,
227,
227,
167,
228,
228,
214,
214,
161,
203,
203,
};
static	yySymbolRange	yyContinuation	[yyLastReadState + 1] = {
0,
84,
1,
28,
1,
28,
1,
47,
28,
1,
47,
28,
1,
47,
28,
1,
47,
34,
1,
86,
66,
2,
66,
86,
86,
1,
33,
34,
86,
28,
2,
1,
47,
28,
47,
47,
2,
1,
47,
28,
27,
47,
34,
27,
39,
31,
2,
28,
34,
2,
34,
2,
2,
2,
1,
2,
34,
1,
2,
34,
33,
2,
34,
1,
39,
28,
1,
2,
34,
2,
2,
3,
2,
2,
34,
2,
34,
1,
2,
2,
1,
2,
53,
2,
34,
2,
34,
2,
34,
12,
2,
53,
2,
34,
29,
29,
33,
29,
66,
2,
3,
10,
100,
3,
11,
86,
2,
11,
29,
2,
3,
11,
29,
3,
11,
11,
29,
2,
27,
28,
86,
1,
28,
3,
10,
84,
2,
34,
8,
3,
0,
68,
3,
16,
2,
53,
2,
0,
69,
2,
2,
3,
10,
84,
68,
3,
0,
84,
2,
61,
86,
29,
86,
10,
49,
3,
11,
2,
3,
86,
3,
3,
11,
11,
29,
29,
3,
0,
3,
0,
2,
61,
2,
29,
2,
61,
2,
29,
2,
29,
2,
29,
2,
3,
10,
84,
99,
2,
61,
47,
29,
10,
100,
100,
11,
29,
11,
29,
73,
2,
27,
28,
28,
3,
10,
84,
2,
106,
2,
2,
29,
29,
112,
29,
29,
2,
3,
10,
2,
3,
10,
84,
3,
0,
11,
3,
84,
3,
0,
84,
11,
3,
10,
84,
11,
3,
0,
56,
3,
56,
3,
10,
84,
11,
3,
0,
41,
41,
3,
41,
3,
10,
84,
11,
2,
1,
2,
29,
2,
29,
29,
2,
2,
1,
2,
29,
2,
29,
2,
29,
29,
55,
2,
27,
28,
28,
61,
2,
29,
2,
10,
2,
91,
61,
3,
91,
73,
2,
27,
28,
28,
29,
3,
1,
28,
86,
86,
1,
1,
28,
86,
55,
2,
27,
28,
28,
29,
3,
86,
3,
10,
84,
79,
2,
3,
11,
26,
2,
3,
2,
2,
53,
1,
1,
2,
2,
3,
0,
2,
3,
3,
2,
3,
2,
3,
3,
2,
10,
84,
11,
11,
3,
0,
3,
2,
3,
2,
3,
2,
11,
29,
55,
2,
27,
28,
28,
61,
2,
29,
10,
2,
91,
11,
29,
3,
10,
84,
11,
32,
2,
3,
10,
84,
11,
3,
10,
84,
11,
3,
10,
84,
11,
35,
49,
3,
3,
10,
84,
11,
2,
3,
2,
35,
1,
11,
3,
10,
41,
11,
11,
3,
10,
56,
11,
3,
10,
84,
11,
11,
3,
2,
3,
10,
84,
11,
11,
29,
11,
11,
11,
11,
3,
10,
69,
11,
11,
29,
28,
28,
1,
39,
28,
12,
12,
2,
53,
2,
34,
28,
28,
28,
86,
54,
28,
28,
3,
0,
28,
3,
0,
8,
0,
3,
0,
};
static	unsigned short	yyFinalToProd	[yyLastReadNontermState - yyFirstReadTermState + 1] = {
1042,
1043,
1044,
1045,
1046,
1047,
1048,
1049,
1050,
1023,
1024,
1025,
896,
889,
1038,
976,
990,
987,
967,
1052,
989,
1027,
991,
988,
992,
1026,
1058,
1057,
985,
941,
949,
950,
953,
958,
840,
948,
993,
994,
995,
996,
997,
998,
999,
1000,
1001,
1002,
1005,
1006,
1007,
1012,
1013,
1003,
1004,
1009,
1014,
1010,
1008,
1011,
1053,
943,
944,
942,
951,
845,
876,
877,
803,
804,
836,
837,
870,
869,
849,
939,
796,
741,
792,
776,
851,
853,
852,
770,
860,
841,
842,
861,
862,
863,
878,
882,
879,
880,
881,
866,
868,
867,
833,
832,
835,
834,
760,
771,
782,
812,
819,
843,
846,
830,
844,
847,
848,
831,
856,
1028,
886,
937,
1029,
1030,
940,
907,
902,
855,
859,
858,
821,
822,
818,
820,
904,
799,
800,
793,
794,
773,
745,
759,
857,
802,
780,
789,
786,
788,
854,
978,
979,
952,
959,
984,
983,
957,
971,
970,
740,
1040,
1041,
1032,
1033,
1037,
1039,
1051,
1055,
1054,
887,
897,
888,
1036,
981,
980,
919,
947,
973,
982,
960,
918,
963,
975,
968,
965,
969,
946,
874,
875,
934,
810,
811,
809,
891,
890,
893,
892,
1035,
1034,
751,
829,
828,
827,
746,
747,
748,
749,
752,
753,
754,
755,
756,
763,
764,
765,
766,
767,
774,
775,
777,
779,
1056,
813,
814,
798,
825,
797,
839,
838,
920,
921,
1031,
864,
865,
883,
933,
928,
936,
935,
930,
932,
924,
925,
884,
926,
900,
915,
908,
914,
906,
905,
913,
911,
910,
817,
816,
823,
826,
815,
824,
1017,
1015,
808,
807,
806,
805,
761,
758,
757,
762,
783,
784,
785,
778,
790,
791,
1016,
962,
961,
733,
734,
736,
737,
738,
739,
};

static	void	yyErrorRecovery		ARGS((yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeContinuation	ARGS((yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet));
static	bool	yyIsContinuation	ARGS((yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr));
static	void	yyComputeRestartPoints	ARGS((yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet));
static	yyStateRange yyNext		ARGS((yyStateRange yyState, yySymbolRange yySymbol));
static	void	BeginParser		();

int Parser ()
   {
      register	yyStateRange	yyState		;
      register	long		yyTerminal	;
      register	yyStateRange *	yyStateStackPtr ;
      register	tParsAttribute *yyAttrStackPtr	;
      register	bool		yyIsRepairing	;
		unsigned long	yyStateStackSize= yyInitStackSize;
		unsigned long	yyAttrStackSize = yyInitStackSize;
		yyStateRange *	yyStateStack	;
		tParsAttribute* yyAttributeStack;
		tParsAttribute	yySynAttribute	;	/* synthesized attribute */
      register	yyStateRange *	yyEndOfStack	;
		int		yyErrorCount	= 0;
   


      BeginParser ();
      yyState		= yyStartState;
      yyTerminal	= GetToken ();

#ifdef YYDEBUG
if (yydebug)  /* SMW */
{
           printf("Reading a token: Next token is %d (%s)\n",yyTerminal,Parser_TokenName[yyTerminal]);
}
#endif

      MakeArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
      MakeArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
      yyEndOfStack	= & yyStateStack [yyStateStackSize];
      yyStateStackPtr	= yyStateStack;
      yyAttrStackPtr	= yyAttributeStack;
      yyIsRepairing	= false;

   ParseLoop:
      for (;;) {
	 if (yyStateStackPtr >= yyEndOfStack) {
	    int yyyStateStackPtr= yyStateStackPtr - yyStateStack;
	    int yyyAttrStackPtr	= yyAttrStackPtr - yyAttributeStack;
	    ExtendArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
	    ExtendArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
	    yyStateStackPtr	= yyStateStack + yyyStateStackPtr;
	    yyAttrStackPtr	= yyAttributeStack + yyyAttrStackPtr;
	    yyEndOfStack	= & yyStateStack [yyStateStackSize];
	 }
	 * yyStateStackPtr = yyState;

#ifdef YYDEBUG
  if (yydebug)      /* SMW */
  {
    yyStateRange *yys = yyStateStack;
    printf("state stack now");
    while(yys <= yyStateStackPtr) printf(" %d",*yys++);
    printf("\n");
  }
#endif

   TermTrans:
	 for (;;) {	/* SPEC State = Next (State, Terminal); terminal transition */
	    register short * yyTCombPtr;

	    yyTCombPtr = (short *) (yyTBasePtr [yyState] + yyTerminal);
	    if (* yyTCombPtr ++ == yyState) { yyState = * yyTCombPtr; break; }
	    if ((yyState = yyDefault [yyState]) != yyNoState) goto TermTrans;

							/* syntax error */
	    if (! yyIsRepairing) {			/* report and recover */
	       yySymbolRange yyyTerminal = yyTerminal;

	       yyErrorCount ++;
	       yyErrorRecovery (& yyyTerminal, yyStateStack, yyStateStackSize, yyStateStackPtr - yyStateStack);
	       yyTerminal = yyyTerminal;
	       yyIsRepairing = true;
	    }
	    yyState = * yyStateStackPtr;
	    for (;;) {
	       if (yyNext (yyState, (yySymbolRange) yyTerminal) == yyNoState) { /* repair */
		  yySymbolRange		yyRepairToken;
		  tScanAttribute	yyRepairAttribute;
	    
		  yyRepairToken = yyContinuation [yyState];
		  yyState = yyNext (yyState, yyRepairToken);
		  if (yyState <= yyLastReadTermState) { /* read or read terminal reduce ? */
		     ErrorAttribute ((int) yyRepairToken, & yyRepairAttribute);
		     ErrorMessageI (xxTokenInserted, xxRepair, Attribute.Position,
			xxString, Parser_TokenName [yyRepairToken]);
		     if (yyState >= yyFirstFinalState) {	/* avoid second push */
			yyState = yyFinalToProd [yyState - yyFirstReadTermState];
		     }
		     yyGetAttribute (yyAttrStackPtr ++, yyRepairAttribute);
		     * ++ yyStateStackPtr = yyState;
		  }
		  if (yyState >= yyFirstFinalState) goto Final; /* final state ? */
	       } else {
		  yyState = yyNext (yyState, (yySymbolRange) yyTerminal);
		  goto Final;
	       }
	    }
	 }

   Final:
	 if (yyState >= yyFirstFinalState) {		/* final state ? */
	    if (yyState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStateStackPtr ++;
	       yyGetAttribute (yyAttrStackPtr ++, Attribute);
	       yyTerminal = GetToken ();

#ifdef YYDEBUG
if (yydebug)        /* SMW */
{
  printf("Reading a token: Next token is %d (%s)\n",yyTerminal,Parser_TokenName[yyTerminal]);
}
#endif

	       yyIsRepairing = false;
	    }

	    for (;;) {
	       /* register long yyNonterminal;		/* left-hand side */
# define yyNonterminal yyState

switch (yyState) {
case 732: /* _0000_ : __START__ _EndOfFile .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 0), ");  printf("__START__ _EndOfFile  -> _0000_ \n");
}
#endif
  ReleaseArray ((char * *) & yyStateStack, & yyStateStackSize, sizeof (yyStateRange));
  ReleaseArray ((char * *) & yyAttributeStack, & yyAttrStackSize, sizeof (tParsAttribute));
  return yyErrorCount;

case 733:
case 726: /* __START__ : program .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 156), ");  printf("program  -> __START__ \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 114; {
/* line 156 "/tmp/lalr6706" */
/* line 169 "occam.lalr" */
 TreeRoot = mStart(yyAttrStackPtr [1-1].Tree); 
} break;
case 734:
case 727: /* program : proc .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 160), ");  printf("proc  -> program \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 113; {
/* line 160 "/tmp/lalr6706" */
/* line 172 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 735: /* program : outerspec sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 161), ");  printf("outerspec sep  -> program \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 113; {
/* line 161 "/tmp/lalr6706" */
/* line 173 "occam.lalr" */
 yySynAttribute.Tree = mNullProcess(Posn(yyAttrStackPtr [1-1]),mNoSpec()); InsertASpec(yySynAttribute.Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 736:
case 728: /* program : outerspec sep program .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 163), ");  printf("outerspec sep program  -> program \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 113; {
/* line 163 "/tmp/lalr6706" */
/* line 174 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 737:
case 729: /* outerspec : definition .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 166), ");  printf("definition  -> outerspec \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 116; {
/* line 166 "/tmp/lalr6706" */
/* line 177 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 738:
case 730: /* outerspec : abbreviation .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 169), ");  printf("abbreviation  -> outerspec \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 116; {
/* line 169 "/tmp/lalr6706" */
/* line 178 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 739:
case 731: /* outerspec : declaration .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 171), ");  printf("declaration  -> outerspec \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 116; {
/* line 171 "/tmp/lalr6706" */
/* line 179 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; Message("Not allowed at outermost level of compilation unit",xxError,Posn(yyAttrStackPtr [1-1]));
} break;
case 740:
case 606: /* outerspec : HASHH CSTR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 172), ");  printf("HASHH CSTR  -> outerspec \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 116; {
/* line 172 "/tmp/lalr6706" */
/* line 180 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mHCode(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [2-1]).String,CurrentScope()); 
} break;
case 741:
case 529: /* case : CASE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 175), ");  printf("CASE  -> case \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 121; {
/* line 175 "/tmp/lalr6706" */
/* line 183 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 742: /* proc : action sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 178), ");  printf("action sep  -> proc \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 115; {
/* line 178 "/tmp/lalr6706" */
/* line 185 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 743: /* proc : SKIP sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 180), ");  printf("SKIP sep  -> proc \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 115; {
/* line 180 "/tmp/lalr6706" */
/* line 186 "occam.lalr" */
 yySynAttribute.Tree = mSkip(Posn(yyAttrStackPtr [1-1]),mNoSpec()); 
} break;
case 744: /* proc : STOP sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 182), ");  printf("STOP sep  -> proc \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 115; {
/* line 182 "/tmp/lalr6706" */
/* line 187 "occam.lalr" */
 yySynAttribute.Tree = mStop(Posn(yyAttrStackPtr [1-1]),mNoSpec()); 
} break;
case 745:
case 588: /* proc : case selector sep BEGIN selectlist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 184), ");  printf("case selector sep BEGIN selectlist END  -> proc \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 115; {
/* line 184 "/tmp/lalr6706" */
/* line 188 "occam.lalr" */
 yySynAttribute.Tree = mCase(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,ReverseTree(yyAttrStackPtr [5-1].Tree)); CloseScope();
} break;
case 746:
case 650: /* proc : construct .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 186), ");  printf("construct  -> proc \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 115; {
/* line 186 "/tmp/lalr6706" */
/* line 189 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 747:
case 651: /* proc : instance .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 188), ");  printf("instance  -> proc \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 115; {
/* line 188 "/tmp/lalr6706" */
/* line 190 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 748:
case 652: /* proc : caseinput .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 190), ");  printf("caseinput  -> proc \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 115; {
/* line 190 "/tmp/lalr6706" */
/* line 191 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 749:
case 653: /* proc : casesingle .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 192), ");  printf("casesingle  -> proc \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 115; {
/* line 192 "/tmp/lalr6706" */
/* line 192 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 750: /* proc : HASHC CSTR sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 194), ");  printf("HASHC CSTR sep  -> proc \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 115; {
/* line 194 "/tmp/lalr6706" */
/* line 193 "occam.lalr" */
 yySynAttribute.Tree = mCCode(Posn(yyAttrStackPtr [1-1]),mNoSpec(),Val(yyAttrStackPtr [2-1]).String,CurrentScope()); 
} break;
case 751:
case 646: /* process : proc .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 197), ");  printf("proc  -> process \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 129; {
/* line 197 "/tmp/lalr6706" */
/* line 196 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 752:
case 654: /* process : specification sep process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 199), ");  printf("specification sep process  -> process \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 129; {
/* line 199 "/tmp/lalr6706" */
/* line 197 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Process.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 753:
case 655: /* action : assignment .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 202), ");  printf("assignment  -> action \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 202 "/tmp/lalr6706" */
/* line 200 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 754:
case 656: /* action : input .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 204), ");  printf("input  -> action \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 204 "/tmp/lalr6706" */
/* line 201 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 755:
case 657: /* action : after .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 206), ");  printf("after  -> action \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 206 "/tmp/lalr6706" */
/* line 202 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 756:
case 658: /* action : output .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 208), ");  printf("output  -> action \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 122; {
/* line 208 "/tmp/lalr6706" */
/* line 203 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 757:
case 715: /* selectlist : select .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 211), ");  printf("select  -> selectlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 124; {
/* line 211 "/tmp/lalr6706" */
/* line 206 "occam.lalr" */
  yyAttrStackPtr [1-1].Tree->AChoice.Next= mNoChoice(); CloseScope(); OpenScope(); 
} break;
case 758:
case 714: /* selectlist : selectlist select .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 213), ");  printf("selectlist select  -> selectlist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 124; {
/* line 213 "/tmp/lalr6706" */
/* line 207 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yyAttrStackPtr [2-1].Tree->AChoice.Next= yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 759:
case 589: /* select : explist sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 216), ");  printf("explist sep BEGIN process END  -> select \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 135; {
/* line 216 "/tmp/lalr6706" */
/* line 211 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree); 
} break;
case 760:
case 554: /* select : ELSE sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 218), ");  printf("ELSE sep BEGIN process END  -> select \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 135; {
/* line 218 "/tmp/lalr6706" */
/* line 212 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,mAnExpr(mNoExpr(),mDefault(Posn(yyAttrStackPtr [1-1]))),yyAttrStackPtr [4-1].Tree); 
} break;
case 761:
case 713: /* select : specification sep select .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 220), ");  printf("specification sep select  -> select \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 135; {
/* line 220 "/tmp/lalr6706" */
/* line 213 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AChoice.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 762:
case 716: /* selector : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 223), ");  printf("expr  -> selector \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 123; {
/* line 223 "/tmp/lalr6706" */
/* line 216 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 763:
case 659: /* construct : sequence .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 226), ");  printf("sequence  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 125; {
/* line 226 "/tmp/lalr6706" */
/* line 220 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 764:
case 660: /* construct : parallel .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 228), ");  printf("parallel  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 125; {
/* line 228 "/tmp/lalr6706" */
/* line 221 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 765:
case 661: /* construct : conditional .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 230), ");  printf("conditional  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 125; {
/* line 230 "/tmp/lalr6706" */
/* line 222 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 766:
case 662: /* construct : alternation .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 232), ");  printf("alternation  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 125; {
/* line 232 "/tmp/lalr6706" */
/* line 223 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 767:
case 663: /* construct : loop .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 234), ");  printf("loop  -> construct \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 125; {
/* line 234 "/tmp/lalr6706" */
/* line 224 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 768: /* instance : ID LP explist RP sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 237), ");  printf("ID LP explist RP sep  -> instance \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 126; {
/* line 237 "/tmp/lalr6706" */
/* line 228 "occam.lalr" */
 yySynAttribute.Tree = CreateProcCall(Posn(yyAttrStackPtr [1-1]),mNoSpec(), LookupSymbol(yyAttrStackPtr [1-1].Scan),ReverseTree(yyAttrStackPtr [3-1].Tree),CurrentScope()); 
} break;
case 769: /* instance : ID LP RP sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 239), ");  printf("ID LP RP sep  -> instance \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 126; {
/* line 239 "/tmp/lalr6706" */
/* line 229 "occam.lalr" */
 yySynAttribute.Tree = CreateProcCall(Posn(yyAttrStackPtr [1-1]),mNoSpec(), LookupSymbol(yyAttrStackPtr [1-1].Scan),mNoExpr(),CurrentScope()); 
} break;
case 770:
case 535: /* seq : SEQ .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 242), ");  printf("SEQ  -> seq \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 143; {
/* line 242 "/tmp/lalr6706" */
/* line 232 "occam.lalr" */
 OpenScope(); yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 771:
case 555: /* sequence : seq sep BEGIN proclist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 245), ");  printf("seq sep BEGIN proclist END  -> sequence \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 138; {
/* line 245 "/tmp/lalr6706" */
/* line 235 "occam.lalr" */
 yySynAttribute.Tree = mSeq(Posn(yyAttrStackPtr [1-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 772: /* sequence : seq sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 247), ");  printf("seq sep  -> sequence \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 138; {
/* line 247 "/tmp/lalr6706" */
/* line 236 "occam.lalr" */
 yySynAttribute.Tree = mSeq(Posn(yyAttrStackPtr [1-1]),mNoSpec(),mNoProcess()); CloseScope(); 
} break;
case 773:
case 587: /* sequence : seq replic sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 249), ");  printf("seq replic sep BEGIN process END  -> sequence \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 138; {
/* line 249 "/tmp/lalr6706" */
/* line 237 "occam.lalr" */
 yySynAttribute.Tree = mSeqRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); CloseScope(); 
} break;
case 774:
case 664: /* proclist : process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 252), ");  printf("process  -> proclist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 144; {
/* line 252 "/tmp/lalr6706" */
/* line 240 "occam.lalr" */
 yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,NoSymbol); CloseScope(); OpenScope(); 
} break;
case 775:
case 665: /* proclist : proclist process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 254), ");  printf("proclist process  -> proclist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 144; {
/* line 254 "/tmp/lalr6706" */
/* line 241 "occam.lalr" */
 yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,NoSymbol); CloseScope(); OpenScope(); 
} break;
case 776:
case 531: /* par : PAR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 257), ");  printf("PAR  -> par \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 146; {
/* line 257 "/tmp/lalr6706" */
/* line 244 "occam.lalr" */
 OpenScope(); OpenScope(); yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 777:
case 666: /* parallel : partype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 260), ");  printf("partype  -> parallel \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 139; {
/* line 260 "/tmp/lalr6706" */
/* line 247 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 778:
case 720: /* parallel : PRI partype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 262), ");  printf("PRI partype  -> parallel \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 139; {
/* line 262 "/tmp/lalr6706" */
/* line 248 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [2-1]; ParType(yySynAttribute.Tree) = xxPriPar; 
} break;
case 779:
case 667: /* parallel : placedpar .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 264), ");  printf("placedpar  -> parallel \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 139; {
/* line 264 "/tmp/lalr6706" */
/* line 249 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 780:
case 592: /* partype : par sep BEGIN parproclist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 267), ");  printf("par sep BEGIN parproclist END  -> partype \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 147; {
/* line 267 "/tmp/lalr6706" */
/* line 252 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); CloseScope(); 
} break;
case 781: /* partype : par sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 269), ");  printf("par sep  -> partype \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 147; {
/* line 269 "/tmp/lalr6706" */
/* line 253 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,mNoProcess()); CloseScope(); CloseScope(); 
} break;
case 782:
case 556: /* partype : parrep sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 271), ");  printf("parrep sep BEGIN process END  -> partype \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 147; {
/* line 271 "/tmp/lalr6706" */
/* line 254 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mParRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPar,yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); CloseScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 783:
case 717: /* parproclist : process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 274), ");  printf("process  -> parproclist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 149; {
/* line 274 "/tmp/lalr6706" */
/* line 257 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 784:
case 718: /* parproclist : parproclist process .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 276), ");  printf("parproclist process  -> parproclist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 149; {
/* line 276 "/tmp/lalr6706" */
/* line 258 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 785:
case 719: /* parrep : par replic .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 279), ");  printf("par replic  -> parrep \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 150; {
/* line 279 "/tmp/lalr6706" */
/* line 261 "occam.lalr" */
 OpenScope(); S=AddSymbol(NoIdent); yySynAttribute.Tree=yyAttrStackPtr [2-1].Tree; yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; 
} break;
case 786:
case 594: /* placedpar : PLACED par sep BEGIN placedlist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 282), ");  printf("PLACED par sep BEGIN placedlist END  -> placedpar \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 148; {
/* line 282 "/tmp/lalr6706" */
/* line 265 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,ReverseTree(yyAttrStackPtr [5-1].Tree)); CloseScope(); CloseScope(); 
} break;
case 787: /* placedpar : PLACED par sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 284), ");  printf("PLACED par sep  -> placedpar \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 148; {
/* line 284 "/tmp/lalr6706" */
/* line 266 "occam.lalr" */
 yySynAttribute.Tree = mPar(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,mNoProcess()); CloseScope(); CloseScope(); 
} break;
case 788:
case 595: /* placedpar : PLACED parrep sep BEGIN placedpar END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 286), ");  printf("PLACED parrep sep BEGIN placedpar END  -> placedpar \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 148; {
/* line 286 "/tmp/lalr6706" */
/* line 267 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mParRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),xxPlacedPar,yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); CloseScope(); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 789:
case 593: /* placedpar : PROCESSOR expr ID sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 288), ");  printf("PROCESSOR expr ID sep BEGIN process END  -> placedpar \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 148; {
/* line 288 "/tmp/lalr6706" */
/* line 268 "occam.lalr" */
 yySynAttribute.Tree = mProcessor(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,Val(yyAttrStackPtr [3-1]).Ident,yyAttrStackPtr [6-1].Tree); 
} break;
case 790:
case 721: /* placedlist : placedpar .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 291), ");  printf("placedpar  -> placedlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 151; {
/* line 291 "/tmp/lalr6706" */
/* line 271 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(mNoProcess(),yyAttrStackPtr [1-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 791:
case 722: /* placedlist : placedlist placedpar .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 293), ");  printf("placedlist placedpar  -> placedlist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 151; {
/* line 293 "/tmp/lalr6706" */
/* line 272 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mAProcess(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree,S=AddSymbol(NoIdent)); CloseScope(); OpenScope(); OpenScope();  SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 792:
case 530: /* if : IF .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 296), ");  printf("IF  -> if \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 152; {
/* line 296 "/tmp/lalr6706" */
/* line 275 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 793:
case 585: /* conditional : if sep BEGIN choicelist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 299), ");  printf("if sep BEGIN choicelist END  -> conditional \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 140; {
/* line 299 "/tmp/lalr6706" */
/* line 277 "occam.lalr" */
 yySynAttribute.Tree = mIf(Posn(yyAttrStackPtr [1-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 794:
case 586: /* conditional : if replic sep BEGIN choice END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 301), ");  printf("if replic sep BEGIN choice END  -> conditional \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 140; {
/* line 301 "/tmp/lalr6706" */
/* line 278 "occam.lalr" */
 yySynAttribute.Tree = mIfRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [5-1].Tree->AChoice.Next=mNoChoice(); CloseScope(); 
} break;
case 795: /* conditional : if sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 303), ");  printf("if sep  -> conditional \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 140; {
/* line 303 "/tmp/lalr6706" */
/* line 279 "occam.lalr" */
 yySynAttribute.Tree = mIf(Posn(yyAttrStackPtr [1-1]),mNoSpec(),mNoChoice()); CloseScope(); 
} break;
case 796:
case 528: /* alt : ALT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 306), ");  printf("ALT  -> alt \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 155; {
/* line 306 "/tmp/lalr6706" */
/* line 282 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 797:
case 673: /* alternation : alttype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 309), ");  printf("alttype  -> alternation \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 141; {
/* line 309 "/tmp/lalr6706" */
/* line 285 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 798:
case 671: /* alternation : PRI alttype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 311), ");  printf("PRI alttype  -> alternation \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 141; {
/* line 311 "/tmp/lalr6706" */
/* line 286 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [2-1]; AltIsPri(yySynAttribute.Tree) = true; 
} break;
case 799:
case 583: /* alttype : alt sep BEGIN alternativelist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 314), ");  printf("alt sep BEGIN alternativelist END  -> alttype \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 156; {
/* line 314 "/tmp/lalr6706" */
/* line 289 "occam.lalr" */
 yySynAttribute.Tree = mAlt(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,ReverseTree(yyAttrStackPtr [4-1].Tree)); CloseScope(); 
} break;
case 800:
case 584: /* alttype : alt replic sep BEGIN alternative END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 316), ");  printf("alt replic sep BEGIN alternative END  -> alttype \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 156; {
/* line 316 "/tmp/lalr6706" */
/* line 290 "occam.lalr" */
 yySynAttribute.Tree = mAltRep(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [5-1].Tree->AnAlts.Next = mNoAlt(); CloseScope(); 
} break;
case 801: /* alttype : alt sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 318), ");  printf("alt sep  -> alttype \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 156; {
/* line 318 "/tmp/lalr6706" */
/* line 291 "occam.lalr" */
 yySynAttribute.Tree = mAlt(Posn(yyAttrStackPtr [1-1]),mNoSpec(),false,mNoAlt()); CloseScope(); 
} break;
case 802:
case 591: /* loop : WHILE expr sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 321), ");  printf("WHILE expr sep BEGIN process END  -> loop \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 142; {
/* line 321 "/tmp/lalr6706" */
/* line 295 "occam.lalr" */
 yySynAttribute.Tree = mWhile(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [5-1].Tree); 
} break;
case 803:
case 520: /* sep : EOL .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 324), ");  printf("EOL  -> sep \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 117; {
/* line 324 "/tmp/lalr6706" */
/* line 299 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 804:
case 521: /* sep : sep EOL .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 326), ");  printf("sep EOL  -> sep \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 117; {
/* line 326 "/tmp/lalr6706" */
/* line 300 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 805:
case 712: /* choicelist : choice .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 329), ");  printf("choice  -> choicelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 153; {
/* line 329 "/tmp/lalr6706" */
/* line 303 "occam.lalr" */
 yySynAttribute.Tree->AChoices.Next = mNoChoice(); CloseScope(); OpenScope();
} break;
case 806:
case 711: /* choicelist : choicelist choice .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 331), ");  printf("choicelist choice  -> choicelist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 153; {
/* line 331 "/tmp/lalr6706" */
/* line 304 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->AChoices.Next=yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 807:
case 710: /* alternativelist : alternative .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 334), ");  printf("alternative  -> alternativelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 157; {
/* line 334 "/tmp/lalr6706" */
/* line 308 "occam.lalr" */
  yySynAttribute.Tree->AnAlts.Next = mNoAlt() ; CloseScope(); OpenScope(); 
} break;
case 808:
case 709: /* alternativelist : alternativelist alternative .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 336), ");  printf("alternativelist alternative  -> alternativelist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 157; {
/* line 336 "/tmp/lalr6706" */
/* line 309 "occam.lalr" */
 yySynAttribute.Scan =yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->AnAlts.Next = yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 809:
case 639: /* replic : ID EQ base FOR count .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 339), ");  printf("ID EQ base FOR count  -> replic \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 145; {
/* line 339 "/tmp/lalr6706" */
/* line 312 "occam.lalr" */
  yySynAttribute.Tree = mReplicator(S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mInt(); 
} break;
case 810:
case 637: /* base : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 342), ");  printf("expr  -> base \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 159; {
/* line 342 "/tmp/lalr6706" */
/* line 315 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 811:
case 638: /* count : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 345), ");  printf("expr  -> count \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 160; {
/* line 345 "/tmp/lalr6706" */
/* line 318 "occam.lalr" */
yySynAttribute=yyAttrStackPtr [1-1];
} break;
case 812:
case 557: /* choice : boolean sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 348), ");  printf("boolean sep BEGIN process END  -> choice \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 154; {
/* line 348 "/tmp/lalr6706" */
/* line 321 "occam.lalr" */
 yySynAttribute.Tree = mAChoice(mNoSpec(),NoTree,mAnExpr(mNoExpr(),yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree);
} break;
case 813:
case 669: /* choice : conditional .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 350), ");  printf("conditional  -> choice \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 154; {
/* line 350 "/tmp/lalr6706" */
/* line 322 "occam.lalr" */
 yySynAttribute.Tree = mANewIf(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree);
} break;
case 814:
case 670: /* choice : specification sep choice .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 352), ");  printf("specification sep choice  -> choice \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 154; {
/* line 352 "/tmp/lalr6706" */
/* line 323 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AChoice.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 815:
case 705: /* alternative : guard .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 355), ");  printf("guard  -> alternative \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 158; {
/* line 355 "/tmp/lalr6706" */
/* line 327 "occam.lalr" */
 yySynAttribute.Tree = mAnAlt(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree); 
} break;
case 816:
case 702: /* alternative : specification sep alternative .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 357), ");  printf("specification sep alternative  -> alternative \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 158; {
/* line 357 "/tmp/lalr6706" */
/* line 328 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->AnAlt.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 817:
case 701: /* alternative : alternation .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 359), ");  printf("alternation  -> alternative \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 158; {
/* line 359 "/tmp/lalr6706" */
/* line 329 "occam.lalr" */
 yySynAttribute.Tree = mANewAlt(mNoSpec(),NoTree,yyAttrStackPtr [1-1].Tree); 
} break;
case 818:
case 580: /* guard : boolean AMPERSAND input sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 362), ");  printf("boolean AMPERSAND input sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 162; {
/* line 362 "/tmp/lalr6706" */
/* line 332 "occam.lalr" */
 yySynAttribute.Tree = mAltInput(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 819:
case 558: /* guard : input sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 364), ");  printf("input sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 162; {
/* line 364 "/tmp/lalr6706" */
/* line 333 "occam.lalr" */
 yySynAttribute.Tree = mAltInput(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree);
} break;
case 820:
case 581: /* guard : boolean AMPERSAND after sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 366), ");  printf("boolean AMPERSAND after sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 162; {
/* line 366 "/tmp/lalr6706" */
/* line 334 "occam.lalr" */
 yySynAttribute.Tree = mAltTimer(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 821:
case 578: /* guard : after sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 368), ");  printf("after sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 162; {
/* line 368 "/tmp/lalr6706" */
/* line 335 "occam.lalr" */
 yySynAttribute.Tree = mAltTimer(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree);
} break;
case 822:
case 579: /* guard : boolean AMPERSAND SKIP sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 370), ");  printf("boolean AMPERSAND SKIP sep BEGIN process END  -> guard \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 162; {
/* line 370 "/tmp/lalr6706" */
/* line 336 "occam.lalr" */
 yySynAttribute.Tree = mNoInput(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [6-1].Tree);
} break;
case 823:
case 703: /* guard : boolean AMPERSAND caseguard .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 372), ");  printf("boolean AMPERSAND caseguard  -> guard \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 162; {
/* line 372 "/tmp/lalr6706" */
/* line 337 "occam.lalr" */
 yySynAttribute.Tree = mAltCaseIn(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree);
} break;
case 824:
case 706: /* guard : caseguard .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 374), ");  printf("caseguard  -> guard \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 162; {
/* line 374 "/tmp/lalr6706" */
/* line 338 "occam.lalr" */
 yySynAttribute.Tree = mAltCaseIn(Posn(yyAttrStackPtr [1-1]),mConst(Posn(yyAttrStackPtr [1-1]),Vtrue,mBool()),yyAttrStackPtr [1-1].Tree);
} break;
case 825:
case 672: /* caseguard : caseinput .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 377), ");  printf("caseinput  -> caseguard \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 163; {
/* line 377 "/tmp/lalr6706" */
/* line 341 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 826:
case 704: /* caseguard : casesingleproc .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 379), ");  printf("casesingleproc  -> caseguard \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 163; {
/* line 379 "/tmp/lalr6706" */
/* line 342 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 827:
case 649: /* specification : declaration .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 382), ");  printf("declaration  -> specification \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 130; {
/* line 382 "/tmp/lalr6706" */
/* line 345 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 828:
case 648: /* specification : abbreviation .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 384), ");  printf("abbreviation  -> specification \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 130; {
/* line 384 "/tmp/lalr6706" */
/* line 346 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 829:
case 647: /* specification : definition .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 386), ");  printf("definition  -> specification \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 130; {
/* line 386 "/tmp/lalr6706" */
/* line 347 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1];
} break;
case 830:
case 561: /* declaration : primtype namelist COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 389), ");  printf("primtype namelist COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 120; {
/* line 389 "/tmp/lalr6706" */
/* line 350 "occam.lalr" */
 yySynAttribute.Tree = mDecl(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,T=ReverseTree(yyAttrStackPtr [2-1].Tree)); TypeDecl(yyAttrStackPtr [1-1].Tree,T); 
} break;
case 831:
case 565: /* declaration : arrtype namelist COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 391), ");  printf("arrtype namelist COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 120; {
/* line 391 "/tmp/lalr6706" */
/* line 351 "occam.lalr" */
 yySynAttribute.Tree = mDecl(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,T=ReverseTree(yyAttrStackPtr [2-1].Tree)); TypeDecl(yyAttrStackPtr [1-1].Tree,T); 
} break;
case 832:
case 551: /* declaration : PLACE ID AT expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 394), ");  printf("PLACE ID AT expr COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 120; {
/* line 394 "/tmp/lalr6706" */
/* line 352 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Variable placement not allowed",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 833:
case 550: /* declaration : PLACE ID AT WORKSPACE expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 396), ");  printf("PLACE ID AT WORKSPACE expr COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 120; {
/* line 396 "/tmp/lalr6706" */
/* line 353 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 834:
case 553: /* declaration : PLACE ID IN VECSPACE COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 398), ");  printf("PLACE ID IN VECSPACE COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 120; {
/* line 398 "/tmp/lalr6706" */
/* line 354 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 835:
case 552: /* declaration : PLACE ID IN WORKSPACE COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 400), ");  printf("PLACE ID IN WORKSPACE COLON  -> declaration \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 120; {
/* line 400 "/tmp/lalr6706" */
/* line 355 "occam.lalr" */
 yySynAttribute.Tree = mNullSpec(Posn(yyAttrStackPtr [1-1])); Message("Ignored variable placement",xxWarning,Posn(yyAttrStackPtr [1-1])); 
} break;
case 836:
case 522: /* name : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 402), ");  printf("ID  -> name \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 168; {
/* line 402 "/tmp/lalr6706" */
/* line 358 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 837:
case 523: /* name : TYPEID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 404), ");  printf("TYPEID  -> name \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 168; {
/* line 404 "/tmp/lalr6706" */
/* line 359 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 838:
case 675: /* namelist : name .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 407), ");  printf("name  -> namelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 166; {
/* line 407 "/tmp/lalr6706" */
/* line 362 "occam.lalr" */
 if (last_type_was_chan) S=AddChanSymbol(Val(yyAttrStackPtr [1-1]).Ident); else S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident); yySynAttribute.Tree = mAnId(mNoId(),S); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 839:
case 674: /* namelist : namelist DECLCOMMA name .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 409), ");  printf("namelist DECLCOMMA name  -> namelist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 166; {
/* line 409 "/tmp/lalr6706" */
/* line 363 "occam.lalr" */
 if (last_type_was_chan) S=AddChanSymbol(Val(yyAttrStackPtr [3-1]).Ident); else S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident); yySynAttribute.Tree = mAnId(yyAttrStackPtr [1-1].Tree,S); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 840:
case 488: /* is : IS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 412), ");  printf("IS  -> is \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 169; {
/* line 412 "/tmp/lalr6706" */
/* line 366 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; colon_ended=false; 
} break;
case 841:
case 537: /* retypes : RETYPES .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 415), ");  printf("RETYPES  -> retypes \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 170; {
/* line 415 "/tmp/lalr6706" */
/* line 369 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; colon_ended=false; 
} break;
case 842:
case 538: /* reshapes : RESHAPES .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 418), ");  printf("RESHAPES  -> reshapes \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 171; {
/* line 418 "/tmp/lalr6706" */
/* line 372 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; colon_ended=false; 
} break;
case 843:
case 559: /* abbreviation : primtype ID is elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 421), ");  printf("primtype ID is elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 119; {
/* line 421 "/tmp/lalr6706" */
/* line 376 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 844:
case 562: /* abbreviation : arrtype ID is elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 423), ");  printf("arrtype ID is elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 119; {
/* line 423 "/tmp/lalr6706" */
/* line 378 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 845:
case 517: /* abbreviation : ID is elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 425), ");  printf("ID is elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 119; {
/* line 425 "/tmp/lalr6706" */
/* line 380 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mIs(Posn(yyAttrStackPtr [1-1]),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),yyAttrStackPtr [3-1].Tree); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 846:
case 560: /* abbreviation : primtype ID retypes elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 427), ");  printf("primtype ID retypes elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 119; {
/* line 427 "/tmp/lalr6706" */
/* line 382 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree; 
} break;
case 847:
case 563: /* abbreviation : arrtype ID retypes elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 429), ");  printf("arrtype ID retypes elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 119; {
/* line 429 "/tmp/lalr6706" */
/* line 384 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 848:
case 564: /* abbreviation : arrtype ID reshapes elemental COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 431), ");  printf("arrtype ID reshapes elemental COLON  -> abbreviation \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 119; {
/* line 431 "/tmp/lalr6706" */
/* line 386 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mReshapes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [1-1].Tree;
} break;
case 849:
case 526: /* id : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 434), ");  printf("ID  -> id \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 173; {
/* line 434 "/tmp/lalr6706" */
/* line 389 "occam.lalr" */
 Val(yySynAttribute).Ident = Val(yyAttrStackPtr [1-1]).Ident; OpenScope(); colon_ended=false; 
} break;
case 850: /* pushtok : .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 437), ");  printf(" -> pushtok \n");
}
#endif
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 174; {
/* line 437 "/tmp/lalr6706" */
/* line 393 "occam.lalr" */
 OpenScope(); PushTokenColumn(); 
} break;
case 851:
case 532: /* definition : PROTOCOL ID IS seqproto COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 440), ");  printf("PROTOCOL ID IS seqproto COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 118; {
/* line 440 "/tmp/lalr6706" */
/* line 396 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefSeqPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),ReverseTree(yyAttrStackPtr [4-1].Tree)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 852:
case 534: /* definition : PROTOCOL ID sep BEGIN CASE sep END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 442), ");  printf("PROTOCOL ID sep BEGIN CASE sep END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 118; {
/* line 442 "/tmp/lalr6706" */
/* line 398 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefTagPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),mNoTagPro()); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 853:
case 533: /* definition : PROTOCOL ID sep BEGIN CASE sep BEGIN tagprotolist sep END END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 444), ");  printf("PROTOCOL ID sep BEGIN CASE sep BEGIN tagprotolist sep END END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=12; yyAttrStackPtr -=12; yyNonterminal = 118; {
/* line 444 "/tmp/lalr6706" */
/* line 400 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDefTagPro(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),ReverseTree(yyAttrStackPtr [8-1].Tree)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 854:
case 596: /* definition : PROC id LP O_fparmlist RP sep BEGIN process END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 446), ");  printf("PROC id LP O_fparmlist RP sep BEGIN process END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=10; yyAttrStackPtr -=10; yyNonterminal = 118; {
/* line 446 "/tmp/lalr6706" */
/* line 402 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefProc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree,yyAttrStackPtr [8-1].Tree); SymbolKind(S)=yySynAttribute.Tree; TypeFormals(yyAttrStackPtr [4-1].Tree);
} break;
case 855:
case 575: /* definition : typelist FUNCTION id LP O_fparmlist RP sep BEGIN pushtok valof END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 448), ");  printf("typelist FUNCTION id LP O_fparmlist RP sep BEGIN pushtok valof END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=12; yyAttrStackPtr -=12; yyNonterminal = 118; {
/* line 448 "/tmp/lalr6706" */
/* line 404 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [5-1].Tree,yyAttrStackPtr [10-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [5-1].Tree); yyAttrStackPtr [10-1].Tree->Valof.Sym=S; 
} break;
case 856:
case 566: /* definition : typelist FUNCTION id LP O_fparmlist RP IS isexplist COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 450), ");  printf("typelist FUNCTION id LP O_fparmlist RP IS isexplist COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 118; {
/* line 450 "/tmp/lalr6706" */
/* line 406 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mDefIsFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [5-1].Tree,ReverseTree(yyAttrStackPtr [8-1].Tree)); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [5-1].Tree);
} break;
case 857:
case 590: /* definition : INLINE PROC id LP O_fparmlist RP sep BEGIN process END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 452), ");  printf("INLINE PROC id LP O_fparmlist RP sep BEGIN process END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=11; yyAttrStackPtr -=11; yyNonterminal = 118; {
/* line 452 "/tmp/lalr6706" */
/* line 408 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mInlineDefProc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree,yyAttrStackPtr [9-1].Tree); SymbolKind(S)=yySynAttribute.Tree; TypeFormals(yyAttrStackPtr [5-1].Tree);
} break;
case 858:
case 577: /* definition : typelist INLINE FUNCTION id LP O_fparmlist RP sep BEGIN pushtok valof END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 454), ");  printf("typelist INLINE FUNCTION id LP O_fparmlist RP sep BEGIN pushtok valof END COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=13; yyAttrStackPtr -=13; yyNonterminal = 118; {
/* line 454 "/tmp/lalr6706" */
/* line 410 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mInlineDefFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [4-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [6-1].Tree,yyAttrStackPtr [11-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [6-1].Tree); yyAttrStackPtr [11-1].Tree->Valof.Sym=S; 
} break;
case 859:
case 576: /* definition : typelist INLINE FUNCTION id LP O_fparmlist RP IS isexplist COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 456), ");  printf("typelist INLINE FUNCTION id LP O_fparmlist RP IS isexplist COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=10; yyAttrStackPtr -=10; yyNonterminal = 118; {
/* line 456 "/tmp/lalr6706" */
/* line 412 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); yySynAttribute.Tree = mInlineDefIsFunc(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [4-1]).Ident),T=ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [6-1].Tree,ReverseTree(yyAttrStackPtr [9-1].Tree)); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [6-1].Tree);
} break;
case 860:
case 536: /* definition : VAL ID is expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 458), ");  printf("VAL ID is expr COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 118; {
/* line 458 "/tmp/lalr6706" */
/* line 414 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mVal(Posn(yyAttrStackPtr [1-1]),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [4-1].Tree); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 861:
case 539: /* definition : VAL spectype ID is expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 460), ");  printf("VAL spectype ID is expr COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 118; {
/* line 460 "/tmp/lalr6706" */
/* line 416 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mVal(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [2-1].Tree;
} break;
case 862:
case 540: /* definition : VAL spectype ID retypes expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 462), ");  printf("VAL spectype ID retypes expr COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 118; {
/* line 462 "/tmp/lalr6706" */
/* line 418 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mValRetypes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [2-1].Tree;
} break;
case 863:
case 541: /* definition : VAL spectype ID reshapes expr COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 464), ");  printf("VAL spectype ID reshapes expr COLON  -> definition \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 118; {
/* line 464 "/tmp/lalr6706" */
/* line 420 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mValReshapes(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=yyAttrStackPtr [2-1].Tree;
} break;
case 864:
case 679: /* definition : prototype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 466), ");  printf("prototype  -> definition \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 118; {
/* line 466 "/tmp/lalr6706" */
/* line 422 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CHK_Mode(xxPrototype,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 865:
case 680: /* definition : userdatatype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 468), ");  printf("userdatatype  -> definition \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 118; {
/* line 468 "/tmp/lalr6706" */
/* line 424 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 866:
case 547: /* userdatatype : DATA TYPE typeid IS datatype COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 472), ");  printf("DATA TYPE typeid IS datatype COLON  -> userdatatype \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 183; {
/* line 472 "/tmp/lalr6706" */
/* line 428 "occam.lalr" */
 
		  CloseScope();
                  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
                  yySynAttribute.Tree = mDeclType(Posn(yyAttrStackPtr [1-1]),TypeUserDataType(yyAttrStackPtr [5-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),Posn(yyAttrStackPtr [1-1]))); 
                  SymbolKind(S)=yySynAttribute.Tree;
                  SymbolType(S)=yySynAttribute.Tree->DeclType.Type; 
                
} break;
case 867:
case 549: /* userdatatype : DATA TYPE typeid sep BEGIN structuredtype END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 482), ");  printf("DATA TYPE typeid sep BEGIN structuredtype END COLON  -> userdatatype \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 183; {
/* line 482 "/tmp/lalr6706" */
/* line 436 "occam.lalr" */
 
		  CloseScope();
                  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
                  yySynAttribute.Tree = mDeclType(Posn(yyAttrStackPtr [1-1]),mUserRecord(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [6-1].Tree)); 
                  SymbolKind(S)=yySynAttribute.Tree; 
                  SymbolType(S)=yySynAttribute.Tree->DeclType.Type; 
                
} break;
case 868:
case 548: /* userdatatype : DATA TYPE typeid sep BEGIN PACKED structuredtype END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 492), ");  printf("DATA TYPE typeid sep BEGIN PACKED structuredtype END COLON  -> userdatatype \n");
}
#endif
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 183; {
/* line 492 "/tmp/lalr6706" */
/* line 444 "occam.lalr" */
 
		  CloseScope();
                  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
                  yySynAttribute.Tree = mDeclType(Posn(yyAttrStackPtr [1-1]),mUserPackedRecord(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [7-1].Tree)); 
                  SymbolKind(S)=yySynAttribute.Tree; 
                  SymbolType(S)=yySynAttribute.Tree->DeclType.Type; 
                
} break;
case 869:
case 525: /* userdatatype : CHAN TYPE typeid sep BEGIN structuredtype END COLON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 502), ");  printf("CHAN TYPE typeid sep BEGIN structuredtype END COLON  -> userdatatype \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 183; {
/* line 502 "/tmp/lalr6706" */
/* line 452 "occam.lalr" */
 
		  CloseScope();
		  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan;
                  yySynAttribute.Tree = mDeclType(Posn(yyAttrStackPtr [1-1]),mUserChanRecord(Posn(yyAttrStackPtr [1-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [6-1].Tree)); 
                  SymbolKind(S)=yySynAttribute.Tree; 
                  SymbolType(S)=yySynAttribute.Tree->DeclType.Type; 
                
} break;
case 870:
case 524: /* structuredtype : RECORD sep BEGIN fieldlist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 512), ");  printf("RECORD sep BEGIN fieldlist END  -> structuredtype \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 186; {
/* line 512 "/tmp/lalr6706" */
/* line 462 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = ReverseTree(yyAttrStackPtr [4-1].Tree); 
} break;
case 871: /* structuredtype : RECORD sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 514), ");  printf("RECORD sep  -> structuredtype \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 186; {
/* line 514 "/tmp/lalr6706" */
/* line 464 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mNoField(); 
} break;
case 872: /* fieldlist : fielddecl COLON sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 517), ");  printf("fielddecl COLON sep  -> fieldlist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 187; {
/* line 517 "/tmp/lalr6706" */
/* line 468 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 873: /* fieldlist : fieldlist fielddecl COLON sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 519), ");  printf("fieldlist fielddecl COLON sep  -> fieldlist \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 187; {
/* line 519 "/tmp/lalr6706" */
/* line 470 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = CatFieldList(yyAttrStackPtr [2-1].Tree,yyAttrStackPtr [1-1].Tree); 
} break;
case 874:
case 634: /* fielddecl : spectype name .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 523), ");  printf("spectype name  -> fielddecl \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 188; {
/* line 523 "/tmp/lalr6706" */
/* line 474 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
                  yySynAttribute.Tree = mAField(mNoField(),S=AddSymbol(Val(yyAttrStackPtr [2-1]).Ident),yyAttrStackPtr [1-1].Tree); 
                  SymbolKind(S)=yySynAttribute.Tree;
		  SymbolType(S)=yyAttrStackPtr [1-1].Tree;
                
} break;
case 875:
case 635: /* fielddecl : fielddecl DECLCOMMA name .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 531), ");  printf("fielddecl DECLCOMMA name  -> fielddecl \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 188; {
/* line 531 "/tmp/lalr6706" */
/* line 480 "occam.lalr" */

		  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan;
		  yySynAttribute.Tree = mAField(yyAttrStackPtr [1-1].Tree,S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [1-1].Tree->AField.Type);
		  SymbolKind(S)=yySynAttribute.Tree;
		  SymbolType(S)=yyAttrStackPtr [1-1].Tree->AField.Type;
		
} break;
case 876:
case 518: /* typeid : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 540), ");  printf("ID  -> typeid \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 184; {
/* line 540 "/tmp/lalr6706" */
/* line 488 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Ident = Val(yyAttrStackPtr [1-1]).Ident; OpenScope(); 
} break;
case 877:
case 519: /* typeid : TYPEID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 542), ");  printf("TYPEID  -> typeid \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 184; {
/* line 542 "/tmp/lalr6706" */
/* line 489 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Ident = Val(yyAttrStackPtr [1-1]).Ident; OpenScope(); 
} break;
case 878:
case 542: /* LANG : EXTERN_OCCAM .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 545), ");  printf("EXTERN_OCCAM  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 189; {
/* line 545 "/tmp/lalr6706" */
/* line 494 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxOccam; 
} break;
case 879:
case 544: /* LANG : EXTERN_F90 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 547), ");  printf("EXTERN_F90  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 189; {
/* line 547 "/tmp/lalr6706" */
/* line 496 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxF90; ADD_Mode(xxCallF90); 
} break;
case 880:
case 545: /* LANG : EXTERN_F77 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 549), ");  printf("EXTERN_F77  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 189; {
/* line 549 "/tmp/lalr6706" */
/* line 498 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxF77; 
} break;
case 881:
case 546: /* LANG : EXTERN_C .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 551), ");  printf("EXTERN_C  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 189; {
/* line 551 "/tmp/lalr6706" */
/* line 500 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxC; 
} break;
case 882:
case 543: /* LANG : EXTERN_ATOMIC .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 553), ");  printf("EXTERN_ATOMIC  -> LANG \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 189; {
/* line 553 "/tmp/lalr6706" */
/* line 502 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; Val(yySynAttribute).Number = xxAtomicOccam; 
} break;
case 883:
case 681: /* prototype : LANG PROC id LP O_fparmlist RP COLON proto_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 556), ");  printf("LANG PROC id LP O_fparmlist RP COLON proto_id  -> prototype \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 182; {
/* line 556 "/tmp/lalr6706" */
/* line 507 "occam.lalr" */
 CloseScope(); yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPrototypeProc(Posn(yyAttrStackPtr [2-1]),S=AddSymbol(Val(yyAttrStackPtr [3-1]).Ident),yyAttrStackPtr [5-1].Tree,Val(yyAttrStackPtr [8-1]).Ident,Val(yyAttrStackPtr [1-1]).Number); SymbolKind(S)=yySynAttribute.Tree; TypeFormals(yyAttrStackPtr [5-1].Tree);
} break;
case 884:
case 690: /* prototype : LANG typelist FUNCTION id LP O_fparmlist RP COLON proto_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 558), ");  printf("LANG typelist FUNCTION id LP O_fparmlist RP COLON proto_id  -> prototype \n");
}
#endif
  yyStateStackPtr -=9; yyAttrStackPtr -=9; yyNonterminal = 182; {
/* line 558 "/tmp/lalr6706" */
/* line 509 "occam.lalr" */
 CloseScope(); yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPrototypeFunc(Posn(yyAttrStackPtr [2-1]),S=AddSymbol(Val(yyAttrStackPtr [4-1]).Ident),T=ReverseTree(yyAttrStackPtr [2-1].Tree),yyAttrStackPtr [6-1].Tree,Val(yyAttrStackPtr [9-1]).Ident,Val(yyAttrStackPtr [1-1]).Number); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=T; TypeFormals(yyAttrStackPtr [6-1].Tree);
} break;
case 885: /* proto_id : .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 561), ");  printf(" -> proto_id \n");
}
#endif
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 190; {
/* line 561 "/tmp/lalr6706" */
/* line 513 "occam.lalr" */
 Val(yySynAttribute).Ident = NoIdent; 
} break;
case 886:
case 568: /* proto_id : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 563), ");  printf("ID  -> proto_id \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 190; {
/* line 563 "/tmp/lalr6706" */
/* line 515 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 887:
case 616: /* simpleproto : spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 566), ");  printf("spectype  -> simpleproto \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 566 "/tmp/lalr6706" */
/* line 518 "occam.lalr" */
  yySynAttribute.Tree = mSimple(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 888:
case 618: /* simpleproto : numerictype DCOLON LSB RSB spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 568), ");  printf("numerictype DCOLON LSB RSB spectype  -> simpleproto \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 191; {
/* line 568 "/tmp/lalr6706" */
/* line 519 "occam.lalr" */
  yySynAttribute.Tree = mCounted(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,mArray(mUnBound(Posn(yyAttrStackPtr [4-1])),yyAttrStackPtr [5-1].Tree)); 
} break;
case 889:
case 467: /* simpleproto : ANY .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 570), ");  printf("ANY  -> simpleproto \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 191; {
/* line 570 "/tmp/lalr6706" */
/* line 520 "occam.lalr" */
  yySynAttribute.Tree = mAny(Posn(yyAttrStackPtr [1-1])); 
} break;
case 890:
case 641: /* seqproto : simpleproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 573), ");  printf("simpleproto  -> seqproto \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 175; {
/* line 573 "/tmp/lalr6706" */
/* line 524 "occam.lalr" */
  yySynAttribute.Tree = mASeqPro(mNoSeqPro(),yyAttrStackPtr [1-1].Tree); 
} break;
case 891:
case 640: /* seqproto : seqproto SEMICOLON simpleproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 575), ");  printf("seqproto SEMICOLON simpleproto  -> seqproto \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 175; {
/* line 575 "/tmp/lalr6706" */
/* line 525 "occam.lalr" */
  yySynAttribute.Tree = mASeqPro(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 892:
case 643: /* tagprotolist : tagproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 578), ");  printf("tagproto  -> tagprotolist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 176; {
/* line 578 "/tmp/lalr6706" */
/* line 529 "occam.lalr" */
  yySynAttribute.Tree->ATagPro.Next = mNoTagPro(); 
} break;
case 893:
case 642: /* tagprotolist : tagprotolist sep tagproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 580), ");  printf("tagprotolist sep tagproto  -> tagprotolist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 176; {
/* line 580 "/tmp/lalr6706" */
/* line 530 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree ; yySynAttribute.Tree->ATagPro.Next = yyAttrStackPtr [1-1].Tree; 
} break;
case 894: /* tagproto : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 583), ");  printf("ID  -> tagproto \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 193; {
/* line 583 "/tmp/lalr6706" */
/* line 534 "occam.lalr" */
  yySynAttribute.Tree = mATagPro(NoTree,S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),mNoSeqPro()); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mByte(); 
} break;
case 895: /* tagproto : ID SEMICOLON seqproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 585), ");  printf("ID SEMICOLON seqproto  -> tagproto \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 193; {
/* line 585 "/tmp/lalr6706" */
/* line 535 "occam.lalr" */
  yySynAttribute.Tree = mATagPro(NoTree,S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident),ReverseTree(yyAttrStackPtr [3-1].Tree)); SymbolKind(S)=yySynAttribute.Tree; SymbolType(S)=mByte(); 
} break;
case 896:
case 466: /* protocol : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 588), ");  printf("ID  -> protocol \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 194; {
/* line 588 "/tmp/lalr6706" */
/* line 539 "occam.lalr" */
 yySynAttribute.Tree = mNamed(Posn(yyAttrStackPtr [1-1]),LookupSymbol(yyAttrStackPtr [1-1].Scan)); 
} break;
case 897:
case 617: /* protocol : simpleproto .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 590), ");  printf("simpleproto  -> protocol \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 194; {
/* line 590 "/tmp/lalr6706" */
/* line 540 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 898: /* assignment : varlist ASSIGN explist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 593), ");  printf("varlist ASSIGN explist  -> assignment \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 131; {
/* line 593 "/tmp/lalr6706" */
/* line 544 "occam.lalr" */
 yySynAttribute.Tree = mAssign(Posn(yyAttrStackPtr [2-1]),mNoSpec(),ReverseTree(yyAttrStackPtr [1-1].Tree),ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 899: /* input : element QUERY ilist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 596), ");  printf("element QUERY ilist  -> input \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 132; {
/* line 596 "/tmp/lalr6706" */
/* line 548 "occam.lalr" */
  yySynAttribute.Tree = mInput(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 900:
case 692: /* after : element QUERY AFTER expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 599), ");  printf("element QUERY AFTER expr  -> after \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 133; {
/* line 599 "/tmp/lalr6706" */
/* line 551 "occam.lalr" */
  yySynAttribute.Tree = mAfter(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [4-1].Tree); 
} break;
case 901: /* caseinput : element QUERY case sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 602), ");  printf("element QUERY case sep  -> caseinput \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 127; {
/* line 602 "/tmp/lalr6706" */
/* line 554 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [1-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mNoCase()); 
} break;
case 902:
case 574: /* caseinput : element QUERY case sep BEGIN variantlist END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 604), ");  printf("element QUERY case sep BEGIN variantlist END  -> caseinput \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 127; {
/* line 604 "/tmp/lalr6706" */
/* line 555 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [1-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [6-1].Tree)); 
} break;
case 903: /* casesingle : element QUERY case ilist sep .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 607), ");  printf("element QUERY case ilist sep  -> casesingle \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 128; {
/* line 607 "/tmp/lalr6706" */
/* line 558 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [2-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mACase(mNoCase(),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree),mSkip(Posn(yyAttrStackPtr [2-1]),mNoSpec())));
} break;
case 904:
case 582: /* casesingleproc : element QUERY case ilist sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 610), ");  printf("element QUERY case ilist sep BEGIN process END  -> casesingleproc \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 164; {
/* line 610 "/tmp/lalr6706" */
/* line 561 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mCaseIn(Posn(yyAttrStackPtr [2-1]),mNoSpec(), yyAttrStackPtr [1-1].Tree,mACase(mNoCase(),mNoSpec(),ReverseTree(yyAttrStackPtr [4-1].Tree),yyAttrStackPtr [7-1].Tree));
} break;
case 905:
case 697: /* variantlist : variant .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 613), ");  printf("variant  -> variantlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 198; {
/* line 613 "/tmp/lalr6706" */
/* line 565 "occam.lalr" */
 yySynAttribute.Tree->ACase.Next = mNoCase(); CloseScope(); OpenScope(); 
} break;
case 906:
case 696: /* variantlist : variantlist variant .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 615), ");  printf("variantlist variant  -> variantlist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 198; {
/* line 615 "/tmp/lalr6706" */
/* line 566 "occam.lalr" */
 yySynAttribute.Scan =yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; yySynAttribute.Tree->ACase.Next = yyAttrStackPtr [1-1].Tree; CloseScope(); OpenScope(); 
} break;
case 907:
case 573: /* variant : ilist sep BEGIN process END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 618), ");  printf("ilist sep BEGIN process END  -> variant \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 199; {
/* line 618 "/tmp/lalr6706" */
/* line 570 "occam.lalr" */
 yySynAttribute.Tree = mACase(NoTree,mNoSpec(),ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [4-1].Tree); 
} break;
case 908:
case 694: /* variant : specification sep variant .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 620), ");  printf("specification sep variant  -> variant \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 199; {
/* line 620 "/tmp/lalr6706" */
/* line 571 "occam.lalr" */
  yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->ACase.SpecList,yyAttrStackPtr [1-1].Tree);
} break;
case 909: /* output : element PLING olist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 623), ");  printf("element PLING olist  -> output \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 134; {
/* line 623 "/tmp/lalr6706" */
/* line 575 "occam.lalr" */
  yySynAttribute.Tree = mOutput(Posn(yyAttrStackPtr [2-1]),mNoSpec(),yyAttrStackPtr [1-1].Tree,ReverseTree(yyAttrStackPtr [3-1].Tree)); 
} break;
case 910:
case 700: /* olist : oitem .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 626), ");  printf("oitem  -> olist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 200; {
/* line 626 "/tmp/lalr6706" */
/* line 579 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 911:
case 699: /* olist : olist SEMICOLON oitem .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 628), ");  printf("olist SEMICOLON oitem  -> olist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 200; {
/* line 628 "/tmp/lalr6706" */
/* line 580 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 912: /* oitem : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 631), ");  printf("expr  -> oitem \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 201; {
/* line 631 "/tmp/lalr6706" */
/* line 583 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 913:
case 698: /* oitem : expr DCOLON expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 633), ");  printf("expr DCOLON expr  -> oitem \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 201; {
/* line 633 "/tmp/lalr6706" */
/* line 584 "occam.lalr" */
  yySynAttribute.Tree = mCountArray(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 914:
case 695: /* ilist : iitem .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 636), ");  printf("iitem  -> ilist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 197; {
/* line 636 "/tmp/lalr6706" */
/* line 587 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 915:
case 693: /* ilist : ilist SEMICOLON iitem .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 638), ");  printf("ilist SEMICOLON iitem  -> ilist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 197; {
/* line 638 "/tmp/lalr6706" */
/* line 588 "occam.lalr" */
  yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 916: /* iitem : element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 641), ");  printf("element  -> iitem \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 202; {
/* line 641 "/tmp/lalr6706" */
/* line 591 "occam.lalr" */
  yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 917: /* iitem : element DCOLON element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 643), ");  printf("element DCOLON element  -> iitem \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 202; {
/* line 643 "/tmp/lalr6706" */
/* line 592 "occam.lalr" */
  yySynAttribute.Tree = mCountArray(Posn(yyAttrStackPtr [1-1]),mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree),mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree)); 
} break;
case 918:
case 627: /* explist : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 646), ");  printf("expr  -> explist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 136; {
/* line 646 "/tmp/lalr6706" */
/* line 596 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 919:
case 622: /* explist : explist COMMA expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 648), ");  printf("explist COMMA expr  -> explist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 136; {
/* line 648 "/tmp/lalr6706" */
/* line 597 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 920:
case 676: /* isexplist : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 651), ");  printf("expr  -> isexplist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 180; {
/* line 651 "/tmp/lalr6706" */
/* line 600 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), yyAttrStackPtr [1-1].Tree); 
} break;
case 921:
case 677: /* isexplist : isexplist comma expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 653), ");  printf("isexplist comma expr  -> isexplist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 180; {
/* line 653 "/tmp/lalr6706" */
/* line 601 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 922: /* varlist : element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 656), ");  printf("element  -> varlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 195; {
/* line 656 "/tmp/lalr6706" */
/* line 605 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(), mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree)); 
} break;
case 923: /* varlist : varlist comma element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 658), ");  printf("varlist comma element  -> varlist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 195; {
/* line 658 "/tmp/lalr6706" */
/* line 606 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree= mAnExpr(yyAttrStackPtr [1-1].Tree, mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree)); 
} break;
case 924:
case 688: /* typelist : primtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 661), ");  printf("primtype  -> typelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 178; {
/* line 661 "/tmp/lalr6706" */
/* line 610 "occam.lalr" */
  yySynAttribute.Tree = mAType(mNoType(),yyAttrStackPtr [1-1].Tree); 
} break;
case 925:
case 689: /* typelist : arrtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 663), ");  printf("arrtype  -> typelist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 178; {
/* line 663 "/tmp/lalr6706" */
/* line 611 "occam.lalr" */
  yySynAttribute.Tree = mAType(mNoType(),yyAttrStackPtr [1-1].Tree); 
} break;
case 926:
case 691: /* typelist : typelist comma spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 665), ");  printf("typelist comma spectype  -> typelist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 178; {
/* line 665 "/tmp/lalr6706" */
/* line 612 "occam.lalr" */
  yySynAttribute.Tree = mAType(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [3-1].Tree); 
} break;
case 927: /* O_fparmlist : .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 668), ");  printf(" -> O_fparmlist \n");
}
#endif
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 177; {
/* line 668 "/tmp/lalr6706" */
/* line 616 "occam.lalr" */
 yySynAttribute.Tree = mNoFormals(SymSize+1); /* Identify next symbol to be declared  */ 
} break;
case 928:
case 683: /* O_fparmlist : fparmlist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 670), ");  printf("fparmlist  -> O_fparmlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 177; {
/* line 670 "/tmp/lalr6706" */
/* line 618 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 929: /* fparmlist : firstparm .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 673), ");  printf("firstparm  -> fparmlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 204; {
/* line 673 "/tmp/lalr6706" */
/* line 621 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = mNoFormal();
} break;
case 930:
case 686: /* fparmlist : firstparm comma fparmrest .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 675), ");  printf("firstparm comma fparmrest  -> fparmlist \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 204; {
/* line 675 "/tmp/lalr6706" */
/* line 622 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = yyAttrStackPtr [3-1].Tree;
} break;
case 931: /* fparmrest : fparm .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 678), ");  printf("fparm  -> fparmrest \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 206; {
/* line 678 "/tmp/lalr6706" */
/* line 626 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = mNoFormal();
} break;
case 932:
case 687: /* fparmrest : fparm comma fparmrest .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 680), ");  printf("fparm comma fparmrest  -> fparmrest \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 206; {
/* line 680 "/tmp/lalr6706" */
/* line 627 "occam.lalr" */
 yySynAttribute.Tree=yyAttrStackPtr [1-1].Tree; yySynAttribute.Tree->AFormal.Next = yyAttrStackPtr [3-1].Tree;
} break;
case 933:
case 682: /* firstparm : spectype O_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 683), ");  printf("spectype O_id  -> firstparm \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 205; {
/* line 683 "/tmp/lalr6706" */
/* line 631 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByRef(),yyAttrStackPtr [1-1].Tree,S=Val(yyAttrStackPtr [2-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 934:
case 636: /* firstparm : VAL spectype O_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 685), ");  printf("VAL spectype O_id  -> firstparm \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 205; {
/* line 685 "/tmp/lalr6706" */
/* line 632 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByVal(),yyAttrStackPtr [2-1].Tree,S=Val(yyAttrStackPtr [3-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 935:
case 685: /* fparm : spectype O_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 688), ");  printf("spectype O_id  -> fparm \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 207; {
/* line 688 "/tmp/lalr6706" */
/* line 636 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByRef(),yyAttrStackPtr [1-1].Tree,S=Val(yyAttrStackPtr [2-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 936:
case 684: /* fparm : VAL spectype O_id .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 690), ");  printf("VAL spectype O_id  -> fparm \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 207; {
/* line 690 "/tmp/lalr6706" */
/* line 637 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByVal(),yyAttrStackPtr [2-1].Tree,S=Val(yyAttrStackPtr [3-1]).Symbol); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 937:
case 569: /* fparm : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 692), ");  printf("ID  -> fparm \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 207; {
/* line 692 "/tmp/lalr6706" */
/* line 638 "occam.lalr" */
 yySynAttribute.Tree=mAFormal(NoTree,Posn(yyAttrStackPtr [1-1]),mByUndef(),mUntyped(),S=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 938: /* O_id : .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 695), ");  printf(" -> O_id \n");
}
#endif
  yyStateStackPtr -=0; yyAttrStackPtr -=0; yyNonterminal = 208; {
/* line 695 "/tmp/lalr6706" */
/* line 641 "occam.lalr" */
 CHK_Mode(xxPrototype,Attribute.Position); Val(yySynAttribute).Symbol=NoSymbol; 
} break;
case 939:
case 527: /* O_id : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 697), ");  printf("ID  -> O_id \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 208; {
/* line 697 "/tmp/lalr6706" */
/* line 642 "occam.lalr" */
 yySynAttribute.Scan=yyAttrStackPtr [1-1].Scan;  Val(yySynAttribute).Symbol=AddSymbol(Val(yyAttrStackPtr [1-1]).Ident);
} break;
case 940:
case 572: /* element : ID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 700), ");  printf("ID  -> element \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 196; {
/* line 700 "/tmp/lalr6706" */
/* line 645 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnmappedIdentifier(Posn(yyAttrStackPtr [1-1]), NoSymbol, CurrentScope(), Val(yyAttrStackPtr [1-1]).Ident); 
} break;
case 941:
case 483: /* element : element LSB subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 702), ");  printf("element LSB subscript RSB  -> element \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 196; {
/* line 702 "/tmp/lalr6706" */
/* line 646 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 942:
case 515: /* element : LSB element FROM subscript FOR subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 704), ");  printf("LSB element FROM subscript FOR subscript RSB  -> element \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 196; {
/* line 704 "/tmp/lalr6706" */
/* line 647 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 943:
case 513: /* element : LSB element FOR subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 707), ");  printf("LSB element FOR subscript RSB  -> element \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 196; {
/* line 707 "/tmp/lalr6706" */
/* line 648 "occam.lalr" */
 
			yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan;
                        {
                          tValue tmp; tmp.Number = 0;
 			  yySynAttribute.Tree = mRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, mConst(Posn(yyAttrStackPtr [1-1]),tmp,mInt()), yyAttrStackPtr [4-1].Tree); 
                        }
			CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])) ; 
} break;
case 944:
case 514: /* element : LSB element FROM subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 717), ");  printf("LSB element FROM subscript RSB  -> element \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 196; {
/* line 717 "/tmp/lalr6706" */
/* line 655 "occam.lalr" */
 
			yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
			yySynAttribute.Tree = mRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, mBinary(Posn(yyAttrStackPtr [1-1]),mUnary(Posn(yyAttrStackPtr [1-1]),mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree),mSize()),yyAttrStackPtr [4-1].Tree,mSubtract())); 
			CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])) ; 
} break;
case 945: /* elemental : element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 724), ");  printf("element  -> elemental \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 172; {
/* line 724 "/tmp/lalr6706" */
/* line 661 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 946:
case 633: /* elemental : table_element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 726), ");  printf("table_element  -> elemental \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 172; {
/* line 726 "/tmp/lalr6706" */
/* line 662 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 947:
case 623: /* subscript : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 729), ");  printf("expr  -> subscript \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 209; {
/* line 729 "/tmp/lalr6706" */
/* line 665 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 948:
case 489: /* table : LSB expr COMMA explist RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 732), ");  printf("LSB expr COMMA explist RSB  -> table \n");
}
#endif
  yyStateStackPtr -=5; yyAttrStackPtr -=5; yyNonterminal = 211; {
/* line 732 "/tmp/lalr6706" */
/* line 668 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTable(Posn(yyAttrStackPtr [1-1]),mAnExpr(ReverseTree(yyAttrStackPtr [4-1].Tree),yyAttrStackPtr [2-1].Tree),Depth,S=AddSymbol(NoIdent)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 949:
case 484: /* table : table LSB subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 734), ");  printf("table LSB subscript RSB  -> table \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 211; {
/* line 734 "/tmp/lalr6706" */
/* line 669 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 950:
case 485: /* table : funccall LSB subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 736), ");  printf("funccall LSB subscript RSB  -> table \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 211; {
/* line 736 "/tmp/lalr6706" */
/* line 670 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableSubscript(Posn(yyAttrStackPtr [3-1]), TypeTableExpr(yyAttrStackPtr [1-1].Tree), yyAttrStackPtr [3-1].Tree); 
} break;
case 951:
case 516: /* table : LSB table_element FROM subscript FOR subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 738), ");  printf("LSB table_element FROM subscript FOR subscript RSB  -> table \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 211; {
/* line 738 "/tmp/lalr6706" */
/* line 671 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 952:
case 599: /* litrecord : LSB expr COMMA explist RSB LP TYPEID RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 741), ");  printf("LSB expr COMMA explist RSB LP TYPEID RP  -> litrecord \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 213; {
/* line 741 "/tmp/lalr6706" */
/* line 674 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),mUserLiteral(Posn(yyAttrStackPtr [1-1]),mAnExpr(ReverseTree(yyAttrStackPtr [4-1].Tree),yyAttrStackPtr [2-1].Tree),Depth,S=AddSymbol(NoIdent),SymbolType(LookupSymbol(yyAttrStackPtr [7-1].Scan)))); 
} break;
case 953:
case 486: /* litrecord : sbexprlist LP TYPEID RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 743), ");  printf("sbexprlist LP TYPEID RP  -> litrecord \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 213; {
/* line 743 "/tmp/lalr6706" */
/* line 675 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),mUserLiteral(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree,Depth,S=AddSymbol(NoIdent),SymbolType(LookupSymbol(yyAttrStackPtr [3-1].Scan)))); 
} break;
case 954: /* table_element : table .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 746), ");  printf("table  -> table_element \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 210; {
/* line 746 "/tmp/lalr6706" */
/* line 679 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [1-1].Tree; 
} break;
case 955: /* table_element : sbexprlist .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 748), ");  printf("sbexprlist  -> table_element \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 210; {
/* line 748 "/tmp/lalr6706" */
/* line 680 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTableElementFromExprList(yyAttrStackPtr [1-1].Tree,Posn(yyAttrStackPtr [1-1]),Depth); 
} break;
case 956: /* string_element : STR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 751), ");  printf("STR  -> string_element \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 215; {
/* line 751 "/tmp/lalr6706" */
/* line 683 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mString(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]).String,mUntyped(),Depth,S=AddSymbol(NoIdent)); SymbolKind(S)=yySynAttribute.Tree;
} break;
case 957:
case 603: /* string_element : STR LP datatype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 753), ");  printf("STR LP datatype RP  -> string_element \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 215; {
/* line 753 "/tmp/lalr6706" */
/* line 684 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mString(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]).String,yyAttrStackPtr [3-1].Tree,Depth,S=AddSymbol(NoIdent)); SymbolKind(S)=yySynAttribute.Tree; CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 958:
case 487: /* string_element : string_element LSB subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 755), ");  printf("string_element LSB subscript RSB  -> string_element \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 215; {
/* line 755 "/tmp/lalr6706" */
/* line 685 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mStringSubscript(Posn(yyAttrStackPtr [3-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 959:
case 600: /* string_element : LSB string_element FROM subscript FOR subscript RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 757), ");  printf("LSB string_element FROM subscript FOR subscript RSB  -> string_element \n");
}
#endif
  yyStateStackPtr -=7; yyAttrStackPtr -=7; yyNonterminal = 215; {
/* line 757 "/tmp/lalr6706" */
/* line 686 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mStringRange(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [4-1].Tree, yyAttrStackPtr [6-1].Tree); 
} break;
case 960:
case 626: /* expr : monop operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 760), ");  printf("monop operand  -> expr \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 137; {
/* line 760 "/tmp/lalr6706" */
/* line 689 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnary(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, yyAttrStackPtr [1-1].Tree); 
} break;
case 961:
case 725: /* expr : SIZE operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 762), ");  printf("SIZE operand  -> expr \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 137; {
/* line 762 "/tmp/lalr6706" */
/* line 690 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnary(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [2-1].Tree, mSize()); 
} break;
case 962:
case 724: /* expr : SIZE spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 764), ");  printf("SIZE spectype  -> expr \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 137; {
/* line 764 "/tmp/lalr6706" */
/* line 691 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSizeOf(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree); 
} break;
case 963:
case 628: /* expr : operand dyop operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 766), ");  printf("operand dyop operand  -> expr \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 137; {
/* line 766 "/tmp/lalr6706" */
/* line 692 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 964: /* expr : operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 768), ");  printf("operand  -> expr \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 137; {
/* line 768 "/tmp/lalr6706" */
/* line 693 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 965:
case 631: /* expr : conversion .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 770), ");  printf("conversion  -> expr \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 137; {
/* line 770 "/tmp/lalr6706" */
/* line 694 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 966: /* expr : boolexpr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 772), ");  printf("boolexpr  -> expr \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 137; {
/* line 772 "/tmp/lalr6706" */
/* line 695 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 967:
case 472: /* lp : LP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 775), ");  printf("LP  -> lp \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 221; {
/* line 775 "/tmp/lalr6706" */
/* line 698 "occam.lalr" */
 OpenScope(); OpenScope(); PushColumn(Posn(yyAttrStackPtr [1-1]).Column); PushTokenColumn(); 
} break;
case 968:
case 630: /* boolexpr : operand boolop operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 778), ");  printf("operand boolop operand  -> boolexpr \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 220; {
/* line 778 "/tmp/lalr6706" */
/* line 701 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 969:
case 632: /* boolexpr : boolexpr boolop operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 780), ");  printf("boolexpr boolop operand  -> boolexpr \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 220; {
/* line 780 "/tmp/lalr6706" */
/* line 702 "occam.lalr" */
yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBinary(Posn(yyAttrStackPtr [2-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 970:
case 605: /* funccall : ID LP explist RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 783), ");  printf("ID LP explist RP  -> funccall \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 212; {
/* line 783 "/tmp/lalr6706" */
/* line 705 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = CreateFuncCall(Posn(yyAttrStackPtr [1-1]), LookupSymbol(yyAttrStackPtr [1-1].Scan),ReverseTree(yyAttrStackPtr [3-1].Tree),Depth); 
} break;
case 971:
case 604: /* funccall : ID LP RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 785), ");  printf("ID LP RP  -> funccall \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 212; {
/* line 785 "/tmp/lalr6706" */
/* line 706 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = CreateFuncCall(Posn(yyAttrStackPtr [1-1]), LookupSymbol(yyAttrStackPtr [1-1].Scan),mNoExpr(),Depth); 
} break;
case 972: /* operand : element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 788), ");  printf("element  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 788 "/tmp/lalr6706" */
/* line 709 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 973:
case 624: /* operand : table_element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 790), ");  printf("table_element  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 790 "/tmp/lalr6706" */
/* line 710 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mElementalExpr(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [1-1].Tree); 
} break;
case 974: /* operand : string_element .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 792), ");  printf("string_element  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 792 "/tmp/lalr6706" */
/* line 711 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 975:
case 629: /* operand : intliteral .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 794), ");  printf("intliteral  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 794 "/tmp/lalr6706" */
/* line 712 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 976:
case 469: /* operand : RNUMBER LP primtype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 797), ");  printf("RNUMBER LP primtype RP  -> operand \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 217; {
/* line 797 "/tmp/lalr6706" */
/* line 713 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree); if (!Tree_IsType(yyAttrStackPtr [3-1].Tree,kReal)) Message("Constant of inappropriate type",xxError,Posn(yyAttrStackPtr [1-1])); 
} break;
case 977: /* operand : RNUMBER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 798), ");  printf("RNUMBER  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 798 "/tmp/lalr6706" */
/* line 714 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),Val(yyAttrStackPtr [1-1]),mUntypedReal()); 
} break;
case 978:
case 597: /* operand : lp expr RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 800), ");  printf("lp expr RP  -> operand \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 217; {
/* line 800 "/tmp/lalr6706" */
/* line 715 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; CloseScope(); CloseScope(); PopColumn(); PopColumn(); 
} break;
case 979:
case 598: /* operand : lp valof RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 802), ");  printf("lp valof RP  -> operand \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 217; {
/* line 802 "/tmp/lalr6706" */
/* line 716 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree; CloseScope(); PopColumn(); 
} break;
case 980:
case 621: /* operand : MOSTPOS numerictype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 804), ");  printf("MOSTPOS numerictype  -> operand \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 804 "/tmp/lalr6706" */
/* line 717 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMostPos(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree); 
} break;
case 981:
case 620: /* operand : MOSTNEG numerictype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 806), ");  printf("MOSTNEG numerictype  -> operand \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 217; {
/* line 806 "/tmp/lalr6706" */
/* line 718 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMostNeg(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [2-1].Tree); 
} break;
case 982:
case 625: /* operand : litrecord .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 808), ");  printf("litrecord  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 808 "/tmp/lalr6706" */
/* line 719 "occam.lalr" */
 CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 983:
case 602: /* operand : BYTESIN LP datatype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 810), ");  printf("BYTESIN LP datatype RP  -> operand \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 217; {
/* line 810 "/tmp/lalr6706" */
/* line 720 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mBytesInType(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [3-1].Tree);  CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 984:
case 601: /* operand : BYTESIN LP expr RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 812), ");  printf("BYTESIN LP expr RP  -> operand \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 217; {
/* line 812 "/tmp/lalr6706" */
/* line 721 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; yySynAttribute.Tree = mBytesInExpr(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [3-1].Tree);  CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 985:
case 482: /* operand : OFFSETOF LP TYPEID comma ID RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 814), ");  printf("OFFSETOF LP TYPEID comma ID RP  -> operand \n");
}
#endif
  yyStateStackPtr -=6; yyAttrStackPtr -=6; yyNonterminal = 217; {
/* line 814 "/tmp/lalr6706" */
/* line 722 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mOffsetOf(Posn(yyAttrStackPtr [1-1]),SymbolType(LookupSymbol(yyAttrStackPtr [3-1].Scan)),mUnmappedIdentifier(Posn(yyAttrStackPtr [5-1]), NoSymbol, CurrentScope(), Val(yyAttrStackPtr [5-1]).Ident));  CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 986: /* operand : funccall .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 816), ");  printf("funccall  -> operand \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 217; {
/* line 816 "/tmp/lalr6706" */
/* line 723 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 987:
case 471: /* monop : SUBTRACT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 819), ");  printf("SUBTRACT  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 819 "/tmp/lalr6706" */
/* line 727 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubtract(); 
} break;
case 988:
case 477: /* monop : NOT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 821), ");  printf("NOT  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 821 "/tmp/lalr6706" */
/* line 728 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mNot(); 
} break;
case 989:
case 474: /* monop : BITNOT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 823), ");  printf("BITNOT  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 823 "/tmp/lalr6706" */
/* line 729 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitNot(); 
} break;
case 990:
case 470: /* monop : ADD .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 825), ");  printf("ADD  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 825 "/tmp/lalr6706" */
/* line 730 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAdd(); 
} break;
case 991:
case 476: /* monop : MINUS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 827), ");  printf("MINUS  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 827 "/tmp/lalr6706" */
/* line 731 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMinus(); 
} break;
case 992:
case 478: /* monop : PLUS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 829), ");  printf("PLUS  -> monop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 216; {
/* line 829 "/tmp/lalr6706" */
/* line 732 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPlus(); 
} break;
case 993:
case 490: /* dyop : LT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 832), ");  printf("LT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 832 "/tmp/lalr6706" */
/* line 735 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLess(); 
} break;
case 994:
case 491: /* dyop : GT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 834), ");  printf("GT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 834 "/tmp/lalr6706" */
/* line 736 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mGreater(); 
} break;
case 995:
case 492: /* dyop : LE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 836), ");  printf("LE  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 836 "/tmp/lalr6706" */
/* line 737 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLessEqual(); 
} break;
case 996:
case 493: /* dyop : GE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 838), ");  printf("GE  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 838 "/tmp/lalr6706" */
/* line 738 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mGreaterEqual(); 
} break;
case 997:
case 494: /* dyop : EQ .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 840), ");  printf("EQ  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 840 "/tmp/lalr6706" */
/* line 739 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mEqual(); 
} break;
case 998:
case 495: /* dyop : NE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 842), ");  printf("NE  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 842 "/tmp/lalr6706" */
/* line 740 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mNotEqual(); 
} break;
case 999:
case 496: /* dyop : ADD .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 844), ");  printf("ADD  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 844 "/tmp/lalr6706" */
/* line 741 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAdd(); 
} break;
case 1000:
case 497: /* dyop : SUBTRACT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 846), ");  printf("SUBTRACT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 846 "/tmp/lalr6706" */
/* line 742 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mSubtract(); 
} break;
case 1001:
case 498: /* dyop : MULTIPLY .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 848), ");  printf("MULTIPLY  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 848 "/tmp/lalr6706" */
/* line 743 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMultiply(); 
} break;
case 1002:
case 499: /* dyop : DIVIDE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 850), ");  printf("DIVIDE  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 850 "/tmp/lalr6706" */
/* line 744 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mDivide(); 
} break;
case 1003:
case 505: /* dyop : BITAND .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 852), ");  printf("BITAND  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 852 "/tmp/lalr6706" */
/* line 745 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitAnd(); 
} break;
case 1004:
case 506: /* dyop : BITOR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 854), ");  printf("BITOR  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 854 "/tmp/lalr6706" */
/* line 746 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitOr(); 
} break;
case 1005:
case 500: /* dyop : BITEOR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 856), ");  printf("BITEOR  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 856 "/tmp/lalr6706" */
/* line 747 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBitEor(); 
} break;
case 1006:
case 501: /* dyop : LSHIFT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 858), ");  printf("LSHIFT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 858 "/tmp/lalr6706" */
/* line 748 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mLeftShift(); 
} break;
case 1007:
case 502: /* dyop : RSHIFT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 860), ");  printf("RSHIFT  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 860 "/tmp/lalr6706" */
/* line 749 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRightShift(); 
} break;
case 1008:
case 510: /* dyop : REM .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 862), ");  printf("REM  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 862 "/tmp/lalr6706" */
/* line 750 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRem(); 
} break;
case 1009:
case 507: /* dyop : MINUS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 864), ");  printf("MINUS  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 864 "/tmp/lalr6706" */
/* line 751 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mMinus(); 
} break;
case 1010:
case 509: /* dyop : PLUS .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 866), ");  printf("PLUS  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 866 "/tmp/lalr6706" */
/* line 752 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mPlus(); 
} break;
case 1011:
case 511: /* dyop : TIMES .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 868), ");  printf("TIMES  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 868 "/tmp/lalr6706" */
/* line 753 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTimes(); 
} break;
case 1012:
case 503: /* dyop : AFTER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 870), ");  printf("AFTER  -> dyop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 218; {
/* line 870 "/tmp/lalr6706" */
/* line 754 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAfterOp(); 
} break;
case 1013:
case 504: /* boolop : AND .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 873), ");  printf("AND  -> boolop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 222; {
/* line 873 "/tmp/lalr6706" */
/* line 757 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnd(); 
} break;
case 1014:
case 508: /* boolop : OR .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 875), ");  printf("OR  -> boolop \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 222; {
/* line 875 "/tmp/lalr6706" */
/* line 758 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mOr(); 
} break;
case 1015:
case 708: /* conversion : primtype operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 878), ");  printf("primtype operand  -> conversion \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 219; {
/* line 878 "/tmp/lalr6706" */
/* line 761 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConvert(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [2-1].Tree); 
} break;
case 1016:
case 723: /* conversion : primtype ROUND operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 880), ");  printf("primtype ROUND operand  -> conversion \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 219; {
/* line 880 "/tmp/lalr6706" */
/* line 762 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mRound(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1017:
case 707: /* conversion : primtype TRUNC operand .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 882), ");  printf("primtype TRUNC operand  -> conversion \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 219; {
/* line 882 "/tmp/lalr6706" */
/* line 763 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTrunc(Posn(yyAttrStackPtr [1-1]), yyAttrStackPtr [1-1].Tree, yyAttrStackPtr [3-1].Tree); 
} break;
case 1018: /* intliteral : NUMBER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 885), ");  printf("NUMBER  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 223; {
/* line 885 "/tmp/lalr6706" */
/* line 766 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mUntyped(),Val(yyAttrStackPtr [1-1]).Number,false),mUntypedInt()); 
} break;
case 1019: /* intliteral : HEXNUMBER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 887), ");  printf("HEXNUMBER  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 223; {
/* line 887 "/tmp/lalr6706" */
/* line 767 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mUntyped(),Val(yyAttrStackPtr [1-1]).Number,true),mUntypedHex()); 
} break;
case 1020: /* intliteral : TRUE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 889), ");  printf("TRUE  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 223; {
/* line 889 "/tmp/lalr6706" */
/* line 768 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mBool(),true,false),mBool()); 
} break;
case 1021: /* intliteral : FALSE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 891), ");  printf("FALSE  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 223; {
/* line 891 "/tmp/lalr6706" */
/* line 769 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mBool(),false,false),mBool()); 
} break;
case 1022: /* intliteral : CHCON .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 893), ");  printf("CHCON  -> intliteral \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 223; {
/* line 893 "/tmp/lalr6706" */
/* line 770 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),mByte(),Val(yyAttrStackPtr [1-1]).Char,true),mUntypedByte()); 
} break;
case 1023:
case 463: /* intliteral : NUMBER LP numerictype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 895), ");  printf("NUMBER LP numerictype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 223; {
/* line 895 "/tmp/lalr6706" */
/* line 771 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Number,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 1024:
case 464: /* intliteral : HEXNUMBER LP numerictype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 897), ");  printf("HEXNUMBER LP numerictype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 223; {
/* line 897 "/tmp/lalr6706" */
/* line 772 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Number,true),yyAttrStackPtr [3-1].Tree); 
} break;
case 1025:
case 465: /* intliteral : CHCON LP numerictype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 899), ");  printf("CHCON LP numerictype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 223; {
/* line 899 "/tmp/lalr6706" */
/* line 773 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,Val(yyAttrStackPtr [1-1]).Char,true),yyAttrStackPtr [3-1].Tree); 
} break;
case 1026:
case 479: /* intliteral : TRUE LP numerictype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 901), ");  printf("TRUE LP numerictype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 223; {
/* line 901 "/tmp/lalr6706" */
/* line 774 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,true,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 1027:
case 475: /* intliteral : FALSE LP numerictype RP .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 903), ");  printf("FALSE LP numerictype RP  -> intliteral \n");
}
#endif
  yyStateStackPtr -=4; yyAttrStackPtr -=4; yyNonterminal = 223; {
/* line 903 "/tmp/lalr6706" */
/* line 775 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mConst(Posn(yyAttrStackPtr [1-1]),CheckConst(Posn(yyAttrStackPtr [1-1]),yyAttrStackPtr [3-1].Tree,false,false),yyAttrStackPtr [3-1].Tree); 
} break;
case 1028:
case 567: /* valoftok : VALOF .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 906), ");  printf("VALOF  -> valoftok \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 224; {
/* line 906 "/tmp/lalr6706" */
/* line 778 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; OpenScope(); 
} break;
case 1029:
case 570: /* result : RESULT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 909), ");  printf("RESULT  -> result \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 225; {
/* line 909 "/tmp/lalr6706" */
/* line 781 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; CloseScope(); PopColumn(); 
} break;
case 1030:
case 571: /* valof : valoftok sep BEGIN process result explist sep END .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 912), ");  printf("valoftok sep BEGIN process result explist sep END  -> valof \n");
}
#endif
  yyStateStackPtr -=8; yyAttrStackPtr -=8; yyNonterminal = 179; {
/* line 912 "/tmp/lalr6706" */
/* line 784 "occam.lalr" */
 CloseScope(); yySynAttribute.Tree = mValof(Posn(yyAttrStackPtr [1-1]),mNoSpec(),yyAttrStackPtr [4-1].Tree,ReverseTree(yyAttrStackPtr [6-1].Tree),S=AddSymbol(NoIdent),Depth); SymbolKind(S)=yySynAttribute.Tree; 
} break;
case 1031:
case 678: /* valof : specification sep valof .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 914), ");  printf("specification sep valof  -> valof \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 179; {
/* line 914 "/tmp/lalr6706" */
/* line 785 "occam.lalr" */
 yySynAttribute.Tree = yyAttrStackPtr [3-1].Tree; InsertASpec(yyAttrStackPtr [3-1].Tree->Valof.SpecList,yyAttrStackPtr [1-1].Tree); 
} break;
case 1032:
case 609: /* spectype : primtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 917), ");  printf("primtype  -> spectype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 181; {
/* line 917 "/tmp/lalr6706" */
/* line 788 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 1033:
case 610: /* spectype : arrtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 919), ");  printf("arrtype  -> spectype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 181; {
/* line 919 "/tmp/lalr6706" */
/* line 789 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 1034:
case 645: /* datatype : numerictype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 922), ");  printf("numerictype  -> datatype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 922 "/tmp/lalr6706" */
/* line 792 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 1035:
case 644: /* datatype : arrtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 924), ");  printf("arrtype  -> datatype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 185; {
/* line 924 "/tmp/lalr6706" */
/* line 793 "occam.lalr" */
 yySynAttribute=yyAttrStackPtr [1-1]; 
} break;
case 1036:
case 619: /* primtype : CHAN OF protocol .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 927), ");  printf("CHAN OF protocol  -> primtype \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 165; {
/* line 927 "/tmp/lalr6706" */
/* line 796 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mChan(yyAttrStackPtr [3-1].Tree); last_type_was_chan=true; 
} break;
case 1037:
case 611: /* primtype : PORT OF spectype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 930), ");  printf("PORT OF spectype  -> primtype \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 165; {
/* line 930 "/tmp/lalr6706" */
/* line 797 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mChan(mSimple(Posn(yyAttrStackPtr [3-1]),yyAttrStackPtr [3-1].Tree)); Message("PORT not supported",xxError,Posn(yyAttrStackPtr [1-1])); last_type_was_chan=true; 
} break;
case 1038:
case 468: /* primtype : TIMER .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 931), ");  printf("TIMER  -> primtype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 165; {
/* line 931 "/tmp/lalr6706" */
/* line 798 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mTimer(); last_type_was_chan=false; 
} break;
case 1039:
case 612: /* primtype : numerictype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 933), ");  printf("numerictype  -> primtype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 165; {
/* line 933 "/tmp/lalr6706" */
/* line 799 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; last_type_was_chan=false;
} break;
case 1040:
case 607: /* numerictype : inttype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 936), ");  printf("inttype  -> numerictype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 192; {
/* line 936 "/tmp/lalr6706" */
/* line 802 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 1041:
case 608: /* numerictype : realtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 938), ");  printf("realtype  -> numerictype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 192; {
/* line 938 "/tmp/lalr6706" */
/* line 803 "occam.lalr" */
 yySynAttribute = yyAttrStackPtr [1-1]; 
} break;
case 1042:
case 454: /* numerictype : TYPEID .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 940), ");  printf("TYPEID  -> numerictype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 192; {
/* line 940 "/tmp/lalr6706" */
/* line 804 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = SymbolType(LookupSymbol(yyAttrStackPtr [1-1].Scan)); CHK_Mode(xxUserDataTypes,Posn(yyAttrStackPtr [1-1])); 
} break;
case 1043:
case 455: /* inttype : BOOL .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 943), ");  printf("BOOL  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 226; {
/* line 943 "/tmp/lalr6706" */
/* line 807 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mBool(); 
} break;
case 1044:
case 456: /* inttype : BYTE .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 945), ");  printf("BYTE  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 226; {
/* line 945 "/tmp/lalr6706" */
/* line 808 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mByte(); 
} break;
case 1045:
case 457: /* inttype : INT .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 947), ");  printf("INT  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 226; {
/* line 947 "/tmp/lalr6706" */
/* line 809 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt(); 
} break;
case 1046:
case 458: /* inttype : INT16 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 949), ");  printf("INT16  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 226; {
/* line 949 "/tmp/lalr6706" */
/* line 810 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt16(); 
} break;
case 1047:
case 459: /* inttype : INT32 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 951), ");  printf("INT32  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 226; {
/* line 951 "/tmp/lalr6706" */
/* line 811 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mInt32(); 
} break;
case 1048:
case 460: /* inttype : INT64 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 954), ");  printf("INT64  -> inttype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 226; {
/* line 954 "/tmp/lalr6706" */
/* line 812 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; if (IS_Mode(xxSupportINT64)) yySynAttribute.Tree = mInt64(); else { Message("No INT64 support therefore converting to INT32",xxWarning,Posn(yyAttrStackPtr [1-1])); yySynAttribute.Tree = mInt32(); } 
} break;
case 1049:
case 461: /* realtype : REAL32 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 956), ");  printf("REAL32  -> realtype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 227; {
/* line 956 "/tmp/lalr6706" */
/* line 815 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mReal32(); 
} break;
case 1050:
case 462: /* realtype : REAL64 .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 958), ");  printf("REAL64  -> realtype \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 227; {
/* line 958 "/tmp/lalr6706" */
/* line 816 "occam.lalr" */
  yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mReal64(); 
} break;
case 1051:
case 613: /* arrtype : sbexprlist primtype .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 961), ");  printf("sbexprlist primtype  -> arrtype \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 167; {
/* line 961 "/tmp/lalr6706" */
/* line 819 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mArrayFromExprList(ReverseTree(yyAttrStackPtr [1-1].Tree),yyAttrStackPtr [2-1].Tree); 
} break;
case 1052:
case 473: /* sbexpr : LSB RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 964), ");  printf("LSB RSB  -> sbexpr \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 228; {
/* line 964 "/tmp/lalr6706" */
/* line 822 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mUnBound(Posn(yyAttrStackPtr [1-1])); 
} break;
case 1053:
case 512: /* sbexpr : LSB expr RSB .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 966), ");  printf("LSB expr RSB  -> sbexpr \n");
}
#endif
  yyStateStackPtr -=3; yyAttrStackPtr -=3; yyNonterminal = 228; {
/* line 966 "/tmp/lalr6706" */
/* line 823 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = yyAttrStackPtr [2-1].Tree ; 
} break;
case 1054:
case 615: /* sbexprlist : sbexpr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 969), ");  printf("sbexpr  -> sbexprlist \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 214; {
/* line 969 "/tmp/lalr6706" */
/* line 826 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(mNoExpr(),yyAttrStackPtr [1-1].Tree) ; 
} break;
case 1055:
case 614: /* sbexprlist : sbexprlist sbexpr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 971), ");  printf("sbexprlist sbexpr  -> sbexprlist \n");
}
#endif
  yyStateStackPtr -=2; yyAttrStackPtr -=2; yyNonterminal = 214; {
/* line 971 "/tmp/lalr6706" */
/* line 827 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; yySynAttribute.Tree = mAnExpr(yyAttrStackPtr [1-1].Tree,yyAttrStackPtr [2-1].Tree); 
} break;
case 1056:
case 668: /* boolean : expr .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 974), ");  printf("expr  -> boolean \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 161; {
/* line 974 "/tmp/lalr6706" */
/* line 830 "occam.lalr" */
 yySynAttribute.Scan = yyAttrStackPtr [1-1].Scan; 
} break;
case 1057:
case 481: /* comma : COMMA .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 0), ");  printf("COMMA  -> comma \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 203; {

} break;
case 1058:
case 480: /* comma : DECLCOMMA .*/
#ifdef YYDEBUG
if (yydebug) {
  printf("Reducing via rule %ld ",yyState);  printf("(line 0), ");  printf("DECLCOMMA  -> comma \n");
}
#endif
  yyStateStackPtr -=1; yyAttrStackPtr -=1; yyNonterminal = 203; {

} break;
}

	       /* SPEC State = Next (Top (), Nonterminal); nonterminal transition */
	       yyState = * (yyNBasePtr [* yyStateStackPtr ++] + yyNonterminal);
	       * yyAttrStackPtr ++ = yySynAttribute;
	       if (yyState < yyFirstFinalState) goto ParseLoop; /* read nonterminal reduce ? */
	    } 

	 } else {					/* read */
	    yyStateStackPtr ++;
	    yyGetAttribute (yyAttrStackPtr ++, Attribute);
	    yyTerminal = GetToken ();

#ifdef YYDEBUG
if (yydebug)  /* SMW */
{
  printf("Reading a token: Next token is %d (%s)\n",yyTerminal,Parser_TokenName[yyTerminal]);
}
#endif

	    yyIsRepairing = false;
	 }
      }
   }

static void yyErrorRecovery
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange * yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange *	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      bool	yyTokensSkipped	;
      tSet	yyContinueSet	;
      tSet	yyRestartSet	;
      int	yyLength = 0	;
      char	yyContinueString [256];

   /* 1. report an error */
      ErrorMessage (xxSyntaxError, xxError, Attribute.Position);

   /* 2. report the set of expected terminal symbols */
      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      yyComputeContinuation (yyStateStack, yyStackSize, yyStackPtr, & yyContinueSet);
      yyContinueString [0] = '\0';
      while (! IsEmpty (& yyContinueSet)) {
	 char * yyTokenString = Parser_TokenName [Extract (& yyContinueSet)];
	 if ((yyLength += strlen (yyTokenString) + 1) >= 256) break;
	 (void) strcat (yyContinueString, yyTokenString);
	 (void) strcat (yyContinueString, " ");
      }
      ErrorMessageI (xxExpectedTokens, xxInformation, Attribute.Position,
	 xxString, yyContinueString);
      ReleaseSet (& yyContinueSet);

   /* 3. compute the set of terminal symbols for restart of the parse */
      MakeSet (& yyRestartSet, (short) yyLastTerminal);
      yyComputeRestartPoints (yyStateStack, yyStackSize, yyStackPtr, & yyRestartSet);

   /* 4. skip terminal symbols until a restart point is reached */
      yyTokensSkipped = false;
      while (! IsElement (* yyTerminal, & yyRestartSet)) {
	 * yyTerminal = GetToken ();
	 yyTokensSkipped = true;
      }
      ReleaseSet (& yyRestartSet);

   /* 5. report the restart point */
      if (yyTokensSkipped) {
	 ErrorMessage (xxRestartPoint, xxInformation, Attribute.Position);
      }
   }

/*
   compute the set of terminal symbols that can be accepted (read)
   in a given stack configuration (eventually after reduce actions)
*/

static void yyComputeContinuation
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyContinueSet)
# else
   (yyStack, yyStackSize, yyStackPtr, yyContinueSet)
   yyStateRange *	yyStack		;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyContinueSet	;
# endif
   {
      register yySymbolRange	yyTerminal;
      register yyStateRange	yyState = yyStack [yyStackPtr];

      AssignEmpty (yyContinueSet);
      for (yyTerminal = yyFirstTerminal; yyTerminal <= yyLastTerminal; yyTerminal ++) {
	 if (yyNext (yyState, yyTerminal) != yyNoState &&
	    yyIsContinuation (yyTerminal, yyStack, yyStackSize, yyStackPtr)) {
	    Include (yyContinueSet, (short) yyTerminal);
	 }
      }
   }

/*
   check whether a given terminal symbol can be accepted (read)
   in a certain stack configuration (eventually after reduce actions)
*/

static bool yyIsContinuation
# if defined __STDC__ | defined __cplusplus
   (yySymbolRange yyTerminal, yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr)
# else
   (yyTerminal, yyStateStack, yyStackSize, yyStackPtr)
   yySymbolRange	yyTerminal	;
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));	/* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      yState = yyStack [yyStackPtr];
      for (;;) {
	 yyStack [yyStackPtr] = yState;
	 yState = yyNext (yState, yyTerminal);
	 if (yState == yyNoState) {
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return false;
	 }
	 if (yState <= yyLastReadTermState) {		/* read or read terminal reduce ? */
	    ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    return true;
	 }

	 for (;;) {					/* reduce */
	    if (yState == yyStopState) {
	       ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	       return true;
	    } else { 
	       yyStackPtr -= yyLength [yState - yyFirstReduceState];
	       yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	    }

	    yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	    if (yyStackPtr >= yyStackSize) {
	       ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	    }
	    yyStackPtr ++;
	    if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	    yState = yyFinalToProd [yState - yyFirstReadTermState];	/* read nonterminal reduce */
	 }
      }
   }

/*
   compute a set of terminal symbols that can be used to restart
   parsing in a given stack configuration. we simulate parsing until
   end of file using a suffix program synthesized by the function
   Continuation. All symbols acceptable in the states reached during
   the simulation can be used to restart parsing.
*/

static void yyComputeRestartPoints
# if defined __STDC__ | defined __cplusplus
   (yyStateRange * yyStateStack, unsigned long yyStackSize, short yyStackPtr, tSet * yyRestartSet)
# else
   (yyStateStack, yyStackSize, yyStackPtr, yyRestartSet)
   yyStateRange *	yyStateStack	;
   unsigned long	yyStackSize	;
   short		yyStackPtr	;
   tSet *		yyRestartSet	;
# endif
   {
      register yyStateRange	yState		;
      register yySymbolRange	yyNonterminal	;
	       yyStateRange *	yyStack		;
	       tSet		yyContinueSet	;
   
      MakeArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange)); /* pass Stack by value */
# ifdef BCOPY
      bcopy ((char *) yyStateStack, (char *) yyStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# else
      (void) memcpy ((char *) yyStack, (char *) yyStateStack, (int) sizeof (yyStateRange) * (yyStackPtr + 1));
# endif

      MakeSet (& yyContinueSet, (short) yyLastTerminal);
      AssignEmpty (yyRestartSet);
      yState = yyStack [yyStackPtr];

      for (;;) {
	 if (yyStackPtr >= yyStackSize) {
	    ExtendArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
	 }
	 yyStack [yyStackPtr] = yState;
	 yyComputeContinuation (yyStack, yyStackSize, yyStackPtr, & yyContinueSet);
	 Union (yyRestartSet, & yyContinueSet);
	 yState = yyNext (yState, yyContinuation [yState]);

	 if (yState >= yyFirstFinalState) {		/* final state ? */
	    if (yState <= yyLastReadTermState) {	/* read terminal reduce ? */
	       yyStackPtr ++;
	       yState = yyFinalToProd [yState - yyFirstReadTermState];
	    }

	    for (;;) {					/* reduce */
	       if (yState == yyStopState) {
		  ReleaseSet (& yyContinueSet);
		  ReleaseArray ((char * *) & yyStack, & yyStackSize, sizeof (yyStateRange));
		  return;
	       } else { 
		  yyStackPtr -= yyLength [yState - yyFirstReduceState];
		  yyNonterminal = yyLeftHandSide [yState - yyFirstReduceState];
	       }

	       yState = yyNext (yyStack [yyStackPtr], yyNonterminal);
	       yyStackPtr ++;
	       if (yState < yyFirstFinalState) break;	/* read nonterminal ? */
	       yState = yyFinalToProd [yState - yyFirstReadTermState]; /* read nonterminal reduce */
	    }
	 } else {					/* read */
	    yyStackPtr ++;
	 }
      }
   }

/* access the parse table:   Next : State x Symbol -> Action */

static yyStateRange yyNext
# if defined __STDC__ | defined __cplusplus
   (yyStateRange yyState, yySymbolRange yySymbol)
# else
   (yyState, yySymbol) yyStateRange yyState; yySymbolRange yySymbol;
# endif
   {
      register yyTCombType * yyTCombPtr;

      if (yySymbol <= yyLastTerminal) {
	 for (;;) {
	    yyTCombPtr = yyTBasePtr [yyState] + yySymbol;
	    if (yyTCombPtr->Check != yyState) {
	       if ((yyState = yyDefault [yyState]) == yyNoState) return yyNoState;
	    } else {
	       return yyTCombPtr->Next;
	    }
	 }
      } else {
	return * (yyNBasePtr [yyState] + yySymbol);
      }
   }

static void BeginParser ()
   {
/* line 26 "/tmp/lalr6706" */
/* line 40 "occam.lalr" */

  OpenScope();
  Vtrue.Number = true;
  Vfalse.Number = false;


   }

void CloseParser ()
   {
/* line 35 "/tmp/lalr6706" */
/* line 49 "occam.lalr" */

  CloseScope();

   }
